<?php

define('HCS_CALLABLE_FILE', true);
$HCS_ROOTPATH = './../';
include_once($HCS_ROOTPATH . 'common.php');
include_once($HCS_ROOTPATH . 'includes/php/async_functions.php');
include_once($HCS_ROOTPATH . 'includes/php/tasker_functions.php');
global $_LANGUAGE, $_LANGUAGE_ADMIN, $_LANGUAGE_ASYNC, $_CONFIG;
$loggedInUser = false;
$isAdmin = false;
$AdminRequired = true;

if (!@include_once($HCS_ROOTPATH . 'language/' . $_CONFIG['language'] . '/admin.php')) {
    $msg = 'Could not include the admin language files! Check to make sure that "' . $HCS_ROOTPATH . 'language/' . $_CONFIG['language'] . '/admin.php" exists!';
    generateErrorMessage($msg);
    die($msg);
}
if (!@include_once($HCS_ROOTPATH . 'language/' . $_CONFIG['language'] . '/async.php')) {
    $msg = 'Could not include the admin language files! Check to make sure that "' . $HCS_ROOTPATH . 'language/' . $_CONFIG['language'] . '/async.php" exists!';
    generateErrorMessage($msg);
    die($msg);
}

$cmd = '';
checkedSet($cmd, $_GET['cmd']);
checkedSet($cmd, $_POST['cmd']);

$noAdminRequiredCmds = array('addPageWidgets', 'editPageWidgets', 'deletePageWidget', 'addPage', 'editPageConfig', 'getUserRights', 'addPageUserRight', 'initCcu', 'initAllCcus');
if (in_array($cmd, $noAdminRequiredCmds)) {
    $AdminRequired = false;
}


/* -------------------------------------------------------------------------- */
// <editor-fold defaultstate="collapsed" desc="LOGIN CHECK">
$loggedInUser = getLoggedInUser();
if ($loggedInUser == false) {
    $msg = sprintf($_LANGUAGE_ADMIN['L_NOT_LOGGEDIN_TEXT'], '<a href="' . insertSessionId($HCS_ROOTPATH . 'login.php?redirect=' . getRefererUri()) . '">', '</a>');
    generateErrorMessage($msg);
    die($msg);
}

if (isset($_SESSION['admin']) && ($_SESSION['admin'] === true)) {
    $isAdmin = true;
} else {
    if ($AdminRequired) {
        $msg = $_LANGUAGE_ADMIN['L_NO_ADMIN_TITLE'] . '<br/>' . $_LANGUAGE_ADMIN['L_NO_ADMIN_TEXT'];
        generateErrorMessage($msg);
        die($msg);
    }
    if (isset($_POST['username']) && $loggedInUser != $_POST['username']) {
        clearLoginCookies();
        clearSession();
        $msg = $_LANGUAGE_ADMIN['L_MISSMATCHING_USERS_TITLE'] . '<br/>' . sprintf($_LANGUAGE_ADMIN['L_MISSMATCHING_USERS_TEXT'], '<a href="' . insertSessionId($HCS_ROOTPATH . 'login.php') . '">', '</a>');
        generateErrorMessage($msg);
        die($msg);
    }
}
// </editor-fold>
/* -------------------------------------------------------------------------- */


switch ($cmd) {
    case "test":
        if (!isset($sql)) {
            $sql = @new SQL();
        }
        $ccuId = '';
        checkedSet($ccuId, $_GET['ccuId']);
        if ($ccuId != '') {
            $ccu = $sql->queryRequest("SELECT CcuAddress, CallbackAddress FROM " . HCS_TABLE_PREFIX . "CcuList WHERE Id = '" . $ccuId . "';");
            if ((count($ccu) > 0) && ($ccu[0]["CcuAddress"] != null)) {
                $bla = Homematic_XmlRpc::deinit($ccu[0]["CcuAddress"], 2000, $ccu[0]["CallbackAddress"]);
                generateReturnMessage($bla);
            }
        } else {
            generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_WRONG_PARAMETER'], $cmd));
        }
        break;

    case 'deleteUser':
        // <editor-fold defaultstate="collapsed" desc="DELETE USER">
        $deleteUsername = '';
        checkedSet($deleteUsername, $_POST['deleteUsername']);
        if ($deleteUsername != '') {
            if (strtolower($deleteUsername) != strtolower($loggedInUser)) {
                if (!isset($sql)) {
                    $sql = @new SQL();
                }
                if ($sql->deleteUser($deleteUsername)) {
                    generateOK();
                } else {
                    $s = sprintf($_LANGUAGE_ASYNC['L_DELETE_USER_ERROR'], $deleteUsername);
                    generateErrorMessage($s);
                }
            } else {
                generateErrorMessage($_LANGUAGE_ASYNC['L_DELETE_USER_SELF_ERROR']);
            }
        } else {
            generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_WRONG_PARAMETER'], $cmd));
        }
        // </editor-fold>
        break;

    case 'addUser':
        // <editor-fold defaultstate="collapsed" desc="ADD USER">
        $addUsername = '';
        $addEMail = '';
        $addPassword = '';
        $addAdmin = 0;
        $addStyle = $_CONFIG['style'];
        $addLanguage = $_CONFIG['language'];
        checkedSet($addUsername, $_POST['addUsername']);
        checkedSet($addEMail, $_POST['addEMail']);
        checkedSet($addPassword, $_POST['addPassword']);
        checkedSet($addAdmin, $_POST['addAdmin']);
        checkedSet($addStyle, $_POST['style']);
        checkedSet($addLanguage, $_POST['lang']);
        if (($addUsername != '') && ($addEMail != '') && (((int)$addAdmin == 0) || ((int)$addAdmin == 1))) {
            if (!isset($sql)) {
                $sql = @new SQL();
            }
            if ($sql->addUser($addUsername, $addPassword, $addEMail, $addAdmin, $addStyle, $addLanguage)) {
                generateOK();
            } else {
                $s = sprintf($_LANGUAGE_ASYNC['L_ADD_USER_ERROR'], $addUsername);
                generateErrorMessage($s);
            }
        } else {
            generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_WRONG_PARAMETER'], $cmd));
        }
        // </editor-fold>
        break;

    case 'editPageWidgets':
        // <editor-fold defaultstate="collapsed" desc="ADD WIDGET PACKET">
        $id = '';
        $page = '';
        $widgetId = '';
        $oFlow = '';
        $comment = '';
        $lock = 0;
        $left = '';
        $top = '';
        $width = '';
        $height = '';
        $zIndex = '';
        $config = '';

        checkedSet($id, $_POST['id']);
        checkedSet($page, $_POST['p']);
        checkedSet($widgetId, $_POST['cls']);
        checkedSet($oFlow, $_POST['oflow']);
        checkedSet($comment, $_POST['com']);
        checkedSet($lock, $_POST['lock']);
        checkedSet($left, $_POST['l']);
        checkedSet($top, $_POST['t']);
        checkedSet($width, $_POST['w']);
        checkedSet($height, $_POST['h']);
        checkedSet($zIndex, $_POST['z']);
        checkedSet($config, $_POST['conf']);
        if (($id != '') && ($page != '') && ($widgetId != '') && ($oFlow != '') && ($left != '') && ($top != '') && ($width != '') && ($height != '') && ($zIndex != '') && ($config != '')) {
            if (!isset($sql)) {
                $sql = @new SQL();
            }
            if ($sql->checkWidgetPageAssociation($id, $page) && $sql->getPageRights($page) >= 3) {
                if ($sql->editPageWidget($id, $page, $widgetId, $oFlow, escapeData($comment), $lock, $left, $top, $width, $height, $zIndex, $config)) {
                    generateOK();
                } else {
                    $request = $sql->queryRequest("SELECT Name FROM " . HCS_TABLE_PREFIX . "Widgets WHERE Id= '" . (int)$widgetId . "';");
                    $s = sprintf($_LANGUAGE_ASYNC['L_EDIT_PAGE_WIDGET_ERROR'], $id, $request[0]["Name"], $page);
                    generateErrorMessage($s);
                }
            } else {
                generateErrorMessage($_LANGUAGE_ASYNC['L_NO_RIGHTS']);
            }
        } else {
            generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_WRONG_PARAMETER'], $cmd));
        }
        // </editor-fold>
        break;

    case 'addPageWidgets':
        // <editor-fold defaultstate="collapsed" desc="ADD WIDGET PACKET">
        $page = '';
        $widgetId = '';
        $oFlow = '';
        $comment = '';
        $lock = 0;
        $left = '';
        $top = '';
        $width = '';
        $height = '';
        $zIndex = '';
        $config = '';

        checkedSet($page, $_POST['p']);
        checkedSet($widgetId, $_POST['cls']);
        checkedSet($oFlow, $_POST['oflow']);
        checkedSet($comment, $_POST['com']);
        checkedSet($lock, $_POST['lock']);
        checkedSet($left, $_POST['l']);
        checkedSet($top, $_POST['t']);
        checkedSet($width, $_POST['w']);
        checkedSet($height, $_POST['h']);
        checkedSet($zIndex, $_POST['z']);
        checkedSet($config, $_POST['conf']);
        if (($page != '') && ($widgetId != '') && ($oFlow != '') && ($left != '') && ($top != '') && ($width != '') && ($height != '') && ($zIndex != '') && ($config != '')) {
            if (!isset($sql)) {
                $sql = @new SQL();
            }
            if ($sql->getPageRights($page) >= 3) {
                if ($sql->addPageWidget($page, $widgetId, $oFlow, escapeData($comment), $lock, $left, $top, $width, $height, $zIndex, $config)) {
                    generateOK();
                } else {
                    $request = $sql->queryRequest("SELECT Name FROM " . HCS_TABLE_PREFIX . "Widgets WHERE Id= '" . (int)$widgetId . "';");
                    $s = sprintf($_LANGUAGE_ASYNC['L_ADD_PAGE_WIDGET_ERROR'], $request[0]["Name"], $page);
                    generateErrorMessage($s);
                }
            } else {
                generateErrorMessage($_LANGUAGE_ASYNC['L_NO_RIGHTS']);
            }
        } else {
            generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_WRONG_PARAMETER'], $cmd));
        }
        // </editor-fold>
        break;

    case 'deletePageWidget':
        // <editor-fold defaultstate="collapsed" desc="DELETE PAGE WIDGET">
        $id = '';
        $page = '';
        checkedSet($id, $_POST['id']);
        checkedSet($page, $_POST['p']);
        if (($id != '') && ($page != '')) {
            if (!isset($sql)) {
                $sql = @new SQL();
            }
            // check if ID is really on page p
            if ($sql->checkWidgetPageAssociation($id, $page) && $sql->getPageRights($page) >= 3) {
                if ($sql->deletePageWidget($id)) {
                    generateOK();
                } else {
                    $s = sprintf($_LANGUAGE_ASYNC['L_DELETE_PAGE_WIDGET_ERROR'], $id, $page);
                    generateErrorMessage($s);
                }
            } else {
                generateErrorMessage($_LANGUAGE_ASYNC['L_NO_RIGHTS']);
            }
        } else {
            generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_WRONG_PARAMETER'], $cmd));
        }
        // </editor-fold>
        break;

    case 'duplicatePageWidget':
        // <editor-fold defaultstate="collapsed" desc="DUPLICATE PAGE WIDGET">
        $id = '';
        $page = '';
        checkedSet($id, $_POST['id']);
        checkedSet($page, $_POST['p']);
        if (($id != '') && ($page != '')) {
            if (!isset($sql)) {
                $sql = @new SQL();
            }
            // check if ID is really on page p
            if ($sql->checkWidgetPageAssociation($id, $page) && $sql->getPageRights($page) >= 3) {
                if ($sql->duplicatePageWidget($id)) {
                    generateOK();
                } else {
                    $s = sprintf($_LANGUAGE_ASYNC['L_DUPLICATE_PAGE_WIDGET_ERROR'], $id, $page);
                    generateErrorMessage($s);
                }
            } else {
                generateErrorMessage($_LANGUAGE_ASYNC['L_NO_RIGHTS']);
            }
        } else {
            generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_WRONG_PARAMETER'], $cmd));
        }
        // </editor-fold>
        break;

    case 'lockPageWidget':
        // <editor-fold defaultstate="collapsed" desc="LOCK PAGE WIDGET">
        $id = '';
        $page = '';
        checkedSet($id, $_POST['id']);
        checkedSet($page, $_POST['p']);
        if (($id != '') && ($page != '')) {
            if (!isset($sql)) {
                $sql = @new SQL();
            }
            // check if ID is really on page p
            if ($sql->checkWidgetPageAssociation($id, $page) && $sql->getPageRights($page) >= 3) {
                if ($sql->lockPageWidget($id)) {
                    generateOK();
                } else {
                    $s = sprintf($_LANGUAGE_ASYNC['L_DUPLICATE_PAGE_WIDGET_ERROR'], $id, $page);
                    generateErrorMessage($s);
                }
            } else {
                generateErrorMessage($_LANGUAGE_ASYNC['L_NO_RIGHTS']);
            }
        } else {
            generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_WRONG_PARAMETER'], $cmd));
        }
        // </editor-fold>
        break;

    case 'unlockPageWidget':
        // <editor-fold defaultstate="collapsed" desc="UNLOCK PAGE WIDGET">
        $id = '';
        $page = '';
        checkedSet($id, $_POST['id']);
        checkedSet($page, $_POST['p']);
        if (($id != '') && ($page != '')) {
            if (!isset($sql)) {
                $sql = @new SQL();
            }
            // check if ID is really on page p
            if ($sql->checkWidgetPageAssociation($id, $page) && $sql->getPageRights($page) >= 3) {
                if ($sql->unlockPageWidget($id)) {
                    generateOK();
                } else {
                    $s = sprintf($_LANGUAGE_ASYNC['L_DUPLICATE_PAGE_WIDGET_ERROR'], $id, $page);
                    generateErrorMessage($s);
                }
            } else {
                generateErrorMessage($_LANGUAGE_ASYNC['L_NO_RIGHTS']);
            }
        } else {
            generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_WRONG_PARAMETER'], $cmd));
        }
        // </editor-fold>
        break;

    case 'addWidgetPacket':
        // <editor-fold defaultstate="collapsed" desc="ADD WIDGET PACKET">
        $folder = '';
        checkedSet($folder, $_POST['folder']);
        if ($folder != '') {
            if (!isset($sql)) {
                $sql = @new SQL();
            }
            $result = $sql->queryRequest("SELECT Id,Name FROM " . HCS_TABLE_PREFIX . "WidgetPackets WHERE Folder = '" . $folder . "';");
            if (count($result) == 0) {
                if ($sql->addWidgetPacket($folder)) {
                    generateOK();
                } else {
                    $s = sprintf($_LANGUAGE_ASYNC['L_ADD_WIDGET_PACKET_ERROR'], $folder);
                    generateErrorMessage($s);
                }
            } else {
                $s = sprintf($_LANGUAGE_ASYNC['L_ADD_WIDGET_PACKET_ALLREADY_ERROR'], $folder);
                generateErrorMessage($s);
            }
        } else {
            generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_WRONG_PARAMETER'], $cmd));
        }
        // </editor-fold>
        break;

    case 'updateWidgetPacket':
        // <editor-fold defaultstate="collapsed" desc="UPDATE WIDGET PACKET">
        $folder = '';
        checkedSet($folder, $_POST['folder']);
        checkedSet($folder, $_GET['folder']);
        if ($folder != '') {
            if (!isset($sql)) {
                $sql = @new SQL();
            }
            $result = $sql->queryRequest("SELECT Id, Name FROM " . HCS_TABLE_PREFIX . "WidgetPackets WHERE Folder = '" . $folder . "';");
            if (count($result) > 0) {
                if ($sql->updateWidgetPacket($folder)) {
                    generateOK();
                } else {
                    $s = sprintf($_LANGUAGE_ASYNC['L_UPDATE_WIDGET_PACKET_ERROR'], $folder);
                    generateErrorMessage($s);
                }
            } else {
                $s = sprintf($_LANGUAGE_ASYNC['L_ADD_WIDGET_PACKET_ALLREADY_ERROR'], $folder);
                generateErrorMessage($s);
            }
        } else {
            generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_WRONG_PARAMETER'], $cmd));
        }
        // </editor-fold>
        break;

    case 'updateAllWidgetPacket':
        // <editor-fold defaultstate="collapsed" desc="UPDATE ALL WIDGET PACKET">
        if (!isset($sql)) {
            $sql = @new SQL();
        }
        $result = $sql->queryRequest("SELECT Folder FROM " . HCS_TABLE_PREFIX . "WidgetPackets;");
        if (count($result) > 0) {
            foreach ($result as $packet) {
                if (!$sql->updateWidgetPacket($packet['Folder'])) {
                    $s = sprintf($_LANGUAGE_ASYNC['L_UPDATE_WIDGET_PACKET_ERROR'], $folder);
                    generateErrorMessage($s);
                }
            }
            generateOK();
        } else {
            $s = sprintf($_LANGUAGE_ASYNC['L_ADD_WIDGET_PACKET_ALLREADY_ERROR'], $folder);
            generateErrorMessage($s);
        }
        // </editor-fold>
        break;

    case 'deleteWidgetPacket':
        // <editor-fold defaultstate="collapsed" desc="DELETE WIDGET PACKET">
        $packetId = '';
        checkedSet($packetId, $_POST['id']);
        if ($packetId != '') {

            if (!isset($sql)) {
                $sql = @new SQL();
            }
            if ($sql->deleteWidgetPacket((int)$packetId)) {
                generateOK();
            } else {
                $s = sprintf($_LANGUAGE_ASYNC['L_DELETE_WIDGET_PACKET_ERROR'], $packetId);
                generateErrorMessage($s);
            }
        } else {
            generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_WRONG_PARAMETER'], $cmd));
        }
        // </editor-fold>
        break;

    case 'getPossibleWidgetPackets':
        // <editor-fold defaultstate="collapsed" desc="GET POSSIBLE WIDGET PACKETS">
        if (!isset($sql)) {
            $sql = @new SQL();
        }

        $folders = glob($HCS_ROOTPATH . 'data/widgets/*', GLOB_ONLYDIR);
        if ($folders === false) {
            generateErrorMessage($_LANGUAGE_ASYNC['L_GET_WIDGET_PACKET_ERROR']);
        } else {
            $result = $sql->queryRequest("SELECT Folder FROM " . HCS_TABLE_PREFIX . "WidgetPackets;");
            $resultFolders = array();
            foreach ($folders as $folder) {
                $temp = substr(strrchr($folder, '/'), 1);
                foreach ($result as $packet) {
                    if (strtolower($packet["Folder"]) == strtolower($temp)) {
                        goto NextFolder;
                    }
                }

                $fileContent = file_get_contents($HCS_ROOTPATH . 'data/widgets/' . $temp . '/content.json');
                if ($fileContent === false) {
                    goto NextFolder;
                } else {
                    $content = json_decode($fileContent, true);
                    $name = null;
                    checkedSet($name, $content["name"]);
                }
                if ($name != null) {
                    $resultFolders[] = array("Name" => $name, "Folder" => $temp);
                }
                NextFolder:;
            }
        }

        generateReturnMessage($resultFolders);
        // </editor-fold>
        break;

    case 'getUserRights':
        // <editor-fold defaultstate="collapsed" desc="GET USER RIGHTS">
        $page = '';
        checkedSet($page, $_POST['id']);
        if ($page != '') {
            if (!isset($sql)) {
                $sql = @new SQL();
            }
            $result = $sql->queryRequest("SELECT " . HCS_TABLE_PREFIX . "Users.Username, r.Rights FROM " . HCS_TABLE_PREFIX . "Users LEFT JOIN (SELECT * FROM " . HCS_TABLE_PREFIX . "UserRights WHERE PageId='" . $page . "') AS r ON " . HCS_TABLE_PREFIX . "Users.Username = r.Username;");
            generateReturnMessage($result);
        } else {
            $s = sprintf($_LANGUAGE_ASYNC['L_GET_USER_RIGHTS_ERROR'], $page);
            generateErrorMessage($s);
        }
        // </editor-fold>
        break;

    case 'addPageUserRight':
        // <editor-fold defaultstate="collapsed" desc="ADD PAGE USER RIGHTS">
        $pageId = '';
        $name = '';
        $right = '';
        checkedSet($pageId, $_POST['id']);
        checkedSet($name, $_POST['name']);
        checkedSet($right, $_POST['right']);
        if (($pageId != '') && ($name != '') && ($right != '')) {
            if (!isset($sql)) {
                $sql = @new SQL();
            }
            if ($sql->addPageUserRight($pageId, $name, (int)$right)) {
                generateOK();
            } else {
                $s = sprintf($_LANGUAGE_ASYNC['L_ADD_PAGE_USER_RIGHT_ERROR'], $pageId, $name);
                generateErrorMessage($s);
            }
        } else {
            generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_WRONG_PARAMETER'], $cmd));
        }
        // </editor-fold>
        break;

    case 'addCcu':
        // <editor-fold defaultstate="collapsed" desc="ADD CCU">
        $id = '';
        $name = '';
        $version = '';
        $ip = '';
        $wired = '';
        $rf = '';
        $system = '';
        checkedSet($id, $_POST['id']);
        checkedSet($name, $_POST['name']);
        checkedSet($version, $_POST['version']);
        checkedSet($ip, $_POST['ip']);
        checkedSet($wired, $_POST['wired']);
        checkedSet($rf, $_POST['rf']);
        checkedSet($system, $_POST['system']);
        if (($name != '') && ($ip != '') && ($version != '') && ($wired != '') && ($rf != '') && ($system != '')) {
            if (!isset($sql)) {
                $sql = @new SQL();
            }

            if ($version == 'CCU2') {
                $system = 0;
            }
            if ($id > 0) {
                if ($sql->editCcu($id, $ip, $name, $version, (int)$wired, (int)$rf, (int)$system)) {
                    generateOK();
                } else {
                    $s = sprintf($_LANGUAGE_ASYNC['L_EDIT_CCU_ERROR'], $id);
                    generateErrorMessage($s);
                }
            } else {
                if ($sql->addCcu($ip, $name, $version, (int)$wired, (int)$rf, (int)$system)) {
                    generateOK();
                } else {
                    $s = sprintf($_LANGUAGE_ASYNC['L_ADD_CCU_ERROR'], $name);
                    generateErrorMessage($s);
                }
            }
        } else {
            generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_WRONG_PARAMETER'], $cmd));
        }
        // </editor-fold>
        break;

    case 'deleteCcu':
        // <editor-fold defaultstate="collapsed" desc="DELETE CCU">
        $ccu = '';
        checkedSet($ccu, $_POST['ccu']);
        if ($ccu != '') {
            if (!isset($sql)) {
                $sql = @new SQL();
            }
            // deinit
            $query = $sql->queryRequest("SELECT * FROM " . HCS_TABLE_PREFIX . "CcuList WHERE Id =" . $ccu . ";");
            $ccuWired = new Homematic_XmlRpcInterface($query[0]["CcuAddress"], Homematic_Interface::Wired, $query[0]['CallbackAddress'], $query[0]["Id"]);
            $ccuRf = new Homematic_XmlRpcInterface($query[0]["CcuAddress"], Homematic_Interface::RF, $query[0]['CallbackAddress'], $query[0]["Id"]);
            $ccuSystem = new Homematic_XmlRpcInterface($query[0]["CcuAddress"], Homematic_Interface::System, $query[0]['CallbackAddress'], $query[0]["Id"]);
            $ccuWired->deinit();
            $ccuRf->deinit();
            $ccuSystem->deinit();

            if ($sql->deleteCcu($ccu)) {
                generateOK();
            } else {
                $s = sprintf($_LANGUAGE_ASYNC['L_DELETE_CCU_ERROR'], $ccu);
                generateErrorMessage($s);
            }
        } else {
            generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_WRONG_PARAMETER'], $cmd));
        }
        // </editor-fold>
        break;

    case 'duplicatePage':
        // <editor-fold defaultstate="collapsed" desc="DUPLICATE PAGE">
        $id = '';
        checkedSet($id, $_POST['id']);
        checkedSet($id, $_GET['id']);
        if (($id != '')) {
            if (!isset($sql)) {
                $sql = @new SQL();
            }
            if ($sql->duplicatePage($id)) {
                generateOK();
            } else {
                $s = sprintf($_LANGUAGE_ASYNC['L_DUPLICATE_PAGE_ERROR'], $id);
                generateErrorMessage($s);
            }
        } else {
            generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_WRONG_PARAMETER'], $cmd));
        }
        // </editor-fold>
        break;

    case 'addPage':
        // <editor-fold defaultstate="collapsed" desc="ADD PAGE">
        $id = '';
        $name = '';
        $right = 0;
        $comment = '';
        $start = false;
        checkedSet($id, $_POST['id']);
        checkedSet($name, $_POST['name']);
        checkedSet($right, $_POST['right']);
        checkedSet($comment, $_POST['comment']);
        checkedSet($start, $_POST['s']);
        if (($name != '') && ($right != '')) {
            if (!isset($sql)) {
                $sql = @new SQL();
            }
            if ($id > 0) {
                if ($sql->editPage($id, $name, $right, $comment, (bool)$start)) {
                    generateOK();
                } else {
                    $s = sprintf($_LANGUAGE_ASYNC['L_EDIT_PAGE_ERROR'], $id);
                    generateErrorMessage($s);
                }
            } else {
                if ($sql->addPage($name, $right, $comment, (bool)$start)) {
                    generateOK();
                } else {
                    $s = sprintf($_LANGUAGE_ASYNC['L_ADD_PAGE_ERROR'], $name);
                    generateErrorMessage($s);
                }
            }
        } else {
            generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_WRONG_PARAMETER'], $cmd));
        }
        // </editor-fold>
        break;

    case 'editPageConfig':
        // <editor-fold defaultstate="collapsed" desc="ADD PAGE">
        $page = -1;
        $title = "";
        $cssStyle = "";
        $style = "";
        $header = false;
        $tail = false;
        $updates = true;
        $timeout = 30;
        $rate = 0;
        $wait = 10;
        checkedSet($page, $_POST['p']);
        checkedSet($title, $_POST['t']);
        checkedSet($cssStyle, $_POST['css']);
        checkedSet($style, $_POST['style']);
        checkedSet($header, $_POST['head']);
        checkedSet($tail, $_POST['tail']);
        checkedSet($updates, $_POST['upd']);
        checkedSet($timeout, $_POST['tout']);
        checkedSet($rate, $_POST['rate']);
        checkedSet($wait, $_POST['wait']);
        if (($page != '') && ($page > 0)) {
            if (!isset($sql)) {
                $sql = @new SQL();
            }
            if ($sql->editPageConfig($page, $title, $cssStyle, $style, $header, $tail, $updates, $timeout, $rate, $wait)) {
                generateOK();
            } else {
                $s = sprintf($_LANGUAGE_ASYNC['L_EDIT_PAGE_CONFIG_ERROR'], $page);
                generateErrorMessage($s);
            }
        } else {
            generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_WRONG_PARAMETER'], $cmd));
        }
        // </editor-fold>
        break;

    case 'deletePage':
        // <editor-fold defaultstate="collapsed" desc="DELETE PAGE">
        $id = '';
        checkedSet($id, $_POST['id']);
        if ($id != '') {
            if (!isset($sql)) {
                $sql = @new SQL();
            }
            if ($sql->deletePage($id)) {
                generateOK();
            } else {
                $s = sprintf($_LANGUAGE_ASYNC['L_DELETE_PAGE_ERROR'], $id);
                generateErrorMessage($s);
            }
        } else {
            generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_WRONG_PARAMETER'], $cmd));
        }
        // </editor-fold>
        break;

    case 'addRule':
        // <editor-fold defaultstate="collapsed" desc="ADD LOGGING RULE">
        $id = '';
        $ccuid = '';
        $device = '';
        $datapoint = '';
        $value = '';
        $interval = '';
        $lifespan = '';
        $changes = '';
        checkedSet($id, $_POST['id']);
        checkedSet($ccuid, $_POST['ccuid']);
        checkedSet($device, $_POST['device']);
        checkedSet($datapoint, $_POST['datapoint']);
        checkedSet($value, $_POST['value']);
        checkedSet($interval, $_POST['interval']);
        checkedSet($lifespan, $_POST['lifespan']);
        checkedSet($changes, $_POST['changes']);
        if (($id != '') && ($ccuid != '') && ($device != '') && ($datapoint != '') && ($value != '') && ($interval != '') && ($lifespan != '') && ($changes != '')) {
            if (!isset($sql)) {
                $sql = @new SQL();
            }
            if ($id > 0) {
                if ($sql->editLoggingRule($id, $ccuid, $device, $datapoint, $value, $interval, $lifespan, (int)$changes)) {
                    generateOK();
                } else {
                    $s = sprintf($_LANGUAGE_ASYNC['L_EDIT_LOGGING_RULE_ERROR'], $id);
                    generateErrorMessage($s);
                }
            } else {
                if ($sql->addLoggingRule($ccuid, $device, $datapoint, $value, $interval, $lifespan, (int)$changes)) {
                    generateOK();
                } else {
                    $s = $_LANGUAGE_ASYNC['L_ADD_LOGGING_RULE_ERROR'];
                    generateErrorMessage($s);
                }
            }
        } else {
            generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_WRONG_PARAMETER'], $cmd));
        }
        // </editor-fold>
        break;

    case 'deleteRule':
        // <editor-fold defaultstate="collapsed" desc="DELETE LOGGING RULE">
        $ruleId = '';
        checkedSet($ruleId, $_POST['id']);
        if ($ruleId != '') {
            if (!isset($sql)) {
                $sql = @new SQL();
            }
            if ($sql->deleteLoggingRule($ruleId)) {
                generateOK();
            } else {
                $s = sprintf($_LANGUAGE_ASYNC['L_DELETE_LOGGING_RULE_ERROR'], $ruleId);
                generateErrorMessage($s);
            }
        } else {
            generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_WRONG_PARAMETER'], $cmd));
        }
        // </editor-fold>
        break;

    case 'changeRulePriority':
        // <editor-fold defaultstate="collapsed" desc="CHANGE RULE PRIORITY">
        $ruleId = '';
        $direction = 0;
        checkedSet($ruleId, $_POST['id']);
        checkedSet($direction, $_POST['dir']);
        $direction = (int)$direction;
        if ($ruleId != '' && $direction != 0) {
            if (!isset($sql)) {
                $sql = @new SQL();
            }
            if ($direction > 0) {
                $result = $sql->changeLoggingRulePriorityUp($ruleId);
            } elseif ($direction < 0) {
                $result = $sql->changeLoggingRulePriorityDown($ruleId);
            } else {
                $result = false;
            }
            if ($result) {
                generateOK();
            } else {
                $s = sprintf($_LANGUAGE_ASYNC['L_CHANGE_LOGGING_RULE_PRIORITY_ERROR'], $ruleId);
                generateErrorMessage($s);
            }
        } else {
            generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_WRONG_PARAMETER'], $cmd));
        }
        // </editor-fold>
        break;

    case 'initCcu':
        // <editor-fold defaultstate="collapsed" desc="INIT CCU">
        $id = '';
        checkedSet($id, $_POST['ccu']);
        if ($id != '') {
            if (HomematicControl::updateCcuSubscription((int)$id)) {
                generateOK();
            } else {
                generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_INIT_CCU_ERROR'], $id));
            }
        } else {
            generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_WRONG_PARAMETER'], $cmd));
        }

        // </editor-fold>
        break;

    case 'initAllCcus':
        // <editor-fold defaultstate="collapsed" desc="INIT ALL CCU">
        if (HomematicControl::updateAllCcuSubscriptions()) {
            generateOK();
        } else {
            generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_INIT_CCU_ERROR'], $id));
        }
        // </editor-fold>
        break;

    case 'clearValues':
        // <editor-fold defaultstate="collapsed" desc="CLEAR VALUES">
        if (!isset($sql)) {
            $sql = @new SQL();
        }
        if (($sql->truncateTable(HCS_TABLE_PREFIX . 'CurrentStates')) && ($sql->truncateTable(HCS_TABLE_PREFIX . 'HistoryStates'))) {
            generateOK();
        } else {
            $s = sprintf($_LANGUAGE_ASYNC['L_DELETE_CCU_ERROR'], $ccu);
            generateErrorMessage($s);
        }
        // </editor-fold>
        break;

    case 'addTask':
        // <editor-fold defaultstate="collapsed" desc="ADD TASK">
        $id = '';
        $ccuid = '';
        $name = '';
        $type = '';
        $interface = '';
        $designator = '';
        $parameter = '';
        $nextExecution = '';
        $interval = '';
        checkedSet($id, $_POST['id']);
        checkedSet($ccuid, $_POST['ccuid']);
        checkedSet($name, $_POST['name']);
        checkedSet($type, $_POST['type']);
        checkedSet($interface, $_POST['interf']);
        checkedSet($designator, $_POST['d']);
        checkedSet($parameter, $_POST['p']);
        checkedSet($nextExecution, $_POST['nextE']);
        checkedSet($interval, $_POST['i']);
        $nextExecution = (string)$nextExecution;
        if (($nextExecution == '0') || ($nextExecution == 'now') || ($nextExecution == 'jetzt')) {
            $nextExecution = date(SQL_SERVER_DATETIME_FORMAT);
        }
        if (($id != '') && ($ccuid != '') && ($type != '') && ($interval != '')) {
            if (!isset($sql)) {
                $sql = @new SQL();
            }
            if ($interval < 0){
                $interval = -1;
                $nextExecution = '';
            }
            if ($id > 0) {
                if ($sql->editTask($id, $ccuid, $name, $type, $interface, $designator, $parameter, $nextExecution, $interval)) {

                    generateOK();
                } else {
                    $s = sprintf($_LANGUAGE_ASYNC['L_EDIT_TASK_ERROR'], $id);
                    generateErrorMessage($s);
                }
            } else {
                if ($sql->addTask($ccuid, $name, $type, $interface, $designator, $parameter, $nextExecution, $interval)) {
                    generateOK();
                } else {
                    $s = $_LANGUAGE_ASYNC['L_ADD_TASK_ERROR'];
                    generateErrorMessage($s);
                }
            }
        } else {
            generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_WRONG_PARAMETER'], $cmd));
        }
        // </editor-fold>
        break;

    case 'deleteTask':
        // <editor-fold defaultstate="collapsed" desc="DELETE TASK">
        $taskId = '';
        checkedSet($taskId, $_POST['id']);
        if ($taskId != '') {
            if (!isset($sql)) {
                $sql = @new SQL();
            }
            if ($sql->deleteTask($taskId)) {
                generateOK();
            } else {
                $s = sprintf($_LANGUAGE_ASYNC['L_DELETE_TASK_ERROR'], $taskId);
                generateErrorMessage($s);
            }
        } else {
            generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_WRONG_PARAMETER'], $cmd));
        }
        // </editor-fold>
        break;

    case 'executeTask':
        // <editor-fold defaultstate="collapsed" desc="EXECUTE TASK">
        $taskIds = '';
        $force = false;
        checkedSet($taskIds, $_POST['id']);
        checkedSet($force, $_POST['force']);
        checkedSet($taskIds, $_GET['id']);
        checkedSet($force, $_GET['force']);
        if ($taskIds != '') {
            if (executeTasker($taskIds, (bool)$force)) {
                generateOK();
            } else {
                $s = sprintf($_LANGUAGE_ASYNC['L_EXECUTE_TASK_ERROR'], $taskIds);
                $s .= '<br />';
                $s .= print_r(LoggingSingleton::getErrorArray(), true);;
                generateErrorMessage($s);
            }
        } else {
            if (executeTasker()) {
                generateOK();
            } else {
                $s = sprintf($_LANGUAGE_ASYNC['L_EXECUTE_TASK_ERROR'], $taskIds);
                $s .= '<br />';
                $s .= print_r(LoggingSingleton::getErrorArray(), true);;
                generateErrorMessage($s);
            }
        }
        // </editor-fold>
        break;

    case 'updateLists':
        // <editor-fold defaultstate="collapsed" desc="UPDATE LISTS">
        $ccuId = '';
        checkedSet($ccuId, $_POST['ccuId']);
        if ($ccuId != '') {
            HomematicControl::updateAllList($ccuId);
            generateOK();
        } else {
            generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_WRONG_PARAMETER'], $cmd));
        }
        // </editor-fold>
        break;

    case 'updateDevices':
        // <editor-fold defaultstate="collapsed" desc="UPDATE DEVICES">
        $ccuId = '';
        checkedSet($ccuId, $_POST['ccuId']);
        checkedSet($ccuId, $_GET['ccuId']);
        if ($ccuId != '') {
            HomematicControl::updateDeviceList($ccuId);
            generateOK();
        } else {
            generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_WRONG_PARAMETER'], $cmd));
        }
        // </editor-fold>
        break;

    case 'updateSystemVariables':
        // <editor-fold defaultstate="collapsed" desc="UPDATE DEVICES">
        $ccuId = '';
        checkedSet($ccuId, $_POST['ccuId']);
        if ($ccuId != '') {
            HomematicControl::updateSystemVariableList($ccuId);
            generateOK();
        } else {
            generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_WRONG_PARAMETER'], $cmd));
        }
        // </editor-fold>
        break;

    case 'updatePrograms':
        // <editor-fold defaultstate="collapsed" desc="UPDATE DEVICES">
        $ccuId = '';
        checkedSet($ccuId, $_POST['ccuId']);
        if ($ccuId != '') {
            HomematicControl::updateProgramsList($ccuId);
            generateOK();
        } else {
            generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_WRONG_PARAMETER'], $cmd));
        }
        // </editor-fold>
        break;

    case 'updateCrafts':
        // <editor-fold defaultstate="collapsed" desc="UPDATE DEVICES">
        $ccuId = '';
        checkedSet($ccuId, $_POST['ccuId']);
        if ($ccuId != '') {
            HomematicControl::updateCraftList($ccuId);
            generateOK();
        } else {
            generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_WRONG_PARAMETER'], $cmd));
        }
        // </editor-fold>
        break;

    case 'updateRooms':
        // <editor-fold defaultstate="collapsed" desc="UPDATE DEVICES">
        $ccuId = '';
        checkedSet($ccuId, $_POST['ccuId']);
        if ($ccuId != '') {
            HomematicControl::updateRoomList($ccuId);
            generateOK();
        } else {
            generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_WRONG_PARAMETER'], $cmd));
        }
        // </editor-fold>
        break;

    case 'changeDefaultLanguage':
        // <editor-fold defaultstate="collapsed" desc="CHANGE DEFAULT LANGUAGE">
        $language = '';
        checkedSet($language, $_POST['lang']);
        if ($language != '') {
            if (!isset($sql)) {
                $sql = @new SQL();
            }
            if ($sql->insertOrUpdateInTo(HCS_TABLE_PREFIX . 'Values', array('Name' => 'DefaultLanguage', 'Value' => $language), array('Name'))) {
                generateOK();
            } else {
                generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_CHANGE_DEFAULT_LANGUAGE_ERROR'], $language));
            }
        } else {
            generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_WRONG_PARAMETER'], $cmd));
        }
        // </editor-fold>
        break;

    case 'changeDefaultStyle':
        // <editor-fold defaultstate="collapsed" desc="CHANGE DEFAULT STYLE">
        $style = '';
        checkedSet($style, $_POST['style']);
        if ($style != '') {
            if (!isset($sql)) {
                $sql = @new SQL();
            }
            if ($sql->insertOrUpdateInTo(HCS_TABLE_PREFIX . 'Values', array('Name' => 'DefaultStyle', 'Value' => $style), array('Name'))) {
                generateOK();
            } else {
                generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_CHANGE_DEFAULT_STYLE_ERROR'], $style));
            }
        } else {
            generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_WRONG_PARAMETER'], $cmd));
        }
        // </editor-fold>
        break;

    case 'changeUpdateCheckInterval':
        // <editor-fold defaultstate="collapsed" desc="CHANGE UPDATE CHECK INTERVAL">
        $interval = '';
        checkedSet($interval, $_POST['int']);
        if ($interval != '') {
            if (!isset($sql)) {
                $sql = @new SQL();
            }
            if ($sql->insertOrUpdateInTo(HCS_TABLE_PREFIX . 'Values', array('Name' => 'UpdateCheckInterval', 'Value' => $interval), array('Name'))) {
                generateOK();
            } else {
                generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_CHANGE_UPDATE_CHECK_INTERVAL_ERROR'], $style));
            }
        } else {
            generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_WRONG_PARAMETER'], $cmd));
        }
        // </editor-fold>
        break;

    case 'toggleUpdateCheck':
        // <editor-fold defaultstate="collapsed" desc="TOGGLE UPDATE CHECK">
        if (!isset($sql)) {
            $sql = @new SQL();
        }
        $answer = $sql->queryRequest("SELECT Value FROM " . HCS_TABLE_PREFIX . "Values WHERE Name = 'UpdateCheck';");
        $mode = false;
        if (isset($answer[0]['Value'])) {
            $mode = !((bool)$answer[0]['Value']);
        }
        if ($sql->insertOrUpdateInTo(HCS_TABLE_PREFIX . 'Values', array('Name' => 'UpdateCheck', 'Value' => (int)$mode), array('Name'))) {
            generateOK();
        } else {
            generateErrorMessage($_LANGUAGE_ASYNC['L_TOGGLE_UPDATE_CHECK_ERROR']);
        }
        // </editor-fold>
        break;

    case 'toggleShowUpdateOnPage':
        // <editor-fold defaultstate="collapsed" desc="TOGGLE SHOW UPDATE ON PAGE">
        if (!isset($sql)) {
            $sql = @new SQL();
        }
        $answer = $sql->queryRequest("SELECT Value FROM " . HCS_TABLE_PREFIX . "Values WHERE Name = 'ShowUpdateOnPage';");
        $mode = false;
        if (isset($answer[0]['Value'])) {
            $mode = !((bool)$answer[0]['Value']);
        }
        if ($sql->insertOrUpdateInTo(HCS_TABLE_PREFIX . 'Values', array('Name' => 'ShowUpdateOnPage', 'Value' => (int)$mode), array('Name'))) {
            generateOK();
        } else {
            generateErrorMessage($_LANGUAGE_ASYNC['L_TOGGLE_SHOW_UPDATE_ON_PAGE_ERROR']);
        }
        // </editor-fold>
        break;

    case 'exportPage':
        // <editor-fold defaultstate="collapsed" desc="EXPORT PAGE">
        $id = '';
        checkedSet($id, $_POST['id']);
        if ($id != '') {
            if (!isset($sql)) {
                $sql = @new SQL();
            }
            $userArray = array();
            $result = $sql->queryRequest("SELECT * FROM " . HCS_TABLE_PREFIX . "UserRights WHERE PageId = " . (int)$id . ";");
            foreach ($result as $page) {
                $userArray[] = array('Name' => $page['Username'], 'Rights' => $page['Rights']);
            }

            $widgetArray = array();
            $result = $sql->queryRequest("SELECT w.ClassName AS ClassName, p.Configuration AS Configuration, p.Comment AS Comment, p.Locked AS Locked, p.Overflow AS Overflow, p.posLeft AS posLeft, p.posTop AS posTop, p.Width AS Width, p.Height AS Height, p.ZIndex AS ZIndex FROM (" . HCS_TABLE_PREFIX . "PageWidgets AS p LEFT JOIN " . HCS_TABLE_PREFIX . "Widgets AS w ON p.WidgetId = w.Id) WHERE PageId = " . (int)$id . ";");
            foreach ($result as $widget) {
                $widgetArray[] = array(
                    'ClassName' => $widget['ClassName'],
                    'Configuration' => $widget['Configuration'],
                    'Comment' => $widget['Comment'],
                    'Locked' => $widget['Locked'],
                    'Overflow' => $widget['Overflow'],
                    'posLeft' => $widget['posLeft'],
                    'posTop' => $widget['posTop'],
                    'Width' => $widget['Width'],
                    'Height' => $widget['Height'],
                    'ZIndex' => $widget['ZIndex'],
                );
            }

            $result = $sql->queryRequest("SELECT * FROM " . HCS_TABLE_PREFIX . "Pages WHERE Id = " . (int)$id . ";");
            if (count($result) != 1) {
                generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_EXPORT_PAGE_ID_ERROR'], $id));
            }

            $exportPageArray = array(
                'Id' => $result[0]['Id'],
                'Name' => $result[0]['Name'],
                'StandardRights' => $result[0]['StandardRights'],
                'Comment' => $result[0]['Comment'],
                'Title' => $result[0]['Title'],
                'CssStyle' => $result[0]['CssStyle'],
                'Style' => $result[0]['Style'],
                'LoginHeader' => $result[0]['LoginHeader'],
                'PageTail' => $result[0]['PageTail'],
                'EventUpdates' => $result[0]['EventUpdates'],
                'RefreshTimeout' => $result[0]['RefreshTimeout'],
                'RefreshRate' => $result[0]['RefreshRate'],
                'RefreshWaitTime' => $result[0]['RefreshWaitTime'],
                'Rights' => $userArray,
                'Widgets' => $widgetArray
            );

            $fileName = sanitize(date('Y-m-d H-i-s') . " - " . $result[0]['Name'] . ".txt", true);
            $handle = fopen($HCS_ROOTPATH . "data/export/" . $fileName, "a");
            if ($handle !== false) {
                fwrite($handle, json_encode($exportPageArray));
                fclose($handle);
                generateReturnMessage(sprintf($_LANGUAGE_ASYNC['L_EXPORT_PAGE_SUCCESS'], $fileName, "data/export/"));
            } else {
                fclose($handle);
                generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_EXPORT_PAGE_ID_ERROR'], $style));
            }
        } else {
            generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_WRONG_PARAMETER'], $cmd));
        }
        // </editor-fold>
        break;

    case 'importPage':
        // <editor-fold defaultstate="collapsed" desc="IMPORT PAGE">
        $file = '';
        checkedSet($file, $_POST['file']);
        if ($file != '') {
            if (!isset($sql)) {
                $sql = @new SQL();
            }

            $fileContent = file_get_contents($HCS_ROOTPATH . 'data/import/' . $file);
            if ($fileContent === false) {
                generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_IMPORT_PAGE_ERROR'], $file));
            }
            $content = json_decode($fileContent, true);

            if (
                (!isset($content['Id'])) ||
                (!isset($content['Name'])) ||
                (!isset($content['StandardRights'])) ||
                (!isset($content['Comment'])) ||
                (!isset($content['Title'])) ||
                (!isset($content['CssStyle'])) ||
                (!isset($content['Style'])) ||
                (!isset($content['LoginHeader'])) ||
                (!isset($content['PageTail'])) ||
                (!isset($content['EventUpdates'])) ||
                (!isset($content['RefreshTimeout'])) ||
                (!isset($content['RefreshRate'])) ||
                (!isset($content['RefreshWaitTime'])) ||
                (!isset($content['Rights'])) ||
                (!isset($content['Widgets']))
            ) {
                generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_IMPORT_PAGE_ERROR_NOT_ALL_VALUES'], $file));
            }

            $result = $sql->queryRequest("SELECT * FROM " . HCS_TABLE_PREFIX . "Pages WHERE Id = " . $content['Id'] . ";");
            $values = array(
                'Name' => $content['Name'],
                'StartPage' => 0,
                'StandardRights' => $content['StandardRights'],
                'Comment' => $content['Comment'],
                'Title' => $content['Title'],
                'CssStyle' => $content['CssStyle'],
                'Style' => $content['Style'],
                'LoginHeader' => (int)$content['LoginHeader'],
                'PageTail' => (int)$content['PageTail'],
                'EventUpdates' => (int)$content['EventUpdates'],
                'RefreshTimeout' => (int)$content['RefreshTimeout'],
                'RefreshRate' => (int)$content['RefreshRate'],
                'RefreshWaitTime' => (int)$content['RefreshWaitTime'],
            );
            if(count($result) > 0){
                // found page with import ID -> new ID
                $importResult = (bool)$sql->insertOrUpdateInTo(HCS_TABLE_PREFIX . 'Pages', $values);
                $id = $packetId = $sql->getPreviousQueryAutoId();
            } else {
                // can use exported ID -> old ID
                $id = (int)$content['Id'];
                $values['Id'] = $id;
                $importResult = (bool)$sql->insertOrUpdateInTo(HCS_TABLE_PREFIX . 'Pages', $values, array('Id'));

            }

            // get an array of all usernames
            $result = $sql->queryRequest("SELECT Username FROM " . HCS_TABLE_PREFIX . "Users;");
            $users = array();
            foreach($result as $userValue){
                $users[] = $userValue['Username'];
            }

            foreach($content['Rights'] as $user){
                if (in_array($user['Name'], $users)){
                    $importResult &= (bool)$sql->insertOrUpdateInTo(HCS_TABLE_PREFIX . 'UserRights', array(
                            'Username' => $user['Name'],
                            'PageId' => $id,
                            'Rights' => $user['Rights'],
                        ));
                }
            }

            // get an array of all widget IDs by their classname
            $result = $sql->queryRequest("SELECT Id, ClassName FROM " . HCS_TABLE_PREFIX . "Widgets;");
            $widgetIds = array();
            foreach($result as $widgetId){
                $widgetIds[$widgetId['ClassName']] = (int)$widgetId['Id'];
            }

            $warningMessage = '';
            foreach($content['Widgets'] as $widget){
                $comment = '';
                $locked = 0;
                if(isset($widget['Comment'])){
                    $comment = $widget['Comment'];
                }
                if(isset($widget['Locked'])){
                    $locked = $widget['Locked'];
                }
                if (isset($widgetIds[$widget['ClassName']])){
                    $importResult &= (bool)$sql->insertOrUpdateInTo(HCS_TABLE_PREFIX . 'PageWidgets', array(
                            'WidgetId' => $widgetIds[$widget['ClassName']],
                            'PageId' => $id,
                            'Configuration' => $widget['Configuration'],
                            'Comment' => $comment,
                            'Locked' => $locked,
                            'Overflow' => $widget['Overflow'],
                            'posLeft' => $widget['posLeft'],
                            'posTop' => $widget['posTop'],
                            'Width' => $widget['Width'],
                            'Height' => $widget['Height'],
                            'ZIndex' => $widget['ZIndex'],
                        ));
                } else {
                    $warningMessage .= (sprintf($_LANGUAGE_ASYNC['L_IMPORT_PAGE_WARNING_GETTING_ID_FOR_WIDGET_CLASS'], $widget['ClassName']));
                }
            }

            if (!$importResult){
                generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_IMPORT_PAGE_ERROR'], $file));
            }
            if ($warningMessage != ''){
                generateErrorMessage((sprintf($_LANGUAGE_ASYNC['L_IMPORT_PAGE_ERROR_WARNING'], $file)).$warningMessage);
            }

            if (rename($HCS_ROOTPATH . 'data/import/' . $file, $HCS_ROOTPATH . 'data/import done/' . $file) ){
                generateReturnMessage(sprintf($_LANGUAGE_ASYNC['L_IMPORT_OK_FILE_MOVED'], $file));
            } else {
                generateReturnMessage(sprintf($_LANGUAGE_ASYNC['L_IMPORT_OK_FILE_NOT_MOVED'], $file));

            }

        } else {
            generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_WRONG_PARAMETER'], $cmd));
        }
        // </editor-fold>
        break;

    case 'toggleExpertView':
        // <editor-fold defaultstate="collapsed" desc="TOGGLE EXPERT VIEW">
        if (!isset($sql)) {
            $sql = @new SQL();
        }
        $answer = $sql->queryRequest("SELECT Value FROM " . HCS_TABLE_PREFIX . "Values WHERE Name = 'ExpertView';");
        $mode = false;
        if (isset($answer[0]['Value'])) {
            $mode = !((bool)$answer[0]['Value']);
        }
        if ($sql->insertOrUpdateInTo(HCS_TABLE_PREFIX . 'Values', array('Name' => 'ExpertView', 'Value' => (int)$mode), array('Name'))) {
            generateOK();
        } else {
            generateErrorMessage($_LANGUAGE_ASYNC['L_TOGGLE_EXPERT_VIEW_ERROR']);
        }
        // </editor-fold>
        break;

    default:
        generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_UNKNOWN_COMMAND'], $cmd));
        break;
}

/*var_dump($isAdmin);
var_dump($loggedInUser);
var_dump($language);*/

header('HTTP/1.1 403 Forbidden');
header('Status: 403');
die("ERROR: Forbidden");

// EOF
?>