<?php

define('HCS_CALLABLE_FILE', true);
$HCS_ROOTPATH = './../';
include_once($HCS_ROOTPATH . 'common.php');
global $TEMPLATE, $_LANGUAGE, $_LANGUAGE_ADMIN, $_CONFIG;

$language = isset($_CONFIG['language']) ? $_CONFIG['language'] : 'german';
if (!@include_once($HCS_ROOTPATH . 'language/' . $language . '/admin.php')) {
    die('Could not include the admin language files! Check to make sure that "' . $HCS_ROOTPATH . 'language/' . $language . '/admin.php" exists!');
}

if (!isset($sql)) {
    $sql = @new SQL();
}

$loggedInUser = getLoggedInUser($sql);
$TEMPLATE->setFilename('page_config.html');

//get page
$id = '';
checkedSet($id, $_GET['id']);
checkedSet($id, $_POST['id']);
if ($id == '') {
    $s = sprintf($_LANGUAGE['L_NO_PAGE_ID'], '<a href="' . insertSessionId($HCS_ROOTPATH) . 'index.php">', '</a>');
    $TEMPLATE->displayDieMessage($_LANGUAGE['L_ERROR'], $s);
    die('Security: you should never reach this!');
}
$right = $sql->getPageRights($id);

if ($right === false) {
    $s = sprintf($_LANGUAGE['L_COULD_NOT_READ_STANDARD_RIGHTS'], '<a href="' . insertSessionId($HCS_ROOTPATH) . 'index.php">', '</a>', $id);
    $TEMPLATE->displayDieMessage($_LANGUAGE['L_ERROR'], $s);
    die('Security: you should never reach this!');
}


if ($right < 3) {
    $TEMPLATE->displayDieMessage($_LANGUAGE['L_WARNING'], $_LANGUAGE['L_NO_RIGHTS']);
    die('Security: you should never reach this!');
}

$request = $sql->queryRequest("SELECT * FROM " . HCS_TABLE_PREFIX . "Pages WHERE Id= '" . (int)$id . "';");
$style = $request[0]["Style"];
if (($style == 'none')) {
    $TEMPLATE->assignVariables(array('HCS_STYLE' => ''));
} elseif (($style == 'standard') || ($style == '')) {
} else {
    $TEMPLATE->assignVariables(array('HCS_STYLE' => $style));
}
$TEMPLATE->assignVariables(array(
    'PAGE_RIGHTS' => $right,
    'PAGE_ID' => $id,
    'PAGE_TITLE' => $request[0]["Title"],
    'SHOW_LOGIN_REDIRECT' => (bool)$request[0]["LoginHeader"],
    'SHOW_PAGE_TAIL' => (bool)$request[0]["PageTail"],
    'EVENT_UPDATES' => (bool)$request[0]["EventUpdates"],
    'STYLE' => $style,
    'CSS_STYLE' => $request[0]["CssStyle"],
    'REFRESH_TIMEOUT' => $request[0]["RefreshTimeout"],
    'REFRESH_RATE' => $request[0]["RefreshRate"],
    'REFRESH_WAIT_TIME' => $request[0]["RefreshWaitTime"],
    'LANGUAGE' => $language,
    'GRID_SIZE' => 10,
    'SHOW_EXPERT_VIEW' => (bool)$_CONFIG['expertView'],
));

$request = $sql->queryRequest("SELECT " . HCS_TABLE_PREFIX . "PageWidgets.Id AS Id, " . HCS_TABLE_PREFIX . "Widgets.Id AS ClassId, ClassName, " . HCS_TABLE_PREFIX . "WidgetPackets.Folder, ConfigClassFile, Configuration, " . HCS_TABLE_PREFIX . "PageWidgets.Comment, Locked, posTop, posLeft, Width, Height, ZIndex, Overflow  FROM (" . HCS_TABLE_PREFIX . "PageWidgets LEFT JOIN " . HCS_TABLE_PREFIX . "Widgets ON " . HCS_TABLE_PREFIX . "PageWidgets.WidgetId = " . HCS_TABLE_PREFIX . "Widgets.Id) LEFT JOIN " . HCS_TABLE_PREFIX . "WidgetPackets ON " . HCS_TABLE_PREFIX . "Widgets.PacketId = " . HCS_TABLE_PREFIX . "WidgetPackets.Id WHERE PageId= '" . (int)$id . "';");
$JsIncludes = array();
foreach ($request as $widget) {
    $folder = $HCS_ROOTPATH . "data/widgets/" . $widget["Folder"] . "/";
    $TEMPLATE->assignBlockVariables('widgets', array(
        'ID' => $widget["Id"],
        'CLASS_ID' => $widget["ClassId"],
        'CLASS' => $widget["ClassName"],
        'CONFIG' => unescapeData($widget["Configuration"]),
        'COMMENT' => unescapeData($widget["Comment"]),
        'LOCKED' => (int)$widget["Locked"],
        'PATH' => $folder,
        'TOP' => $widget["posTop"],
        'LEFT' => $widget["posLeft"],
        'WIDTH' => $widget["Width"],
        'HEIGHT' => $widget["Height"],
        'Z_INDEX' => $widget["ZIndex"],
        'OVERFLOW' => $widget["Overflow"],
    ));

    $path = $folder . $widget["ConfigClassFile"];
    if (!in_array($path, $JsIncludes)) {
        $JsIncludes[] = $path;
    }
}

/* This would be only the used includes
foreach ($JsIncludes as $include) {
    $TEMPLATE->assignBlockVariables('widgetJsIncludes', array('PATH' => $include));
}
*/

$request = $sql->queryRequest("SELECT Folder, ConfigClassFile FROM " . HCS_TABLE_PREFIX . "Widgets LEFT JOIN " . HCS_TABLE_PREFIX . "WidgetPackets ON " . HCS_TABLE_PREFIX . "Widgets.PacketId = " . HCS_TABLE_PREFIX . "WidgetPackets.Id;");
foreach ($request as $include) {
    $path = $HCS_ROOTPATH . "data/widgets/" . $include["Folder"] . "/" . $include["ConfigClassFile"];
    $TEMPLATE->assignBlockVariables('widgetJsIncludes', array('PATH' => $path));
}


// installation style
$path = $HCS_ROOTPATH . 'style/';
$dir = @opendir($path);
if ($dir) {
    while ($file = @readdir($dir)) {
        $folder = $path . $file;
        if ((!is_file($folder)) && (is_file($folder . '/style.css')) && (!is_link($folder)) && valid_folder($file)) {
            $TEMPLATE->assignBlockVariables('styleSelect', array('VALUE' => $file, 'OPTION' => ucfirst(strtolower($file)),));
        }
    }
}

$request = $sql->queryRequest("SELECT " . HCS_TABLE_PREFIX . "Widgets.Id, " . HCS_TABLE_PREFIX . "Widgets.Name, " . HCS_TABLE_PREFIX . "WidgetPackets.Name AS PacketName, " . HCS_TABLE_PREFIX . "WidgetPackets.Id AS PacketId, " . HCS_TABLE_PREFIX . "WidgetPackets.Folder AS PacketFolder, ClassName FROM " . HCS_TABLE_PREFIX . "Widgets LEFT JOIN " . HCS_TABLE_PREFIX . "WidgetPackets ON " . HCS_TABLE_PREFIX . "Widgets.PacketId = " . HCS_TABLE_PREFIX . "WidgetPackets.Id ORDER BY PacketId;");
$allWidgets = array();
foreach ($request as $widget) {
    if (!isset($allWidgets[$widget['PacketId']])) {
        $allWidgets[$widget['PacketId']] = array();
    }
    $allWidgets[$widget['PacketId']]['PacketName'] = $widget["PacketName"];
    $allWidgets[$widget['PacketId']]['PacketFolder'] = $HCS_ROOTPATH . "data/widgets/" . $widget["PacketFolder"] . "/";
    $allWidgets[$widget['PacketId']][$widget["Id"]] = $widget["Name"];

    $TEMPLATE->assignBlockVariables('widgetClasses', array(
        'ID' => $widget["Id"],
        'CLASS' => $widget["ClassName"],
    ));
}

foreach ($allWidgets as $packetId => $packet){

        $TEMPLATE->assignBlockVariables('widgetPackets', array(
            'ID' => $packetId,
            'NAME' => $packet["PacketName"],
        ));

}

if ($loggedInUser != false) {
    $TEMPLATE->assignVariables(array(
        'L_INFO_LOGGED_IN_TITLE' => sprintf($_LANGUAGE['L_INFO_LOGGED_IN_TITLE'], $loggedInUser),
        'SESSION_INFO' => sprintf($_LANGUAGE['L_SESSION_INFO'], nl2br(var_export($_SESSION, true))),
        'SESSION_ID' => 'SID: ' . session_id(),
        'COOKIE_INFO' => sprintf($_LANGUAGE['L_COOKIE_INFO'], nl2br(var_export($_COOKIE, true))),
    ));
} else {
    $s = sprintf($_LANGUAGE['L_INFO_NOT_LOGGEDIN_TEXT'], '<a href="' . insertSessionId($HCS_ROOTPATH . 'login.php?redirect=' . getRequestUri()) . '">', '</a>');
    $TEMPLATE->assignVariables(array(
        'L_INFO_NOT_LOGGEDIN_TITLE' => $_LANGUAGE['L_INFO_NOT_LOGGEDIN_TITLE'],
        'L_INFO_NOT_LOGGEDIN_TEXT' => $s,
    ));
}

$TEMPLATE->assignVariables(array(
    'CLASS_PACKETS_ARRAY' => json_encode($allWidgets),
    'L_CONFIG_RUN' => $_LANGUAGE_ADMIN['L_CONFIG_RUN'],
    'L_CONFIG_SELECT_WIDGET_PACKET' => $_LANGUAGE_ADMIN['L_CONFIG_SELECT_WIDGET_PACKET'],
    'L_CONFIG_SELECT_WIDGET' => $_LANGUAGE_ADMIN['L_CONFIG_SELECT_WIDGET'],
    'L_CONFIG_HEADER_PAGE_TITLE' => $_LANGUAGE_ADMIN['L_CONFIG_HEADER_PAGE_TITLE'],
    'L_CONFIG_HEADER_PAGE_LOGIN_HEADER' => $_LANGUAGE_ADMIN['L_CONFIG_HEADER_PAGE_LOGIN_HEADER'],
    'L_CONFIG_HEADER_PAGE_TAIL' => $_LANGUAGE_ADMIN['L_CONFIG_HEADER_PAGE_TAIL'],
    'L_CONFIG_HEADER_STYLE' => $_LANGUAGE_ADMIN['L_CONFIG_HEADER_STYLE'],
    'L_CONFIG_HEADER_CSS_STYLE' => $_LANGUAGE_ADMIN['L_CONFIG_HEADER_CSS_STYLE'],
    'L_CONFIG_HEADER_EVENT_UPDATES' => $_LANGUAGE_ADMIN['L_CONFIG_HEADER_EVENT_UPDATES'],
    'L_CONFIG_HEADER_REFRESH_TIMEOUT' => $_LANGUAGE_ADMIN['L_CONFIG_HEADER_REFRESH_TIMEOUT'],
    'L_CONFIG_HEADER_REFRESH_RATE' => $_LANGUAGE_ADMIN['L_CONFIG_HEADER_REFRESH_RATE'],
    'L_CONFIG_HEADER_REFRESH_WAIT_TIME' => $_LANGUAGE_ADMIN['L_CONFIG_HEADER_REFRESH_WAIT_TIME'],
    'L_CONFIG_SAVE_CHANGES' => $_LANGUAGE_ADMIN['L_CONFIG_SAVE_CHANGES'],
    'L_CONFIG_SAVE_POSITION_CHANGES' => $_LANGUAGE_ADMIN['L_CONFIG_SAVE_POSITION_CHANGES'],
    'L_LANGUAGE_STYLE_NONE' => $_LANGUAGE_ADMIN['L_LANGUAGE_STYLE_NONE'],
    'L_LANGUAGE_STYLE_STANDARD' => $_LANGUAGE_ADMIN['L_LANGUAGE_STYLE_STANDARD'],
    'L_CONFIG_ADD_WIDGET' => $_LANGUAGE_ADMIN['L_CONFIG_ADD_WIDGET'],
    'L_CONFIG_HEADER_OVERFLOW' => $_LANGUAGE_ADMIN['L_CONFIG_HEADER_OVERFLOW'],
    'L_CONFIG_HEADER_CONFIG' => $_LANGUAGE_ADMIN['L_CONFIG_HEADER_CONFIG'],
    'L_CONFIG_HEADER_Z_INDEX' => $_LANGUAGE_ADMIN['L_CONFIG_HEADER_Z_INDEX'],
    'L_CONFIG_HEADER_WIDGET_PACKET' => $_LANGUAGE_ADMIN['L_CONFIG_HEADER_WIDGET_PACKET'],
    'L_CONFIG_HEADER_WIDGET_CLASS' => $_LANGUAGE_ADMIN['L_CONFIG_HEADER_WIDGET_CLASS'],
    'L_ADD_WIDGET_TITLE' => $_LANGUAGE_ADMIN['L_ADD_WIDGET_TITLE'],
    'L_ADD_WIDGET' => $_LANGUAGE_ADMIN['L_ADD_WIDGET'],
    'L_EDIT_WIDGET_TITLE' => $_LANGUAGE_ADMIN['L_EDIT_WIDGET_TITLE'],
    'L_EDIT_WIDGET' => $_LANGUAGE_ADMIN['L_EDIT_WIDGET'],
    'L_DELETE_WIDGET' => $_LANGUAGE_ADMIN['L_DELETE_WIDGET'],
    'L_DELETE_WIDGET_CONFIRM_TEXT' => $_LANGUAGE_ADMIN['L_DELETE_WIDGET_CONFIRM_TEXT'],
    'L_DUPLICATE_WIDGET' => $_LANGUAGE_ADMIN['L_DUPLICATE_WIDGET'],
    'L_LOCK_WIDGET' => $_LANGUAGE_ADMIN['L_LOCK_WIDGET'],
    'L_UNLOCK_WIDGET' => $_LANGUAGE_ADMIN['L_UNLOCK_WIDGET'],
    'L_EDIT_CONFIG' => $_LANGUAGE_ADMIN['L_EDIT_CONFIG'],
    'L_CONFIG_WIDGET_TITLE' => $_LANGUAGE_ADMIN['L_CONFIG_WIDGET_TITLE'],
    'L_SAVE_CONFIG_WIDGET' => $_LANGUAGE_ADMIN['L_SAVE_CONFIG_WIDGET'],
    'L_CONFIG_HEADER_COMMENT' => $_LANGUAGE_ADMIN['L_CONFIG_HEADER_COMMENT'],
    'L_CONFIG_HEADER_POS_LEFT' => $_LANGUAGE_ADMIN['L_CONFIG_HEADER_POS_LEFT'],
    'L_CONFIG_HEADER_POS_TOP' => $_LANGUAGE_ADMIN['L_CONFIG_HEADER_POS_TOP'],
    'L_CONFIG_HEADER_POS_WIDTH' => $_LANGUAGE_ADMIN['L_CONFIG_HEADER_POS_WIDTH'],
    'L_CONFIG_HEADER_POS_HEIGHT' => $_LANGUAGE_ADMIN['L_CONFIG_HEADER_POS_HEIGHT'],
    'L_CONFIG_ADD_EMPTY_WIDGET_ERROR' => $_LANGUAGE_ADMIN['L_CONFIG_ADD_EMPTY_WIDGET_ERROR'],
));


$TEMPLATE->preparePageHeader();
$TEMPLATE->prepratePageTailAndDisplay();
// EOF
?>