<?php

define('HCS_CALLABLE_FILE', true);
$HCS_ROOTPATH = './../';
require_once($HCS_ROOTPATH . 'common.php');
global $_LANGUAGE, $_LANGUAGE_ADMIN, $_CONFIG;
$loggedInUser = false;
$isAdmin = false;

if (!@include_once($HCS_ROOTPATH . 'language/' . $_CONFIG['language'] . '/admin.php')) {
    die('Could not include the admin language files! Check to make sure that "' . $HCS_ROOTPATH . 'language/' . $_CONFIG['language'] . '/admin.php" exists!');
}

$TEMPLATE = new PageTemplate('admin');
$TEMPLATE->assignVariable('L_ADMIN_HEADER', $_LANGUAGE_ADMIN['L_ADMIN_HEADER']);


/* -------------------------------------------------------------------------- */
// <editor-fold defaultstate="collapsed" desc="LOGIN CHECK">
$loggedInUser = getLoggedInUser();
if ($loggedInUser == false) {
    $s = sprintf($_LANGUAGE_ADMIN['L_NOT_LOGGEDIN_TEXT'], '<a href="' . insertSessionId($HCS_ROOTPATH . 'login.php?redirect=' . getRequestUri()) . '">', '</a>');
    $TEMPLATE->displayDieMessage($_LANGUAGE_ADMIN['L_NOT_LOGGEDIN_TITLE'], $s);
    die('Security: you should never reach this!');
}

$tabIndex = (isset($_POST['tab'])) ? $_POST['tab'] : (isset($_GET['tab']) ? $_GET['tab'] : '0');
$tabIndex = intval($tabIndex);


if (isset($_SESSION['admin']) && ($_SESSION['admin'] === true)) {
    $isAdmin = true;
} else {
    if ($tabIndex > 1) {
        $TEMPLATE->displayDieMessage($_LANGUAGE_ADMIN['L_NO_ADMIN_TITLE'], $_LANGUAGE_ADMIN['L_NO_ADMIN_TEXT']);
        die('Security: you should never reach this!');
    }
    if (isset($_POST['username']) && $loggedInUser != $_POST['username']) {
        clearLoginCookies();
        clearSession();
        $s = sprintf($_LANGUAGE_ADMIN['L_MISSMATCHING_USERS_TEXT'], '<a href="' . insertSessionId($HCS_ROOTPATH . 'login.php') . '">', '</a>');
        $TEMPLATE->displayDieMessage($_LANGUAGE_ADMIN['L_MISSMATCHING_USERS_TITLE'], $s);
        die('Security: you should never reach this!');
    }
}

// </editor-fold>
/* -------------------------------------------------------------------------- */


// <editor-fold defaultstate="collapsed" desc="CHANGE LANGUAGE">
$setLanguage = '';
checkedSet($setLanguage, $_GET['language']);
checkedSet($setLanguage, $_POST['language']);

if ($setLanguage != '') {
    $_SESSION['language'] = $setLanguage;
    //setLanguageCookie($setLanguage);
    if ($loggedInUser !== false) {
        $sql = @new SQL();
        $sql->updateUser($loggedInUser, array('Language' => $setLanguage));
    }
    header("Location: " . removeUriKey(getRequestUri(), 'language'));
}
unset($setLanguage);
// </editor-fold>
/* -------------------------------------------------------------------------- */
// <editor-fold defaultstate="collapsed" desc="CHANGE STYLE">
$setStyle = '';
checkedSet($setStyle, $_GET['style']);
checkedSet($setStyle, $_POST['style']);

if ($setStyle != '') {
    $_SESSION['style'] = $setStyle;
    //setStyleCookie($setStyle);
    if ($loggedInUser !== false) {
        $sql = @new SQL();
        $sql->updateUser($loggedInUser, array('Style' => $setStyle));
    }
    header("Location: " . removeUriKey(getRequestUri(), 'style'));
}
unset($setStyle);
// </editor-fold>
/* -------------------------------------------------------------------------- */
// <editor-fold defaultstate="collapsed" desc="CHANGE EMAIL">
$setEMail = '';
checkedSet($setEMail, $_POST['EMail']);

if ($setEMail != '') {
    $_SESSION['email'] = $setEMail;
    unset($_POST['EMail']);

    if ($loggedInUser !== false) {
        $sql = @new SQL();
        if ($isAdmin) {
            $username = $loggedInUser;
            checkedSet($username, $_POST['username']);
            checkedSet($username, $_GET['username']);
            checkedSet($username, $_GET['u']);
            $sql->updateUser($username, array('EMail' => $setEMail));
            unset($username);
        } else {
            $sql->updateUser($loggedInUser, array('EMail' => $setEMail));
        }
    }
    header("Location: " . removeUriKey(getRequestUri(), array('username', 'u')));
}
unset($setEMail);
// </editor-fold>
/* -------------------------------------------------------------------------- */
// <editor-fold defaultstate="collapsed" desc="CHANGE PASSWORD">
$oldPassword = '';
checkedSet($oldPassword, $_POST['oldPassword']);
$newPassword = '';
checkedSet($newPassword, $_POST['newPassword']);
$newPasswordConfirm = '';
checkedSet($newPasswordConfirm, $_POST['newPasswordConfirm']);

if (($oldPassword != '') && ($newPassword == $newPasswordConfirm) && ($newPassword != '')) {
    $sql = @new SQL();
    if ($sql->checkLoginData($loggedInUser, $oldPassword)) {
        $sql->updateUser($loggedInUser, array('Password' => hasher($newPassword)));
        header('Location: ' . insertSessionId($HCS_ROOTPATH . 'login.php?logout=true&redirect=' . getRequestUri()));
    } else {
        $TEMPLATE->appendMessage($TEMPLATE->StatusIcon('error') . $_LANGUAGE_ADMIN['L_CURRENT_PASSWORD_WRONG']);
    }
}
unset($oldPassword);
unset($newPassword);
unset($newPasswordConfirm);
// </editor-fold>
/* -------------------------------------------------------------------------- */

// <editor-fold defaultstate="collapsed" desc="TAB SELECTION">

$TEMPLATE->assignVariable('SELECTED_TAB_INDEX', $tabIndex);

$tabNames = array();
$tabNames[0] = $_LANGUAGE_ADMIN['L_ADMIN_TABNAME_0'];
$tabNames[1] = $_LANGUAGE_ADMIN['L_ADMIN_TABNAME_1'];

if ($isAdmin) {
    $tabNames[2] = $_LANGUAGE_ADMIN['L_ADMIN_TABNAME_2'];
    $tabNames[3] = $_LANGUAGE_ADMIN['L_ADMIN_TABNAME_3'];
    $tabNames[4] = $_LANGUAGE_ADMIN['L_ADMIN_TABNAME_4'];
    $tabNames[5] = $_LANGUAGE_ADMIN['L_ADMIN_TABNAME_5'];
    $tabNames[6] = $_LANGUAGE_ADMIN['L_ADMIN_TABNAME_6'];
    $tabNames[7] = $_LANGUAGE_ADMIN['L_ADMIN_TABNAME_7'];
    $tabNames[8] = $_LANGUAGE_ADMIN['L_ADMIN_TABNAME_8'];
}
// status indicator
foreach ($tabNames as $tabsIndex => $tabsText) {
    $TEMPLATE->assignBlockVariables('tabsArray', array(
        'TEXT' => $tabsText,
        'INDEX' => $tabsIndex
    ));
}


$TEMPLATE->setFilename('message.html');

switch ($tabIndex) {
    case 0:
        configurationTab();
        break;
    case 1:
        controlPagesTab();
        break;
    case 2:
        currentStatesTab();
        break;
    case 3:
        ccusTab();
        break;
    case 4:
        loggingTab();
        break;
    case 5:
        tasksTab();
        break;
    case 6:
        usersTab();
        break;
    case 7:
        widgetsTab();
        break;
    case 8:
        settingsTab();
        break;
    default:
        configurationTab();
        break;
}

// </editor-fold>
/* -------------------------------------------------------------------------- */

// <editor-fold defaultstate="collapsed" desc="CONFIGURATION TAB">
function configurationTab()
{
    global $HCS_ROOTPATH, $_CONFIG, $TEMPLATE, $_LANGUAGE_ADMIN;
    $TEMPLATE->setFilename('configuration.html');

    // installation language
    $path = $HCS_ROOTPATH . 'language/';
    $dir = @opendir($path);
    if ($dir) {
        while ($file = @readdir($dir)) {
            $folder = $path . $file;
            if ((!is_file($folder)) && (is_file($folder . '/page.php')) && (!is_link($folder)) && valid_folder($file)) {
                $TEMPLATE->assignBlockVariables('languageSelect', array(
                        'VALUE' => $file,
                        'OPTION' => ucfirst(strtolower($file)),
                        'SELECTED' => option_selected(strtolower($file) == strtolower($_CONFIG['language'])),
                    )
                );
            }
        }
    }

    // installation style
    $path = $HCS_ROOTPATH . 'style/';
    $dir = @opendir($path);
    if ($dir) {
        while ($file = @readdir($dir)) {
            $folder = $path . $file;
            if ((!is_file($folder)) && (is_file($folder . '/style.css')) && (!is_link($folder)) && valid_folder($file)) {
                $TEMPLATE->assignBlockVariables('styleSelect', array(
                        'VALUE' => $file,
                        'OPTION' => ucfirst(strtolower($file)),
                        'SELECTED' => option_selected(strtolower($file) == strtolower($_CONFIG['style'])),
                    )
                );
            }
        }
    }

    $TEMPLATE->assignVariables(array(
        'L_LANGUAGE' => $_LANGUAGE_ADMIN['L_LANGUAGE'],
        'L_LANGUAGE_SELECT' => $_LANGUAGE_ADMIN['L_LANGUAGE_SELECT'],
        'L_STYLE' => $_LANGUAGE_ADMIN['L_STYLE'],
        'L_STYLE_SELECT' => $_LANGUAGE_ADMIN['L_STYLE_SELECT'],
        'L_CHANGE_PASSWORD_HEADER' => $_LANGUAGE_ADMIN['L_CHANGE_PASSWORD_HEADER'],
        'L_CHANGE_PASSWORD_TEXT' => sprintf($_LANGUAGE_ADMIN['L_CHANGE_PASSWORD_TEXT'], $_LANGUAGE_ADMIN['L_BUTTON_CHANGE_PASSWORD']),
        'L_CURRENT_PASSWORD' => $_LANGUAGE_ADMIN['L_CURRENT_PASSWORD'],
        'L_NEW_PASSWORD' => $_LANGUAGE_ADMIN['L_NEW_PASSWORD'],
        'L_NEW_PASSWORD_CONFIRM' => $_LANGUAGE_ADMIN['L_NEW_PASSWORD_CONFIRM'],
        'L_PASSWORD_NO_MATCH' => $_LANGUAGE_ADMIN['L_PASSWORD_NO_MATCH'],
        'L_BUTTON_CHANGE_PASSWORD' => $_LANGUAGE_ADMIN['L_BUTTON_CHANGE_PASSWORD'],
        'L_CHANGE_EMAIL_HEADER' => $_LANGUAGE_ADMIN['L_CHANGE_EMAIL_HEADER'],
        'L_CHANGE_EMAIL_TEXT' => sprintf($_LANGUAGE_ADMIN['L_CHANGE_EMAIL_TEXT'], $_LANGUAGE_ADMIN['L_BUTTON_CHANGE_EMAIL']),
        'L_EMAIL' => $_LANGUAGE_ADMIN['L_EMAIL'],
        'L_EMAIL_ERROR' => $_LANGUAGE_ADMIN['L_EMAIL_ERROR'],
        'L_BUTTON_CHANGE_EMAIL' => $_LANGUAGE_ADMIN['L_BUTTON_CHANGE_EMAIL'],
        'CURRENT_EMAIL' => $_SESSION['email'],
        'INFO_TITLE' => $_LANGUAGE_ADMIN['INFO_TITLE'],
        'INFO_TEXT' => $_LANGUAGE_ADMIN['INFO_TEXT'],
    ));

}

// </editor-fold>
/* -------------------------------------------------------------------------- */

// <editor-fold defaultstate="collapsed" desc="CONTROLPAGES TAB">
function controlPagesTab()
{
    global $TEMPLATE, $_LANGUAGE, $_LANGUAGE_ADMIN, $isAdmin, $HCS_ROOTPATH;
    $TEMPLATE->setFilename('pages.html');

    if (!isset($sql)) {
        $sql = @new SQL();
    }

    $request = $sql->queryRequest("SELECT * FROM " . HCS_TABLE_PREFIX . "Pages");

    foreach ($request as $page) {

        if ($isAdmin || ($page['StandardRights'] >= 3)) {
            $edit = true;
            $show = true;
        } else {
            $rights = (int)$sql->getPageRights($page['Id']);
            if ($rights >= 3) {
                $edit = true;
                $show = true;
            } else {
                $edit = false;
                if ($rights >= 1) {
                    $show = true;
                } else {
                    $show = false;
                }
            }
        }

        if ($show) {
            $TEMPLATE->assignBlockVariables('pagesArray', array(
                'EDITABLE' => $edit,
                'START_ICON' => ($page['StartPage'] == 1) ? 'check' : 'minus',
                'START_TEXT' => ($page['StartPage'] == 1) ? 'x' : '-',
                'ID' => $page['Id'],
                'NAME' => $page['Name'],
                'STANDARD_RIGHTS_INT' => $page['StandardRights'],
                'STANDARD_RIGHTS' => pageRightsToString($page['StandardRights'], $_LANGUAGE_ADMIN),
                'COMMENT' => $page['Comment'],
            ));
        }
    }

    $files = glob($HCS_ROOTPATH . 'data/import/*');

    if ($files !== false) {
        foreach ($files as $file) {
            $TEMPLATE->assignBlockVariables('importableArray', array(
                'FILENAME' => substr(strrchr($file, '/'), 1),
            ));
        }
    }

    $TEMPLATE->assignVariables(array(
        'L_HEADER_PAGES_ID' => $_LANGUAGE_ADMIN['L_HEADER_PAGES_ID'],
        'L_HEADER_PAGES_EDIT' => $_LANGUAGE_ADMIN['L_HEADER_PAGES_EDIT'],
        'L_HEADER_PAGES_EXPORT' => $_LANGUAGE_ADMIN['L_HEADER_PAGES_EXPORT'],
        'L_HEADER_PAGES_NAME' => $_LANGUAGE_ADMIN['L_HEADER_PAGES_NAME'],
        'L_HEADER_PAGES_STANDARD_RIGHT' => $_LANGUAGE_ADMIN['L_HEADER_PAGES_STANDARD_RIGHT'],
        'L_HEADER_PAGES_COMMENT' => $_LANGUAGE_ADMIN['L_HEADER_PAGES_COMMENT'],
        'L_HEADER_LOGGING_RULES_DELETE' => $_LANGUAGE_ADMIN['L_HEADER_LOGGING_RULES_DELETE'],
        'L_PAGES_HEADER' => $_LANGUAGE_ADMIN['L_PAGES_HEADER'],
        'L_PAGES_EXPLANATION' => $_LANGUAGE_ADMIN['L_PAGES_EXPLANATION'],
        'L_ADD_PAGE' => $_LANGUAGE_ADMIN['L_ADD_PAGE'],
        'L_DELETE_PAGE' => $_LANGUAGE_ADMIN['L_DELETE_PAGE'],
        'L_PAGE_NAME' => $_LANGUAGE_ADMIN['L_PAGE_NAME'],
        'L_PAGE_STANDARD_RIGHTS' => $_LANGUAGE_ADMIN['L_PAGE_STANDARD_RIGHTS'],
        'L_PAGE_COMMENT' => $_LANGUAGE_ADMIN['L_PAGE_COMMENT'],
        'L_TITLE_ADD_PAGE' => $_LANGUAGE_ADMIN['L_TITLE_ADD_PAGE'],
        'L_EDIT_PAGE' => $_LANGUAGE_ADMIN['L_EDIT_PAGE'],
        'L_EXPORT_PAGE' => $_LANGUAGE_ADMIN['L_EXPORT_PAGE'],
        'L_TITLE_EDIT_PAGE' => $_LANGUAGE_ADMIN['L_TITLE_EDIT_PAGE'],
        'L_DELETE_PAGE_CONFIRM_TEXT' => sprintf($_LANGUAGE_ADMIN['L_DELETE_PAGE_CONFIRM_TEXT'], '_CCUNAME_', '_ID_'),
        'L_PAGE_RIGHTS_NONE' => $_LANGUAGE_ADMIN['L_PAGE_RIGHTS_NONE'],
        'L_PAGE_RIGHTS_DISPLAY' => $_LANGUAGE_ADMIN['L_PAGE_RIGHTS_DISPLAY'],
        'L_PAGE_RIGHTS_CONTROL' => $_LANGUAGE_ADMIN['L_PAGE_RIGHTS_CONTROL'],
        'L_PAGE_RIGHTS_EDIT' => $_LANGUAGE_ADMIN['L_PAGE_RIGHTS_EDIT'],
        'L_CONFIG_PAGE' => $_LANGUAGE_ADMIN['L_CONFIG_PAGE'],
        'L_HEADER_PAGES_CONFIG' => $_LANGUAGE_ADMIN['L_HEADER_PAGES_CONFIG'],
        'L_HEADER_PAGE_EDIT_USER_RIGHTS' => $_LANGUAGE_ADMIN['L_HEADER_PAGE_EDIT_USER_RIGHTS'],
        'L_EDIT_PAGE_USER_RIGHTS' => $_LANGUAGE_ADMIN['L_EDIT_PAGE_USER_RIGHTS'],
        'L_TITLE_PAGE_USER_RIGHTS' => sprintf($_LANGUAGE_ADMIN['L_TITLE_PAGE_USER_RIGHTS'], '_PAGENAME_'),
        'L_SAVE_PAGE_USER_RIGHS' => $_LANGUAGE_ADMIN['L_SAVE_PAGE_USER_RIGHS'],
        'L_NO_PAGE_USER_RIGHTS_FOUND' => $_LANGUAGE_ADMIN['L_NO_PAGE_USER_RIGHTS_FOUND'],
        'L_ADD_PAGE_EXPLANATION' => $_LANGUAGE_ADMIN['L_ADD_PAGE_EXPLANATION'],
        'L_PAGE_USER_RIGHTS_EXPLANATION' => $_LANGUAGE_ADMIN['L_PAGE_USER_RIGHTS_EXPLANATION'],
        'L_HEADER_PAGES_SHOW' => $_LANGUAGE_ADMIN['L_HEADER_PAGES_SHOW'],
        'L_SHOW_PAGE' => $_LANGUAGE_ADMIN['L_SHOW_PAGE'],
        'L_HEADER_PAGES_START' => $_LANGUAGE_ADMIN['L_HEADER_PAGES_START'],
        'L_PAGE_START_PAGE' => $_LANGUAGE_ADMIN['L_PAGE_START_PAGE'],
        'L_HEADER_PAGES_DUPLICATE' => $_LANGUAGE_ADMIN['L_HEADER_PAGES_DUPLICATE'],
        'L_DUPLICATE_PAGE' => $_LANGUAGE_ADMIN['L_DUPLICATE_PAGE'],
        'L_IMPORT_PAGE' => $_LANGUAGE_ADMIN['L_IMPORT_PAGE'],
        'L_IMPORT_PAGE_TITLE' => $_LANGUAGE_ADMIN['L_IMPORT_PAGE_TITLE'],
        'L_IMPORT_PAGE_TEXT' => $_LANGUAGE_ADMIN['L_IMPORT_PAGE_TEXT'],
        'L_OK' => $_LANGUAGE_ADMIN['L_OK'],
        'L_SELECT_IMPORT_PAGE' => $_LANGUAGE_ADMIN['L_SELECT_IMPORT_PAGE'],
    ));

}

// </editor-fold>
/* -------------------------------------------------------------------------- */

// <editor-fold defaultstate="collapsed" desc="CURRENT STATES TAB">
function currentStatesTab()
{
    global $HCS_ROOTPATH, $TEMPLATE, $_LANGUAGE, $_LANGUAGE_ADMIN;
    if (!isset($sql)) {
        $sql = @new SQL();
    }
    $deviceAddress = '';
    $ccuId = '';
    checkedSet($deviceAddress, $_GET['address']);
    checkedSet($deviceAddress, $_POST['address']);
    checkedSet($ccuId, $_GET['ccu']);
    checkedSet($ccuId, $_POST['ccu']);
    if ($deviceAddress != '') {
        $TEMPLATE->setFilename('state.html');
        $dataP = '';
        checkedSet($dataP, $_GET['data']);
        checkedSet($dataP, $_POST['data']);

        if ($deviceAddress == 'SYSTEM_VARIABLES') {
            $TEMPLATE->assignVariable('TITLE', utf8_encode('System Variablen'));
        } else {
            $request = $sql->queryRequest("SELECT Name FROM " . HCS_TABLE_PREFIX . "Channels WHERE Address = '" . $deviceAddress . "'");
            $TEMPLATE->assignVariable('TITLE', utf8_encode($request[0]['Name']));
        }

        $TEMPLATE->assignVariable('SUB_TITLE', utf8_encode($deviceAddress));

        if ($dataP != '') {
            $request = array(array('DataPoint' => $dataP));
        } else {
            $request = $sql->queryRequest("SELECT DataPoint FROM " . HCS_TABLE_PREFIX . "HistoryStates WHERE (CcuId = " . $ccuId . " AND ChannelAddress = '" . $deviceAddress . "') GROUP BY Datapoint");
        }
        foreach ($request as $point) {
            $datapoint = $point['DataPoint'];
            $dataString = '';
            $request = $sql->queryRequest("SELECT CcuId, ChannelAddress, DataPoint, Value, Timestamp FROM " . HCS_TABLE_PREFIX . "HistoryStates WHERE (CcuId = " . $ccuId . " AND ChannelAddress = '" . $deviceAddress . "' AND DataPoint = '" . $datapoint . "') ORDER BY Timestamp");
            foreach ($request as $data) {
                $dataString .= '[' . strtotime($data['Timestamp']) . '000, ' . booleanToInt($data['Value']) . '], ';
            }

            $temp = highcharts_LinetypeAndStepFromDatapoint($datapoint);
            // get line and step type for datapoints
            if ($deviceAddress == 'SYSTEM_VARIABLES') {

                $TEMPLATE->assignBlockVariables('dataArray', array(
                    'NAME' => utf8_encode(HomematicControl::getSysVarNameById($ccuId, $datapoint, $sql)),
                    'DATE' => $dataString,
                    'TYPE' => $temp[0],
                    'STEP' => $temp[1]
                ));
            } else {
                $TEMPLATE->assignBlockVariables('dataArray', array(
                    'NAME' => utf8_encode($datapoint),
                    'DATE' => $dataString,
                    'TYPE' => $temp[0],
                    'STEP' => $temp[1]
                ));
            }
        }
    } else {
        $TEMPLATE->setFilename('current_states.html');

        $request = $sql->queryRequest("SELECT cs.CcuId, cs.ChannelAddress, c.Name, cs.DataPoint, cs.Value, d.ValueUnit AS ValueUnit, cs.LastUpdate FROM (" . HCS_TABLE_PREFIX . "CurrentStates cs LEFT JOIN " . HCS_TABLE_PREFIX . "Channels c ON ((cs.ChannelAddress = c.Address) AND (cs.CcuId = c.CcuId))) LEFT JOIN  " . HCS_TABLE_PREFIX . "DataPoints d ON ((cs.DataPoint = d.Type) AND (c.Address = d.ChannelAddress)) ORDER BY cs.CcuId,c.Name ASC");

        for ($i = count($request) - 1; $i >= 0; $i--) {
            if (!isset($request[$i]['ChannelAddress_SPAN'])) {
                $request[$i]['ChannelAddress_SPAN'] = 1;
            }
            if (!isset($request[$i]['ChannelName_SPAN'])) {
                $request[$i]['ChannelName_SPAN'] = 1;
            }
            if (!isset($request[$i]['CcuId_SPAN'])) {
                $request[$i]['CcuId_SPAN'] = 1;
            }
            if (!isset($request[$i]['LastUpdate_SPAN'])) {
                $request[$i]['LastUpdate_SPAN'] = 1;
            }
            if ($i > 0) {
                if ($request[$i]['ChannelAddress'] == $request[$i - 1]['ChannelAddress']) {
                    // $request[$i]['ChannelAddress'] = '';
                    $request[$i - 1]['ChannelAddress_SPAN'] = $request[$i]['ChannelAddress_SPAN'] + 1;
                    $request[$i]['ChannelAddress_SPAN'] = 0;
                }
                if ($request[$i]['Name'] == $request[$i - 1]['Name']) {
                    //$request[$i]['ChannelName'] = '';
                    $request[$i - 1]['ChannelName_SPAN'] = $request[$i]['ChannelName_SPAN'] + 1;
                    $request[$i]['ChannelName_SPAN'] = 0;
                }
                if ($request[$i]['CcuId'] == $request[$i - 1]['CcuId']) {
                    //$request[$i]['CcuId'] = '';
                    $request[$i - 1]['CcuId_SPAN'] = $request[$i]['CcuId_SPAN'] + 1;
                    $request[$i]['CcuId_SPAN'] = 0;
                }
                if ($request[$i]['LastUpdate'] == $request[$i - 1]['LastUpdate']) {
                    // $request[$i]['LastUpdate'] = '';
                    $request[$i - 1]['LastUpdate_SPAN'] = $request[$i]['LastUpdate_SPAN'] + 1;
                    $request[$i]['LastUpdate_SPAN'] = 0;
                }
            }
        }
        foreach ($request as $state) {
            if ($state['ChannelAddress'] == 'SYSTEM_VARIABLES') {
                $TEMPLATE->assignBlockVariables('stateArray', array(
                    'CCU_ID' => $state['CcuId'],
                    'CCU_ID_SPAN' => $state['CcuId_SPAN'],
                    'CHANNEL_ADDRESS' => $state['ChannelAddress'],
                    'CHANNEL_ADDRESS_SPAN' => $state['ChannelAddress_SPAN'],
                    'CHANNEL_NAME' => utf8_encode(HomematicControl::getSysVarNameById($state['CcuId'], $state['DataPoint'], $sql)),
                    'CHANNEL_NAME_SPAN' => 1,
                    'DATAPOINT' => $state['DataPoint'],
                    'VALUE' => $state['Value'],
                    'LASTUPDATE' => $state['LastUpdate'],
                    'LASTUPDATE_SPAN' => $state['LastUpdate_SPAN'],
                ));
            } else {
                if($state['ValueUnit'] == '100%'){
                    $state['Value'] *= 100;
                    $state['ValueUnit'] = '%';
                }
                $TEMPLATE->assignBlockVariables('stateArray', array(
                    'CCU_ID' => $state['CcuId'],
                    'CCU_ID_SPAN' => $state['CcuId_SPAN'],
                    'CHANNEL_ADDRESS' => $state['ChannelAddress'],
                    'CHANNEL_ADDRESS_SPAN' => $state['ChannelAddress_SPAN'],
                    'CHANNEL_NAME' => utf8_encode($state['Name']),
                    'CHANNEL_NAME_SPAN' => $state['ChannelName_SPAN'],
                    'DATAPOINT' => $state['DataPoint'],
                    'VALUE' => $state['Value'] .' '. utf8_encode($state['ValueUnit']),
                    'LASTUPDATE' => $state['LastUpdate'],
                    'LASTUPDATE_SPAN' => $state['LastUpdate_SPAN'],
                ));
            }
        }
    }


    $TEMPLATE->assignVariables(array(
        'L_CURRENTSTATES_HEADER' => $_LANGUAGE_ADMIN['L_CURRENTSTATES_HEADER'],
        'L_CURRENTSTATES_EXPLANATION' => sprintf($_LANGUAGE_ADMIN['L_CURRENTSTATES_EXPLANATION'], '<a href="' . insertSessionId($HCS_ROOTPATH . 'admin/settings.php?tab=3') . '">' . $_LANGUAGE_ADMIN['L_ADMIN_TABNAME_3'] . '</a>'),
        'L_HEADER_CCU_ID' => $_LANGUAGE_ADMIN['L_HEADER_CCU_ID'],
        'L_HEADER_CHANNEL_ADDRESS' => $_LANGUAGE_ADMIN['L_HEADER_CHANNEL_ADDRESS'],
        'L_HEADER_CHANNEL_NAME' => $_LANGUAGE_ADMIN['L_HEADER_CHANNEL_NAME'],
        'L_HEADER_DATAPOINT' => $_LANGUAGE_ADMIN['L_HEADER_DATAPOINT'],
        'L_HEADER_VALUE' => $_LANGUAGE_ADMIN['L_HEADER_VALUE'],
        'L_HEADER_LASTUPDATE' => $_LANGUAGE_ADMIN['L_HEADER_LASTUPDATE'],
        'L_CLEAR_CURRENT_AND_LOGGED_VALUES' => $_LANGUAGE_ADMIN['L_CLEAR_CURRENT_AND_LOGGED_VALUES'],
        'L_CLEAR_CHECK' => $_LANGUAGE_ADMIN['L_CLEAR_CHECK'],
    ));

}

// </editor-fold>
/* -------------------------------------------------------------------------- */

// <editor-fold defaultstate="collapsed" desc="CCUS TAB">
function ccusTab()
{
    global $HCS_ROOTPATH, $TEMPLATE, $_LANGUAGE, $_LANGUAGE_ADMIN;
    $TEMPLATE->setFilename('ccus.html');

    if (!isset($sql)) {
        $sql = @new SQL();
    }
    if (SQL_SERVER_TYPE == 'MSSQL') {
        $request = $sql->queryRequest("SELECT Id, l.LastUpdate, CcuAddress, CcuName, CcuVersion, CallbackAddress, SubscribeWiredEvents, SubscribeRfEvents, SubscribeSystemEvents FROM (SELECT CcuId, MAX(LastUpdate) AS LastUpdate FROM " . HCS_TABLE_PREFIX . "CurrentStates GROUP BY CcuId)l RIGHT JOIN " . HCS_TABLE_PREFIX . "CcuList ON l.CcuId=" . HCS_TABLE_PREFIX . "CcuList.Id");
    } else {
        $request = $sql->queryRequest("SELECT Id, LastUpdate, CcuAddress, CcuName, CcuVersion, CallbackAddress, SubscribeWiredEvents, SubscribeRfEvents, SubscribeSystemEvents FROM (SELECT CcuId, MAX(LastUpdate) AS LastUpdate FROM " . HCS_TABLE_PREFIX . "CurrentStates GROUP BY CcuId)l RIGHT JOIN " . HCS_TABLE_PREFIX . "CcuList ON l.CcuId=" . HCS_TABLE_PREFIX . "CcuList.Id");
    }

    foreach ($request as $ccu) {
        $TEMPLATE->assignBlockVariables('ccusArray', array(
            'ID' => $ccu['Id'],
            'NAME' => $ccu['CcuName'],
            'VERSION' => $ccu['CcuVersion'],
            'LAST_UPDATE' => $ccu['LastUpdate'],
            'ADDRESS' => $ccu['CcuAddress'],
            'CALLBACK' => $ccu['CallbackAddress'],
            'WIRED_ICON' => ($ccu['SubscribeWiredEvents'] == 1) ? 'check' : 'minus',
            'WIRED_TEXT' => ($ccu['SubscribeWiredEvents'] == 1) ? 'x' : '-',
            'RF_ICON' => ($ccu['SubscribeRfEvents'] == 1) ? 'check' : 'minus',
            'RF_TEXT' => ($ccu['SubscribeRfEvents'] == 1) ? 'x' : '-',
            'SYSTEM_ICON' => ($ccu['SubscribeSystemEvents'] == 1) ? 'check' : 'minus',
            'SYSTEM_TEXT' => ($ccu['SubscribeSystemEvents'] == 1) ? 'x' : '-',
        ));
    }

    $TEMPLATE->assignVariables(array(
        'L_CCU_HEADER' => $_LANGUAGE_ADMIN['L_CCU_HEADER'],
        'L_CCU_EXPLANATION' => sprintf($_LANGUAGE_ADMIN['L_CCU_EXPLANATION'], '<a href="' . insertSessionId($HCS_ROOTPATH . 'admin/settings.php?tab=5') . '">' . $_LANGUAGE_ADMIN['L_ADMIN_TABNAME_5'] . '</a>', '<a id="aboScriptButton" href="#">' . $_LANGUAGE_ADMIN['L_CCU_ABO_SCRIPT'] . '</a>'),
        'L_HEADER_CCU_INIT' => $_LANGUAGE_ADMIN['L_HEADER_CCU_INIT'],
        'L_CCU_ABO_SCRIPT_TITLE' => $_LANGUAGE_ADMIN['L_CCU_ABO_SCRIPT_TITLE'],
        'L_CCU_ABO_SCRIPT_TEXT1' => $_LANGUAGE_ADMIN['L_CCU_ABO_SCRIPT_TEXT1'],
        'L_CCU_ABO_SCRIPT_TEXT2' => $_LANGUAGE_ADMIN['L_CCU_ABO_SCRIPT_TEXT2'],
        'L_HEADER_CCU_LAST_UPDATE' => $_LANGUAGE_ADMIN['L_HEADER_CCU_LAST_UPDATE'],
        'L_HEADER_CCU_ID' => $_LANGUAGE_ADMIN['L_HEADER_CCU_ID'],
        'L_HEADER_CCU_NAME' => $_LANGUAGE_ADMIN['L_HEADER_CCU_NAME'],
        'L_HEADER_CCU_ADDRESS' => $_LANGUAGE_ADMIN['L_HEADER_CCU_ADDRESS'],
        'L_HEADER_CCU_VERSION' => $_LANGUAGE_ADMIN['L_HEADER_CCU_VERSION'],
        'L_HEADER_CCU_WIRED' => $_LANGUAGE_ADMIN['L_HEADER_CCU_WIRED'],
        'L_HEADER_CCU_RF' => $_LANGUAGE_ADMIN['L_HEADER_CCU_RF'],
        'L_HEADER_CCU_SYSTEM' => $_LANGUAGE_ADMIN['L_HEADER_CCU_SYSTEM'],
        'L_HEADER_EDIT_CCU' => $_LANGUAGE_ADMIN['L_HEADER_EDIT_CCU'],
        'L_HEADER_DELETE_CCU' => $_LANGUAGE_ADMIN['L_HEADER_DELETE_CCU'],
        'L_ADD_CCU' => $_LANGUAGE_ADMIN['L_ADD_CCU'],
        'L_EDIT_CCU' => $_LANGUAGE_ADMIN['L_EDIT_CCU'],
        'L_DELETE_CCU' => $_LANGUAGE_ADMIN['L_DELETE_CCU'],
        'L_INIT_CCU' => $_LANGUAGE_ADMIN['L_INIT_CCU'],
        'L_INIT_ALL_CCUS' => $_LANGUAGE_ADMIN['L_INIT_ALL_CCUS'],
        'L_CCU_NAME' => $_LANGUAGE_ADMIN['L_CCU_NAME'],
        'L_CCU_VERSION' => $_LANGUAGE_ADMIN['L_CCU_VERSION'],
        'L_CCU_IP' => $_LANGUAGE_ADMIN['L_CCU_IP'],
        'L_CCU_ADD_WIRED' => $_LANGUAGE_ADMIN['L_CCU_ADD_WIRED'],
        'L_CCU_ADD_RF' => $_LANGUAGE_ADMIN['L_CCU_ADD_RF'],
        'L_CCU_ADD_SYSTEM' => $_LANGUAGE_ADMIN['L_CCU_ADD_SYSTEM'],
        'L_CCU_ADD_EMPTY_NAME' => $_LANGUAGE_ADMIN['L_CCU_ADD_EMPTY_NAME'],
        'L_CCU_ADD_EMPTY_IP' => $_LANGUAGE_ADMIN['L_CCU_ADD_EMPTY_IP'],
        'L_TITLE_ADD_CCU' => $_LANGUAGE_ADMIN['L_TITLE_ADD_CCU'],
        'L_TITLE_EDIT_CCU' => $_LANGUAGE_ADMIN['L_TITLE_EDIT_CCU'],
        'L_DELETE_CCU_CONFIRM_TEXT' => sprintf($_LANGUAGE_ADMIN['L_DELETE_CCU_CONFIRM_TEXT'], '_CCUNAME_', '_ID_'),
        'L_HEADER_CCU_LISTS' => $_LANGUAGE_ADMIN['L_HEADER_CCU_LISTS'],
        'L_CCU_LISTS' => $_LANGUAGE_ADMIN['L_CCU_LISTS'],
        'SERVER_PATH' => HCS_SERVER_NAME . ':' . HCS_SERVER_PORT . HCS_SERVER_PATH,
        'L_CCU_HEADER_LISTS' => $_LANGUAGE_ADMIN['L_CCU_HEADER_LISTS'],
        'L_CCU_LISTS_DEVICES' => $_LANGUAGE_ADMIN['L_CCU_LISTS_DEVICES'],
        'L_CCU_LISTS_DEVICES_HEADER_DEVICE' => $_LANGUAGE_ADMIN['L_CCU_LISTS_DEVICES_HEADER_DEVICE'],
        'L_CCU_LISTS_DEVICES_HEADER_DEVICETYP' => $_LANGUAGE_ADMIN['L_CCU_LISTS_DEVICES_HEADER_DEVICETYP'],
        'L_CCU_LISTS_DEVICES_HEADER_CHANNEL' => $_LANGUAGE_ADMIN['L_CCU_LISTS_DEVICES_HEADER_CHANNEL'],
        'L_CCU_LISTS_SYSVARS' => $_LANGUAGE_ADMIN['L_CCU_LISTS_SYSVARS'],
        'L_CCU_LISTS_SYSVARS_HEADER_ID' => $_LANGUAGE_ADMIN['L_CCU_LISTS_SYSVARS_HEADER_ID'],
        'L_CCU_LISTS_SYSVARS_HEADER_NAME' => $_LANGUAGE_ADMIN['L_CCU_LISTS_SYSVARS_HEADER_NAME'],
        'L_CCU_LISTS_SYSVARS_HEADER_TYP' => $_LANGUAGE_ADMIN['L_CCU_LISTS_SYSVARS_HEADER_TYP'],
        'L_CCU_LISTS_ROOMS' => $_LANGUAGE_ADMIN['L_CCU_LISTS_ROOMS'],
        'L_CCU_LISTS_CRAFTS' => $_LANGUAGE_ADMIN['L_CCU_LISTS_CRAFTS'],
        'L_CCU_LISTS_PROGRAMS' => $_LANGUAGE_ADMIN['L_CCU_LISTS_PROGRAMS'],
        'L_CCU_LISTS_UPDATE_ALL' => $_LANGUAGE_ADMIN['L_CCU_LISTS_UPDATE_ALL'],
        'L_CCU_LISTS_UPDATE_DEVICES' => $_LANGUAGE_ADMIN['L_CCU_LISTS_UPDATE_DEVICES'],
        'L_CCU_LISTS_UPDATE_SYSVARS' => $_LANGUAGE_ADMIN['L_CCU_LISTS_UPDATE_SYSVARS'],
        'L_CCU_LISTS_UPDATE_ROOMS' => $_LANGUAGE_ADMIN['L_CCU_LISTS_UPDATE_ROOMS'],
        'L_CCU_LISTS_UPDATE_CRAFTS' => $_LANGUAGE_ADMIN['L_CCU_LISTS_UPDATE_CRAFTS'],
        'L_CCU_LISTS_UPDATE_PROGRAMS' => $_LANGUAGE_ADMIN['L_CCU_LISTS_UPDATE_PROGRAMS'],
    ));

}

// </editor-fold>
/* -------------------------------------------------------------------------- */

// <editor-fold defaultstate="collapsed" desc="LOGGING TAB">
function loggingTab()
{
    global $TEMPLATE, $_LANGUAGE, $_LANGUAGE_ADMIN;
    $TEMPLATE->setFilename('logging_rules.html');

    if (!isset($sql)) {
        $sql = @new SQL();
    }
    $request = $sql->queryRequest("SELECT * FROM " . HCS_TABLE_PREFIX . "LoggingRules ORDER BY Priority DESC");

    foreach ($request as $rule) {
        $onlyChanges = ($rule['OnlyLogChanges'] == 1) ? 'check">x' : 'minus">-';
        $TEMPLATE->assignBlockVariables('rulesArray', array(
            'ID' => $rule['Id'],
            'PRIORITY' => $rule['Priority'],
            'CCU_ID' => $rule['CcuId'],
            'DEVICES' => $rule['Device'],
            'DATAPOINT' => $rule['DataPoint'],
            'VALUE' => $rule['Value'],
            'LOGGING_INTERVAL' => $rule['LoggingInterval'],
            'LIFESPAN' => $rule['LifeSpan'],
            'LOGGING_INTERVAL_STRING' => intToTimeString($rule['LoggingInterval'], array($_LANGUAGE['L_SHORT_SECONDS'], $_LANGUAGE['L_SHORT_MINUTES'], $_LANGUAGE['L_SHORT_HOURS'], $_LANGUAGE['L_SHORT_DAYS'])),
            'LIFESPAN_STRING' => intToTimeString($rule['LifeSpan'], array($_LANGUAGE['L_SHORT_SECONDS'], $_LANGUAGE['L_SHORT_MINUTES'], $_LANGUAGE['L_SHORT_HOURS'], $_LANGUAGE['L_SHORT_DAYS'])),
            'ONLY_CHANGES' => $onlyChanges,
        ));
    }
    $TEMPLATE->assignVariables(array(
        'L_DELETE_LOGGING_RULE_CONFIRM_TEXT' => sprintf($_LANGUAGE_ADMIN['L_DELETE_LOGGING_RULE_CONFIRM_TEXT'], '_ID_'),
        'L_LOGGING_RULES_HEADER' => $_LANGUAGE_ADMIN['L_LOGGING_RULES_HEADER'],
        'L_LOGGING_RULES_EXPLANATION' => $_LANGUAGE_ADMIN['L_LOGGING_RULES_EXPLANATION'],
        'L_DELETE_LOGGING_RULE' => $_LANGUAGE_ADMIN['L_DELETE_LOGGING_RULE'],
        'L_EDIT_LOGGING_RULE' => $_LANGUAGE_ADMIN['L_EDIT_LOGGING_RULE'],
        'L_ADD_LOGGING_RULE' => $_LANGUAGE_ADMIN['L_ADD_LOGGING_RULE'],
        'L_LOGGING_RULE_PRIORITY_DOWN' => $_LANGUAGE_ADMIN['L_LOGGING_RULE_PRIORITY_DOWN'],
        'L_LOGGING_RULE_PRIORITY_UP' => $_LANGUAGE_ADMIN['L_LOGGING_RULE_PRIORITY_UP'],
        'L_TITLE_EDIT_LOGGING_RULE' => $_LANGUAGE_ADMIN['L_TITLE_EDIT_LOGGING_RULE'],
        'L_TITLE_ADD_LOGGING_RULE' => $_LANGUAGE_ADMIN['L_TITLE_ADD_LOGGING_RULE'],
        'L_HEADER_LOGGING_RULES_ID' => $_LANGUAGE_ADMIN['L_HEADER_LOGGING_RULES_ID'],
        'L_HEADER_LOGGING_RULES_PRIORITY' => $_LANGUAGE_ADMIN['L_HEADER_LOGGING_RULES_PRIORITY'],
        'L_HEADER_LOGGING_RULES_EDIT' => $_LANGUAGE_ADMIN['L_HEADER_LOGGING_RULES_EDIT'],
        'L_HEADER_LOGGING_RULES_CCUID' => $_LANGUAGE_ADMIN['L_HEADER_LOGGING_RULES_CCUID'],
        'L_HEADER_LOGGING_RULES_DEVICES' => $_LANGUAGE_ADMIN['L_HEADER_LOGGING_RULES_DEVICES'],
        'L_HEADER_LOGGING_RULES_DATAPOINT' => $_LANGUAGE_ADMIN['L_HEADER_LOGGING_RULES_DATAPOINT'],
        'L_HEADER_LOGGING_RULES_VALUES' => $_LANGUAGE_ADMIN['L_HEADER_LOGGING_RULES_VALUES'],
        'L_HEADER_LOGGING_RULES_INTERVAL' => $_LANGUAGE_ADMIN['L_HEADER_LOGGING_RULES_INTERVAL'],
        'L_HEADER_LOGGING_RULES_LIFESPAN' => $_LANGUAGE_ADMIN['L_HEADER_LOGGING_RULES_LIFESPAN'],
        'L_HEADER_LOGGING_RULES_ONLYCHANGES' => $_LANGUAGE_ADMIN['L_HEADER_LOGGING_RULES_ONLYCHANGES'],
        'L_HEADER_LOGGING_RULES_DELETE' => $_LANGUAGE_ADMIN['L_HEADER_LOGGING_RULES_DELETE'],
        'L_LOGGING_RULE_CCUID' => $_LANGUAGE_ADMIN['L_LOGGING_RULE_CCUID'],
        'L_LOGGING_RULE_DEVICE' => $_LANGUAGE_ADMIN['L_LOGGING_RULE_DEVICE'],
        'L_LOGGING_RULE_DATAPOINT' => $_LANGUAGE_ADMIN['L_LOGGING_RULE_DATAPOINT'],
        'L_LOGGING_RULE_VALUE' => $_LANGUAGE_ADMIN['L_LOGGING_RULE_VALUE'],
        'L_LOGGING_RULE_INTERVAL' => $_LANGUAGE_ADMIN['L_LOGGING_RULE_INTERVAL'],
        'L_LOGGING_RULE_LIFESPAN' => $_LANGUAGE_ADMIN['L_LOGGING_RULE_LIFESPAN'],
        'L_LOGGING_RULE_ONLYCHANGES' => $_LANGUAGE_ADMIN['L_LOGGING_RULE_ONLYCHANGES'],
        'L_LOGGING_RULES_TESTER' => $_LANGUAGE_ADMIN['L_LOGGING_RULES_TESTER'],
        'L_LOGGING_RULES_TESTER_DESCRIPTION' => $_LANGUAGE_ADMIN['L_LOGGING_RULES_TESTER_DESCRIPTION'],
    ));

}

// </editor-fold>
/* -------------------------------------------------------------------------- */

// <editor-fold defaultstate="collapsed" desc="TASKS TAB">
function tasksTab()
{
    global $TEMPLATE, $_LANGUAGE, $_LANGUAGE_ADMIN;
    $TEMPLATE->setFilename('tasks.html');

    if (!isset($sql)) {
        $sql = @new SQL();
    }
    $request = $sql->queryRequest("SELECT * FROM " . HCS_TABLE_PREFIX . "Tasks ORDER BY Id DESC");

    foreach ($request as $task) {
        $TEMPLATE->assignBlockVariables('tasksArray', array(
            'ID' => $task['Id'],
            'CCU_ID' => $task['CcuId'],
            'NAME' => $task['Name'],
            'TYPE' => $task['Type'],
            'INTERFACE' => $task['Interface'],
            'DESIGNATOR' => $task['Designator'],
            'PARAMETER' => $task['Parameter'],
            'NEXT_EXECUTION' => $task['NextExecution'],
            'INTERVAL' => $task['ExecutionInterval'],
        ));
    }
    $request = $sql->queryRequest("SELECT Id, CcuName FROM " . HCS_TABLE_PREFIX . "CcuList");
    foreach ($request as $task) {
        $TEMPLATE->assignBlockVariables('ccuArray', array(
            'ID' => $task['Id'],
            'NAME' => $task['CcuName'],
        ));
    }


    $TEMPLATE->assignVariables(array(
        'L_DELETE_TASK_CONFIRM_TEXT' => sprintf($_LANGUAGE_ADMIN['L_DELETE_TASK_CONFIRM_TEXT'], '_ID_'),
        'L_TASKS_HEADER' => $_LANGUAGE_ADMIN['L_TASKS_HEADER'],
        'L_TASKS_EXPLANATION' => sprintf($_LANGUAGE_ADMIN['L_TASKS_EXPLANATION'], '<a id="taskerScriptButton" href="#">' . $_LANGUAGE_ADMIN['L_CCU_ABO_SCRIPT'] . '</a>'),
        'L_DELETE_TASK' => $_LANGUAGE_ADMIN['L_DELETE_TASK'],
        'L_EDIT_TASK' => $_LANGUAGE_ADMIN['L_EDIT_TASK'],
        'L_ADD_TASK' => $_LANGUAGE_ADMIN['L_ADD_TASK'],
        'L_TITLE_EDIT_TASK' => $_LANGUAGE_ADMIN['L_TITLE_EDIT_TASK'],
        'L_TITLE_ADD_TASK' => $_LANGUAGE_ADMIN['L_TITLE_ADD_TASK'],
        'L_HEADER_TASKS_ID' => $_LANGUAGE_ADMIN['L_HEADER_TASKS_ID'],
        'L_HEADER_TASKS_EDIT' => $_LANGUAGE_ADMIN['L_HEADER_TASKS_EDIT'],
        'L_HEADER_TASKS_EXECUTE' => $_LANGUAGE_ADMIN['L_HEADER_TASKS_EXECUTE'],
        'L_HEADER_TASKS_CCUID' => $_LANGUAGE_ADMIN['L_HEADER_TASKS_CCUID'],
        'L_HEADER_TASKS_NAME' => $_LANGUAGE_ADMIN['L_HEADER_TASKS_NAME'],
        'L_HEADER_TASKS_TYPE' => $_LANGUAGE_ADMIN['L_HEADER_TASKS_TYPE'],
        'L_HEADER_TASKS_INTERFACE' => $_LANGUAGE_ADMIN['L_HEADER_TASKS_INTERFACE'],
        'L_HEADER_TASKS_DESIGNATOR' => $_LANGUAGE_ADMIN['L_HEADER_TASKS_DESIGNATOR'],
        'L_HEADER_TASKS_PARAMETER' => $_LANGUAGE_ADMIN['L_HEADER_TASKS_PARAMETER'],
        'L_HEADER_TASKS_NEXT_EXECUTION' => $_LANGUAGE_ADMIN['L_HEADER_TASKS_NEXT_EXECUTION'],
        'L_HEADER_TASKS_INTERVAL' => $_LANGUAGE_ADMIN['L_HEADER_TASKS_INTERVAL'],
        'L_HEADER_TASKS_DELETE' => $_LANGUAGE_ADMIN['L_HEADER_TASKS_DELETE'],
        'L_TASK_CCUID' => $_LANGUAGE_ADMIN['L_TASK_CCUID'],
        'L_TASK_NAME' => $_LANGUAGE_ADMIN['L_TASK_NAME'],
        'L_TASK_TYPE' => $_LANGUAGE_ADMIN['L_TASK_TYPE'],
        'L_TASK_INTERFACE' => $_LANGUAGE_ADMIN['L_TASK_INTERFACE'],
        'L_TASK_DESIGNATOR' => $_LANGUAGE_ADMIN['L_TASK_DESIGNATOR'],
        'L_TASK_PARAMETER' => $_LANGUAGE_ADMIN['L_TASK_PARAMETER'],
        'L_TASK_NEXT_EXECUTION' => $_LANGUAGE_ADMIN['L_TASK_NEXT_EXECUTION'],
        'L_TASK_INTERVAL' => $_LANGUAGE_ADMIN['L_TASK_INTERVAL'],
        'L_EXECUTE_TASKER' => $_LANGUAGE_ADMIN['L_EXECUTE_TASKER'],
        'L_EXECUTE_TASK' => $_LANGUAGE_ADMIN['L_EXECUTE_TASK'],
        'L_TASKNAME_UPDATE_SUBSCRIPTION' => $_LANGUAGE_ADMIN['L_TASKNAME_UPDATE_SUBSCRIPTION'],
        'L_TASKNAME_UPDATE_ALL_SUBSCRIPTIONS' => $_LANGUAGE_ADMIN['L_TASKNAME_UPDATE_ALL_SUBSCRIPTIONS'],
        'L_TASKNAME_INIT' => $_LANGUAGE_ADMIN['L_TASKNAME_INIT'],
        'L_TASKNAME_DEINIT' => $_LANGUAGE_ADMIN['L_TASKNAME_DEINIT'],
        'L_TASKNAME_GET_VAULE_BY_NAME' => $_LANGUAGE_ADMIN['L_TASKNAME_GET_VAULE_BY_NAME'],
        'L_TASKNAME_GET_VAULE_BY_SN' => $_LANGUAGE_ADMIN['L_TASKNAME_GET_VAULE_BY_SN'],
        'L_TASKNAME_SET_VAULE_BY_NAME' => $_LANGUAGE_ADMIN['L_TASKNAME_SET_VAULE_BY_NAME'],
        'L_TASKNAME_SET_VAULE_BY_SN' => $_LANGUAGE_ADMIN['L_TASKNAME_SET_VAULE_BY_SN'],
        'L_TASKNAME_LOG_ALL_SYSVAR' => $_LANGUAGE_ADMIN['L_TASKNAME_LOG_ALL_SYSVAR'],
        'L_TASKNAME_LOG_SYSVAR' => $_LANGUAGE_ADMIN['L_TASKNAME_LOG_SYSVAR'],
        'L_TASKNAME_GET_SYSVAR' => $_LANGUAGE_ADMIN['L_TASKNAME_GET_SYSVAR'],
        'L_TASKNAME_SET_SYSVAR' => $_LANGUAGE_ADMIN['L_TASKNAME_SET_SYSVAR'],
        'L_TASKNAME_EXEC_PROGRAM' => $_LANGUAGE_ADMIN['L_TASKNAME_EXEC_PROGRAM'],
        'L_TASKNAME_UPDATE_LISTS_ROOMS' => $_LANGUAGE_ADMIN['L_TASKNAME_UPDATE_LISTS_ROOMS'],
        'L_TASKNAME_UPDATE_LIST_CRAFTS' => $_LANGUAGE_ADMIN['L_TASKNAME_UPDATE_LIST_CRAFTS'],
        'L_TASKNAME_UPDATE_LIST_PROGRAMS' => $_LANGUAGE_ADMIN['L_TASKNAME_UPDATE_LIST_PROGRAMS'],
        'L_TASKNAME_UPDATE_ALL_LISTS' => $_LANGUAGE_ADMIN['L_TASKNAME_UPDATE_ALL_LISTS'],
        'L_TASKNAME_UPDATE_LIST_DEVICES' => $_LANGUAGE_ADMIN['L_TASKNAME_UPDATE_LIST_DEVICES'],
        'L_TASKNAME_UPDATE_LIST_SYSVAR' => $_LANGUAGE_ADMIN['L_TASKNAME_UPDATE_LIST_SYSVAR'],
        'L_CCU_TASKER_SCRIPT_TITLE' => $_LANGUAGE_ADMIN['L_CCU_TASKER_SCRIPT_TITLE'],
        'L_CCU_TASKER_SCRIPT_TEXT1' => $_LANGUAGE_ADMIN['L_CCU_TASKER_SCRIPT_TEXT1'],
        'L_CCU_TASKER_SCRIPT_TEXT2' => $_LANGUAGE_ADMIN['L_CCU_TASKER_SCRIPT_TEXT2'],
        'SERVER_PATH' => HCS_SERVER_NAME . ':' . HCS_SERVER_PORT . HCS_SERVER_PATH
    ));

}

// </editor-fold>
/* -------------------------------------------------------------------------- */

// <editor-fold defaultstate="collapsed" desc="USERS TAB">
function usersTab()
{
    global $HCS_ROOTPATH, $_CONFIG, $TEMPLATE, $_LANGUAGE, $_LANGUAGE_ADMIN;
    $TEMPLATE->setFilename('users.html');

    if (!isset($sql)) {
        $sql = @new SQL();
    }
    $request = $sql->queryRequest("SELECT Username, EMail, Adminrights, Style, Language, LastLogin FROM " . HCS_TABLE_PREFIX . "Users");
    foreach ($request as $user) {
        $adminRights = ($user['Adminrights'] == 1) ? 'check">x' : 'minus">-';
        $TEMPLATE->assignBlockVariables('usersArray', array(
            'NAME' => $user['Username'],
            'EMAIL' => $user['EMail'],
            'ADMINRIGHTS' => $adminRights,
            'STYLE' => $user['Style'],
            'LANGUAGE' => $user['Language'],
            'LASTLOGIN' => $user['LastLogin'],
        ));
    }
    // installation language
    $path = $HCS_ROOTPATH . 'language/';
    $dir = @opendir($path);
    if ($dir) {
        while ($file = @readdir($dir)) {
            $folder = $path . $file;
            if ((!is_file($folder)) && (is_file($folder . '/page.php')) && (!is_link($folder)) && valid_folder($file)) {
                $TEMPLATE->assignBlockVariables('language', array(
                        'VALUE' => $file,
                        'OPTION' => ucfirst(strtolower($file)),
                        'SELECTED' => option_selected(strtolower($file) == strtolower($_CONFIG['language'])),
                    )
                );
            }
        }
    }

    // installation style
    $path = $HCS_ROOTPATH . 'style/';
    $dir = @opendir($path);
    if ($dir) {
        while ($file = @readdir($dir)) {
            $folder = $path . $file;
            if ((!is_file($folder)) && (is_file($folder . '/style.css')) && (!is_link($folder)) && valid_folder($file)) {
                $TEMPLATE->assignBlockVariables('style', array(
                        'VALUE' => $file,
                        'OPTION' => ucfirst(strtolower($file)),
                        'SELECTED' => option_selected(strtolower($file) == strtolower($_CONFIG['style'])),
                    )
                );
            }
        }
    }

    $TEMPLATE->assignVariables(array(
        'L_USERS_HEADER' => $_LANGUAGE_ADMIN['L_USERS_HEADER'],
        'L_USERS_EXPLANATION' => sprintf($_LANGUAGE_ADMIN['L_USERS_EXPLANATION'], '<a href="' . insertSessionId($HCS_ROOTPATH . 'admin/settings.php?tab=1') . '">' . $_LANGUAGE_ADMIN['L_ADMIN_TABNAME_1'] . '</a>'),
        'L_HEADER_USERNAME' => $_LANGUAGE_ADMIN['L_HEADER_USERNAME'],
        'L_HEADER_ADMINRIGHTS' => $_LANGUAGE_ADMIN['L_HEADER_ADMINRIGHTS'],
        'L_HEADER_EMAIL' => $_LANGUAGE_ADMIN['L_HEADER_EMAIL'],
        'L_HEADER_STYLE' => $_LANGUAGE_ADMIN['L_HEADER_STYLE'],
        'L_HEADER_LANGUAGE' => $_LANGUAGE_ADMIN['L_HEADER_LANGUAGE'],
        'L_HEADER_LASTLOGIN' => $_LANGUAGE_ADMIN['L_HEADER_LASTLOGIN'],
        'L_HEADER_EDIT_RIGHTS' => $_LANGUAGE_ADMIN['L_HEADER_EDIT_RIGHTS'],
        'L_HEADER_DELETE_USER' => $_LANGUAGE_ADMIN['L_HEADER_DELETE_USER'],
        'L_ADD_USER' => $_LANGUAGE_ADMIN['L_ADD_USER'],
        'L_EDIT_USER' => $_LANGUAGE_ADMIN['L_EDIT_USER'],
        'L_DELETE_USER' => $_LANGUAGE_ADMIN['L_DELETE_USER'],
        'L_DELETE_USER_CONFIRM_TEXT' => sprintf($_LANGUAGE_ADMIN['L_DELETE_USER_CONFIRM_TEXT'], '_USERNAME_'),
        'L_DELETE_USER_SELF_ERROR' => $_LANGUAGE_ADMIN['L_DELETE_USER_SELF_ERROR'],
        'L_PASSWORD' => $_LANGUAGE_ADMIN['L_PASSWORD'],
        'L_PASSWORD_CONFIRM' => $_LANGUAGE_ADMIN['L_PASSWORD_CONFIRM'],
        'L_USER_EMAIL_ERROR' => $_LANGUAGE_ADMIN['L_USER_EMAIL_ERROR'],
        'L_USER_PASSWORD_NO_MATCH' => $_LANGUAGE_ADMIN['L_USER_PASSWORD_NO_MATCH'],
        'L_ADMIN_RIGHTS' => $_LANGUAGE_ADMIN['L_ADMIN_RIGHTS'],
    ));

}

// </editor-fold>
/* -------------------------------------------------------------------------- */

// <editor-fold defaultstate="collapsed" desc="WIDGETS TAB">
function widgetsTab()
{
    global $TEMPLATE, $_LANGUAGE, $_LANGUAGE_ADMIN, $HCS_ROOTPATH;
    $TEMPLATE->setFilename('widgets.html');

    if (!isset($sql)) {
        $sql = @new SQL();
    }
    $request = $sql->queryRequest("SELECT Id, Name, Comment, Folder FROM " . HCS_TABLE_PREFIX . "WidgetPackets");
    foreach ($request as $widgetPacket) {
        $widgetRequests = $sql->queryRequest("SELECT Name, Description FROM " . HCS_TABLE_PREFIX . "Widgets WHERE PacketId = '" . $widgetPacket['Id'] . "'");
        $contentName = '';
        $contentDesc = '';
        $contentRest = '';
        $contentParts = count($widgetRequests);

        if ($contentParts >= 1) {
            $contentName = '<b>' . $widgetRequests[0]['Name'] . ':</b>';
            $contentDesc = $widgetRequests[0]['Description'];
            for ($i = 1; $i < count($widgetRequests); $i++) {
                $contentRest .= '<tr><th style="text-align: left;"><b>' . $widgetRequests[$i]['Name'] . ':</b></th><th style="text-align: left;">' . $widgetRequests[$i]['Description'] . '</th></tr>';
            }
        }

        $TEMPLATE->assignBlockVariables('widgetsArray', array(
            'ID' => $widgetPacket['Id'],
            'NAME' => $widgetPacket['Name'],
            'FOLDER' => $widgetPacket['Folder'],
            'COMMENT' => $widgetPacket['Comment'],
            'PARTS' => $contentParts,
            'CONTENT1_NAME' => $contentName,
            'CONTENT1_DESC' => $contentDesc,
            'CONTENT_REST' => $contentRest
        ));
    }

    $folders = glob($HCS_ROOTPATH . 'data/widgets/*', GLOB_ONLYDIR);
    if ($folders === false) {
        Logging::error('[Widgets] '.sprintf($_LANGUAGE_ADMIN['L_WIDGET_PACKET_CONTENT_NO_NAME'], $HCS_ROOTPATH . 'data/widgets/'));
    } else {
        $result = $sql->queryRequest("SELECT Folder FROM " . HCS_TABLE_PREFIX . "WidgetPackets;");
        foreach ($folders as $folder) {
            $found = false;
            $temp = substr(strrchr($folder, '/'), 1);
            foreach ($result as $packet) {
                if (strtolower($packet["Folder"]) == strtolower($temp)) {
                    $found = true;
                    break;
                }
            }
            if ($found) {
                continue;
            }


            $filename = $HCS_ROOTPATH . 'data/widgets/' . $temp . '/content.json';
            $fileContent = file_get_contents($filename);
            if ($fileContent !== false) {
                $content = json_decode($fileContent, true);
                if (isset($content["name"])) {
                    $TEMPLATE->assignBlockVariables('installableArray', array(
                        'NAME' => $content["name"],
                        'FOLDER' => $temp,
                    ));
                } else {
                    Logging::error('[Widgets] '.sprintf($_LANGUAGE_ADMIN['L_WIDGET_PACKET_CONTENT_NO_NAME'], $filename));
                }
            } else {
                Logging::error('[Widgets] '.sprintf($_LANGUAGE_ADMIN['L_WIDGET_PACKET_CONTENT_NOT_READABLE'], $filename));
            }
        }
    }

    $TEMPLATE->assignVariables(array(
        'L_WIDGET_PACKETS_EXPLANATION' => $_LANGUAGE_ADMIN['L_WIDGET_PACKETS_EXPLANATION'],
        'L_WIDGET_PACKETS_HEADER' => $_LANGUAGE_ADMIN['L_WIDGET_PACKETS_HEADER'],
        'L_HEADER_PACKET_NAME' => $_LANGUAGE_ADMIN['L_HEADER_PACKET_NAME'],
        'L_HEADER_COMMENT' => $_LANGUAGE_ADMIN['L_HEADER_COMMENT'],
        'L_HEADER_WIDGET_UPDATE' => $_LANGUAGE_ADMIN['L_HEADER_WIDGET_UPDATE'],
        'L_HEADER_CONTENT' => $_LANGUAGE_ADMIN['L_HEADER_CONTENT'],
        'L_HEADER_WIDGET_DEINSTALL' => $_LANGUAGE_ADMIN['L_HEADER_WIDGET_DEINSTALL'],
        'L_ADD_WIDGET_PACKETS' => $_LANGUAGE_ADMIN['L_ADD_WIDGET_PACKETS'],
        'L_UPDATE_WIDGET' => $_LANGUAGE_ADMIN['L_UPDATE_WIDGET'],
        'L_UPDATE_ALL_WIDGET_PACKETS' => $_LANGUAGE_ADMIN['L_UPDATE_ALL_WIDGET_PACKETS'],
        'L_DELETE_WIDGET_PACKET_CONFIRM_TEXT' => sprintf($_LANGUAGE_ADMIN['L_DELETE_WIDGET_PACKET_CONFIRM_TEXT'], '_PACKETNAME_'),
        'L_DEINSTALL_WIDGET' => $_LANGUAGE_ADMIN['L_DEINSTALL_WIDGET'],
        'L_ADD_WIDGET_PACKET_EXPLANATION' => $_LANGUAGE_ADMIN['L_ADD_WIDGET_PACKET_EXPLANATION'],
        'L_SELECT_WIDGET_PACKET' => $_LANGUAGE_ADMIN['L_SELECT_WIDGET_PACKET'],
        'L_ADD_PACKET' => $_LANGUAGE_ADMIN['L_ADD_PACKET'],
        'L_NO_WIDGET_PACKET_FOUND' => $_LANGUAGE_ADMIN['L_NO_WIDGET_PACKET_FOUND'],
    ));
}

// </editor-fold>
/* -------------------------------------------------------------------------- */

// <editor-fold defaultstate="collapsed" desc="SETTINGS TAB">
function settingsTab()
{
    global $HCS_ROOTPATH, $_CONFIG, $TEMPLATE, $_LANGUAGE_ADMIN;
    $TEMPLATE->setFilename('settings.html');

    // installation language
    $path = $HCS_ROOTPATH . 'language/';
    $dir = @opendir($path);
    if ($dir) {
        while ($file = @readdir($dir)) {
            $folder = $path . $file;
            if ((!is_file($folder)) && (is_file($folder . '/page.php')) && (!is_link($folder)) && valid_folder($file)) {
                $TEMPLATE->assignBlockVariables('languageSelect', array(
                        'VALUE' => $file,
                        'OPTION' => ucfirst(strtolower($file)),
                        'SELECTED' => option_selected(strtolower($file) == strtolower($_CONFIG['default_language'])),
                    )
                );
            }
        }
    }

    // installation style
    $path = $HCS_ROOTPATH . 'style/';
    $dir = @opendir($path);
    if ($dir) {
        while ($file = @readdir($dir)) {
            $folder = $path . $file;
            if ((!is_file($folder)) && (is_file($folder . '/style.css')) && (!is_link($folder)) && valid_folder($file)) {
                $TEMPLATE->assignBlockVariables('styleSelect', array(
                        'VALUE' => $file,
                        'OPTION' => ucfirst(strtolower($file)),
                        'SELECTED' => option_selected(strtolower($file) == strtolower($_CONFIG['default_style'])),
                    )
                );
            }
        }
    }

    $newestVersion = $_LANGUAGE_ADMIN['L_NEWEST_HCS_VERSION_UNKNOWN'];
    $versionText = HCS_VERSION;

    if (!isset($sql)) {
        $sql = @new SQL();
    }

    if ((bool)$_CONFIG['updateCheck']) {
        // only check if update check ist enabled
        if ($_CONFIG['checkedVersion'] == '') {
            $newestVersion = checkNewestHcsVersion($sql);
        } else {
            $newestVersion = $_CONFIG['checkedVersion'];
        }
        if ($newestVersion != '') {
            $comp = compareVersion($newestVersion, HCS_VERSION);
            if ($comp == 1) {
                $versionText = sprintf($_LANGUAGE_ADMIN['L_INSTALLED_HCS_VERSION_OLD'], HCS_VERSION);
            } elseif ($comp == -1) {
                $versionText = sprintf($_LANGUAGE_ADMIN['L_INSTALLED_HCS_VERSION_PRE'], HCS_VERSION);
            } else {
                $versionText = sprintf($_LANGUAGE_ADMIN['L_INSTALLED_HCS_VERSION_LATEST'], HCS_VERSION);
            }
        } else {
            $newestVersion = $_LANGUAGE_ADMIN['L_NEWEST_HCS_VERSION_ERROR'];
        }
    }

    $TEMPLATE->assignVariables(array(
        'L_DEFAULT_VALUES' => $_LANGUAGE_ADMIN['L_DEFAULT_VALUES'],
        'L_DEFAULT_LANGUAGE' => $_LANGUAGE_ADMIN['L_DEFAULT_LANGUAGE'],
        'L_DEFAULT_STYLE' => $_LANGUAGE_ADMIN['L_DEFAULT_STYLE'],
        'L_UPDATE_CHECK_TITLE' => $_LANGUAGE_ADMIN['L_UPDATE_CHECK_TITLE'],
        'L_UPDATE_CHECK_TEXT' => $_LANGUAGE_ADMIN['L_UPDATE_CHECK_TEXT'],
        'L_UPDATE_CHECK_STATUS' => (bool)$_CONFIG['updateCheck'] ? $_LANGUAGE_ADMIN['L_UPDATE_CHECK_STATUS_ON'] : $_LANGUAGE_ADMIN['L_UPDATE_CHECK_STATUS_OFF'],
        'L_UPDATE_CHECK_TOGGLE' => $_LANGUAGE_ADMIN['L_UPDATE_CHECK_TOGGLE'],
        'L_UPDATE_CHECK_INTERVAL_TEXT' => $_LANGUAGE_ADMIN['L_UPDATE_CHECK_INTERVAL_TEXT'],
        'L_UPDATE_CHECK_INTERVAL' => (int)$_CONFIG['updateCheckInterval'],
        'L_SET_UPDATE_CHECK_INTERVAL' => $_LANGUAGE_ADMIN['L_SET_UPDATE_CHECK_INTERVAL'],
        'L_NEWEST_HCS_VERSION_TEXT' => $_LANGUAGE_ADMIN['L_NEWEST_HCS_VERSION_TEXT'],
        'L_INSTALLED_HCS_VERSION_TEXT' => $_LANGUAGE_ADMIN['L_INSTALLED_HCS_VERSION_TEXT'],
        'L_INSTALLED_HCS_VERSION' => $versionText,
        'L_NEWEST_HCS_VERSION' => $newestVersion,
        'L_SHOW_UPDATE_ON_PAGE_TEXT' => $_LANGUAGE_ADMIN['L_SHOW_UPDATE_ON_PAGE_TEXT'],
        'L_SHOW_UPDATE_ON_PAGE_TOGGLE' => $_LANGUAGE_ADMIN['L_SHOW_UPDATE_ON_PAGE_TOGGLE'],
        'L_SHOW_UPDATE_ON_PAGE_STATUS' => (bool)$_CONFIG['showUpdateOnPage'] ? $_LANGUAGE_ADMIN['L_SHOW_UPDATE_ON_PAGE_STATUS_ON'] : $_LANGUAGE_ADMIN['L_SHOW_UPDATE_ON_PAGE_STATUS_OFF'],
        'L_EXPERT_VIEW_TEXT' => $_LANGUAGE_ADMIN['L_EXPERT_VIEW_TEXT'],
        'L_EXPERT_VIEW_TOGGLE' => $_LANGUAGE_ADMIN['L_EXPERT_VIEW_TOGGLE'],
        'L_EXPERT_VIEW_STATUS' => (bool)$_CONFIG['expertView'] ? $_LANGUAGE_ADMIN['L_SHOW_UPDATE_ON_PAGE_STATUS_ON'] : $_LANGUAGE_ADMIN['L_SHOW_UPDATE_ON_PAGE_STATUS_OFF'],
    ));

}

// </editor-fold>
/* -------------------------------------------------------------------------- */


$TEMPLATE->preparePageHeader();
$TEMPLATE->prepratePageTailAndDisplay();

// EOF
?>