<?php

define('HCS_CALLABLE_FILE', true);
$HCS_ROOTPATH = './';
include_once($HCS_ROOTPATH . 'common.php');
include_once($HCS_ROOTPATH . 'includes/php/async_functions.php');
include_once($HCS_ROOTPATH . 'includes/php/tasker_functions.php');
global $_LANGUAGE, $_LANGUAGE_ADMIN, $_LANGUAGE_ASYNC;
$loggedInUser = false;
$isAdmin = false;

$language = (isset($_CONFIG['language'])) ? $_CONFIG['language'] : ((isset($_SESSION['language'])) ? $_SESSION['language'] : (isset($_DEFAULTS['default_lang']) ? $_DEFAULTS['default_lang'] : 'german'));
if (!@include_once($HCS_ROOTPATH . 'language/' . $language . '/admin.php')) {
    $msg = 'Could not include the admin language files! Check to make sure that "' . $HCS_ROOTPATH . 'language/' . $language . '/admin.php" exists!';
    generateErrorMessage($msg);
    die($msg);
}
if (!@include_once($HCS_ROOTPATH . 'language/' . $language . '/async.php')) {
    $msg = 'Could not include the admin language files! Check to make sure that "' . $HCS_ROOTPATH . 'language/' . $language . '/async.php" exists!';
    generateErrorMessage($msg);
    die($msg);
}

//get command
$cmd = '';
checkedSet($cmd, $_GET['cmd']);
checkedSet($cmd, $_POST['cmd']);

if (!isset($sql)) {
    $sql = @new SQL();
}

if ($sql->isUserAdmin(getLoggedInUser($sql))) {
    $isAdmin = true;
}

//get page
$page = '';
$ref = array();
if (isset($_SERVER["HTTP_REFERER"])) {
    parse_str(parse_url($_SERVER["HTTP_REFERER"], PHP_URL_QUERY), $ref);
}

checkedSet($page, $ref["page"]);
checkedSet($page, $_GET['page']);
checkedSet($page, $_POST['page']);

if ($isAdmin !== true) {
    if ($page == '') {
        generateErrorMessage($_LANGUAGE_ASYNC['L_NO_PAGE_ID']);
    }

    $right = $sql->getPageRights($page);
    if ($right === false) {
        generateErrorMessage($_LANGUAGE_ASYNC['L_COULD_NOT_READ_STANDARD_RIGHTS']);
    }
    if ($right <= 0) {
        generateErrorMessage($_LANGUAGE_ASYNC['L_NO_RIGHTS']);
    }

    $controlCmds = array('setValueBySn', 'setValue', 'setValueByName', 'setSystemVar', 'setSysVar', 'executeProgram', 'execute', 'execProgram', 'exec');
    if (in_array($cmd, $controlCmds)) {
        if ($right < 2) {
            generateErrorMessage($_LANGUAGE_ASYNC['L_NO_CONTROL_RIGHTS']);
        }
    }
}


switch ($cmd) {
    case "test":
        Homematic_XmlRpc::init('192.168.0.2', '2001', '192.168.0.5/hcs/server.php', '3');
        break;

    case "dumpDevices":
        var_dump($sql->queryRequest("SELECT * FROM " . HCS_TABLE_PREFIX . "Channels;"));
        break;

    case "getPages":
        $result = $sql->queryRequest("SELECT Id, Name, Comment FROM " . HCS_TABLE_PREFIX . "Pages;");
        if ($result !== false) {
            generateReturnMessage(utf8_array_encode($result));
        } else {
            generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_GET_ROOMS_ERROR'], $ccu));
        }
        break;

    case "getFolderContent":
        $folder = '';
        checkedSet($folder, $_POST['folder']);
        checkedSet($folder, $_GET['folder']);
        if ($folder != '') {
            $result = array();
            foreach (scandir($folder) as $entry) {
                if (!is_dir($entry) && ($entry != null) && ($entry != 'null') && ($entry != '.') && ($entry != '..') && ( strpos($entry, '.db') === false )) {
                    $result[] = $entry;
                }
            }
            generateReturnMessage(utf8_array_encode($result));
        } else {
            generateErrorMessage("Fehler");
        }
        break;

    case "getDatapoints":
        $datapoints = '*';
        $operations = 7;
        checkedSet($datapoints, $_POST['dps']);
        checkedSet($datapoints, $_GET['dps']);
        checkedSet($operations, $_POST['ops']);
        checkedSet($operations, $_GET['ops']);
        if (($datapoints != '*')) {
            $result = $sql->queryRequest("SELECT c.CcuId AS ccu, d.Id AS devId, d.Address AS devAdr, d.Name AS devName, d.Type AS Type, d.Interface AS Port, c.Id AS Id, c.Address AS adr, c.Name AS Name, c.HssType AS HssType, c.Type AS cType, c.Direction AS Dir, c.Label AS Label, dp.Type AS Dp FROM (" . HCS_TABLE_PREFIX . "DataPoints AS dp LEFT JOIN (" . HCS_TABLE_PREFIX . "Channels AS c LEFT JOIN " . HCS_TABLE_PREFIX . "Devices AS d ON c.DeviceAddress = d.Address) ON c.Address = dp.ChannelAddress) WHERE (dp.Type IN ('" . implode("','", explode(',', $datapoints)) . "')) AND ((dp.Operations & " . (int)$operations . ") != 0);");
        } else {
            $result = $sql->queryRequest("SELECT c.CcuId AS ccu, d.Id AS devId, d.Address AS devAdr, d.Name AS devName, d.Type AS Type, d.Interface AS Port, c.Id AS Id, c.Address AS adr, c.Name AS Name, c.HssType AS HssType, c.Type AS cType, c.Direction AS Dir, c.Label AS Label, dp.Type AS Dp FROM (" . HCS_TABLE_PREFIX . "DataPoints AS dp LEFT JOIN (" . HCS_TABLE_PREFIX . "Channels AS c LEFT JOIN " . HCS_TABLE_PREFIX . "Devices AS d ON c.DeviceAddress = d.Address) ON c.Address = dp.ChannelAddress) WHERE (dp.Operations & " . (int)$operations . ") != 0;");
        }
        if ($result !== false) {
            $devices = array();

            foreach ($result as $item) {
                if (!isset($devices[$item['ccu']])) {
                    $devices[$item['ccu']] = array();

                    $ccu = $sql->queryRequest("SELECT CcuName FROM " . HCS_TABLE_PREFIX . "CcuList WHERE Id = " . (int)$item['ccu'] . ";");
                    $ccuName = '';
                    if (isset($ccu[0]["CcuName"]) && ($ccu[0]["CcuName"] != '')) {
                        $ccuName = $ccu[0]["CcuName"];
                    }
                    $devices[$item['ccu']]['CCU_NAME'] = $ccuName;
                }
                if (!isset($devices[$item['ccu']][$item['devAdr']])) {
                    $devices[$item['ccu']][$item['devAdr']] = array();
                }
                if (!isset($devices[$item['ccu']][$item['devAdr']]['Channels'][$item['adr']])) {
                    $devices[$item['ccu']][$item['devAdr']]['Channels'][$item['adr']] = array();
                }
                if (!isset($devices[$item['ccu']][$item['devAdr']]['Channels'][$item['adr']]['DPs'])) {
                    $devices[$item['ccu']][$item['devAdr']]['Channels'][$item['adr']]['DPs'] = array();
                }

                $devices[$item['ccu']][$item['devAdr']]['Id'] = utf8_encode($item['devId']);
                $devices[$item['ccu']][$item['devAdr']]['Name'] = utf8_encode($item['devName']);
                $devices[$item['ccu']][$item['devAdr']]['Type'] = utf8_encode($item['Type']);
                $devices[$item['ccu']][$item['devAdr']]['Port'] = utf8_encode($item['Port']);
                $devices[$item['ccu']][$item['devAdr']]['Channels'][$item['adr']]['Id'] = utf8_encode($item['Id']);
                $devices[$item['ccu']][$item['devAdr']]['Channels'][$item['adr']]['Name'] = utf8_encode($item['Name']);
                $devices[$item['ccu']][$item['devAdr']]['Channels'][$item['adr']]['Type'] = utf8_encode($item['cType']);
                $devices[$item['ccu']][$item['devAdr']]['Channels'][$item['adr']]['HssType'] = utf8_encode($item['HssType']);
                $devices[$item['ccu']][$item['devAdr']]['Channels'][$item['adr']]['Dir'] = utf8_encode($item['Dir']);
                $devices[$item['ccu']][$item['devAdr']]['Channels'][$item['adr']]['Label'] = utf8_encode($item['Label']);
                if (!in_array(utf8_encode($item['Dp']), $devices[$item['ccu']][$item['devAdr']]['Channels'][$item['adr']]['DPs'])) {
                    $devices[$item['ccu']][$item['devAdr']]['Channels'][$item['adr']]['DPs'][] = utf8_encode($item['Dp']);
                }
            }
            generateReturnMessage($devices);
        }

        break;

    case "getDevices":
        $ccu = '';
        checkedSet($ccu, $_POST['ccu']);
        checkedSet($ccu, $_GET['ccu']);
        if (($ccu != '')) {
            $result = $sql->queryRequest("SELECT d.Id AS devId, d.Address AS devAdr, d.Name AS devName, d.Type AS Type, d.Interface AS Port, c.Id AS Id, c.Address AS adr, c.Name AS Name, c.HssType AS HssType, c.Type AS cType, c.Direction AS Dir, c.Label AS Label FROM (" . HCS_TABLE_PREFIX . "Channels AS c LEFT JOIN " . HCS_TABLE_PREFIX . "Devices AS d ON c.DeviceAddress = d.Address) WHERE c.CcuId=" . $ccu . " AND d.CcuId=" . $ccu . ";");
        } else {
            $result = $sql->queryRequest("SELECT c.CcuId AS ccu, d.Id AS devId, d.Address AS devAdr, d.Name AS devName, d.Type AS Type, d.Interface AS Port, c.Id AS Id, c.Address AS adr, c.Name AS Name, c.HssType AS HssType, c.Type AS cType, c.Direction AS Dir, c.Label AS Label FROM (" . HCS_TABLE_PREFIX . "Channels AS c LEFT JOIN " . HCS_TABLE_PREFIX . "Devices AS d ON c.DeviceAddress = d.Address);");
        }

        if ($result !== false) {
            $devices = array();

            if (($ccu == '')) {
                foreach ($result as $item) {
                    if (!isset($devices[$item['ccu']])) {
                        $devices[$item['ccu']] = array();
                    }
                    if (!isset($devices[$item['ccu']][$item['devAdr']])) {
                        $devices[$item['ccu']][$item['devAdr']] = array();
                    }
                    if (!isset($devices[$item['ccu']][$item['devAdr']]['Channels'][$item['adr']])) {
                        $devices[$item['ccu']][$item['devAdr']]['Channels'][$item['adr']] = array();
                    }
                    $devices[$item['ccu']][$item['devAdr']]['Id'] = utf8_encode($item['devId']);
                    $devices[$item['ccu']][$item['devAdr']]['Name'] = utf8_encode($item['devName']);
                    $devices[$item['ccu']][$item['devAdr']]['Type'] = utf8_encode($item['Type']);
                    $devices[$item['ccu']][$item['devAdr']]['Port'] = utf8_encode($item['Port']);
                    $devices[$item['ccu']][$item['devAdr']]['Channels'][$item['adr']]['Id'] = utf8_encode($item['Id']);
                    $devices[$item['ccu']][$item['devAdr']]['Channels'][$item['adr']]['Name'] = utf8_encode($item['Name']);
                    $devices[$item['ccu']][$item['devAdr']]['Channels'][$item['adr']]['Type'] = utf8_encode($item['cType']);
                    $devices[$item['ccu']][$item['devAdr']]['Channels'][$item['adr']]['HssType'] = utf8_encode($item['HssType']);
                    $devices[$item['ccu']][$item['devAdr']]['Channels'][$item['adr']]['Dir'] = utf8_encode($item['Dir']);
                    $devices[$item['ccu']][$item['devAdr']]['Channels'][$item['adr']]['Label'] = utf8_encode($item['Label']);

                }
                generateReturnMessage($devices);
            } else {
                generateReturnMessage(utf8_array_encode($result));
            }
        } else {
            generateErrorMessage($_LANGUAGE_ASYNC['L_GET_DEVICES_ERROR']);
        }
        break;

    case "getRooms":
        $ccu = '';
        checkedSet($ccu, $_POST['ccu']);
        checkedSet($ccu, $_GET['ccu']);
        if (($ccu != '')) {
            $result = $sql->queryRequest("SELECT Id, Name, Description FROM " . HCS_TABLE_PREFIX . "Rooms WHERE CcuId=" . $ccu . ";");
        } else {
            $result = $sql->queryRequest("SELECT CcuId, Id, Name, Description FROM " . HCS_TABLE_PREFIX . "Rooms;");
        }
        if ($result !== false) {
            if (($ccu == '')) {
                $items = array();
                foreach ($result as $key => $item) {
                    if (!isset($items[$item['CcuId']])) {
                        $items[$item['CcuId']] = array();
                    }
                    if (!isset($items[$item['CcuId']][$key])) {
                        $items[$item['CcuId']][$key] = array();
                    }
                    $items[$item['CcuId']][$key] = utf8_array_encode($item);
                    unset($items[$item['CcuId']][$key]['CcuId']);
                }
                generateReturnMessage($items);
            } else {
                generateReturnMessage(utf8_array_encode($result));
            }
        } else {
            generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_GET_ROOMS_ERROR'], $ccu));
        }
        break;

    case "getCrafts":
        $ccu = '';
        checkedSet($ccu, $_POST['ccu']);
        checkedSet($ccu, $_GET['ccu']);
        if (($ccu != '')) {
            $result = $sql->queryRequest("SELECT Id, Name, Description FROM " . HCS_TABLE_PREFIX . "Crafts WHERE CcuId=" . $ccu . ";");
        } else {
            $result = $sql->queryRequest("SELECT CcuId, Id, Name, Description FROM " . HCS_TABLE_PREFIX . "Crafts;");
        }
        if ($result !== false) {
            if (($ccu == '')) {
                $items = array();
                foreach ($result as $key => $item) {
                    if (!isset($items[$item['CcuId']])) {
                        $items[$item['CcuId']] = array();
                    }
                    if (!isset($items[$item['CcuId']][$key])) {
                        $items[$item['CcuId']][$key] = array();
                    }
                    $items[$item['CcuId']][$key] = utf8_array_encode($item);
                    unset($items[$item['CcuId']][$key]['CcuId']);
                }
                generateReturnMessage($items);
            } else {
                generateReturnMessage(utf8_array_encode($result));
            }
        } else {
            generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_GET_CRAFTS_ERROR'], $ccu));
        }
        break;

    case "getPrograms":
        $ccu = '';
        checkedSet($ccu, $_POST['ccu']);
        checkedSet($ccu, $_GET['ccu']);
        if (($ccu != '')) {
            $result = $sql->queryRequest("SELECT Id, Name, Description FROM " . HCS_TABLE_PREFIX . "Programs WHERE CcuId=" . $ccu . ";");
        } else {
            $result = $sql->queryRequest("SELECT CcuId, Id, Name, Description FROM " . HCS_TABLE_PREFIX . "Programs;");
        }
        if ($result !== false) {
            if (($ccu == '')) {
                $items = array();
                foreach ($result as $key => $item) {
                    if (!isset($items[$item['CcuId']])) {
                        $items[$item['CcuId']] = array();
                    }
                    if (!isset($items[$item['CcuId']][$key])) {
                        $items[$item['CcuId']][$key] = array();
                    }
                    $items[$item['CcuId']][$key] = utf8_array_encode($item);
                    unset($items[$item['CcuId']][$key]['CcuId']);
                }
                generateReturnMessage($items);
            } else {
                generateReturnMessage(utf8_array_encode($result));
            }
        } else {
            generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_GET_PROGRAMS_ERROR'], $ccu));
        }
        break;

    case "getSystemVariables":
        $ccu = '';
        checkedSet($ccu, $_POST['ccu']);
        checkedSet($ccu, $_GET['ccu']);
        if (($ccu != '')) {
            $result = $sql->queryRequest("SELECT  Id, Name, Description, ValueMin, ValueMax, ValueUnit, ValueType, ValueSubType, ValueList FROM " . HCS_TABLE_PREFIX . "SystemVariables WHERE CcuId=" . $ccu . ";");
        } else {
            $result = $sql->queryRequest("SELECT CcuId, Id, Name, Description, ValueMin, ValueMax, ValueUnit, ValueType, ValueSubType, ValueList FROM " . HCS_TABLE_PREFIX . "SystemVariables;");
        }
        if ($result !== false) {
            if (($ccu == '')) {
                $items = array();
                foreach ($result as $key => $item) {
                    if (!isset($items[$item['CcuId']])) {
                        $items[$item['CcuId']] = array();
                    }
                    if (!isset($items[$item['CcuId']][$key])) {
                        $items[$item['CcuId']][$key] = array();
                    }
                    $items[$item['CcuId']][$key] = utf8_array_encode($item);
                    unset($items[$item['CcuId']][$key]['CcuId']);
                }
                generateReturnMessage($items);
            } else {
                generateReturnMessage(utf8_array_encode($result));
            }
        } else {
            generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_GET_SYSTEM_VARIABLES_ERROR'], $ccu));
        }
        break;

    case "getValueBySn":
        $ccu = '';
        $adr = '';
        $dp = '';
        checkedSet($ccu, $_POST['ccu']);
        checkedSet($adr, $_POST['adr']);
        checkedSet($dp, $_POST['dp']);
        checkedSet($ccu, $_GET['ccu']);
        checkedSet($adr, $_GET['adr']);
        checkedSet($dp, $_GET['dp']);
        if (($ccu != '') && ($adr != '') && ($dp != '')) {
            if ($adr == 'SYSTEM_VARIABLES') {
                $value = HomematicControl::getSystemVariable($ccu, HomematicControl::getSysVarNameById($ccu, $dp, $sql), $sql);
            } else {
                $value = HomematicControl::getValueBySn($ccu, $adr, $dp, "XML-RPC", $sql);
            }
            if ($value !== false) {
                generateReturnMessage($value);
            } else {
                $s = sprintf($_LANGUAGE_ASYNC['L_GET_VALUE_ERROR'], $ccu, $adr, $dp);
                generateErrorMessage($s);
            }
        } else {
            generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_WRONG_PARAMETER'], $cmd));
        }
        break;

    case "getValue":
    case "getValueByName":
        $ccu = '';
        $name = '';
        $dp = '';
        checkedSet($ccu, $_POST['ccu']);
        checkedSet($name, $_POST['name']);
        checkedSet($dp, $_POST['dp']);
        if (($ccu != '') && ($name != '') && ($dp != '')) {
            if ($name == 'SYSTEM_VARIABLES') {
                $value = HomematicControl::getSystemVariable($ccu, $dp, $sql);
            } else {
                $value = HomematicControl::getValueByName($ccu, $name, $dp, "XML-RPC", $sql);
            }
            if ($value !== false) {
                generateReturnMessage($value);
            } else {
                $s = sprintf($_LANGUAGE_ASYNC['L_GET_VALUE_ERROR'], $ccu, $name, $dp);
                generateErrorMessage($s);
            }
        } else {
            generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_WRONG_PARAMETER'], $cmd));
        }
        break;

    case "setValueBySn":
        $ccu = '';
        $adr = '';
        $dp = '';
        $val = '';
        checkedSet($ccu, $_POST['ccu']);
        checkedSet($adr, $_POST['adr']);
        checkedSet($dp, $_POST['dp']);
        checkedSet($val, $_POST['val']);
        checkedSet($ccu, $_GET['ccu']);
        checkedSet($adr, $_GET['adr']);
        checkedSet($dp, $_GET['dp']);
        checkedSet($val, $_GET['val']);
        if (($ccu != '') && ($adr != '') && ($dp != '') && ($val != '')) {
            if ($adr == 'SYSTEM_VARIABLES') {
                $result = HomematicControl::setSystemVariable($ccu, HomematicControl::getSysVarNameById($ccu, $dp, $sql), $val, $sql);
            } else {
                $result = HomematicControl::setValueBySn($ccu, $adr, $dp, $val, "XML-RPC", $sql);
            }
            if ($result !== false) {
                generateOK();
            } else {
                $s = sprintf($_LANGUAGE_ASYNC['L_SET_VALUE_ERROR'], $ccu, $adr, $dp, $val);
                generateErrorMessage($s);
            }
        } else {
            generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_WRONG_PARAMETER'], $cmd));
        }
        break;

    case "setValue":
    case "setValueByName":
        $ccu = '';
        $name = '';
        $dp = '';
        $val = '';
        checkedSet($ccu, $_POST['ccu']);
        checkedSet($name, $_POST['name']);
        checkedSet($dp, $_POST['dp']);
        checkedSet($val, $_POST['val']);
        checkedSet($ccu, $_GET['ccu']);
        checkedSet($name, $_GET['name']);
        checkedSet($dp, $_GET['dp']);
        checkedSet($val, $_GET['val']);
        if (($ccu != '') && ($name != '') && ($dp != '') && ($val != '')) {
            if ($name == 'SYSTEM_VARIABLES') {
                $result = HomematicControl::setSystemVariable($ccu, $dp, $val, $sql);
            } else {
                $result = HomematicControl::setValueByName($ccu, $name, $dp, $val, "XML-RPC", $sql);
            }
            if ($result !== false) {
                generateOK();
            } else {
                $s = sprintf($_LANGUAGE_ASYNC['L_SET_VALUE_ERROR'], $ccu, $name, $dp, $val);
                generateErrorMessage($s);
            }
        } else {
            generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_WRONG_PARAMETER'], $cmd));
        }
        break;

    case "getSystemVar":
    case "getSysVar":
        $ccu = '';
        $var = '';
        checkedSet($ccu, $_POST['ccu']);
        checkedSet($var, $_POST['var']);
        checkedSet($ccu, $_GET['ccu']);
        checkedSet($var, $_GET['var']);
        if (($ccu != '') && ($var != '')) {
            $value = HomematicControl::getSystemVariable($ccu, $var, $sql);
            if ($value !== false) {
                generateReturnMessage($value);
            } else {
                $s = sprintf($_LANGUAGE_ASYNC['L_GET_SYSTEM_VAR_ERROR'], $var);
                generateErrorMessage($s);
            }
        } else {
            generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_WRONG_PARAMETER'], $cmd));
        }
        break;

    case "setSystemVar":
    case "setSysVar":
        $ccu = '';
        $var = '';
        $val = '';
        checkedSet($ccu, $_POST['ccu']);
        checkedSet($var, $_POST['var']);
        checkedSet($val, $_POST['val']);
        checkedSet($ccu, $_GET['ccu']);
        checkedSet($var, $_GET['var']);
        checkedSet($val, $_GET['val']);
        if (($ccu != '') && ($var != '') && ($val != '')) {
            if (HomematicControl::setSystemVariable($ccu, $var, $val, $sql) !== false) {
                generateOK();
            } else {
                $s = sprintf($_LANGUAGE_ASYNC['L_SET_SYSTEM_VAR_ERROR'], $var, $val);
                generateErrorMessage($s);
            }
        } else {
            generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_WRONG_PARAMETER'], $cmd));
        }
        break;

    case "executeProgram":
    case "execute":
    case "execProgram":
    case "exec":
        $ccu = '';
        $prog = '';
        checkedSet($ccu, $_POST['ccu']);
        checkedSet($prog, $_POST['prog']);
        checkedSet($ccu, $_GET['ccu']);
        checkedSet($prog, $_GET['prog']);
        if (($ccu != '') && ($prog != '')) {
            if (HomematicControl::executeProgram($ccu, $prog, $sql) !== false) {
                generateOK();
            } else {
                $s = sprintf($_LANGUAGE_ASYNC['L_EXECUTE_PROGRAM_ERROR'], $prog);
                generateErrorMessage($s);
            }
        } else {
            generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_WRONG_PARAMETER'], $cmd));
        }
        break;

    case "getHistoryValueBySn":
        $ccu = '';
        $adr = '';
        $dp = '';
        $since = '';
        checkedSet($ccu, $_POST['ccu']);
        checkedSet($adr, $_POST['adr']);
        checkedSet($dp, $_POST['dp']);
        checkedSet($since, $_POST['since']);
        checkedSet($ccu, $_GET['ccu']);
        checkedSet($adr, $_GET['adr']);
        checkedSet($dp, $_GET['dp']);
        checkedSet($since, $_GET['since']);
        if (($ccu != '') && ($adr != '') && ($dp != '')) {
            if ($since != ''){
                $request = $sql->queryRequest("SELECT Value, Timestamp FROM " . HCS_TABLE_PREFIX . "HistoryStates WHERE (CcuId = " . $ccu . " AND ChannelAddress = '" . $adr . "' AND DataPoint = '" . $dp . "' AND Timestamp > '" . gmstrftime('%Y-%m-%d %H:%M:%S', $since / 1000) . "') ORDER BY Timestamp");
            } else {
                $request = $sql->queryRequest("SELECT Value, Timestamp FROM " . HCS_TABLE_PREFIX . "HistoryStates WHERE (CcuId = " . $ccu . " AND ChannelAddress = '" . $adr . "' AND DataPoint = '" . $dp . "') ORDER BY Timestamp");
            }
            $rows = array();
            foreach ($request as $data) {
                $rows[] = array(strtotime($data['Timestamp'])*1000, (float)booleanToInt($data['Value']));
            }

            $request = $sql->queryRequest("SELECT Value FROM " . HCS_TABLE_PREFIX . "CurrentStates WHERE (CcuId = " . $ccu . " AND ChannelAddress = '" . $adr . "' AND DataPoint = '" . $dp . "')");
            if (count($request) > 0 ){
                $rows[] = array(time()*1000, (float)booleanToInt($request[0]['Value']));
            }

            generateReturnMessage($rows);
        } else {
            generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_WRONG_PARAMETER'], $cmd));
        }
        break;


    default:
        generateErrorMessage(sprintf($_LANGUAGE_ASYNC['L_UNKNOWN_COMMAND'], $cmd));
        break;
}

header('HTTP/1.1 403 Forbidden');
header('Status: 403');
die("ERROR: Forbidden");

// EOF
?>