// DISPLAY AREA
function BS_ToggleButton(containerElement, eventHandler, globals, config, selfPath) {
    this.config = config;
    this.container = containerElement;
    this.path = selfPath;

    $(containerElement).empty();
    this.button = $('<div style="width:100px; height: 100px; border-width: 0px; background: 0px 0px url(' + this.path + 'images/button.png) no-repeat;" title="' + config.titleUnknown + '"></div>')
    $(containerElement).append(this.button);

}
BS_ToggleButton.prototype = new Widget;
BS_ToggleButton.prototype.constructor = BS_ToggleButton;

// CONFIG AREA
function BS_ToggleButton_CONFIG(containerElement, eventHandler, globals, selfPath) {
    var _this = this;
    this.container = containerElement;
    this.eventHandler = eventHandler;
    this.globals = globals;
    this.path = selfPath;

    this.config = {};
    this.config.ccu = "";
    this.config.adr = "";
    this.config.dp = "";

    this.config.setWhileUncertain = true;

    this.config.titleOn = "";
    this.config.titleOnExpected = "";
    this.config.titleOff = "";
    this.config.titleOffExpected = "";
    this.config.titleUnknown = "";


    this.id = randomString(16, 'aA');

    var spinnerPath = "url('" + this.globals["rootPath"] + "data/images/spinner.gif');";

    this.devicesDlg = $('<div id="' + _this.id + '_Devices"></div>')
        .append($('<div style="height:100%; width:100%; background: no-repeat center; background-image: ' + spinnerPath + '"></div>'))
        .dialog({resizable: true, height: 700, width: 'auto', modal: true, title: "Wähle Geräte Datenpunkt", autoOpen: false});

    $.getScript(selfPath + 'includes.js', function(){
        eventHandler.getDataPointDevices(function (param) {fillDevices(_this, param, true);}, 'STATE,LEVEL');
    });
}
BS_ToggleButton_CONFIG.prototype = new Widget_CONFIG;
BS_ToggleButton_CONFIG.prototype.constructor = BS_ToggleButton_CONFIG;

BS_ToggleButton_CONFIG.prototype.createContent = function () {
    var _this = this;

    $(this.container)
        .append($('<div></div>')
            .append($('<div style="float: left; width: 50px;"></div>')
                .append($('<label for="' + _this.id + '_ccu">CCU:</label>'))
                .append($('<br/>'))
                .append($('<input id="' + _this.id + '_ccu" style="width: 40px;" type="text" disabled/>').addClass("ui-widget-content ui-corner-all").val(this.config.ccu).blur(function () {
                    _this.config.ccu = $(this).val();
                }))
            )
            .append($('<div style="float: left; width: 210px;"></div>')
                .append($('<label for="' + _this.id + '_adr">Adresse:</label>'))
                .append($('<br/>'))
                .append($('<input id="' + _this.id + '_adr" style="width: 200px;" type="text" disabled/>').addClass("ui-widget-content ui-corner-all").val(this.config.adr).blur(function () {
                    _this.config.adr = $(this).val();
                }))
            )
            .append($('<div style="float: left; width: 160px;"></div>')
                .append($('<label for="' + _this.id + '_dp">DataPoint:</label>'))
                .append($('<br/>'))
                .append($('<input id="' + _this.id + '_dp" style="width: 150px;" type="text" disabled/>').addClass("ui-widget-content ui-corner-all").val(this.config.dp).blur(function () {
                    _this.config.dp = $(this).val();
                }))
            )
        )
        .append($('<div class="ui-helper-clearfix" />'))
        .append($('<br/>'))
        .append($('<div></div>')
            .append($('<button>Geräte DataPoint wählen</button>').button().click(function () {
                $(_this.devicesDlg).dialog('open');
            }))
        )
        .append($('<br/>'))
        .append($('<div class="ui-helper-clearfix" />'))
        .append($('<div class="expertView" style="font-weight: bold">Hover-Title:</div>'))
        .append($('<div class="expertView"></div>')
            .append($('<label for="' + _this.id + '_titleOn">An:</label>'))
            .append($('<br/>'))
            .append($('<input id="' + _this.id + '_titleOn" style="width:400px" type="text"/>').addClass("ui-widget-content ui-corner-all").val(this.config.titleOn).blur(function () {
                _this.config.titleOn = $(this).val();
            }))
        )
        .append($('<div class="expertView"></div>')
            .append($('<label for="' + _this.id + '_titleOnExpected">An (Vermutet):</label>'))
            .append($('<br/>'))
            .append($('<input id="' + _this.id + '_titleOnExpected" style="width:400px" type="text"/>').addClass("ui-widget-content ui-corner-all").val(this.config.titleOnExpected).blur(function () {
                _this.config.titleOnExpected = $(this).val();
            }))
        )
        .append($('<div class="expertView"></div>')
            .append($('<label for="' + _this.id + '_titleOff">Aus:</label>'))
            .append($('<br/>'))
            .append($('<input id="' + _this.id + '_titleOff" style="width:400px" type="text"/>').addClass("ui-widget-content ui-corner-all").val(this.config.titleOff).blur(function () {
                _this.config.titleOff = $(this).val();
            }))
        )
        .append($('<div class="expertView"></div>')
            .append($('<label for="' + _this.id + '_titleOffExpected">Aus (Vermutet):</label>'))
            .append($('<br/>'))
            .append($('<input id="' + _this.id + '_titleOffExpected" style="width:400px" type="text"/>').addClass("ui-widget-content ui-corner-all").val(this.config.titleOffExpected).blur(function () {
                _this.config.titleOffExpected = $(this).val();
            }))
        )
        .append($('<div class="expertView"></div>')
            .append($('<label for="' + _this.id + '_titleUnknown">Unbekannt:</label>'))
            .append($('<br/>'))
            .append($('<input id="' + _this.id + '_titleUnknown" style="width:400px" type="text"/>').addClass("ui-widget-content ui-corner-all").val(this.config.titleUnknown).blur(function () {
                _this.config.titleUnknown = $(this).val();
            }))
        )
    ;
};

BS_ToggleButton_CONFIG.prototype.createComment = function () {
    return this.deviceName;
};