function BS_Slider(containerElement, eventHandler, globals, config, selfPath) {
    this.config = config;
    this.container = containerElement;
    this.expected = true;
    this.level = 0;
    this.eventHandler = eventHandler;
    this.globals = globals;
    this.working = false;
    this.sending = false;
    this.sliding = false;
    this.pendingValue = false;
    this.config.orientation = 'horizontal' // horizontal, vertical
    this.path = selfPath;

    var _this = this;

    this.slider = $('<div style="height: 35px; background: url(' + this.path + 'images/slider.png) 0px 0px; border: none;" />').attr('title', this.config.title).slider({
        orientation: this.config.orientation,
        max: 100,
        min: 0,
        range: 'min',
        step: 5,
        start: function (event, ui){
            _this.pendingValue = false;
            _this.sliding = true;
        },
        slide: function (event, ui) {
            if (_this.sending == false) {
                _this.pendingValue = false;
                _this.setValue(ui.value);
            } else {
                _this.pendingValue = ui.value;
            }
        },
        stop: function (event, ui) {
            _this.pendingValue = false;
            _this.sliding = false;
            _this.setValue(ui.value);
        },
        animate: 'slow'
    })
        .removeClass('ui-corner-all ui-widget-content ui-widget ui-widget-content ui-state-default ui-widget-header')

        .find('.ui-slider-range')
        .removeClass('ui-corner-all ui-widget-content ui-widget ui-widget-content ui-state-default ui-widget-header')
        .css('background', 'url(' + this.path + 'images/slider.png) 0px -35px')
        .end()

        .find('.ui-slider-handle')
        .removeClass('ui-corner-all ui-widget-content ui-widget ui-widget-content ui-state-default ui-widget-header')
        .css('border', 'none')
        .css('background', 'none')
        .css('outline', 'none')
        .css('width', '30px')
        .css('height', '35px')
        .css('margin-left', '-15px')
        .css('top', '0px')
        .end()
    ;
    $(this.container).empty().append(this.slider);

    eventHandler.register(function (param) {
            _this.updateValue(param)
        },
        {
            "working": {"ccu": config.ccu, "adr": config.adr, "dp": "WORKING"},
            "value": {"ccu": config.ccu, "adr": config.adr, "dp": _this.config.dp}
        });
    if (this.globals['RIGHTS'] < 2) {
        $(this.slider).slider('disable');
    }
}
BS_Slider.prototype = new Widget;
BS_Slider.prototype.constructor = BS_Slider;

BS_Slider.prototype.setValue = function (value) {
    if (this.globals['RIGHTS'] >= 2) {
        this.eventHandler.setValueSn(this.config.ccu, this.config.adr, this.config.dp, (value / 100));
        this.sending = true;
        this.expected = true;
        this.working = true;
        this.level = value;
        this.updateSlider();
    }
};

BS_Slider.prototype.updateValue = function (value) {
    if (typeof value["working"] != "undefined") {
        if ((value["working"] == true) || (value["working"] == 'true')) {
            this.working = true;
        } else {
            this.working = false;
        }
    }
    if (typeof value["value"] != "undefined") {
        this.level = parseInt(100 * value["value"]);
        this.expected = false;
    }
    if (this.pendingValue !== false) {
        var temp = this.pendingValue;
        this.pendingValue = false;
        this.setValue(temp);
    } else {
        this.sending = false;
    }
    this.updateSlider();
};

BS_Slider.prototype.updateSlider = function () {
    if (!this.working) {
        if ((!this.sliding) && ($(this.slider).slider('value') != this.level)) {
            $(this.slider).slider('value', this.level);
        }
    }
};