function BS_ToggleButton(containerElement, eventHandler, globals, config, selfPath) {
    this.config = config;
    this.container = containerElement;
    this.expected = true;
    this.state = false;
    this.eventHandler = eventHandler;
    this.globals = globals;
    this.working = false;
    this.worker = false;
    this.path = selfPath;

    var _this = this;

    $(containerElement).empty();
    this.button = $('<div style="width:100px; height: 100px; border-width: 0px; background: 0px 0px url(' + this.path + 'images/button.png) no-repeat;" title="' + config.titleUnknown + '"></div>')
        .click(function () {
            _this.eventHandler.getValueSn(_this.config.ccu, _this.config.adr, _this.config.dp, function (param) {
                _this.updateValue({"state": param})
            });
        })
        .mousedown(function () {
            $(this).css('background-position', '-100px, 0px');
        })
        .mouseup(function () {
            $(this).css('background-position', '0px, 0px');
        });
    $(containerElement).append(this.button);

    if (_this.config.dp == 'LEVEL') {
        this.worker = true;
        eventHandler.register(function (param) {
                _this.updateValue(param)
            },
            {
                "working": {"ccu": config.ccu, "adr": config.adr, "dp": "WORKING"},
                "state": {"ccu": config.ccu, "adr": config.adr, "dp": _this.config.dp}
            });
    } else {
        eventHandler.register(function (param) {
                _this.updateValue(param);
            },
            {
                "state": {"ccu": config.ccu, "adr": config.adr, "dp": _this.config.dp}
            });
    }

}
BS_ToggleButton.prototype = new Widget;
BS_ToggleButton.prototype.constructor = BS_ToggleButton;

BS_ToggleButton.prototype.updateValue = function (value) {
    if (typeof value["working"] != "undefined") {
        if ((value["working"] == true) || (value["working"] == 'true')) {
            this.working = true;
        } else {
            this.working = false;
        }
    }
    if (typeof value["state"] != "undefined") {
        if ((value["state"] == true) || (value["state"] == 'true') || (value["state"] > 0)) {
            this.state = true;
        } else {
            this.state = false;
        }
        this.expected = false;
    }

    this.updateButton();
};

BS_ToggleButton.prototype.updateButton = function () {
    var _this = this;
    var mode = 'unknown';

    if (this.working) {
        return;
    }

    if (this.state && !this.expected) {
        mode = 'on';

    } else if (this.state && this.expected) {
        mode = 'expected on';

    } else if (!this.state && !this.expected) {
        mode = 'off';

    } else if (!this.state && this.expected) {
        mode = 'expected off';
    }

    switch (mode) {
        case "on":
            $(this.button)
                .css('background-position', '-200px, 0px')
                .mouseup(function () {
                    $(this).css('background-position', '-200px, 0px');
                })
                .mouseleave(function () {
                    $(this).css('background-position', '-200px, 0px');
                })
                .unbind('click')
                .unbind('mousedown')
                .click(function () {
                    if (_this.globals['RIGHTS'] >= 2) {
                        _this.eventHandler.setValueSn(_this.config.ccu, _this.config.adr, _this.config.dp, 0);
                        _this.state = false;
                        _this.expected = true;
                        _this.updateButton();
                        if (_this.worker) {
                            _this.working = true;
                        }
                    }
                })
                .title = this.config.titleOn;
            if (_this.globals['RIGHTS'] >= 2) {
                $(this.button).mousedown(function () {
                    $(this).css('background-position', '-300px, 0px');
                })
            }
            break;

        case "expected on":
            $(this.button)
                .css('background-position', '-400px, 0px')
                .mouseup(function () {
                    $(this).css('background-position', '-400px, 0px');
                })
                .mouseleave(function () {
                    $(this).css('background-position', '-400px, 0px');
                })
                .unbind('click')
                .unbind('mousedown')
                .click(function () {
                    if (_this.config.setWhileUncertain) {
                        if (_this.globals['RIGHTS'] >= 2) {
                            _this.eventHandler.setValueSn(_this.config.ccu, _this.config.adr, _this.config.dp, 0);
                            _this.state = false;
                            _this.expected = true;
                            _this.updateButton();
                            if (_this.worker) {
                                _this.working = true;
                            }
                        }
                    } else {
                        _this.eventHandler.getValueSn(_this.config.ccu, _this.config.adr, 'STATE', function (param) {
                            _this.updateValue({"state": param})
                        });
                    }
                })
                .title = this.config.titleOnExpected;
            if (_this.globals['RIGHTS'] >= 2) {
                $(this.button).mousedown(function () {
                    $(this).css('background-position', '-500px, 0px');
                })
            }
            break;

        case "off":
            $(this.button)
                .css('background-position', '-600px, 0px')
                .mouseup(function () {
                    $(this).css('background-position', '-600px, 0px');
                })
                .mouseleave(function () {
                    $(this).css('background-position', '-600px, 0px');
                })
                .unbind('click')
                .unbind('mousedown')
                .click(function () {
                    if (_this.globals['RIGHTS'] >= 2) {
                        _this.eventHandler.setValueSn(_this.config.ccu, _this.config.adr, _this.config.dp, 1);
                        _this.state = true;
                        _this.expected = true;
                        _this.updateButton();
                        if (_this.worker) {
                            _this.working = true;
                        }
                    }
                })
                .title = this.config.titleOff;
            if (_this.globals['RIGHTS'] >= 2) {
                $(this.button).mousedown(function () {
                    $(this).css('background-position', '-700px, 0px');
                })
            }
            break;

        case "expected off":
            $(this.button)
                .css('background-position', '-800px, 0px')
                .mouseup(function () {
                    $(this).css('background-position', '-800px, 0px');
                })
                .mouseleave(function () {
                    $(this).css('background-position', '-800px, 0px');
                })
                .unbind('click')
                .unbind('mousedown')
                .click(function () {
                    if (_this.config.setWhileUncertain) {
                        if (_this.globals['RIGHTS'] >= 2) {
                            _this.eventHandler.setValueSn(_this.config.ccu, _this.config.adr, _this.config.dp, 1);
                            _this.state = true;
                            _this.expected = true;
                            _this.updateButton();
                            if (_this.worker) {
                                _this.working = true;
                            }
                        }
                    } else {
                        _this.eventHandler.getValueSn(_this.config.ccu, _this.config.adr, _this.config.dp, function (param) {
                            _this.updateValue({"state": param})
                        });
                    }
                })
                .title = this.config.titleOffExpected;
            if (_this.globals['RIGHTS'] >= 2) {
                $(this.button).mousedown(function () {
                    $(this).css('background-position', '-900px, 0px');
                })
            }
            break;


    }
};