// DISPLAY AREA
function HCS_Controls_Control_Change_jQueryButton(containerElement, eventHandler, globals, config, selfPath) {
    this.config = config;
    this.container = containerElement;

    $(containerElement).append('<button title="' + config.title + '" style="' + config.style + '">' + config.text + '</button>');

    if (config.icon && config.icon != "") {
        $(containerElement).find("button").button().button("option", "icons", {primary: config.icon});
        if (config.text == "") {
            $(containerElement).find("button").button().button("option", "text", false);
        }
    } else {
        $(containerElement).find("button").button();
    }
}
HCS_Controls_Control_Change_jQueryButton.prototype = new Widget;
HCS_Controls_Control_Change_jQueryButton.prototype.constructor = HCS_Controls_Control_Change_jQueryButton;

// CONFIG AREA
function HCS_Controls_Control_Change_jQueryButton_CONFIG(containerElement, eventHandler, globals, selfPath) {
    var _this = this;
    this.container = containerElement;
    this.eventHandler = eventHandler;
    this.globals = globals;

    this.config = {};
    this.config.text = "";
    this.config.ccu = "";
    this.config.adr = "";
    this.config.dp = "";
    this.config.step = "0.1";
    this.config.changeType = "inc";
    this.config.extreme = "1";
    this.config.title = "";
    this.config.icon = "";
    this.config.style = "";
    this.id = randomString(16, 'aA');

    var spinnerPath = "url('" + this.globals["rootPath"] + "data/images/spinner.gif');";

    this.devicesDlg = $('<div id="' + _this.id + '_Devices"></div>')
        .append($('<div style="height:100%; width:100%; background: no-repeat center; background-image: ' + spinnerPath + '"></div>'))
        .dialog({resizable: true, height: 700, width: 'auto', modal: true, title: "Wähle Geräte DataPoint", autoOpen: false});
    this.iconDlg = $('<div></div>').append($('<div style="height:100%; width:100%; background: no-repeat center; background-image: ' + spinnerPath + '"></div>')).dialog({resizable: false, height: 'auto', width: '500', modal: true, title: "Icon", autoOpen: false});

    $.getScript(selfPath + 'includes.js', function(){
        eventHandler.getControllableDevices(function (param) {fillDevices(_this, param, true);});
        createIconDlgFunction(_this);
    });

}
HCS_Controls_Control_Change_jQueryButton_CONFIG.prototype = new Widget_CONFIG;
HCS_Controls_Control_Change_jQueryButton_CONFIG.prototype.constructor = HCS_Controls_Control_Change_jQueryButton_CONFIG;

HCS_Controls_Control_Change_jQueryButton_CONFIG.prototype.createContent = function () {
    var _this = this;

    $(this.container)
        .append($('<div></div>')
            .append($('<div style="float: left; width: 70px;"></div>')
                .append($('<label for="' + _this.id + '_ccu">CCU:</label>'))
                .append($('<br/>'))
                .append($('<input id="' + _this.id + '_ccu" style="width: 50px;" type="text" disabled/>').addClass("ui-widget-content ui-corner-all").val(this.config.ccu).blur(function () {
                    _this.config.ccu = $(this).val();
                }))
            )
            .append($('<div style="float: left; width: 170px;"></div>')
                .append($('<label for="' + _this.id + '_adr">Adresse:</label>'))
                .append($('<br/>'))
                .append($('<input id="' + _this.id + '_adr" style="width: 150px;" type="text" disabled/>').addClass("ui-widget-content ui-corner-all").val(this.config.adr).blur(function () {
                    _this.config.adr = $(this).val();
                }))
            )
            .append($('<div style="float: left; width: 170px;"></div>')
                .append($('<label for="' + _this.id + '_dp">DataPoint:</label>'))
                .append($('<br/>'))
                .append($('<input id="' + _this.id + '_dp" style="width: 150px;" type="text" disabled/>').addClass("ui-widget-content ui-corner-all").val(this.config.dp).blur(function () {
                    _this.config.dp = $(this).val();
                }))
            )
        )
        .append($('<div class="ui-helper-clearfix" />'))
        .append($('<br/>'))
        .append($('<div></div>')
            .append($('<button>Geräte DataPoint wählen</button>').button().click(function () {
                $(_this.devicesDlg).dialog('open');
            }))
            .append($('<br/>'))
        )
        .append($('<br/>'))
        .append($('<div></div>')
            .append($('<label for="' + _this.id + '_changeType">Typ: </label>'))
            .append($('<select id="' + _this.id + '_changeType" class="multiSelect" style="width: 120px;"/>')
                .append($('<option value="inc">erhöhen</option>'))
                .append($('<option value="dec">verringern</option>'))
                .val(this.config.changeType).bind("multiselectclick", function(event, ui){
                    _this.config.changeType = ui.value;
                }).blur(function () {
                    _this.config.changeType = $(this).val();
                })
            )
        )
        .append($('<br/>'))
        .append($('<div></div>')
            .append($('<label for="' + _this.id + '_step">Schrittweite: </label>'))
            .append($('<input id="' + _this.id + '_step" style="width:50px" type="text"/>').addClass("ui-widget-content ui-corner-all").val(this.config.step).blur(function () {
                _this.config.step = $(this).val();
            }))
            .append($('<label for="' + _this.id + '_extreme"> Extrem(Min/Max): </label>'))
            .append($('<input id="' + _this.id + '_extreme" style="width:50px" type="text"/>').addClass("ui-widget-content ui-corner-all").val(this.config.extreme).blur(function () {
                _this.config.extreme = $(this).val();
            }))
        )
        .append($('<div></div>')
            .append($('<div style="float: left;"></div>')
                .append($('<label for="' + _this.id + '_icon">Icon: </label>'))
                .append($('<br/>'))
                .append($('<button id ="' + _this.id + '_icon" style="height: 26px; width: 40px;"></button>').button().button("option", "icons", {primary: this.config.icon}).click(function () {
                    usrSelectIcon(_this, function (iconName) {
                        _this.config.icon = iconName;
                        $('#' + _this.id + '_icon').button("option", "icons", {primary: iconName})
                    });
                }))
            )
            .append($('<div style="float: left; margin-left: 10px"></div>')
                .append($('<label for="' + _this.id + '_text">Text:</label>'))
                .append($('<br/>'))
                .append($('<input id="' + _this.id + '_text" type="text" style="width:350px"/>').addClass("ui-widget-content ui-corner-all").val(this.config.text).blur(function () {
                    _this.config.text = $(this).val();
                }))
            )
        )
        .append($('<div class="ui-helper-clearfix" />'))
        .append($('<div class="expertView"></div>')
            .append($('<label for="' + _this.id + '_title">Hover-Title:</label>'))
            .append($('<br/>'))
            .append($('<input id="' + _this.id + '_title" type="text" style="width:400px"/>').addClass("ui-widget-content ui-corner-all").val(this.config.title).blur(function () {
                _this.config.title = $(this).val();
            }))
        )
        .append($('<div class="expertView"></div>')
            .append($('<label for="' + _this.id + '_css">CSS-Style:</label>'))
            .append($('<br/>'))
            .append($('<input id="' + _this.id + '_css" type="text" style="width:400px"/>').addClass("ui-widget-content ui-corner-all").val(this.config.style).blur(function () {
                _this.config.style = $(this).val();
            }))
        )
    ;
    $('.multiSelect').multiselect({multiple: false, header: false, selectedList: 1, minWidth: 'auto', height: 'auto', noneSelectedText: ' '});
};

HCS_Controls_Control_Change_jQueryButton_CONFIG.prototype.createComment = function () {
    return this.deviceName + (this.config.changeType == 'inc' ? ' erhöhen' : ' verringern') + ' um ' + this.config.step + ' bis zu ' + this.config.extreme;
};