// DISPLAY AREA
function HCS_Controls_Control_ExecuteProgram_jQueryButton(containerElement, eventHandler, globals, config) {
    this.config = config;
    this.container = containerElement;

    $(containerElement).append('<button title="' + config.title + '" style="' + config.style + '">' + config.text + '</button>');

    if (config.icon && config.icon != "") {
        $(containerElement).find("button").button().button("option", "icons", {primary: config.icon});
        if (config.text == "") {
            $(containerElement).find("button").button().button("option", "text", false);
        }
    } else {
        $(containerElement).find("button").button();
    }
}
HCS_Controls_Control_ExecuteProgram_jQueryButton.prototype = new Widget;
HCS_Controls_Control_ExecuteProgram_jQueryButton.prototype.constructor = HCS_Controls_Control_ExecuteProgram_jQueryButton;

// CONFIG AREA
function HCS_Controls_Control_ExecuteProgram_jQueryButton_CONFIG(containerElement, eventHandler, globals, selfPath) {
    var _this = this;
    this.container = containerElement;
    this.eventHandler = eventHandler;
    this.globals = globals;

    this.config = {};
    this.config.text = "";
    this.config.ccu = "";
    this.config.program = "";
    this.config.title = "";
    this.config.icon = "";
    this.config.style = "";
    this.id = randomString(16, 'aA');

    var spinnerPath = "url('" + this.globals["rootPath"] + "data/images/spinner.gif');";

    this.devicesDlg = $('<div id="' + _this.id + '_Devices"></div>')
        .append($('<div style="height:100%; width:100%; background: no-repeat center; background-image: ' + spinnerPath + '"></div>'))
        .dialog({resizable: true, height: 700, width: 'auto', modal: true, title: "Wähle Programm", autoOpen: false});

    eventHandler.getPrograms(function (param) {
        _this.fillContent(param)
    });
    this.iconDlg = $('<div></div>').append($('<div style="height:100%; width:100%; background: no-repeat center; background-image: ' + spinnerPath + '"></div>')).dialog({resizable: false, height: 'auto', width: '500', modal: true, title: "Icon", autoOpen: false});
    $.getScript(selfPath + 'includes.js', function(){
        createIconDlgFunction(_this);
    });

}
HCS_Controls_Control_ExecuteProgram_jQueryButton_CONFIG.prototype = new Widget_CONFIG;
HCS_Controls_Control_ExecuteProgram_jQueryButton_CONFIG.prototype.constructor = HCS_Controls_Control_ExecuteProgram_jQueryButton_CONFIG;


HCS_Controls_Control_ExecuteProgram_jQueryButton_CONFIG.prototype.fillContent = function (content) {
    $(this.devicesDlg).empty()
        .append($('<table class="ui-widget ui-widget-content"></table>')
            .append($('<thead></thead>')
                .append($('<tr class="ui-widget-header"></tr>')
                    .append($('<th style="min-width: 40px;">CCU</th>'))
                    .append($('<th>Programme</th>'))
                    .append($('<th>Bemerkung</th>'))
                )
            )
            .append($('<tbody id="' + this.id + '_tBody"></tbody>'))
        );

    var _this = this;

    for (var ccu in content) {
        var ccu1st = true;
        var cuuSpan = obj_len(content[ccu]);

        for (var program in content[ccu]) {
            var prgrm = content[ccu][program]['Name'];
            var desc = content[ccu][program]['Description'];
            var tr = $('#' + this.id + '_tBody').append($('<tr></tr>')).children().last();
            if (ccu1st) {
                // row count = alle also device * channel * dp
                $(tr).append($('<th rowspan="' + cuuSpan + '" style="font-weight: normal; border-bottom: #FFF thin dashed;">' + ccu + '</th>'));
            }

            $(tr).append($('<th style="font-weight: normal; border-bottom: #FFF thin dashed;">' + prgrm + '</th><th style="font-weight: normal; border-bottom: #FFF thin dashed;">' + desc + '</th>')
                .on('click', {pccu: ccu, pprgrm: prgrm}, function (e) {
                    $('#' + _this.id + '_ccu').val(e.data.pccu);
                    _this.config.ccu = e.data.pccu;

                    $('#' + _this.id + '_prgrm').val(e.data.pprgrm);
                    _this.config.program = e.data.pprgrm;

                    $(_this.devicesDlg).dialog('close');
                })
                .hover(function(){$(this).addClass('ui-state-hover');},function(){$(this).removeClass('ui-state-hover');})
                .mouseover(function() {$(this).css('cursor', 'pointer');})
            );
            ccu1st = false;
        }
    }
};

HCS_Controls_Control_ExecuteProgram_jQueryButton_CONFIG.prototype.createContent = function () {
    var _this = this;

    $(this.container)
        .append($('<div></div>')
            .append($('<div style="float: left; width: 70px;"></div>')
                .append($('<label for="' + _this.id + '_ccu">CCU:</label>'))
                .append($('<br/>'))
                .append($('<input id="' + _this.id + '_ccu" style="width: 50px;" type="text" disabled/>').addClass("ui-widget-content ui-corner-all").val(this.config.ccu).blur(function () {
                    _this.config.ccu = $(this).val();
                }))
            )
            .append($('<div style="float: left; width: 340px;"></div>')
                .append($('<label for="' + _this.id + '_prgrm">Programm:</label>'))
                .append($('<br/>'))
                .append($('<input id="' + _this.id + '_prgrm" style="width: 330px;" type="text" disabled/>').addClass("ui-widget-content ui-corner-all").val(this.config.program).blur(function () {
                    _this.config.program = $(this).val();
                }))
            )
        )
        .append($('<div class="ui-helper-clearfix" />'))
        .append($('<br/>'))
        .append($('<div></div>')
            .append($('<button>Programm auswählen</button>').button().click(function () {
                $(_this.devicesDlg).dialog('open');
            }))
            .append($('<br/>'))
        )
        .append($('<div></div>')
            .append($('<div style="float: left;"></div>')
                .append($('<label for="' + _this.id + '_icon">Icon: </label>'))
                .append($('<br/>'))
                .append($('<button id ="' + _this.id + '_icon" style="height: 26px; width: 40px;"></button>').button().button("option", "icons", {primary: this.config.icon}).click(function () {
                    usrSelectIcon(_this, function (iconName) {
                        _this.config.icon = iconName;
                        $('#' + _this.id + '_icon').button("option", "icons", {primary: iconName})
                    });
                }))
            )
            .append($('<div style="float: left; margin-left: 10px"></div>')
                .append($('<label for="' + _this.id + '_text">Text:</label>'))
                .append($('<br/>'))
                .append($('<input id="' + _this.id + '_text" type="text" style="width:350px"/>').addClass("ui-widget-content ui-corner-all").val(this.config.text).blur(function () {
                    _this.config.text = $(this).val();
                }))
            )
        )
        .append($('<div class="ui-helper-clearfix" />'))
        .append($('<div class="expertView"></div>')
            .append($('<label for="' + _this.id + '_title">Hover-Title:</label>'))
            .append($('<br/>'))
            .append($('<input id="' + _this.id + '_title" type="text" style="width:400px"/>').addClass("ui-widget-content ui-corner-all").val(this.config.title).blur(function () {
                _this.config.title = $(this).val();
            }))
        )
        .append($('<div class="expertView"></div>')
            .append($('<label for="' + _this.id + '_css">CSS-Style:</label>'))
            .append($('<br/>'))
            .append($('<input id="' + _this.id + '_css" type="text" style="width:400px"/>').addClass("ui-widget-content ui-corner-all").val(this.config.style).blur(function () {
                _this.config.style = $(this).val();
            }))
        )
    ;
};

HCS_Controls_Control_ExecuteProgram_jQueryButton_CONFIG.prototype.createComment = function () {
    return this.config.program;
};