// DISPLAY AREA
function HCS_Controls_Control_jQuerySlider(containerElement, eventHandler, globals, config, selfPath) {
    this.config = config;
    this.container = containerElement;
    this.config.orientation = 'horizontal' // horizontal, vertical

    this.slider = $('<div />').attr('title', this.config.title).attr('style', this.config.style).slider({
        orientation: this.config.orientation,
        animate: "fast",
        max: 100,
        min: 0,
        value: 35,
        range: 'min',
        disabled: true
    }).css({'opacity': '1'});
    $(this.container).empty().append(this.slider);

}
HCS_Controls_Control_jQuerySlider.prototype = new Widget;
HCS_Controls_Control_jQuerySlider.prototype.constructor = HCS_Controls_Control_jQuerySlider;

// CONFIG AREA
function HCS_Controls_Control_jQuerySlider_CONFIG(containerElement, eventHandler, globals, selfPath) {
    var _this = this;
    this.container = containerElement;
    this.eventHandler = eventHandler;
    this.globals = globals;
    this.selfPath = selfPath;

    this.config = {};
    this.config.text = "";
    this.config.ccu = "";
    this.config.adr = "";
    this.config.dp = "";
    this.config.val = "";
    this.config.title = "";
    this.config.icon = "";
    this.config.style = "";
    this.id = randomString(16, 'aA');

    var spinnerPath = "url('" + this.globals["rootPath"] + "data/images/spinner.gif');";

    this.devicesDlg = $('<div id="' + _this.id + '_Devices"></div>')
        .append($('<div style="height:100%; width:100%; background: no-repeat center; background-image: ' + spinnerPath + '"></div>'))
        .dialog({resizable: true, height: 700, width: 'auto', modal: true, title: "Gerät wählen", autoOpen: false});

    this.iconDlg = null;
    $.getScript(selfPath + 'includes.js', function(){
        eventHandler.getDataPointDevices(function (param) {fillDevices(_this, param, false);}, 'LEVEL');
    });
}
HCS_Controls_Control_jQuerySlider_CONFIG.prototype = new Widget_CONFIG;
HCS_Controls_Control_jQuerySlider_CONFIG.prototype.constructor = HCS_Controls_Control_jQuerySlider_CONFIG;

HCS_Controls_Control_jQuerySlider_CONFIG.prototype.createContent = function () {
    var _this = this;

    $(this.container)
        .append($('<div></div>')
            .append($('<div style="float: left; width: 70px;"></div>')
                .append($('<label for="' + _this.id + '_ccu">CCU:</label>'))
                .append($('<br/>'))
                .append($('<input id="' + _this.id + '_ccu" style="width: 50px;" type="text" disabled/>').addClass("ui-widget-content ui-corner-all").val(this.config.ccu).blur(function () {
                    _this.config.ccu = $(this).val();
                }))
            )
            .append($('<div style="float: left; width: 170px;"></div>')
                .append($('<label for="' + _this.id + '_adr">Adresse:</label>'))
                .append($('<br/>'))
                .append($('<input id="' + _this.id + '_adr" style="width: 150px;" type="text" disabled/>').addClass("ui-widget-content ui-corner-all").val(this.config.adr).blur(function () {
                    _this.config.adr = $(this).val();
                }))
            )
            .append($('<div style="float: left; width: 170px;"></div>')
                .append($('<label for="' + _this.id + '_dp">DataPoint:</label>'))
                .append($('<br/>'))
                .append($('<input id="' + _this.id + '_dp" style="width: 150px;" type="text" disabled/>').addClass("ui-widget-content ui-corner-all").val(this.config.dp).blur(function () {
                    _this.config.dp = $(this).val();
                }))
            )
        )
        .append($('<div class="ui-helper-clearfix" />'))
        .append($('<br/>'))
        .append($('<div></div>')
            .append($('<button>Geräte wählen</button>').button().click(function () {
                $(_this.devicesDlg).dialog('open');
            }))
            .append($('<br/>'))
        )
        .append($('<br class="expertView"/>'))
        .append($('<div class="expertView"></div>')
            .append($('<label for="' + _this.id + '_title">Hover-Title:</label>'))
            .append($('<br/>'))
            .append($('<input id="' + _this.id + '_title" type="text" style="width:400px"/>').addClass("ui-widget-content ui-corner-all").val(this.config.title).blur(function () {
                _this.config.title = $(this).val();
            }))
        )
        .append($('<div class="expertView"></div>')
            .append($('<label for="' + _this.id + '_css">CSS-Style:</label>'))
            .append($('<br/>'))
            .append($('<input id="' + _this.id + '_css" type="text" style="width:400px"/>').addClass("ui-widget-content ui-corner-all").val(this.config.style).blur(function () {
                _this.config.style = $(this).val();
            }))
        )
    ;
};

HCS_Controls_Control_jQuerySlider_CONFIG.prototype.createComment = function () {
    return this.deviceName;
};
