// DISPLAY AREA
function HCS_Controls_Control_Toggle_jQueryButton(containerElement, eventHandler, globals, config, selfPath) {
    this.config = config;
    this.container = containerElement;

    $(containerElement).empty();

    this.button = $('<button title="' + config.titleUnknown + '" style="' + config.style + '">' + config.textUnknown + '</button>')
        .button()
        .button("option", "icons", {primary: this.config.iconUnknown})

    if (config.text == "") {
        $(containerElement).find("button").button().button("option", "text", false);
    }
    $(containerElement).append(this.button);
    $(containerElement).css({"text-align": "center", "vertical-align": "middle"});

}
HCS_Controls_Control_Toggle_jQueryButton.prototype = new Widget;
HCS_Controls_Control_Toggle_jQueryButton.prototype.constructor = HCS_Controls_Control_Toggle_jQueryButton;

// CONFIG AREA
function HCS_Controls_Control_Toggle_jQueryButton_CONFIG(containerElement, eventHandler, globals, selfPath) {
    var _this = this;
    this.container = containerElement;
    this.eventHandler = eventHandler;
    this.globals = globals;

    this.config = {};
    this.config.ccu = "";
    this.config.adr = "";
    this.config.dp = "";

    this.config.setWhileUncertain = true;

    this.config.iconOn = "";
    this.config.textOn = "";
    this.config.titleOn = "";

    this.config.iconOnExpected = "";
    this.config.textOnExpected = "";
    this.config.titleOnExpected = "";

    this.config.iconOff = "";
    this.config.textOff = "";
    this.config.titleOff = "";

    this.config.iconOffExpected = "";
    this.config.textOffExpected = "";
    this.config.titleOffExpected = "";

    this.config.iconUnknown = "";
    this.config.textUnknown = "";
    this.config.titleUnknown = "";

    this.config.style = "";

    this.id = randomString(16, 'aA');

    var spinnerPath = "url('" + this.globals["rootPath"] + "data/images/spinner.gif');";

    this.devicesDlg = $('<div id="' + _this.id + '_Devices"></div>')
        .append($('<div style="height:100%; width:100%; background: no-repeat center; background-image: ' + spinnerPath + '"></div>'))
        .dialog({resizable: true, height: 700, width: 'auto', modal: true, title: "Wähle Geräte Datenpunkt", autoOpen: false});
    this.iconDlg = $('<div></div>').append($('<div style="height:100%; width:100%; background: no-repeat center; background-image: ' + spinnerPath + '"></div>')).dialog({resizable: false, height: 'auto', width: '500', modal: true, title: "Icon", autoOpen: false});

    $.getScript(selfPath + 'includes.js', function(){
        eventHandler.getDataPointDevices(function (param) {fillDevices(_this, param, true);}, 'STATE,LEVEL');
        createIconDlgFunction(_this);
    });
}
HCS_Controls_Control_Toggle_jQueryButton_CONFIG.prototype = new Widget_CONFIG;
HCS_Controls_Control_Toggle_jQueryButton_CONFIG.prototype.constructor = HCS_Controls_Control_Toggle_jQueryButton_CONFIG;

HCS_Controls_Control_Toggle_jQueryButton_CONFIG.prototype.createContent = function () {
    var _this = this;

    $(this.container)
        .append($('<div></div>')
            .append($('<div style="float: left; width: 50px;"></div>')
                .append($('<label for="' + _this.id + '_ccu">CCU:</label>'))
                .append($('<br/>'))
                .append($('<input id="' + _this.id + '_ccu" style="width: 40px;" type="text" disabled/>').addClass("ui-widget-content ui-corner-all").val(this.config.ccu).blur(function () {
                    _this.config.ccu = $(this).val();
                }))
            )
            .append($('<div style="float: left; width: 210px;"></div>')
                .append($('<label for="' + _this.id + '_adr">Adresse:</label>'))
                .append($('<br/>'))
                .append($('<input id="' + _this.id + '_adr" style="width: 200px;" type="text" disabled/>').addClass("ui-widget-content ui-corner-all").val(this.config.adr).blur(function () {
                    _this.config.adr = $(this).val();
                }))
            )
            .append($('<div style="float: left; width: 210px;"></div>')
                .append($('<label for="' + _this.id + '_dp">DataPoint:</label>'))
                .append($('<br/>'))
                .append($('<input id="' + _this.id + '_dp" style="width: 200px;" type="text" disabled/>').addClass("ui-widget-content ui-corner-all").val(this.config.dp).blur(function () {
                    _this.config.dp = $(this).val();
                }))
            )
        )
        .append($('<div class="ui-helper-clearfix" />'))
        .append($('<br/>'))
        .append($('<div></div>')
            .append($('<button>Geräte DataPoint wählen</button>').button().click(function () {
                $(_this.devicesDlg).dialog('open');
            }))
            .append($('<br/>'))
        )
        .append($('<div class="ui-helper-clearfix" />'))
        .append($('<div style="font-weight: bold">An:</div>'))
        .append($('<div></div>')
            .append($('<div style="float: left;"></div>')
                .append($('<label for="' + _this.id + '_iconOn">Icon: </label>'))
                .append($('<br/>'))
                .append($('<button id ="' + _this.id + '_iconOn" style="height: 26px; width: 40px;"></button>').button().button("option", "icons", {primary: this.config.iconOn}).click(function () {
                    usrSelectIcon(_this, function (iconName) {
                        _this.config.iconOn = iconName;
                        $('#' + _this.id + '_iconOn').button("option", "icons", {primary: iconName})
                    });
                }))
            )
            .append($('<div style="float: left; margin-left: 10px"></div>')
                .append($('<label for="' + _this.id + '_textOn">Text:</label>'))
                .append($('<br/>'))
                .append($('<input id="' + _this.id + '_textOn" type="text" style="width:200px"/>').addClass("ui-widget-content ui-corner-all").val(this.config.textOn).blur(function () {
                    _this.config.textOn = $(this).val();
                }))
            )
            .append($('<div class="expertView" style="float: left; margin-left: 10px"></div>')
                .append($('<label for="' + _this.id + '_titleOn">Title: </label>'))
                .append($('<br/>'))
                .append($('<input id="' + _this.id + '_titleOn" style="width:200px" type="text"/>').addClass("ui-widget-content ui-corner-all").val(this.config.titleOn).blur(function () {
                    _this.config.titleOn = $(this).val();
                }))
            )
        )
        .append($('<div class="ui-helper-clearfix" />'))
        .append($('<div style="font-weight: bold">An (Vermutet):</div>'))
        .append($('<div></div>')
            .append($('<div style="float: left;"></div>')
                .append($('<label for="' + _this.id + '_iconOnExpected">Icon: </label>'))
                .append($('<br/>'))
                .append($('<button id ="' + _this.id + '_iconOnExpected" style="height: 26px; width: 40px;"></button>').button().button("option", "icons", {primary: this.config.iconOnExpected}).click(function () {
                    usrSelectIcon(_this, function (iconName) {
                        _this.config.iconOnExpected = iconName;
                        $('#' + _this.id + '_iconOnExpected').button("option", "icons", {primary: iconName})
                    });
                }))
            )
            .append($('<div style="float: left; margin-left: 10px"></div>')
                .append($('<label for="' + _this.id + '_textOnExpected">Text:</label>'))
                .append($('<br/>'))
                .append($('<input id="' + _this.id + '_textOnExpected" type="text" style="width:200px"/>').addClass("ui-widget-content ui-corner-all").val(this.config.textOnExpected).blur(function () {
                    _this.config.textOnExpected = $(this).val();
                }))
            )
            .append($('<div class="expertView" style="float: left; margin-left: 10px"></div>')
                .append($('<label for="' + _this.id + '_titleOnExpected">Title: </label>'))
                .append($('<br/>'))
                .append($('<input id="' + _this.id + '_titleOnExpected" style="width:200px" type="text"/>').addClass("ui-widget-content ui-corner-all").val(this.config.titleOnExpected).blur(function () {
                    _this.config.titleOnExpected = $(this).val();
                }))
            )
        )
        .append($('<div class="ui-helper-clearfix" />'))
        .append($('<div style="font-weight: bold">Aus:</div>'))
        .append($('<div></div>')
            .append($('<div style="float: left;"></div>')
                .append($('<label for="' + _this.id + '_iconOff">Icon: </label>'))
                .append($('<br/>'))
                .append($('<button id ="' + _this.id + '_iconOff" style="height: 26px; width: 40px;"></button>').button().button("option", "icons", {primary: this.config.iconOff}).click(function () {
                    usrSelectIcon(_this, function (iconName) {
                        _this.config.iconOff = iconName;
                        $('#' + _this.id + '_iconOff').button("option", "icons", {primary: iconName})
                    });
                }))
            )
            .append($('<div style="float: left; margin-left: 10px"></div>')
                .append($('<label for="' + _this.id + '_textOff">Text:</label>'))
                .append($('<br/>'))
                .append($('<input id="' + _this.id + '_textOff" type="text" style="width:200px"/>').addClass("ui-widget-content ui-corner-all").val(this.config.textOff).blur(function () {
                    _this.config.textOff = $(this).val();
                }))
            )
            .append($('<div class="expertView" style="float: left; margin-left: 10px"></div>')
                .append($('<label for="' + _this.id + '_titleOff">Title: </label>'))
                .append($('<br/>'))
                .append($('<input id="' + _this.id + '_titleOff" style="width:200px" type="text"/>').addClass("ui-widget-content ui-corner-all").val(this.config.titleOff).blur(function () {
                    _this.config.titleOff = $(this).val();
                }))
            )
        )
        .append($('<div class="ui-helper-clearfix" />'))
        .append($('<div style="font-weight: bold">Aus (Vermutet):</div>'))
        .append($('<div></div>')
            .append($('<div style="float: left;"></div>')
                .append($('<label for="' + _this.id + '_iconOffExpected">Icon: </label>'))
                .append($('<br/>'))
                .append($('<button id ="' + _this.id + '_iconOffExpected" style="height: 26px; width: 40px;"></button>').button().button("option", "icons", {primary: this.config.iconOffExpected}).click(function () {
                    usrSelectIcon(_this, function (iconName) {
                        _this.config.iconOffExpected = iconName;
                        $('#' + _this.id + '_iconOffExpected').button("option", "icons", {primary: iconName})
                    });
                }))
            )
            .append($('<div style="float: left; margin-left: 10px"></div>')
                .append($('<label for="' + _this.id + '_textOffExpected">Text:</label>'))
                .append($('<br/>'))
                .append($('<input id="' + _this.id + '_textOffExpected" type="text" style="width:200px"/>').addClass("ui-widget-content ui-corner-all").val(this.config.textOffExpected).blur(function () {
                    _this.config.textOffExpected = $(this).val();
                }))
            )
            .append($('<div class="expertView" style="float: left; margin-left: 10px"></div>')
                .append($('<label for="' + _this.id + '_titleOffExpected">Title: </label>'))
                .append($('<br/>'))
                .append($('<input id="' + _this.id + '_titleOffExpected" style="width:200px" type="text"/>').addClass("ui-widget-content ui-corner-all").val(this.config.titleOffExpected).blur(function () {
                    _this.config.titleOffExpected = $(this).val();
                }))
            )
        )
        .append($('<div class="ui-helper-clearfix" />'))
        .append($('<div style="font-weight: bold">Unbekannt:</div>'))
        .append($('<div></div>')
            .append($('<div style="float: left;"></div>')
                .append($('<label for="' + _this.id + '_iconUnknown">Icon: </label>'))
                .append($('<br/>'))
                .append($('<button id ="' + _this.id + '_iconUnknown" style="height: 26px; width: 40px;"></button>').button().button("option", "icons", {primary: this.config.iconUnknown}).click(function () {
                    usrSelectIcon(_this, function (iconName) {
                        _this.config.iconUnknown = iconName;
                        $('#' + _this.id + '_iconUnknown').button("option", "icons", {primary: iconName})
                    });
                }))
            )
            .append($('<div style="float: left; margin-left: 10px"></div>')
                .append($('<label for="' + _this.id + '_textUnknown">Text:</label>'))
                .append($('<br/>'))
                .append($('<input id="' + _this.id + '_textUnknown" type="text" style="width:200px"/>').addClass("ui-widget-content ui-corner-all").val(this.config.textUnknown).blur(function () {
                    _this.config.textUnknown = $(this).val();
                }))
            )
            .append($('<div class="expertView" style="float: left; margin-left: 10px"></div>')
                .append($('<label for="' + _this.id + '_titleUnknown">Title: </label>'))
                .append($('<br/>'))
                .append($('<input id="' + _this.id + '_titleUnknown" style="width:200px" type="text"/>').addClass("ui-widget-content ui-corner-all").val(this.config.titleUnknown).blur(function () {
                    _this.config.titleUnknown = $(this).val();
                }))
            )
        )
        .append($('<div class="expertView"></div>')
            .append($('<label for="' + _this.id + '_css">CSS-Style:</label>'))
            .append($('<br/>'))
            .append($('<input id="' + _this.id + '_css" type="text" style="width:465px"/>').addClass("ui-widget-content ui-corner-all").val(this.config.style).blur(function () {
                _this.config.style = $(this).val();
            }))
        )
    ;
};

HCS_Controls_Control_Toggle_jQueryButton_CONFIG.prototype.createComment = function () {
    return this.deviceName;
};