function HCS_Controls_Image(containerElement, eventHandler, globals, config, selfPath) {
    var imageSrc = "";
    if (config["internImage"] === true) {
        imageSrc = globals["rootPath"] + config["imagePath"];
    } else {
        imageSrc = config["imagePath"];
    }

    $(containerElement).append('<img style="' + config["imgStyle"] + '" alt="' + config["alt"] + '" src="' + imageSrc + '" />');
}
HCS_Controls_Image.prototype = new Widget;
HCS_Controls_Image.prototype.constructor = HCS_Controls_Image;

// CONFIG AREA
function HCS_Controls_Image_CONFIG(containerElement, eventHandler, globals, selfPath) {
    this.container = containerElement;
    this.eventHandler = eventHandler;
    this.globals = globals;

    this.config = {};
    this.config.title = "";
    this.config.internImage = false;
    this.config.imagePath = "";
    this.config.alt = "";
    this.config.imgStyle = "";
    this.config.refreshInterval = 0;
    this.id = randomString(16, 'aA');
}
HCS_Controls_Image_CONFIG.prototype = new Widget_CONFIG;
HCS_Controls_Image_CONFIG.prototype.constructor = HCS_Controls_Image_CONFIG;

HCS_Controls_Image_CONFIG.prototype.createContent = function () {
    var _this = this;

    $(this.container)
        .append($('<div class="expertView"></div>')
            .append($('<label>Hover-Title:</label>')
                .append('<br/>')
                .append($('<input type="text" style="width:400px"/>').addClass("ui-widget-content ui-corner-all").val(this.config.title).blur(function () {
                    _this.config.title = $(this).val();
                }))
            )
        )
        .append($('<br/>'))
        .append($('<div style="font-weight: bold">Bild:</div>'))
        .append($('<div></div>')
            .append($('<div style="float: left; width: 60px;"></div>')
                .append($('<label>Intern:</label>')
                    .append('<br/>')
                    .append($('<input type="checkbox" id="' + _this.id + '_internImage"/>').click(function () {
                        _this.config.internImage = ($(this).prop("checked")) ? true : false;
                    }))
                )
            )
            .append($('<div style="float: left; width: 340px;"></div>')
                .append($('<label>Bild-Pfad:</label>')
                    .append('<br/>')
                    .append($('<input type="text" style="width:340px"/>').addClass("ui-widget-content ui-corner-all").val(this.config.imagePath).blur(function () {
                        _this.config.imagePath = $(this).val();
                    }))
                )
            )
        )
        .append($('<div class="expertView"></div>')
            .append($('<label>Bild Beschreibung (alt):</label>')
                .append('<br/>')
                .append($('<input type="text" style="width:400px"/>').addClass("ui-widget-content ui-corner-all").val(this.config.alt).blur(function () {
                    _this.config.alt = $(this).val();
                }))
            )
        )
        .append($('<div class="expertView"></div>')
            .append($('<label>CSS-Style:</label>')
                .append('<br/>')
                .append($('<input type="text" style="width:400px"/>').addClass("ui-widget-content ui-corner-all").val(this.config.imgStyle).blur(function () {
                    _this.config.imgStyle = $(this).val();
                }))
            )
        )
        .append($('<div></div>')
            .append($('<label>Refresh-Interval in Sekunden (0 = deaktiviert):</label>')
                .append('<br/>')
                .append($('<input id="' + _this.id + '_refreshInterval" type="text" style="width:100px"/>').addClass("ui-widget-content ui-corner-all").val(this.config.refreshInterval).blur(function () {
                    _this.config.refreshInterval = $(this).val();
                }))
            )
        )
    ;
    $('#' + _this.id + '_refreshInterval').spinner({min: 0, incremental: true}).removeClass("ui-widget-content ui-corner-all")
    $('#' + _this.id + '_internImage').checkbox().checkbox(boolToChecked(this.config.internImage));
};

HCS_Controls_Image_CONFIG.prototype.createComment = function () {
    return this.config.alt;
};
