function HCS_Controls_Link_Image(containerElement, eventHandler, globals, config, selfPath) {
    var imageSrc = "";
    if (config["internImage"] === true) {
        imageSrc = globals["rootPath"] + config["imagePath"];
    } else {
        imageSrc = config["imagePath"];
    }

    var linkImage = '<img style="' + config["imgStyle"] + '" alt="' + config["alt"] + '" src="' + imageSrc + '" />';

    $(containerElement).append('<a href="#" title="' + config["title"] + '" style="' + config["style"] + '">' + linkImage + '</a>');
}
HCS_Controls_Link_Image.prototype = new Widget;
HCS_Controls_Link_Image.prototype.constructor = HCS_Controls_Link_Image;

// CONFIG AREA
function HCS_Controls_Link_Image_CONFIG(containerElement, eventHandler, globals, selfPath) {
    this.container = containerElement;
    this.eventHandler = eventHandler;
    this.globals = globals;

    this.config = {};
    this.config.title = "";
    this.config.newWindow = false;
    this.config.href = "";
    this.config.intern = false;
    this.config.internParam = "";
    this.config.internImage = false;
    this.config.imagePath = "";
    this.config.alt = "";
    this.config.style = "";
    this.config.ImgStyle = "";
    this.id = randomString(16, 'aA');
}
HCS_Controls_Link_Image_CONFIG.prototype = new Widget_CONFIG;
HCS_Controls_Link_Image_CONFIG.prototype.constructor = HCS_Controls_Link_Image_CONFIG;


HCS_Controls_Link_Image_CONFIG.prototype.createContent = function () {
    var _this = this;

    $(this.container)

        .append($('<div class="expertView"></div>')
            .append($('<label for="' + _this.id + '_title">Hover-Title:</label>'))
            .append($('<br/>'))
            .append($('<input id="' + _this.id + '_title" type="text" style="width:400px"/>').addClass("ui-widget-content ui-corner-all").val(this.config.title).blur(function () {
                _this.config.title = $(this).val();
            }))
        )
        .append($('<br/>'))
        .append($('<div style="font-weight: bold">Bild:</div>'))
        .append($('<div></div>')
            .append($('<div style="float: left; width: 60px;"></div>')
                .append($('<label for="' + _this.id + '_internImage">Intern:</label>'))
                .append($('<br/>'))
                .append($('<input type="checkbox" id="' + _this.id + '_internImage"/>').click(function () {
                    _this.config.internImage = ($(this).prop("checked")) ? true : false;
                }))
            )
            .append($('<div style="float: left; width: 340px;"></div>')
                .append($('<label for="' + _this.id + '_imagePath">Bild-Pfad:</label>'))
                .append($('<br/>'))
                .append($('<input id="' + _this.id + '_imagePath" type="text" style="width:340px"/>').addClass("ui-widget-content ui-corner-all").val(this.config.imagePath).blur(function () {
                    _this.config.imagePath = $(this).val();
                }))
            )
        )
        .append($('<div class="expertView"></div>')
            .append($('<label for="' + _this.id + '_alt">Bild Beschreibung (alt):</label>'))
            .append($('<br/>'))
            .append($('<input id="' + _this.id + '_alt" type="text" style="width:400px"/>').addClass("ui-widget-content ui-corner-all").val(this.config.alt).blur(function () {
                _this.config.alt = $(this).val();
            }))
        )
        .append($('<div class="expertView"></div>')
            .append($('<label for="' + _this.id + '_imgCss">Bild CSS-Style:</label>'))
            .append($('<br/>'))
            .append($('<input id="' + _this.id + '_imgCss" type="text" style="width:400px"/>').addClass("ui-widget-content ui-corner-all").val(this.config.imgStyle).blur(function () {
                _this.config.imgStyle = $(this).val();
            }))
        )
        .append($('<div class="ui-helper-clearfix" />'))

        .append($('<br/>'))
        .append($('<div style="font-weight: bold">Link:</div>'))
        .append($('<div></div>')
            .append($('<div style="float: left; width: 60px;"></div>')
                .append($('<label for="' + _this.id + '_newWindow">Neu:</label>'))
                .append($('<br/>'))
                .append($('<input type="checkbox" id="' + _this.id + '_newWindow"/>').click(function () {
                    _this.config.newWindow = ($(this).prop("checked")) ? true : false;
                }))
            )
            .append($('<div style="float: left; width: 300px;"></div>')
                .append($('<label for="' + _this.id + '_href">Link Adresse (href):</label>'))
                .append($('<br/>'))
                .append($('<input id="' + _this.id + '_href" type="text" style="width:340px"/>').addClass("ui-widget-content ui-corner-all").val(this.config.href).blur(function () {
                    _this.config.href = $(this).val();
                }))
            )
        )
        .append($('<div></div>')
            .append($('<div style="float: left; width: 60px;"></div>')
                .append($('<label for="' + _this.id + '_intern">Intern:</label>'))
                .append($('<br/>'))
                .append($('<input type="checkbox" id="' + _this.id + '_intern"/>').click(function () {
                    _this.config.intern = ($(this).prop("checked")) ? true : false;
                }))
            )
            .append($('<div style="float: left; width: 300px;"></div>')
                .append($('<label for="' + _this.id + '_internParam">Interne Parameter:</label>'))
                .append($('<br/>'))
                .append($('<input id="' + _this.id + '_internParam" type="text" style="width:340px"/>').addClass("ui-widget-content ui-corner-all").val(this.config.internParam).blur(function () {
                    _this.config.internParam = $(this).val();
                }))
            )
        )
        .append($('<div class="expertView"></div>')
            .append($('<label for="' + _this.id + '_css">CSS-Style:</label>'))
            .append($('<br/>'))
            .append($('<input id="' + _this.id + '_css" type="text" style="width:400px"/>').addClass("ui-widget-content ui-corner-all").val(this.config.style).blur(function () {
                _this.config.style = $(this).val();
            }))
        )
    ;
    $('#' + _this.id + '_newWindow').checkbox().checkbox(boolToChecked(this.config.newWindow));
    $('#' + _this.id + '_intern').checkbox().checkbox(boolToChecked(this.config.intern));
    $('#' + _this.id + '_internImage').checkbox().checkbox(boolToChecked(this.config.internImage));
};

HCS_Controls_Link_Image_CONFIG.prototype.createComment = function () {
    return this.config.href;
};
