function HCS_Controls_Link_jQueryButton(containerElement, eventHandler, globals, config, selfPath) {
    $(containerElement).append('<a href="#" title="' + config["title"] + '" style="' + config["style"] + '">' + config["text"] + '</a>');
    var buttonEle = $(containerElement).find("a");
    buttonEle.button();

    if (config["icon"] && config["icon"] != "") {
        $(buttonEle).button("option", "icons", {primary: config["icon"]});
        if (config["text"] == "") {
            buttonEle.button("option", "text", false);
        }
    }
}

HCS_Controls_Link_jQueryButton.prototype = new Widget;
HCS_Controls_Link_jQueryButton.prototype.constructor = HCS_Controls_Link_jQueryButton;

// CONFIG AREA
function HCS_Controls_Link_jQueryButton_CONFIG(containerElement, eventHandler, globals, selfPath) {
    var _this = this;
    this.container = containerElement;
    this.eventHandler = eventHandler;
    this.globals = globals;

    this.config = {};
    this.config.icon = "";
    this.config.text = "";
    this.config.title = "";
    this.config.newWindow = false;
    this.config.href = "";
    this.config.intern = false;
    this.config.internParam = "";
    this.config.style = "";
    this.id = randomString(16, 'aA');

    var spinnerPath = "url('" + this.globals["rootPath"] + "data/images/spinner.gif');";
    this.iconDlg = $('<div></div>').append($('<div style="height:100%; width:100%; background: no-repeat center; background-image: ' + spinnerPath + '"></div>')).dialog({resizable: false, height: 'auto', width: '500', modal: true, title: "Icon", autoOpen: false});

    $.getScript(selfPath + 'includes.js', function(){
        createIconDlgFunction(_this);
    });

}
HCS_Controls_Link_jQueryButton_CONFIG.prototype = new Widget_CONFIG;
HCS_Controls_Link_jQueryButton_CONFIG.prototype.constructor = HCS_Controls_Link_jQueryButton_CONFIG;

HCS_Controls_Link_jQueryButton_CONFIG.prototype.createContent = function () {
    var _this = this;

    $(this.container)
        .append($('<div></div>')
            .append($('<div style="float: left;"></div>')
                .append($('<label for="' + _this.id + '_icon">Icon: </label>'))
                .append($('<br/>'))
                .append($('<button id ="' + _this.id + '_icon" style="height: 26px; width: 40px;"></button>').button().button("option", "icons", {primary: this.config.icon}).click(function () {
                    usrSelectIcon(_this, function (iconName) {
                        _this.config.icon = iconName;
                        $('#' + _this.id + '_icon').button("option", "icons", {primary: iconName})
                    });
                }))
            )
            .append($('<div style="float: left; margin-left: 10px"></div>')
                .append($('<label for="' + _this.id + '_text">Text:</label>'))
                .append($('<br/>'))
                .append($('<input id="' + _this.id + '_text" type="text" style="width:350px"/>').addClass("ui-widget-content ui-corner-all").val(this.config.text).blur(function () {
                    _this.config.text = $(this).val();
                }))
            )
        )
        .append($('<div class="expertView"></div>')
            .append($('<label for="' + _this.id + '_title">Title:</label>'))
            .append($('<br/>'))
            .append($('<input id="' + _this.id + '_title" type="text" style="width:400px"/>').addClass("ui-widget-content ui-corner-all").val(this.config.title).blur(function () {
                _this.config.title = $(this).val();
            }))
        )
        .append($('<br/>'))
        .append($('<div style="font-weight: bold">Link:</div>'))
        .append($('<div></div>')
            .append($('<div style="float: left; width: 60px;"></div>')
                .append($('<label for="' + _this.id + '_newWindow">New:</label>'))
                .append($('<br/>'))
                .append($('<input type="checkbox" id="' + _this.id + '_newWindow"/>').click(function () {
                    _this.config.newWindow = ($(this).prop("checked")) ? true : false;
                }))
            )
            .append($('<div style="float: left; width: 300px;"></div>')
                .append($('<label for="' + _this.id + '_href">hyperlink reference (href):</label>'))
                .append($('<br/>'))
                .append($('<input id="' + _this.id + '_href" type="text" style="width:340px"/>').addClass("ui-widget-content ui-corner-all").val(this.config.href).blur(function () {
                    _this.config.href = $(this).val();
                }))
            )
        )
        .append($('<div></div>')
            .append($('<div style="float: left; width: 60px;"></div>')
                .append($('<label for="' + _this.id + '_intern">Intern:</label>'))
                .append($('<br/>'))
                .append($('<input type="checkbox" id="' + _this.id + '_intern"/>').click(function () {
                    _this.config.intern = ($(this).prop("checked")) ? true : false;
                }))
            )
            .append($('<div style="float: left; width: 300px;"></div>')
                .append($('<label for="' + _this.id + '_internParam">Intern Parameter:</label>'))
                .append($('<br/>'))
                .append($('<input id="' + _this.id + '_internParam" type="text" style="width:340px"/>').addClass("ui-widget-content ui-corner-all").val(this.config.internParam).blur(function () {
                    _this.config.internParam = $(this).val();
                }))
            )
        )
        .append($('<div class="expertView"></div>')
            .append($('<label for="' + _this.id + '_css">CSS-Style:</label>'))
            .append($('<br/>'))
            .append($('<input id="' + _this.id + '_css" type="text" style="width:400px"/>').addClass("ui-widget-content ui-corner-all").val(this.config.style).blur(function () {
                _this.config.style = $(this).val();
            }))
        )

    ;
    $('#' + _this.id + '_newWindow').checkbox().checkbox(boolToChecked(this.config.newWindow));
    $('#' + _this.id + '_intern').checkbox().checkbox(boolToChecked(this.config.intern));
};

HCS_Controls_Link_jQueryButton_CONFIG.prototype.createComment = function () {
    return this.config.href;
};