function HCS_Controls_pageLink_jQueryButton(containerElement, eventHandler, globals, config, selfPath) {
    this.config = config;
    this.container = containerElement;

    $(containerElement).append('<button title="' + config.title + '" style="' + config.style + '">' + config.text + '</button>');

    if (config.icon && config.icon != "") {
        $(containerElement).find("button").button().button("option", "icons", {primary: config.icon});
        if (config.text == "") {
            $(containerElement).find("button").button().button("option", "text", false);
        }
    } else {
        $(containerElement).find("button").button();
    }
}

HCS_Controls_pageLink_jQueryButton.prototype = new Widget;
HCS_Controls_pageLink_jQueryButton.prototype.constructor = HCS_Controls_pageLink_jQueryButton;

function HCS_Controls_pageLink_jQueryButton_CONFIG(containerElement, eventHandler, globals, selfPath) {
    var _this = this;
    this.container = containerElement;
    this.eventHandler = eventHandler;
    this.globals = globals;

    this.config = {};

    this.config.newWindow = false;
    this.config.pageId = "";
    this.config.pageName = "";
    this.config.title = "";
    this.config.icon = "";
    this.config.text = "";
    this.config.style = "";

    this.id = randomString(16, 'aA');
    var spinnerPath = "url('" + this.globals["rootPath"] + "data/images/spinner.gif');";

    this.PageDlg = $('<div id="' + _this.id + '_PageDlg"></div>')
        .append($('<div style="height:100%; width:100%; background: no-repeat center; background-image: ' + spinnerPath + '"></div>'))
        .dialog({resizable: true, height: 700, width: 'auto', modal: true, title: "Steuerungsseite wählen", autoOpen: false});
    this.iconDlg = $('<div></div>').append($('<div style="height:100%; width:100%; background: no-repeat center; background-image: ' + spinnerPath + '"></div>')).dialog({resizable: false, height: 'auto', width: '500', modal: true, title: "Icon", autoOpen: false});

    $.getScript(selfPath + 'includes.js', function(){
        createIconDlgFunction(_this);
    });

    eventHandler.getPages(function (param) {
        _this.fillContent(param)
    });
}
HCS_Controls_pageLink_jQueryButton_CONFIG.prototype = new Widget_CONFIG;
HCS_Controls_pageLink_jQueryButton_CONFIG.prototype.constructor = HCS_Controls_pageLink_jQueryButton_CONFIG;

HCS_Controls_pageLink_jQueryButton_CONFIG.prototype.createContent = function () {
    var _this = this;

    $(this.container)
        .append($('<div></div>')
            .append($('<div style="float: left; width: 60px;"></div>')
                .append($('<label for="' + _this.id + '_newWindow">Neu:</label>'))
                .append($('<br/>'))
                .append($('<input type="checkbox" id="' + _this.id + '_newWindow"/>').click(function () {
                    _this.config.newWindow = ($(this).prop("checked")) ? true : false;
                }))
            )
            .append($('<div style="float: left; width: 300px;"></div>')
                .append($('<label for="' + _this.id + '_page">Steuerungsseite:</label>'))
                .append($('<br/>'))
                .append($('<input id="' + _this.id + '_page" type="text" style="width:340px" disabled/>').addClass("ui-widget-content ui-corner-all").val(this.config.pageName))
            )
        )
        .append($('<div class="ui-helper-clearfix" />'))
        .append($('<br/>'))
        .append($('<div></div>')
            .append($('<button>Steuerungsseite auswählen</button>').button().click(function () {
                $(_this.PageDlg).dialog('open');
            }))
            .append($('<br/>'))
        )
        .append($('<br/>'))
        .append($('<div style="font-weight: bold">Button:</div>'))
        .append($('<div></div>')
            .append($('<div style="float: left;"></div>')
                .append($('<label for="' + _this.id + '_icon">Icon: </label>'))
                .append($('<br/>'))
                .append($('<button id ="' + _this.id + '_icon" style="height: 26px; width: 40px;"></button>').button().button("option", "icons", {primary: this.config.icon}).click(function () {
                    usrSelectIcon(_this, function (iconName) {
                        _this.config.icon = iconName;
                        $('#' + _this.id + '_icon').button("option", "icons", {primary: iconName})
                    });
                }))
            )
            .append($('<div style="float: left; margin-left: 10px"></div>')
                .append($('<label for="' + _this.id + '_text">Text:</label>'))
                .append($('<br/>'))
                .append($('<input id="' + _this.id + '_text" type="text" style="width:350px"/>').addClass("ui-widget-content ui-corner-all").val(this.config.text).blur(function () {
                    _this.config.text = $(this).val();
                }))
            )
        )
        .append($('<div class="expertView"></div>')
            .append($('<label for="' + _this.id + '_title">Title:</label>'))
            .append($('<br/>'))
            .append($('<input id="' + _this.id + '_title" type="text" style="width:400px"/>').addClass("ui-widget-content ui-corner-all").val(this.config.title).blur(function () {
                _this.config.title = $(this).val();
            }))
        )
        .append($('<div class="expertView"></div>')
            .append($('<label for="' + _this.id + '_css">CSS-Style:</label>'))
            .append($('<br/>'))
            .append($('<input id="' + _this.id + '_css" type="text" style="width:400px"/>').addClass("ui-widget-content ui-corner-all").val(this.config.style).blur(function () {
                _this.config.style = $(this).val();
            }))
        )

    ;
    $('#' + _this.id + '_newWindow').checkbox().checkbox(boolToChecked(this.config.newWindow));
};

HCS_Controls_pageLink_jQueryButton_CONFIG.prototype.fillContent = function (content) {
    $(this.PageDlg).empty()
        .append($('<table class="ui-widget ui-widget-content"></table>')
            .append($('<thead></thead>')
                .append($('<tr class="ui-widget-header"></tr>')
                    .append($('<th style="min-width: 40px;">ID</th>'))
                    .append($('<th>Name</th>'))
                    .append($('<th>Kommentar</th>'))
                )
            )
            .append($('<tbody id="' + this.id + '_tBody"></tbody>'))
        );

    var _this = this;

    for (var pageIndex in content) {
        var tr = $('#' + this.id + '_tBody').append($('<tr></tr>')).children().last();

        $(tr).append($('<th style="font-weight: normal; border-bottom: #FFF thin dashed;">' + content[pageIndex]['Id'] + '</th>'))
            .append($('<th style="font-weight: normal; border-bottom: #FFF thin dashed;">' + content[pageIndex]['Name'] + '</th>'))
            .append($('<th style="font-weight: normal; border-bottom: #FFF thin dashed;">' + content[pageIndex]['Comment'] + '</th>'))
            .on('click', {pId: content[pageIndex]['Id'], pName: content[pageIndex]['Name']}, function (e) {
                $('#' + _this.id + '_page').val(e.data.pName);
                _this.config.pageName = e.data.pName;
                _this.config.pageId = e.data.pId;

                $(_this.PageDlg).dialog('close');
            })
            .hover(function(){$(this).addClass('ui-state-hover');},function(){$(this).removeClass('ui-state-hover');})
            .mouseover(function() {$(this).css('cursor', 'pointer');})
        ;
    }
};

HCS_Controls_pageLink_jQueryButton_CONFIG.prototype.createComment = function () {
    return this.config.pageName;
};