// DISPLAY AREA
function HCS_Controls_Status_Text(containerElement, eventHandler, globals, config, selfPath) {
    this.config = config;
    this.container = containerElement;
    this.config.position = parseInt(this.config.position);

    if ((this.config.position < 1) || (this.config.position > 9)) {
        this.config.position = 1;
    }

    $(this.container).empty();
    this.span = $('<span style="' + this.config.style + '" />').css({
        'color': this.config.color,
        'font-size': this.config.fontSize,
        'font-family': this.config.fontFamily,
        'font-weight': this.config.fontWeight,
        'position': 'absolute',
        'line-height': this.config.fontSize
    }).append(this.config.text);
    $(this.container).append(this.span);

    if ((this.config.position <= 6)) {
        $(this.span).css({'left': '0'});
    }
    if ((this.config.position >= 4)) {
        $(this.span).css({'right': '0'});
    }
    if ((this.config.position == 4) || (this.config.position == 5) || (this.config.position == 6)) {
        $(this.span).css({'text-align': 'center'});
    }
    if ((this.config.position == 2) || (this.config.position == 5) || (this.config.position == 8)) {
        $(this.span).css({
            'top': '50%',
            'margin-top': '-' + parseInt($(this.span).height() / 2) + 'px'
        });
    }
    if ((this.config.position == 3) || (this.config.position == 6) || (this.config.position == 9)) {
        $(this.span).css({'bottom': '0'});
    }
}
HCS_Controls_Status_Text.prototype = new Widget;
HCS_Controls_Status_Text.prototype.constructor = HCS_Controls_Status_Text;

// CONFIG AREA
function HCS_Controls_Status_Text_CONFIG(containerElement, eventHandler, globals, selfPath) {
    var _this = this;
    this.container = containerElement;
    this.eventHandler = eventHandler;
    this.globals = globals;

    this.config = {};
    this.config.replace = "{}";
    this.config.value = "%VALUE%";
    this.config.text = "%VALUE%";
    this.config.ccu = "";
    this.config.adr = "";
    this.config.dp = "";
    this.config.style = "";
    this.config.position = 1;
    this.config.NoPointerEvent = 0;
    this.config.color = colorToHex(getCSS('color', 'ui-widget-content'));
    this.config.fontSize = getCSS('font-size', 'ui-widget');
    this.config.fontFamily = getCSS('font-family', 'ui-widget');
    this.config.fontWeight = getCSS('font-weight', 'ui-widget-content');
    this.id = randomString(16, 'aA');
    this.replaceObj = null;

    var spinnerPath = "url('" + this.globals["rootPath"] + "data/images/spinner.gif');";

    this.devicesDlg = $('<div id="' + _this.id + '_Devices"></div>')
        .append($('<div style="height:100%; width:100%; background: no-repeat center; background-image: ' + spinnerPath + '"></div>'))
        .dialog({resizable: true, height: 700, width: 'auto', modal: true, title: "Select Device DataPoint", autoOpen: false});

    $.getScript(selfPath + 'includes.js', function(){
        eventHandler.getDataPointDevices(function (param) {fillDevices(_this, param, true);}, '*');
    });

    this.replaceDlg = $('<div />')
        .append($('<div></div>')
            .append($('<div>Wertebereich mit Komma trennen bspw. 1 bis 10: <b>1,10</b></div>'))
            .append($('<div style="float: left; width: 150px;"></div>')
                .append($('<label for="' + _this.id + '_repaceValue">Wert:</label>'))
                .append($('<br/>'))
                .append($('<input id="' + _this.id + '_repaceValue" style="width: 140px;" type="text"/>').addClass("ui-widget-content ui-corner-all"))
            )
            .append($('<div style="float: left; width: 300px;"></div>')
                .append($('<label for="' + _this.id + '_replaceString">ersetzen mit:</label>'))
                .append($('<div style="line-height:30px; height: 30px"></div>')
                    .append($('<input id="' + _this.id + '_replaceString" type="text" style="width:250px"/>').addClass("ui-widget-content ui-corner-all"))
                    .append($('<button style="margin-left: 5px; height: 28px; top: -2px; width: 36px;"/>').button().button("option", "icons", {primary: 'ui-icon-circle-plus'}).click(function () {
                        _this.replaceObj[$('#' + _this.id + '_repaceValue').val()] = $('#' + _this.id + '_replaceString').val();
                        $('#' + _this.id + '_repaceValue').val('');
                        $('#' + _this.id + '_replaceString').val('');
                        _this.fillReplace();
                    }))
                )
            )
        )
        .append('<div class="ui-helper-clearfix" />')
        .append('<br/>')
        .append($('<table style="width: 100%" class="ui-widget ui-widget-content StateTable"></table>')
            .append($('<thead></thead>')
                .append($('<tr class="ui-widget-header"></tr>')
                    .append('<th>Wert</th>')
                    .append('<th>wird ersetzt mit</th>')
                    .append('<th style="width: 100px;">Entfernen</th>')
                )
            )
            .append($('<tbody id="replaceHeader"></tbody>'))
        )
        .dialog({
            resizable: false,
            height: 'auto',
            width: '500',
            modal: true,
            title: "Werte ersetzen",
            autoOpen: false,
            open: function () {
                _this.replaceObj = hcs_parseJSON(_this.config.replace);
                _this.fillReplace();
            },
            buttons: {
                "Abbrechen": function () {
                    $(this).dialog('close');
                },
                "Speichern": function () {
                    var replaceString = JSON.stringify(_this.replaceObj);

                    $('#' + _this.id + '_replace').val(replaceString);
                    _this.config.replace = replaceString;
                    $(this).dialog('close');
                }
            }
        });
}
HCS_Controls_Status_Text_CONFIG.prototype = new Widget_CONFIG;
HCS_Controls_Status_Text_CONFIG.prototype.constructor = HCS_Controls_Status_Text_CONFIG;

HCS_Controls_Status_Text_CONFIG.prototype.createContent = function () {
    var _this = this;
    $(this.container)
        .append($('<div></div>')
            .append($('<div style="float: left; width: 70px;"></div>')
                .append($('<label for="' + _this.id + '_ccu">CCU:</label>'))
                .append($('<br/>'))
                .append($('<input id="' + _this.id + '_ccu" style="width: 50px;" type="text" disabled/>').addClass("ui-widget-content ui-corner-all").val(this.config.ccu).blur(function () {
                    _this.config.ccu = $(this).val();
                }))
            )
            .append($('<div style="float: left; width: 170px;"></div>')
                .append($('<label for="' + _this.id + '_adr">Address:</label>'))
                .append($('<br/>'))
                .append($('<input id="' + _this.id + '_adr" style="width: 150px;" type="text" disabled/>').addClass("ui-widget-content ui-corner-all").val(this.config.adr).blur(function () {
                    _this.config.adr = $(this).val();
                }))
            )
            .append($('<div style="float: left; width: 170px;"></div>')
                .append($('<label for="' + _this.id + '_dp">DataPoint:</label>'))
                .append($('<br/>'))
                .append($('<input id="' + _this.id + '_dp" style="width: 150px;" type="text" disabled/>').addClass("ui-widget-content ui-corner-all").val(this.config.dp).blur(function () {
                    _this.config.dp = $(this).val();
                }))
            )
        )
        .append($('<div class="ui-helper-clearfix" />'))
        .append($('<br/>'))
        .append($('<div></div>')
            .append($('<button>Select Device DataPoint</button>').button().click(function () {
                $(_this.devicesDlg).dialog('open');
            }))
            .append($('<br/>'))
        )
        .append($('<br/>'))
        .append($('<div></div>')
            .append($('<div style="float: left; width: 400px;"></div>')
                .append($('<label for="' + _this.id + '_value">Wert umrechnen z.B. "%VALUE% * 100":</label>'))
                .append($('<div style="line-height:30px; height: 30px"></div>')
                    .append($('<input id="' + _this.id + '_value" type="text" style="width:355px"/>').addClass("ui-widget-content ui-corner-all").val(this.config.value).blur(function () {
                        _this.config.value = $(this).val();
                    }))
                    .append($('<button style="margin-left: 5px; height: 28px; top: -2px; width: 36px;"/>').button().button("option", "icons", {primary: 'ui-icon-circle-plus'}).click(function () {
                        var iText = $('#' + _this.id + '_value');
                        iText.val(iText.val() + '%VALUE%');
                        _this.config.value = iText.val();
                    }))
                )
            )
        )
        .append($('<br/>'))
        .append($('<div></div>')
            .append($('<div style="float: left; width: 400px;"></div>')
                .append($('<label for="' + _this.id + '_replace">Werte individuell ersetzen:</label>'))
                .append($('<div style="line-height:30px; height: 30px"></div>')
                    .append($('<input id="' + _this.id + '_replace" type="text" disabled style="width:355px"/>').addClass("ui-widget-content ui-corner-all").val(this.config.replace).blur(function () {
                        _this.config.replace = $(this).val();
                    }))
                    .append($('<button style="margin-left: 5px; height: 28px; top: -2px; width: 36px;"/>').button().button("option", "icons", {primary: 'ui-icon-pencil'}).click(function () {
                        _this.replaceDlg.dialog('open');
                    }))
                )
            )
        )
        .append($('<br/>'))
        .append($('<div></div>')
            .append($('<div style="float: left; width: 400px;"></div>')
                .append($('<label for="' + _this.id + '_text">oder generell: z.B. "Zustand: %VALUE%":</label>'))
                .append($('<div style="line-height:30px; height: 30px"></div>')
                    .append($('<input id="' + _this.id + '_text" type="text" style="width:355px"/>').addClass("ui-widget-content ui-corner-all").val(this.config.text).blur(function () {
                        _this.config.text = $(this).val();
                    }))
                    .append($('<button style="margin-left: 5px; height: 28px; top: -2px; width: 36px;"/>').button().button("option", "icons", {primary: 'ui-icon-circle-plus'}).click(function () {
                        var iText = $('#' + _this.id + '_text');
                        iText.val(iText.val() + '%VALUE%');
                        _this.config.text = iText.val();
                    }))
                )
            )
        )
        .append($('<br/>'))
        .append($('<div class="ui-helper-clearfix" />'))
        .append($('<div class="expertView"></div>')
            .append($('<label for="' + _this.id + '_css">CSS-Style:</label>'))
            .append($('<br/>'))
            .append($('<input id="' + _this.id + '_css" type="text" style="width:400px"/>').addClass("ui-widget-content ui-corner-all").val(this.config.style).blur(function () {
                _this.config.style = $(this).val();
            }))
        )
        .append($('<div class="expertView"></div>')
            .append($('<input type="checkbox" id="' + _this.id + '_noPointerEvent"/>').click(function () {
                _this.config.NoPointerEvent = ($(this).prop("checked")) ? true : false;
            }))
            .append($('<label for="' + _this.id + '_noPointerEvent">"Durchklickbar" Verliert die Funktion aktuellen<br />Wert durch Klick abzurufen.</label>'))
        )
        .append($('<div class="hcs_table"/>')
            .append($('<b>Schrift:</b>'))
            .append($('<br/>'))
            .append($('<div class="hcs_tr"/>')
                .append($('<div class="hcs_td"/>')
                    .append($('<label for="' + _this.id + '_fontFamily">Art: </label>'))
                )
                .append($('<div class="hcs_td"/>')
                    .append($('<input id="' + _this.id + '_fontFamily" type="textarea" style="width:150px"/>').addClass("ui-widget-content ui-corner-all").val(this.config.fontFamily).blur(function () {
                        _this.config.fontFamily = $(this).val();
                    }))
                )
                .append($('<div class="hcs_td"/>')
                    .append($('<label for="' + _this.id + '_fontSize">Größe: </label>'))
                )
                .append($('<div class="hcs_td"/>')
                    .append($('<input id="' + _this.id + '_fontSize" type="textarea" style="width:75px"/>').addClass("ui-widget-content ui-corner-all").val(this.config.fontSize).blur(function () {
                        _this.config.fontSize = $(this).val();
                    }))
                )
            )
            .append($('<div class="hcs_tr"/>')
                .append($('<div class="hcs_td"/>')
                    .append($('<label for="' + _this.id + '_fontWeight">Dicke: </label>'))
                )
                .append($('<div class="hcs_td"/>')
                    .append($('<select id="' + _this.id + '_fontWeight" class="multiSelect" style="width: 150px;"/>')
                        .append($('<option value="normal">normal</option>'))
                        .append($('<option value="bold">bold</option>'))
                        .append($('<option value="bolder">bolder</option>'))
                        .append($('<option value="lighter">lighter</option>'))
                        .append($('<option value="100">100</option>'))
                        .append($('<option value="200">200</option>'))
                        .append($('<option value="300">300</option>'))
                        .append($('<option value="400">400</option>'))
                        .append($('<option value="500">500</option>'))
                        .append($('<option value="600">600</option>'))
                        .append($('<option value="700">700</option>'))
                        .append($('<option value="800">800</option>'))
                        .append($('<option value="900">900</option>'))
                        .append($('<option value="inherit">inherit</option>'))
                        .val(this.config.fontWeight).bind("multiselectclick", function(event, ui){
                            _this.config.fontWeight = ui.value;
                        }).blur(function () {
                            _this.config.fontWeight = $(this).val();
                        }))
                )
                .append($('<div class="hcs_td"/>')
                    .append($('<label for="' + _this.id + '_color">Farbe: </label>'))
                )
                .append($('<div class="hcs_td"/>')
                    .append($('<input id="' + _this.id + '_color" type="text" class="colorPickerNoOp"/>').addClass("ui-widget-content ui-corner-all").val(this.config.color).blur(function () {
                        _this.config.color = $(this).val();
                    }))
                )
            )
            .append($('<div class="hcs_tr"/>')
                .append($('<div class="hcs_td"/>')
                    .append($('<label for="' + _this.id + '_pos">Position: </label>'))
                )
                .append($('<div class="hcs_td"/>')
                    .append($('<select id="' + _this.id + '_pos" class="multiSelect" style="width: 150px;"/>')
                        .append($('<option value="1">links oben</option>'))
                        .append($('<option value="2">links mitte</option>'))
                        .append($('<option value="3">links unten</option>'))
                        .append($('<option value="4">mitte oben</option>'))
                        .append($('<option value="5">mitte mitte</option>'))
                        .append($('<option value="6">mitte unten</option>'))
                        .append($('<option value="7">rechts oben</option>'))
                        .append($('<option value="8">rechts mitte</option>'))
                        .append($('<option value="9">rechts unten</option>'))
                        .val(this.config.position).bind("multiselectclick", function(event, ui){
                            _this.config.position = ui.value;
                        }).blur(function () {
                            _this.config.position = $(this).val();
                        }))
                )
            )
        )
    ;
    $('.hcs_td').css({'padding-right': '10px'});
    $('.colorPickerNoOp').colorpicker({
        colorFormat: ['#HEX3', '#HEX'],
        regional: 'local',
        showOn: 'span',
        okOnEnter: true
    });
    $('.multiSelect').multiselect({multiple: false, header: false, selectedList: 1, minWidth: 'auto', height: 'auto', noneSelectedText: ' '});
    $('#' + _this.id + '_noPointerEvent').checkbox().checkbox(boolToChecked(this.config.NoPointerEvent));
    $(this.container).dialog('option', 'position', 'center');
};

HCS_Controls_Status_Text_CONFIG.prototype.fillReplace = function () {
    var _this = this;
    $('#replaceHeader').empty();
    for (var key in this.replaceObj){
        $('#replaceHeader').append($('<tr>' +
            '<th class="replaceKey">' + key + '</th>' +
            '<th class="replaceString">' + this.replaceObj[key] + '</th>' +
            '<th><a class="replaceDelete">Entfernen</a></th>' +
            '</tr>'));
    }
    $('.replaceDelete').button({
        icons: {primary: "ui-icon-closethick"},
        text: false
    }).click(function () {
            var delKey = $(this).parent().siblings('.replaceKey').text();
            delete _this.replaceObj[delKey];
            _this.fillReplace();
        });
    $('.replaceKey').click(function () {
        $('#' + _this.id + '_repaceValue').val($(this).html());
        $('#' + _this.id + '_replaceString').val($(this).siblings('.replaceString').html());
    });
    $('.replaceString').click(function () {
        $('#' + _this.id + '_repaceValue').val($(this).siblings('.replaceKey').html());
        $('#' + _this.id + '_replaceString').val($(this).html());
    });
};

HCS_Controls_Status_Text_CONFIG.prototype.createComment = function () {
    return this.deviceName;
};