// DISPLAY AREA
function HCS_Controls_Text(containerElement, eventHandler, globals, config, selfPath) {
    this.config = config;
    this.container = containerElement;
    this.config.position = parseInt(this.config.position);

    if ((this.config.position < 1) || (this.config.position > 9)) {
        this.config.position = 1;
    }

    $(this.container).empty();
    this.span = $('<span style="' + this.config.style + '" />').css({
        'color': this.config.color,
        'font-size': this.config.fontSize,
        'font-family': this.config.fontFamily,
        'font-weight': this.config.fontWeight,
        'position': 'absolute',
        'line-height': this.config.fontSize
    }).append(this.config.text);
    $(this.container).append(this.span);

    if ((this.config.position <= 6)) {
        $(this.span).css({'left': '0'});
    }
    if ((this.config.position >= 4)) {
        $(this.span).css({'right': '0'});
    }
    if ((this.config.position == 4) || (this.config.position == 5) || (this.config.position == 6)) {
        $(this.span).css({'text-align': 'center'});
    }
    if ((this.config.position == 2) || (this.config.position == 5) || (this.config.position == 8)) {
        $(this.span).css({
            'top': '50%',
            'margin-top': '-' + parseInt($(this.span).height() / 2) + 'px'
        });
    }
    if ((this.config.position == 3) || (this.config.position == 6) || (this.config.position == 9)) {
        $(this.span).css({'bottom': '0'});
    }
}
HCS_Controls_Text.prototype = new Widget;
HCS_Controls_Text.prototype.constructor = HCS_Controls_Text;

// CONFIG AREA
function HCS_Controls_Text_CONFIG(containerElement, eventHandler, globals, selfPath) {
    var _this = this;
    this.container = containerElement;
    this.eventHandler = eventHandler;
    this.globals = globals;

    this.config = {};
    this.config.text = "";
    this.config.style = "";
    this.config.position = 1;
    this.config.color = colorToHex(getCSS('color', 'ui-widget-content'));
    this.config.fontSize = getCSS('font-size', 'ui-widget');
    this.config.fontFamily = getCSS('font-family', 'ui-widget');
    this.config.fontWeight = getCSS('font-weight', 'ui-widget-content');
    this.id = randomString(16, 'aA');
}
HCS_Controls_Text_CONFIG.prototype = new Widget_CONFIG;
HCS_Controls_Text_CONFIG.prototype.constructor = HCS_Controls_Text_CONFIG;

HCS_Controls_Text_CONFIG.prototype.createContent = function () {
    var _this = this;
    $(this.container)
        .append($('<div></div>')
            .append($('<label for="' + _this.id + '_text">Text:</label>'))
            .append($('<br/>'))
            .append($('<input id="' + _this.id + '_text" type="text" style="width:500px"/>').addClass("ui-widget-content ui-corner-all").val(this.config.text).blur(function () {
                _this.config.text = $(this).val();
            }))
        )
        .append($('<div class="expertView"></div>')
            .append($('<label for="' + _this.id + '_css">CSS-Style:</label>'))
            .append($('<br/>'))
            .append($('<input id="' + _this.id + '_css" type="text" style="width:500px"/>').addClass("ui-widget-content ui-corner-all").val(this.config.style).blur(function () {
                _this.config.style = $(this).val();
            }))
        )
        .append($('<div class="hcs_table"/>')
            .append($('<b>Schrift:</b>'))
            .append($('<br/>'))
            .append($('<div class="hcs_tr"/>')
                .append($('<div class="hcs_td"/>')
                    .append($('<label for="' + _this.id + '_fontFamily">Art: </label>'))
                )
                .append($('<div class="hcs_td"/>')
                    .append($('<input id="' + _this.id + '_fontFamily" type="textarea" style="width:150px"/>').addClass("ui-widget-content ui-corner-all").val(this.config.fontFamily).blur(function () {
                        _this.config.fontFamily = $(this).val();
                    }))
                )
                .append($('<div class="hcs_td"/>')
                    .append($('<label for="' + _this.id + '_fontSize">Größe: </label>'))
                )
                .append($('<div class="hcs_td"/>')
                    .append($('<input id="' + _this.id + '_fontSize" type="textarea" style="width:75px"/>').addClass("ui-widget-content ui-corner-all").val(this.config.fontSize).blur(function () {
                        _this.config.fontSize = $(this).val();
                    }))
                )
            )
            .append($('<div class="hcs_tr"/>')
                .append($('<div class="hcs_td"/>')
                    .append($('<label for="' + _this.id + '_fontWeight">Dicke: </label>'))
                )
                .append($('<div class="hcs_td"/>')
                    .append($('<select id="' + _this.id + '_fontWeight" class="multiSelect" style="width: 150px;"/>')
                        .append($('<option value="normal">normal</option>'))
                        .append($('<option value="bold">bold</option>'))
                        .append($('<option value="bolder">bolder</option>'))
                        .append($('<option value="lighter">lighter</option>'))
                        .append($('<option value="100">100</option>'))
                        .append($('<option value="200">200</option>'))
                        .append($('<option value="300">300</option>'))
                        .append($('<option value="400">400</option>'))
                        .append($('<option value="500">500</option>'))
                        .append($('<option value="600">600</option>'))
                        .append($('<option value="700">700</option>'))
                        .append($('<option value="800">800</option>'))
                        .append($('<option value="900">900</option>'))
                        .append($('<option value="inherit">inherit</option>'))
                        .val(this.config.fontWeight).bind("multiselectclick", function(event, ui){
                            _this.config.fontWeight = ui.value;
                        }).blur(function () {
                            _this.config.fontWeight = $(this).val();
                        }))
                )
                .append($('<div class="hcs_td"/>')
                    .append($('<label for="' + _this.id + '_color">Farbe: </label>'))
                )
                .append($('<div class="hcs_td"/>')
                    .append($('<input id="' + _this.id + '_color" type="text" class="colorPickerNoOp"/>').addClass("ui-widget-content ui-corner-all").val(this.config.color).blur(function () {
                        _this.config.color = $(this).val();
                    }))
                )
            )
            .append($('<div class="hcs_tr"/>')
                .append($('<div class="hcs_td"/>')
                    .append($('<label for="' + _this.id + '_pos">Position: </label>'))
                )
                .append($('<div class="hcs_td"/>')
                    .append($('<select id="' + _this.id + '_pos" class="multiSelect" style="width: 150px;"/>')
                        .append($('<option value="1">links oben</option>'))
                        .append($('<option value="2">links mitte</option>'))
                        .append($('<option value="3">links unten</option>'))
                        .append($('<option value="4">mitte oben</option>'))
                        .append($('<option value="5">mitte mitte</option>'))
                        .append($('<option value="6">mitte unten</option>'))
                        .append($('<option value="7">rechts oben</option>'))
                        .append($('<option value="8">rechts mitte</option>'))
                        .append($('<option value="9">rechts unten</option>'))
                        .val(this.config.position).bind("multiselectclick", function(event, ui){
                            _this.config.position = ui.value;
                        }).blur(function () {
                            _this.config.position = $(this).val();
                        }))
                )
            )
        )
    ;
    $('.hcs_td').css({'padding-right': '10px'});
    $('.colorPickerNoOp').colorpicker({
        colorFormat: ['#HEX3', '#HEX'],
        regional: 'local',
        showOn: 'span',
        okOnEnter: true
    });
    $('.multiSelect').multiselect({multiple: false, header: false, selectedList: 1, minWidth: 'auto', height: 'auto', noneSelectedText: ' '});
    $(this.container).dialog('option', 'position', 'center');
};

