function HCS_Controls_Control_jQuerySlider(containerElement, eventHandler, globals, config, selfPath) {
    this.config = config;
    this.container = containerElement;
    this.expected = true;
    this.level = 0;
    this.eventHandler = eventHandler;
    this.globals = globals;
    this.working = false;
    this.sending = false;
    this.sliding = false;
    this.pendingValue = false;
    this.config.orientation = 'horizontal' // horizontal, vertical

    var _this = this;

    this.slider = $('<div />').attr('title', this.config.title).attr('style', this.config.style).slider({
        orientation: this.config.orientation,
        max: 100,
        min: 0,
        range: 'min',
        start: function (event, ui){
            _this.pendingValue = false;
            _this.sliding = true;
        },
        slide: function (event, ui) {
            if (_this.sending == false) {
                _this.pendingValue = false;
                _this.setValue(ui.value);
            } else {
                _this.pendingValue = ui.value;
            }
        },
        stop: function (event, ui) {
            _this.pendingValue = false;
            _this.sliding = false;
            _this.setValue(ui.value);
        },
        animate: 'slow'
    });
    $(this.container).empty().append(this.slider);

    eventHandler.register(function (param) {
            _this.updateValue(param)
        },
        {
            "working": {"ccu": config.ccu, "adr": config.adr, "dp": "WORKING"},
            "value": {"ccu": config.ccu, "adr": config.adr, "dp": _this.config.dp}
        });
    if (this.globals['RIGHTS'] < 2) {
        $(this.slider).slider('disable');
    }
}
HCS_Controls_Control_jQuerySlider.prototype = new Widget;
HCS_Controls_Control_jQuerySlider.prototype.constructor = HCS_Controls_Control_jQuerySlider;

HCS_Controls_Control_jQuerySlider.prototype.setValue = function (value) {
    if (this.globals['RIGHTS'] >= 2) {
        this.eventHandler.setValueSn(this.config.ccu, this.config.adr, this.config.dp, (value / 100));
        this.sending = true;
        this.expected = true;
        this.working = true;
        this.level = value;
        this.updateSlider();
    }
};

HCS_Controls_Control_jQuerySlider.prototype.updateValue = function (value) {
    if (typeof value["working"] != "undefined") {
        if ((value["working"] == true) || (value["working"] == 'true')) {
            this.working = true;
        } else {
            this.working = false;
        }
    }
    if (typeof value["value"] != "undefined") {
        this.level = parseInt(100 * value["value"]);
        this.expected = false;
    }
    if (this.pendingValue !== false) {
        var temp = this.pendingValue;
        this.pendingValue = false;
        this.setValue(temp);
    } else {
        this.sending = false;
    }
    this.updateSlider();
};

HCS_Controls_Control_jQuerySlider.prototype.updateSlider = function () {
    if (!this.working) {
        if ((!this.sliding) && ($(this.slider).slider('value') != this.level)) {
            $(this.slider).slider('value', this.level);
        }
    }
};