function HCS_Controls_Control_Toggle_jQueryButton(containerElement, eventHandler, globals, config, selfPath) {
    this.config = config;
    this.container = containerElement;
    this.expected = true;
    this.state = false;
    this.eventHandler = eventHandler;
    this.globals = globals;
    this.working = false;
    this.worker = false;

    var _this = this;
    $(containerElement).empty();
    this.button = $('<button title="' + config.titleUnknown + '" style="' + config.style + '">' + config.textUnknown + '</button>')
        .button()
        .button("option", "icons", {primary: this.config.iconUnknown})
        .click(function () {
            _this.eventHandler.getValueSn(_this.config.ccu, _this.config.adr, _this.config.dp, function (param) {
                _this.updateValue({"state": param})
            });
        });
    $(containerElement).append(this.button);

    if (_this.config.dp == 'LEVEL') {
        this.worker = true;
        eventHandler.register(function (param) {
                _this.updateValue(param)
            },
            {
                "working": {"ccu": config.ccu, "adr": config.adr, "dp": "WORKING"},
                "state": {"ccu": config.ccu, "adr": config.adr, "dp": _this.config.dp}
            });
    } else {
        eventHandler.register(function (param) {
                _this.updateValue(param);
            },
            {
                "state": {"ccu": config.ccu, "adr": config.adr, "dp": _this.config.dp}
            });
    }

    $(this.button).unbind('focus');
    if (this.globals['RIGHTS'] < 2){
        $(this.button).unbind('mouseenter');
        $(this.button).unbind('mousedown');
    }

}
HCS_Controls_Control_Toggle_jQueryButton.prototype = new Widget;
HCS_Controls_Control_Toggle_jQueryButton.prototype.constructor = HCS_Controls_Control_Toggle_jQueryButton;

HCS_Controls_Control_Toggle_jQueryButton.prototype.updateValue = function (value) {
    if (typeof value["working"] != "undefined") {
        if ((value["working"] == true) || (value["working"] == 'true')) {
            this.working = true;
        } else {
            this.working = false;
        }
    }
    if (typeof value["state"] != "undefined") {
        if ((value["state"] == true) || (value["state"] == 'true') || (value["state"] > 0)) {
            this.state = true;
        } else {
            this.state = false;
        }
        this.expected = false;
    }

    this.updateButton();
};

HCS_Controls_Control_Toggle_jQueryButton.prototype.updateButton = function () {
    var _this = this;

    var mode = 'unknown';


    if (this.state && !this.expected) {
        if (this.working){
            return;
        }
        mode = 'on';

    } else if (this.state && this.expected) {
        mode = 'expected on';

    } else if (!this.state && !this.expected) {
        if (this.working){
            return;
        }
        mode = 'off';

    } else if (!this.state && this.expected) {
        mode = 'expected off';
    }

    switch(mode){
        case "on":
            $(this.button)
                .button("option", "icons", {primary: this.config.iconOn})
                .unbind('click')
                .click(function () {
                    if (_this.globals['RIGHTS'] >= 2) {
                        _this.eventHandler.setValueSn(_this.config.ccu, _this.config.adr, _this.config.dp, 0);
                        _this.state = false;
                        _this.expected = true;
                        _this.updateButton();
                        if (_this.worker) {
                            _this.working = true;
                        }
                    }
                })
                .title = this.config.titleOn;
            if (this.config.textOn == '') {
                $(this.button).button("option", "text", false);
            } else {
                $(this.button).button("option", "text", true).find('.ui-button-text').text(this.config.textOn);
            }
            break;

        case "expected on":
            $(this.button)
                .button("option", "icons", {primary: this.config.iconOnExpected})
                .unbind('click')
                .click(function () {
                    if (_this.config.setWhileUncertain) {
                        if (_this.globals['RIGHTS'] >= 2) {
                            _this.eventHandler.setValueSn(_this.config.ccu, _this.config.adr, _this.config.dp, 0);
                            _this.state = false;
                            _this.expected = true;
                            _this.updateButton();
                            if (_this.worker) {
                                _this.working = true;
                            }
                        }
                    } else {
                        _this.eventHandler.getValueSn(_this.config.ccu, _this.config.adr, 'STATE', function (param) {
                            _this.updateValue({"state": param})
                        });
                    }
                })
                .title = this.config.titleOnExpected;
            if (this.config.textOnExpected == '') {
                $(this.button).button("option", "text", false);
            } else {
                $(this.button).button("option", "text", true).find('.ui-button-text').text(this.config.textOnExpected);
            }
            break;

        case "off":
            $(this.button)
                .button("option", "icons", {primary: this.config.iconOff})
                .unbind('click')
                .click(function () {
                    if (_this.globals['RIGHTS'] >= 2) {
                        _this.eventHandler.setValueSn(_this.config.ccu, _this.config.adr, _this.config.dp, 1);
                        _this.state = true;
                        _this.expected = true;
                        _this.updateButton();
                        if (_this.worker) {
                            _this.working = true;
                        }
                    }
                })
                .title = this.config.titleOff;
            if (this.config.textOff == '') {
                $(this.button).button("option", "text", false);
            } else {
                $(this.button).button("option", "text", true).find('.ui-button-text').text(this.config.textOff);

            }
            break;

        case "expected off":
            $(this.button)
                .button("option", "icons", {primary: this.config.iconOffExpected})
                .unbind('click')
                .click(function () {
                    if (_this.config.setWhileUncertain) {
                        if (_this.globals['RIGHTS'] >= 2) {
                            _this.eventHandler.setValueSn(_this.config.ccu, _this.config.adr, _this.config.dp, 1);
                            _this.state = true;
                            _this.expected = true;
                            _this.updateButton();
                            if (_this.worker) {
                                _this.working = true;
                            }
                        }
                    } else {
                        _this.eventHandler.getValueSn(_this.config.ccu, _this.config.adr, _this.config.dp, function (param) {
                            _this.updateValue({"state": param})
                        });
                    }
                })
                .title = this.config.titleOffExpected;
            if (this.config.textOffExpected == '') {
                $(this.button).button("option", "text", false);
            } else {
                $(this.button).button("option", "text", true).find('.ui-button-text').text(this.config.textOffExpected);
            }
            break;


    }
};