function fillDevices(param_obejct, ctrlDevices, includeSystemVariables) {

    var _this = param_obejct;
    var content = $('<div></div>');
    $(_this.devicesDlg).empty().append('<div class="ui-helper-reset"></div>').append(content);
    for (var ccuId in ctrlDevices) {
        var ccu = $('<div/>');

        $(content).append('<h3>' + ccuId + ' - ' + ctrlDevices[ccuId]['CCU_NAME'] + '</h3>').append($('<div/>').append(ccu));
        for (var devAdr in ctrlDevices[ccuId]) {
            if (devAdr == 'CCU_NAME'){
                continue;
            }
            var device = $('<div/>');
            $(ccu).append('<h3>' + ctrlDevices[ccuId][devAdr]['Name'] + ' (' + devAdr + ') - ' + ctrlDevices[ccuId][devAdr]['Type'] + '</h3>').append(device);
            for (var chnAdr in ctrlDevices[ccuId][devAdr]['Channels']) {
                var channel = $('<div/>');
                $(device).append('<h3>' + ctrlDevices[ccuId][devAdr]['Channels'][chnAdr]['Name'] + ' (' + chnAdr + ')</h3>').append(channel);
                for (var dp in ctrlDevices[ccuId][devAdr]['Channels'][chnAdr]['DPs']) {
                    $(channel)
                        .append($('<div class="ui-widget-content" style="font-weight: bold; margin-top: 5px;">' + ctrlDevices[ccuId][devAdr]['Channels'][chnAdr]['DPs'][dp] + '</div>')
                            .on('click', {pccu: ccuId, pchannel: chnAdr, pdp: ctrlDevices[ccuId][devAdr]['Channels'][chnAdr]['DPs'][dp], pname: ctrlDevices[ccuId][devAdr]['Channels'][chnAdr]['Name']}, function (e) {
                                $('#' + _this.id + '_ccu').val(e.data.pccu);
                                _this.config.ccu = e.data.pccu;

                                $('#' + _this.id + '_adr').val(e.data.pchannel);
                                _this.config.adr = e.data.pchannel;

                                $('#' + _this.id + '_dp').val(e.data.pdp);
                                _this.config.dp = e.data.pdp;
                                
                                _this.deviceName = e.data.pname;

                                $(_this.devicesDlg).dialog('close');
                            })
                            .hover(function () {$(this).addClass('ui-state-hover');}, function () {$(this).removeClass('ui-state-hover');})
                            .mouseover(function () {$(this).css('cursor', 'pointer');})
                        );
                }
            }
            $(device).accordion({heightStyle: "content", autoHeight: false, collapsible: true, active: false});
        }
        $(ccu).accordion({heightStyle: "content", collapsible: true, active: false});

        if (includeSystemVariables){
            (function(ccuId, ccu, _this){
                _this.eventHandler.getSystemVariablesForCcuId(function (param) {
                    var sysvar = $('<div/>');
                    $(ccu).append('<h3>Systemvariablen</h3>').append(sysvar);
                    for (var sysIndex in param) {
                        $(sysvar)
                            .append($('<div class="ui-widget-content" style="font-weight: bold; margin-top: 5px;">' + param[sysIndex]['Name'] + ' - ' + SysVarTypeToString(param[sysIndex]['ValueType']) + ' (' + SysVarSubTypeToString(param[sysIndex]['ValueSubType']) + ')</div>')
                                .on('click', {pccu: ccuId, pchannel: 'SYSTEM_VARIABLES', pdp:  param[sysIndex]['Id'], pname: param[sysIndex]['Name']}, function (e) {
                                    $('#' + _this.id + '_ccu').val(e.data.pccu);
                                    _this.config.ccu = e.data.pccu;

                                    $('#' + _this.id + '_adr').val(e.data.pchannel);
                                    _this.config.adr = e.data.pchannel;

                                    $('#' + _this.id + '_dp').val(e.data.pdp);
                                    _this.config.dp = e.data.pdp;

                                    _this.deviceName = e.data.pname;

                                    $(_this.devicesDlg).dialog('close');
                                })
                                .hover(function () {$(this).addClass('ui-state-hover');}, function () {$(this).removeClass('ui-state-hover');})
                                .mouseover(function () {$(this).css('cursor', 'pointer');})
                            );
                    }
                    $(ccu).accordion("refresh").accordion({active: false});
                    $('.ui-accordion .ui-accordion-content').css({'padding-left': '1em', 'padding-right': '0em', 'padding-top': '0.1em'})
                }, ccuId);
            })(ccuId, ccu, _this);
        }

    }
    $(content).accordion({heightStyle: "content", collapsible: true, active: false});
    $('.ui-accordion .ui-accordion-content').css({'padding-left': '1em', 'padding-right': '0em', 'padding-top': '0.1em'})
};

function createIconDlgFunction(param_object) {
    param_object.iconDlg = $('<div></div>')
        .append($('<ul id="test" class="ui-widget ui-helper-clearfix" style="margin: 0; padding: 0; outline: 0 none !important;"></ul>')
            .append($('<li title="ui-icon-carat-1-n"><span class="ui-icon-carat-1-n"></span></li>'))
            .append($('<li title="ui-icon-carat-1-ne"><span class="ui-icon-carat-1-ne"></span></li>'))
            .append($('<li title="ui-icon-carat-1-e"><span class="ui-icon-carat-1-e"></span></li>'))
            .append($('<li title="ui-icon-carat-1-se"><span class="ui-icon-carat-1-se"></span></li>'))
            .append($('<li title="ui-icon-carat-1-s"><span class="ui-icon-carat-1-s"></span></li>'))
            .append($('<li title="ui-icon-carat-1-sw"><span class="ui-icon-carat-1-sw"></span></li>'))
            .append($('<li title="ui-icon-carat-1-w"><span class="ui-icon-carat-1-w"></span></li>'))
            .append($('<li title="ui-icon-carat-1-nw"><span class="ui-icon-carat-1-nw"></span></li>'))
            .append($('<li title="ui-icon-carat-2-n-s"><span class="ui-icon-carat-2-n-s"></span></li>'))
            .append($('<li title="ui-icon-carat-2-e-w"><span class="ui-icon-carat-2-e-w"></span></li>'))

            .append($('<li title="ui-icon-triangle-1-n"><span class="ui-icon-triangle-1-n"></span></li>'))
            .append($('<li title="ui-icon-triangle-1-ne"><span class="ui-icon-triangle-1-ne"></span></li>'))
            .append($('<li title="ui-icon-triangle-1-e"><span class="ui-icon-triangle-1-e"></span></li>'))
            .append($('<li title="ui-icon-triangle-1-se"><span class="ui-icon-triangle-1-se"></span></li>'))
            .append($('<li title="ui-icon-triangle-1-s"><span class="ui-icon-triangle-1-s"></span></li>'))
            .append($('<li title="ui-icon-triangle-1-sw"><span class="ui-icon-triangle-1-sw"></span></li>'))
            .append($('<li title="ui-icon-triangle-1-w"><span class="ui-icon-triangle-1-w"></span></li>'))
            .append($('<li title="ui-icon-triangle-1-nw"><span class="ui-icon-triangle-1-nw"></span></li>'))

            .append($('<li title="ui-icon-arrow-1-n"><span class="ui-icon-arrow-1-n"></span></li>'))
            .append($('<li title="ui-icon-arrow-1-ne"><span class="ui-icon-arrow-1-ne"></span></li>'))
            .append($('<li title="ui-icon-arrow-1-e"><span class="ui-icon-arrow-1-e"></span></li>'))
            .append($('<li title="ui-icon-arrow-1-se"><span class="ui-icon-arrow-1-se"></span></li>'))
            .append($('<li title="ui-icon-arrow-1-s"><span class="ui-icon-arrow-1-s"></span></li>'))
            .append($('<li title="ui-icon-arrow-1-sw"><span class="ui-icon-arrow-1-sw"></span></li>'))
            .append($('<li title="ui-icon-arrow-1-w"><span class="ui-icon-arrow-1-w"></span></li>'))
            .append($('<li title="ui-icon-arrow-1-nw"><span class="ui-icon-arrow-1-nw"></span></li>'))

            .append($('<li title="ui-icon-arrow-2-n-s"><span class="ui-icon-arrow-2-n-s"></span></li>'))
            .append($('<li title="ui-icon-arrow-2-ne-sw"><span class="ui-icon-arrow-2-ne-sw"></span></li>'))
            .append($('<li title="ui-icon-arrow-2-e-w"><span class="ui-icon-arrow-2-e-w"></span></li>'))
            .append($('<li title="ui-icon-arrow-2-se-nw"><span class="ui-icon-arrow-2-se-nw"></span></li>'))

            .append($('<li title="ui-icon-arrowstop-1-n"><span class="ui-icon-arrowstop-1-n"></span></li>'))
            .append($('<li title="ui-icon-arrowstop-1-e"><span class="ui-icon-arrowstop-1-e"></span></li>'))
            .append($('<li title="ui-icon-arrowstop-1-s"><span class="ui-icon-arrowstop-1-s"></span></li>'))
            .append($('<li title="ui-icon-arrowstop-1-w"><span class="ui-icon-arrowstop-1-w"></span></li>'))

            .append($('<li title="ui-icon-arrowthick-1-n"><span class="ui-icon-arrowthick-1-n"></span></li>'))
            .append($('<li title="ui-icon-arrowthick-1-ne"><span class="ui-icon-arrowthick-1-ne"></span></li>'))
            .append($('<li title="ui-icon-arrowthick-1-e"><span class="ui-icon-arrowthick-1-e"></span></li>'))
            .append($('<li title="ui-icon-arrowthick-1-se"><span class="ui-icon-arrowthick-1-se"></span></li>'))
            .append($('<li title="ui-icon-arrowthick-1-s"><span class="ui-icon-arrowthick-1-s"></span></li>'))
            .append($('<li title="ui-icon-arrowthick-1-sw"><span class="ui-icon-arrowthick-1-sw"></span></li>'))
            .append($('<li title="ui-icon-arrowthick-1-w"><span class="ui-icon-arrowthick-1-w"></span></li>'))
            .append($('<li title="ui-icon-arrowthick-1-nw"><span class="ui-icon-arrowthick-1-nw"></span></li>'))

            .append($('<li title="ui-icon-arrowthick-2-n-s"><span class="ui-icon-arrowthick-2-n-s"></span></li>'))
            .append($('<li title="ui-icon-arrowthick-2-ne-sw"><span class="ui-icon-arrowthick-2-ne-sw"></span></li>'))
            .append($('<li title="ui-icon-arrowthick-2-e-w"><span class="ui-icon-arrowthick-2-e-w"></span></li>'))
            .append($('<li title="ui-icon-arrowthick-2-se-nw"><span class="ui-icon-arrowthick-2-se-nw"></span></li>'))

            .append($('<li title="ui-icon-arrowthickstop-1-n"><span class="ui-icon-arrowthickstop-1-n"></span></li>'))
            .append($('<li title="ui-icon-arrowthickstop-1-e"><span class="ui-icon-arrowthickstop-1-e"></span></li>'))
            .append($('<li title="ui-icon-arrowthickstop-1-s"><span class="ui-icon-arrowthickstop-1-s"></span></li>'))
            .append($('<li title="ui-icon-arrowthickstop-1-w"><span class="ui-icon-arrowthickstop-1-w"></span></li>'))

            .append($('<li title="ui-icon-arrowreturnthick-1-n"><span class="ui-icon-arrowreturnthick-1-n"></span></li>'))
            .append($('<li title="ui-icon-arrowreturnthick-1-e"><span class="ui-icon-arrowreturnthick-1-e"></span></li>'))
            .append($('<li title="ui-icon-arrowreturnthick-1-s"><span class="ui-icon-arrowreturnthick-1-s"></span></li>'))
            .append($('<li title="ui-icon-arrowreturnthick-1-w"><span class="ui-icon-arrowreturnthick-1-w"></span></li>'))

            .append($('<li title="ui-icon-arrowreturn-1-n"><span class="ui-icon-arrowreturn-1-n"></span></li>'))
            .append($('<li title="ui-icon-arrowreturn-1-e"><span class="ui-icon-arrowreturn-1-e"></span></li>'))
            .append($('<li title="ui-icon-arrowreturn-1-s"><span class="ui-icon-arrowreturn-1-s"></span></li>'))
            .append($('<li title="ui-icon-arrowreturn-1-w"><span class="ui-icon-arrowreturn-1-w"></span></li>'))

            .append($('<li title="ui-icon-arrowrefresh-1-n"><span class="ui-icon-arrowrefresh-1-n"></span></li>'))
            .append($('<li title="ui-icon-arrowrefresh-1-e"><span class="ui-icon-arrowrefresh-1-e"></span></li>'))
            .append($('<li title="ui-icon-arrowrefresh-1-s"><span class="ui-icon-arrowrefresh-1-s"></span></li>'))
            .append($('<li title="ui-icon-arrowrefresh-1-w"><span class="ui-icon-arrowrefresh-1-w"></span></li>'))

            .append($('<li title="ui-icon-arrow-4"><span class="ui-icon-arrow-4"></span></li>'))
            .append($('<li title="ui-icon-arrow-4-diag"><span class="ui-icon-arrow-4-diag"></span></li>'))
            .append($('<li title="ui-icon-extlink"><span class="ui-icon-extlink"></span></li>'))
            .append($('<li title="ui-icon-newwin"><span class="ui-icon-newwin"></span></li>'))
            .append($('<li title="ui-icon-shuffle"><span class="ui-icon-shuffle"></span></li>'))
            .append($('<li title="ui-icon-transfer-e-w"><span class="ui-icon-transfer-e-w"></span></li>'))
            .append($('<li title="ui-icon-transferthick-e-w"><span class="ui-icon-transferthick-e-w"></span></li>'))
            .append($('<li title="ui-icon-folder-collapsed"><span class="ui-icon-folder-collapsed"></span></li>'))
            .append($('<li title="ui-icon-folder-open"><span class="ui-icon-folder-open"></span></li>'))
            .append($('<li title="ui-icon-document"><span class="ui-icon-document"></span></li>'))
            .append($('<li title="ui-icon-document-b"><span class="ui-icon-document-b"></span></li>'))
            .append($('<li title="ui-icon-note"><span class="ui-icon-note"></span></li>'))
            .append($('<li title="ui-icon-mail-closed"><span class="ui-icon-mail-closed"></span></li>'))
            .append($('<li title="ui-icon-mail-open"><span class="ui-icon-mail-open"></span></li>'))
            .append($('<li title="ui-icon-suitcase"><span class="ui-icon-suitcase"></span></li>'))
            .append($('<li title="ui-icon-comment"><span class="ui-icon-comment"></span></li>'))
            .append($('<li title="ui-icon-person"><span class="ui-icon-person"></span></li>'))
            .append($('<li title="ui-icon-print"><span class="ui-icon-print"></span></li>'))
            .append($('<li title="ui-icon-trash"><span class="ui-icon-trash"></span></li>'))
            .append($('<li title="ui-icon-locked"><span class="ui-icon-locked"></span></li>'))
            .append($('<li title="ui-icon-unlocked"><span class="ui-icon-unlocked"></span></li>'))
            .append($('<li title="ui-icon-bookmark"><span class="ui-icon-bookmark"></span></li>'))
            .append($('<li title="ui-icon-tag"><span class="ui-icon-tag"></span></li>'))
            .append($('<li title="ui-icon-home"><span class="ui-icon-home"></span></li>'))
            .append($('<li title="ui-icon-flag"><span class="ui-icon-flag"></span></li>'))
            .append($('<li title="ui-icon-calculator"><span class="ui-icon-calculator"></span></li>'))
            .append($('<li title="ui-icon-cart"><span class="ui-icon-cart"></span></li>'))
            .append($('<li title="ui-icon-pencil"><span class="ui-icon-pencil"></span></li>'))
            .append($('<li title="ui-icon-clock"><span class="ui-icon-clock"></span></li>'))
            .append($('<li title="ui-icon-disk"><span class="ui-icon-disk"></span></li>'))
            .append($('<li title="ui-icon-calendar"><span class="ui-icon-calendar"></span></li>'))
            .append($('<li title="ui-icon-zoomin"><span class="ui-icon-zoomin"></span></li>'))
            .append($('<li title="ui-icon-zoomout"><span class="ui-icon-zoomout"></span></li>'))
            .append($('<li title="ui-icon-search"><span class="ui-icon-search"></span></li>'))
            .append($('<li title="ui-icon-wrench"><span class="ui-icon-wrench"></span></li>'))
            .append($('<li title="ui-icon-gear"><span class="ui-icon-gear"></span></li>'))
            .append($('<li title="ui-icon-heart"><span class="ui-icon-heart"></span></li>'))
            .append($('<li title="ui-icon-star"><span class="ui-icon-star"></span></li>'))
            .append($('<li title="ui-icon-link"><span class="ui-icon-link"></span></li>'))
            .append($('<li title="ui-icon-cancel"><span class="ui-icon-cancel"></span></li>'))
            .append($('<li title="ui-icon-plus"><span class="ui-icon-plus"></span></li>'))
            .append($('<li title="ui-icon-plusthick"><span class="ui-icon-plusthick"></span></li>'))
            .append($('<li title="ui-icon-minus"><span class="ui-icon-minus"></span></li>'))
            .append($('<li title="ui-icon-minusthick"><span class="ui-icon-minusthick"></span></li>'))
            .append($('<li title="ui-icon-close"><span class="ui-icon-close"></span></li>'))
            .append($('<li title="ui-icon-closethick"><span class="ui-icon-closethick"></span></li>'))
            .append($('<li title="ui-icon-key"><span class="ui-icon-key"></span></li>'))
            .append($('<li title="ui-icon-lightbulb"><span class="ui-icon-lightbulb"></span></li>'))
            .append($('<li title="ui-icon-scissors"><span class="ui-icon-scissors"></span></li>'))
            .append($('<li title="ui-icon-clipboard"><span class="ui-icon-clipboard"></span></li>'))
            .append($('<li title="ui-icon-copy"><span class="ui-icon-copy"></span></li>'))
            .append($('<li title="ui-icon-contact"><span class="ui-icon-contact"></span></li>'))
            .append($('<li title="ui-icon-image"><span class="ui-icon-image"></span></li>'))
            .append($('<li title="ui-icon-video"><span class="ui-icon-video"></span></li>'))
            .append($('<li title="ui-icon-script"><span class="ui-icon-script"></span></li>'))
            .append($('<li title="ui-icon-alert"><span class="ui-icon-alert"></span></li>'))
            .append($('<li title="ui-icon-info"><span class="ui-icon-info"></span></li>'))
            .append($('<li title="ui-icon-notice"><span class="ui-icon-notice"></span></li>'))
            .append($('<li title="ui-icon-help"><span class="ui-icon-help"></span></li>'))
            .append($('<li title="ui-icon-check"><span class="ui-icon-check"></span></li>'))
            .append($('<li title="ui-icon-bullet"><span class="ui-icon-bullet"></span></li>'))
            .append($('<li title="ui-icon-radio-off"><span class="ui-icon-radio-off"></span></li>'))
            .append($('<li title="ui-icon-radio-on"><span class="ui-icon-radio-on"></span></li>'))
            .append($('<li title="ui-icon-pin-w"><span class="ui-icon-pin-w"></span></li>'))
            .append($('<li title="ui-icon-pin-s"><span class="ui-icon-pin-s"></span></li>'))
            .append($('<li title="ui-icon-play"><span class="ui-icon-play"></span></li>'))
            .append($('<li title="ui-icon-pause"><span class="ui-icon-pause"></span></li>'))
            .append($('<li title="ui-icon-seek-next"><span class="ui-icon-seek-next"></span></li>'))
            .append($('<li title="ui-icon-seek-prev"><span class="ui-icon-seek-prev"></span></li>'))
            .append($('<li title="ui-icon-seek-end"><span class="ui-icon-seek-end"></span></li>'))
            .append($('<li title="ui-icon-seek-first"><span class="ui-icon-seek-first"></span></li>'))
            .append($('<li title="ui-icon-stop"><span class="ui-icon-stop"></span></li>'))
            .append($('<li title="ui-icon-eject"><span class="ui-icon-eject"></span></li>'))
            .append($('<li title="ui-icon-volume-off"><span class="ui-icon-volume-off"></span></li>'))
            .append($('<li title="ui-icon-volume-on"><span class="ui-icon-volume-on"></span></li>'))
            .append($('<li title="ui-icon-power"><span class="ui-icon-power"></span></li>'))
            .append($('<li title="ui-icon-signal-diag"><span class="ui-icon-signal-diag"></span></li>'))
            .append($('<li title="ui-icon-signal"><span class="ui-icon-signal"></span></li>'))
            .append($('<li title="ui-icon-battery-0"><span class="ui-icon-battery-0"></span></li>'))
            .append($('<li title="ui-icon-battery-1"><span class="ui-icon-battery-1"></span></li>'))
            .append($('<li title="ui-icon-battery-2"><span class="ui-icon-battery-2"></span></li>'))
            .append($('<li title="ui-icon-battery-3"><span class="ui-icon-battery-3"></span></li>'))
            .append($('<li title="ui-icon-circle-plus"><span class="ui-icon-circle-plus"></span></li>'))
            .append($('<li title="ui-icon-circle-minus"><span class="ui-icon-circle-minus"></span></li>'))
            .append($('<li title="ui-icon-circle-close"><span class="ui-icon-circle-close"></span></li>'))
            .append($('<li title="ui-icon-circle-triangle-e"><span class="ui-icon-circle-triangle-e"></span></li>'))
            .append($('<li title="ui-icon-circle-triangle-s"><span class="ui-icon-circle-triangle-s"></span></li>'))
            .append($('<li title="ui-icon-circle-triangle-w"><span class="ui-icon-circle-triangle-w"></span></li>'))
            .append($('<li title="ui-icon-circle-triangle-n"><span class="ui-icon-circle-triangle-n"></span></li>'))
            .append($('<li title="ui-icon-circle-arrow-e"><span class="ui-icon-circle-arrow-e"></span></li>'))
            .append($('<li title="ui-icon-circle-arrow-s"><span class="ui-icon-circle-arrow-s"></span></li>'))
            .append($('<li title="ui-icon-circle-arrow-w"><span class="ui-icon-circle-arrow-w"></span></li>'))
            .append($('<li title="ui-icon-circle-arrow-n"><span class="ui-icon-circle-arrow-n"></span></li>'))
            .append($('<li title="ui-icon-circle-zoomin"><span class="ui-icon-circle-zoomin"></span></li>'))
            .append($('<li title="ui-icon-circle-zoomout"><span class="ui-icon-circle-zoomout"></span></li>'))
            .append($('<li title="ui-icon-circle-check"><span class="ui-icon-circle-check"></span></li>'))
            .append($('<li title="ui-icon-circlesmall-plus"><span class="ui-icon-circlesmall-plus"></span></li>'))
            .append($('<li title="ui-icon-circlesmall-minus"><span class="ui-icon-circlesmall-minus"></span></li>'))
            .append($('<li title="ui-icon-circlesmall-close"><span class="ui-icon-circlesmall-close"></span></li>'))
            .append($('<li title="ui-icon-squaresmall-plus"><span class="ui-icon-squaresmall-plus"></span></li>'))
            .append($('<li title="ui-icon-squaresmall-minus"><span class="ui-icon-squaresmall-minus"></span></li>'))
            .append($('<li title="ui-icon-squaresmall-close"><span class="ui-icon-squaresmall-close"></span></li>'))
            .append($('<li title="ui-icon-grip-dotted-vertical"><span class="ui-icon-grip-dotted-vertical"></span></li>'))
            .append($('<li title="ui-icon-grip-dotted-horizontal"><span class="ui-icon-grip-dotted-horizontal"></span></li>'))
            .append($('<li title="ui-icon-grip-solid-vertical"><span class="ui-icon-grip-solid-vertical"></span></li>'))
            .append($('<li title="ui-icon-grip-solid-horizontal"><span class="ui-icon-grip-solid-horizontal"></span></li>'))
            .append($('<li title="ui-icon-gripsmall-diagonal-se"><span class="ui-icon-gripsmall-diagonal-se"></span></li>'))
            .append($('<li title="ui-icon-grip-diagonal-se"><span class="ui-icon-grip-diagonal-se"></span></li>'))
            .append($('<li title=""><span style="background-image: none !important;"></span></li>'))
            .find("li")
            .css({'float': 'left', 'margin': '2px', 'padding': '4px 0', 'position': 'relative', 'list-style': 'none outside none'})
            .addClass("ui-state-default ui-corner-all")
            .end()
            .find("span").css({'float': 'left', 'margin': '0 4px'})
            .addClass("ui-icon")
            .end()
        )
        .dialog({resizable: false, height: 'auto', width: '500', modal: true, title: "Icon", autoOpen: false});
};

function usrSelectIcon(param_this, callback) {
    $(param_this.iconDlg)
        .dialog('open')
        .find('li').unbind().click(function () {
            callback(this.title);
            $(param_this.iconDlg).dialog('close');
        });
}