function HCS_CLOCKS_AnalogClock(containerElement, eventHandler, globals, config, selfPath) {
    var _this = this;
    this.container = containerElement;
    this.selfPath = selfPath;

    this.id = randomString(16, '#');

    this.config = {};

    this.config.radius = 100;
    this.config.seconds = true;

    this.config.outerBorderColor = colorToHex(getCSS('color', 'ui-widget-header'));
    this.config.outerBorderAlpha = 1;
    this.config.outerBorderWidth = 2;
    this.config.outerBorderFillColor = colorToHex(getCSS('background-color', 'ui-widget-header'));
    this.config.outerBorderRadius = 95;

    this.config.hourHandColor = colorToHex(getCSS('color', 'ui-widget-header'));
    this.config.hourHandAlpha = 1;
    this.config.hourHandWidth = 6;
    this.config.hourHandStartAt = -15;
    this.config.hourHandEndAt = 50;

    this.config.minuteHandColor = colorToHex(getCSS('color', 'ui-widget-header'));
    this.config.minuteHandAlpha = 1;
    this.config.minuteHandWidth = 4;
    this.config.minuteHandStartAt = -15;
    this.config.minuteHandEndAt = 75;

    this.config.secondHandColor = colorToHex(getCSS('color', 'ui-state-default'));;
    this.config.secondHandAlpha = 1;
    this.config.secondHandWidth = 1;
    this.config.secondHandStartAt = -20;
    this.config.secondHandEndAt = 85;

    this.config.secondDecorationColor = colorToHex(getCSS('color', 'ui-state-default'));;
    this.config.secondDecorationAlpha = 1;
    this.config.secondDecorationWidth = 1;
    this.config.secondDecorationFillColor = colorToHex(getCSS('color', 'ui-state-default'));;
    this.config.secondDecorationRadius = 3;
    this.config.secondDecorationStartAt = 75;

    this.config.smallIndicatorColor = colorToHex(getCSS('color', 'ui-widget-header'));
    this.config.smallIndicatorAlpha = 1;
    this.config.smallIndicatorWidth = 2;
    this.config.smallIndicatorStartAt = 88;
    this.config.smallIndicatorEndAt = 92;

    this.config.largeIndicatorColor = colorToHex(getCSS('color', 'ui-widget-header'));
    this.config.largeIndicatorAlpha = 1;
    this.config.largeIndicatorWidth = 4;
    this.config.largeIndicatorStartAt = 79;
    this.config.largeIndicatorEndAt = 92;

    $.extend(this.config, config);

    // load assets
    yepnope({
        test : (window.navigator.userAgent.indexOf("MSIE ") > 0),
        yep  : selfPath + "assets/coolclock/excanvas.js",
        load: [selfPath + "assets/coolclock/coolclock.js"],
        complete: function () {
            _this.init();
        }
    });
}
HCS_CLOCKS_AnalogClock.prototype = new Widget;
HCS_CLOCKS_AnalogClock.prototype.constructor = HCS_CLOCKS_AnalogClock;

HCS_CLOCKS_AnalogClock.prototype.init = function () {
    var _this = this;
    CoolClock.config.skins['hcsSkin'+_this.id] = {
        outerBorder:      { lineWidth: parseInt(_this.config.outerBorderWidth), radius: parseInt(_this.config.outerBorderRadius), color: _this.config.outerBorderColor, fillColor: _this.config.outerBorderFillColor, alpha: parseFloat(_this.config.outerBorderAlpha) },
        secondDecoration: { lineWidth: parseInt(_this.config.secondDecorationWidth), startAt: parseInt(_this.config.secondDecorationStartAt), radius: parseInt(_this.config.secondDecorationRadius), fillColor: _this.config.secondDecorationFillColor, color: _this.config.secondDecorationColor, alpha: parseFloat(_this.config.secondDecorationAlpha) },
        smallIndicator:   { lineWidth: parseInt(_this.config.smallIndicatorWidth), startAt: parseInt(_this.config.smallIndicatorStartAt), endAt: parseInt(_this.config.smallIndicatorEndAt), color: _this.config.smallIndicatorColor, alpha: parseFloat(_this.config.smallIndicatorAlpha) },
        largeIndicator:   { lineWidth: parseInt(_this.config.largeIndicatorWidth), startAt: parseInt(_this.config.largeIndicatorStartAt), endAt: parseInt(_this.config.largeIndicatorEndAt), color: _this.config.largeIndicatorColor, alpha: parseFloat(_this.config.largeIndicatorAlpha) },
        hourHand:         { lineWidth: parseInt(_this.config.hourHandWidth), startAt: parseInt(_this.config.hourHandStartAt), endAt: parseInt(_this.config.hourHandEndAt), color: _this.config.hourHandColor, alpha: parseFloat(_this.config.hourHandAlpha) },
        minuteHand:       { lineWidth: parseInt(_this.config.minuteHandWidth), startAt: parseInt(_this.config.minuteHandStartAt), endAt: parseInt(_this.config.minuteHandEndAt), color: _this.config.minuteHandColor, alpha: parseFloat(_this.config.minuteHandAlpha) },
        secondHand:       { lineWidth: parseInt(_this.config.secondHandWidth), startAt: parseInt(_this.config.secondHandStartAt), endAt: parseInt(_this.config.secondHandEndAt), color: _this.config.secondHandColor, alpha: parseFloat(_this.config.secondHandAlpha) }
    }

    if (this.config.seconds) {
        $(this.container).append('<canvas class="CoolClock:hcsSkin'+_this.id+':' + parseInt(this.config.radius) + '"></canvas>');
    } else {
        $(this.container).append('<canvas class="CoolClock:hcsSkin'+_this.id+':' + parseInt(this.config.radius) + ':noSeconds"></canvas>');
    }
    CoolClock.findAndCreateClocks();

}
