function HCS_CLOCKS_AnalogClock(containerElement, eventHandler, globals, config, selfPath) {
    var _this = this;
    this.container = containerElement;
    this.selfPath = selfPath;

    this.id = randomString(16, '#');

    this.config = {};

    this.config.radius = 100;
    this.config.seconds = true;

    this.config.outerBorderWidth = 2;
    this.config.outerBorderRadius = 95;
    this.config.outerBorderColor = colorToHex(getCSS('color', 'ui-widget-header'));
    this.config.outerBorderFillColor = colorToHex(getCSS('background-color', 'ui-widget-header'));
    this.config.outerBorderAlpha = 1;

    this.config.secondDecorationWidth = 1;
    this.config.secondDecorationStartAt = 75;
    this.config.secondDecorationRadius = 3;
    this.config.secondDecorationFillColor = colorToHex(getCSS('color', 'ui-state-default'));;
    this.config.secondDecorationColor = colorToHex(getCSS('color', 'ui-state-default'));;
    this.config.secondDecorationAlpha = 1;

    this.config.smallIndicatorWidth = 2;
    this.config.smallIndicatorStartAt = 88;
    this.config.smallIndicatorEndAt = 92;
    this.config.smallIndicatorColor = colorToHex(getCSS('color', 'ui-widget-header'));
    this.config.smallIndicatorAlpha = 1;

    this.config.largeIndicatorWidth = 4;
    this.config.largeIndicatorStartAt = 79;
    this.config.largeIndicatorEndAt = 92;
    this.config.largeIndicatorColor = colorToHex(getCSS('color', 'ui-widget-header'));
    this.config.largeIndicatorAlpha = 1;

    this.config.hourHandWidth = 6;
    this.config.hourHandStartAt = -15;
    this.config.hourHandEndAt = 50;
    this.config.hourHandColor = colorToHex(getCSS('color', 'ui-widget-header'));
    this.config.hourHandAlpha = 1;

    this.config.minuteHandWidth = 4;
    this.config.minuteHandStartAt = -15;
    this.config.minuteHandEndAt = 75;
    this.config.minuteHandColor = colorToHex(getCSS('color', 'ui-widget-header'));
    this.config.minuteHandAlpha = 1;

    this.config.secondHandWidth = 1;
    this.config.secondHandStartAt = -20;
    this.config.secondHandEndAt = 85;
    this.config.secondHandColor = colorToHex(getCSS('color', 'ui-state-default'));;
    this.config.secondHandAlpha = 1;

    $.extend(this.config, config);

    // load assets
    yepnope({
        test : (window.navigator.userAgent.indexOf("MSIE ") > 0),
        yep  : selfPath + "assets/coolclock/excanvas.js",
        load: [selfPath + "assets/coolclock/coolclock.js"],
        complete: function () {
            _this.init();
        }
    });
}
HCS_CLOCKS_AnalogClock.prototype = new Widget;
HCS_CLOCKS_AnalogClock.prototype.constructor = HCS_CLOCKS_AnalogClock;

HCS_CLOCKS_AnalogClock.prototype.init = function () {
    var _this = this;
    CoolClock.config.skins['hcsSkin'+_this.id] = {
        outerBorder:      { lineWidth: parseInt(_this.config.outerBorderWidth), radius: parseInt(_this.config.outerBorderRadius), color: _this.config.outerBorderColor, fillColor: _this.config.outerBorderFillColor, alpha: parseFloat(_this.config.outerBorderAlpha) },
        secondDecoration: { lineWidth: parseInt(_this.config.secondDecorationWidth), startAt: parseInt(_this.config.secondDecorationStartAt), radius: parseInt(_this.config.secondDecorationRadius), fillColor: _this.config.secondDecorationFillColor, color: _this.config.secondDecorationColor, alpha: parseFloat(_this.config.secondDecorationAlpha) },
        smallIndicator:   { lineWidth: parseInt(_this.config.smallIndicatorWidth), startAt: parseInt(_this.config.smallIndicatorStartAt), endAt: parseInt(_this.config.smallIndicatorEndAt), color: _this.config.smallIndicatorColor, alpha: parseFloat(_this.config.smallIndicatorAlpha) },
        largeIndicator:   { lineWidth: parseInt(_this.config.largeIndicatorWidth), startAt: parseInt(_this.config.largeIndicatorStartAt), endAt: parseInt(_this.config.largeIndicatorEndAt), color: _this.config.largeIndicatorColor, alpha: parseFloat(_this.config.largeIndicatorAlpha) },
        hourHand:         { lineWidth: parseInt(_this.config.hourHandWidth), startAt: parseInt(_this.config.hourHandStartAt), endAt: parseInt(_this.config.hourHandEndAt), color: _this.config.hourHandColor, alpha: parseFloat(_this.config.hourHandAlpha) },
        minuteHand:       { lineWidth: parseInt(_this.config.minuteHandWidth), startAt: parseInt(_this.config.minuteHandStartAt), endAt: parseInt(_this.config.minuteHandEndAt), color: _this.config.minuteHandColor, alpha: parseFloat(_this.config.minuteHandAlpha) },
        secondHand:       { lineWidth: parseInt(_this.config.secondHandWidth), startAt: parseInt(_this.config.secondHandStartAt), endAt: parseInt(_this.config.secondHandEndAt), color: _this.config.secondHandColor, alpha: parseFloat(_this.config.secondHandAlpha) }
    }

    if (this.config.seconds) {
        $(this.container).append('<canvas class="CoolClock:hcsSkin'+_this.id+':' + parseInt(this.config.radius) + '"></canvas>');
    } else {
        $(this.container).append('<canvas class="CoolClock:hcsSkin'+_this.id+':' + parseInt(this.config.radius) + ':noSeconds"></canvas>');
    }
    CoolClock.findAndCreateClocks();
}

// CONFIG AREA
function HCS_CLOCKS_AnalogClock_CONFIG(containerElement, eventHandler, globals, selfPath) {
    var _this = this;
    this.container = containerElement;
    this.eventHandler = eventHandler;
    this.globals = globals;

    this.config = {};
    this.config.radius = 100;
    this.config.seconds = true;

    this.config.outerBorderWidth = 2;
    this.config.outerBorderRadius = 95;
    this.config.outerBorderColor = colorToHex(getCSS('color', 'ui-widget-header'));
    this.config.outerBorderFillColor = colorToHex(getCSS('background-color', 'ui-widget-header'));
    this.config.outerBorderAlpha = 1;

    this.config.secondDecorationWidth = 1;
    this.config.secondDecorationStartAt = 75;
    this.config.secondDecorationRadius = 3;
    this.config.secondDecorationFillColor = colorToHex(getCSS('color', 'ui-state-default'));;
    this.config.secondDecorationColor = colorToHex(getCSS('color', 'ui-state-default'));;
    this.config.secondDecorationAlpha = 1;

    this.config.smallIndicatorWidth = 2;
    this.config.smallIndicatorStartAt = 88;
    this.config.smallIndicatorEndAt = 92;
    this.config.smallIndicatorColor = colorToHex(getCSS('color', 'ui-widget-header'));
    this.config.smallIndicatorAlpha = 1;

    this.config.largeIndicatorWidth = 4;
    this.config.largeIndicatorStartAt = 79;
    this.config.largeIndicatorEndAt = 92;
    this.config.largeIndicatorColor = colorToHex(getCSS('color', 'ui-widget-header'));
    this.config.largeIndicatorAlpha = 1;

    this.config.hourHandWidth = 6;
    this.config.hourHandStartAt = -15;
    this.config.hourHandEndAt = 50;
    this.config.hourHandColor = colorToHex(getCSS('color', 'ui-widget-header'));
    this.config.hourHandAlpha = 1;

    this.config.minuteHandWidth = 4;
    this.config.minuteHandStartAt = -15;
    this.config.minuteHandEndAt = 75;
    this.config.minuteHandColor = colorToHex(getCSS('color', 'ui-widget-header'));
    this.config.minuteHandAlpha = 1;

    this.config.secondHandWidth = 1;
    this.config.secondHandStartAt = -20;
    this.config.secondHandEndAt = 85;
    this.config.secondHandColor = colorToHex(getCSS('color', 'ui-state-default'));;
    this.config.secondHandAlpha = 1;

    this.id = randomString(16, 'aA');
}
HCS_CLOCKS_AnalogClock_CONFIG.prototype = new Widget_CONFIG;
HCS_CLOCKS_AnalogClock_CONFIG.prototype.constructor = HCS_CLOCKS_AnalogClock_CONFIG;

HCS_CLOCKS_AnalogClock_CONFIG.prototype.createContent = function () {
    var _this = this;
    $(this.container)
        .empty()
        .append($('<div><b>Uhr:</b></div>'))
        .append($('<div></div>')
            .append($('<label for="' + _this.id + '_seconds">Sekundenzeiger: </label>'))
            .append($('<input type="checkbox" id="' + _this.id + '_seconds"/>').click(function () {
                _this.config.seconds = ($(this).prop("checked")) ? true : false;
            }))
            .append($('<label for="' + _this.id + '_radius">Radius: </label>'))
            .append($('<input id="' + _this.id + '_radius" type="text" class="spinnerMin"/>').addClass("ui-widget-content ui-corner-all").val(this.config.radius).blur(function () {
                _this.config.radius = $(this).val();
            }))
        )
        .append($('<div><b>Rahmen:</b></div>'))
        .append($('<div></div>')
            .append($('<label for="' + _this.id + '_outerBorderColor">Farbe: </label>'))
            .append($('<input id="' + _this.id + '_outerBorderColor" type="text" class="colorPicker" data-opacity="'+this.config.outerBorderAlpha+'"/>').addClass("ui-widget-content ui-corner-all").val(this.config.outerBorderColor).blur(function () {
                _this.config.outerBorderColor = $(this).val();
                _this.config.outerBorderAlpha = $(this).attr('data-opacity');
            }))
            .append($('<label for="' + _this.id + '_outerBorderWidth" class="expertView">Breite: </label>'))
            .append($('<input id="' + _this.id + '_outerBorderWidth" type="text" class="spinnerMin expertView"/>').addClass("ui-widget-content ui-corner-all").val(this.config.outerBorderWidth).blur(function () {
                _this.config.outerBorderWidth = $(this).val();
            }))
            .append($('<label for="' + _this.id + '_outerBorderFillColor">Füllfarbe: </label>'))
            .append($('<input id="' + _this.id + '_outerBorderFillColor" type="text" class="colorPickerNoOp"/>').addClass("ui-widget-content ui-corner-all").val(this.config.outerBorderFillColor).blur(function () {
                _this.config.outerBorderFillColor = $(this).val();
            }))
            .append($('<label for="' + _this.id + '_outerBorderRadius" class="expertView">Radius: </label>'))
            .append($('<input id="' + _this.id + '_outerBorderRadius" type="text" class="spinnerMin expertView"/>').addClass("ui-widget-content ui-corner-all").val(this.config.outerBorderRadius).blur(function () {
                _this.config.outerBorderRadius = $(this).val();
            }))
        )
        .append($('<div><b>'+ ((_this.globals['expertView']) ? "Stundenzeiger:" : "Zeiger:")+'</b></div>'))
        .append($('<div></div>')
            .append($('<label for="' + _this.id + '_hourHandColor">Farbe: </label>'))
            .append($('<input id="' + _this.id + '_hourHandColor" type="text" class="colorPicker" data-opacity="'+this.config.hourHandAlpha+'"/>').addClass("ui-widget-content ui-corner-all").val(this.config.hourHandColor).blur(function () {
                _this.config.hourHandColor = $(this).val();
                _this.config.hourHandAlpha = $(this).attr('data-opacity');
                if (!_this.globals['expertView']){
                    _this.config.minuteHandColor = _this.config.hourHandColor;
                    _this.config.minuteHandAlpha = _this.config.hourHandAlpha;
                    _this.config.largeIndicatorColor = _this.config.hourHandColor;
                    _this.config.largeIndicatorAlpha = _this.config.hourHandAlpha;
                    _this.config.smallIndicatorColor = _this.config.hourHandColor;
                    _this.config.smallIndicatorAlpha = _this.config.hourHandAlpha;
                }
            }))
            .append($('<label for="' + _this.id + '_hourHandWidth" class="expertView">Breite: </label>'))
            .append($('<input id="' + _this.id + '_hourHandWidth" type="text" class="spinnerMin expertView"/>').addClass("ui-widget-content ui-corner-all").val(this.config.hourHandWidth).blur(function () {
                _this.config.hourHandWidth = $(this).val();
            }))
            .append($('<label for="' + _this.id + '_hourHandStartAt" class="expertView">Von: </label>'))
            .append($('<input id="' + _this.id + '_hourHandStartAt" type="text" class="spinner expertView"/>').addClass("ui-widget-content ui-corner-all").val(this.config.hourHandStartAt).blur(function () {
                _this.config.hourHandStartAt = $(this).val();
            }))
            .append($('<label for="' + _this.id + '_hourHandEndAt" class="expertView">Bis: </label>'))
            .append($('<input id="' + _this.id + '_hourHandEndAt" type="text" class="spinner expertView"/>').addClass("ui-widget-content ui-corner-all").val(this.config.hourHandEndAt).blur(function () {
                _this.config.hourHandEndAt = $(this).val();
            }))
        )
        .append($('<div class="expertView"><b>Minutenzeiger:</b></div>'))
        .append($('<div class="expertView"></div>')
            .append($('<label for="' + _this.id + '_minuteHandColor">Farbe: </label>'))
            .append($('<input id="' + _this.id + '_minuteHandColor" type="text" class="colorPicker" data-opacity="'+this.config.minuteHandAlpha+'"/>').addClass("ui-widget-content ui-corner-all").val(this.config.minuteHandColor).blur(function () {
                _this.config.minuteHandColor = $(this).val();
                _this.config.minuteHandAlpha = $(this).attr('data-opacity');
            }))
            .append($('<label for="' + _this.id + '_minuteHandWidth">Breite: </label>'))
            .append($('<input id="' + _this.id + '_minuteHandWidth" type="text" class="spinnerMin"/>').addClass("ui-widget-content ui-corner-all").val(this.config.minuteHandWidth).blur(function () {
                _this.config.minuteHandWidth = $(this).val();
            }))
            .append($('<label for="' + _this.id + '_minuteHandStartAt">Von: </label>'))
            .append($('<input id="' + _this.id + '_minuteHandStartAt" type="text" class="spinner"/>').addClass("ui-widget-content ui-corner-all").val(this.config.minuteHandStartAt).blur(function () {
                _this.config.minuteHandStartAt = $(this).val();
            }))
            .append($('<label for="' + _this.id + '_minuteHandEndAt">Bis: </label>'))
            .append($('<input id="' + _this.id + '_minuteHandEndAt" type="text" class="spinner"/>').addClass("ui-widget-content ui-corner-all").val(this.config.minuteHandEndAt).blur(function () {
                _this.config.minuteHandEndAt = $(this).val();
            }))
        )
        .append($('<div><b>Sekundenzeiger:</b></div>'))
        .append($('<div></div>')
            .append($('<label for="' + _this.id + '_secondHandColor">Farbe: </label>'))
            .append($('<input id="' + _this.id + '_secondHandColor" type="text" class="colorPicker" data-opacity="'+this.config.secondHandAlpha+'"/>').addClass("ui-widget-content ui-corner-all").val(this.config.secondHandColor).blur(function () {
                _this.config.secondHandColor = $(this).val();
                _this.config.secondHandAlpha = $(this).attr('data-opacity');
                if (!_this.globals['expertView']){
                    _this.config.secondDecorationColor = _this.config.secondHandColor;
                    _this.config.secondDecorationAlpha = _this.config.secondHandAlpha;
                    _this.config.secondDecorationFillColor = _this.config.secondHandColor;
                }
            }))
            .append($('<label for="' + _this.id + '_secondHandWidth" class="expertView">Breite: </label>'))
            .append($('<input id="' + _this.id + '_secondHandWidth" type="text" class="spinnerMin expertView"/>').addClass("ui-widget-content ui-corner-all").val(this.config.secondHandWidth).blur(function () {
                _this.config.secondHandWidth = $(this).val();
            }))
            .append($('<label for="' + _this.id + '_secondHandStartAt" class="expertView">Von: </label>'))
            .append($('<input id="' + _this.id + '_secondHandStartAt" type="text" class="spinner expertView"/>').addClass("ui-widget-content ui-corner-all").val(this.config.secondHandStartAt).blur(function () {
                _this.config.secondHandStartAt = $(this).val();
            }))
            .append($('<label for="' + _this.id + '_secondHandEndAt" class="expertView">Bis: </label>'))
            .append($('<input id="' + _this.id + '_secondHandEndAt" type="text" class="spinner expertView"/>').addClass("ui-widget-content ui-corner-all").val(this.config.secondHandEndAt).blur(function () {
                _this.config.secondHandEndAt = $(this).val();
            }))
        )
        .append($('<div class="expertView"><b>Sekundenzeiger-Punkt:</b></div>'))
        .append($('<div class="expertView"></div>')
            .append($('<label for="' + _this.id + '_secondDecorationColor">Farbe: </label>'))
            .append($('<input id="' + _this.id + '_secondDecorationColor" type="text" class="colorPicker" data-opacity="'+this.config.secondDecorationAlpha+'"/>').addClass("ui-widget-content ui-corner-all").val(this.config.secondDecorationColor).blur(function () {
                _this.config.secondDecorationColor = $(this).val();
                _this.config.secondDecorationAlpha = $(this).attr('data-opacity');
            }))
            .append($('<label for="' + _this.id + '_secondDecorationWidth">Breite: </label>'))
            .append($('<input id="' + _this.id + '_secondDecorationWidth" type="text" class="spinnerMin"/>').addClass("ui-widget-content ui-corner-all").val(this.config.secondDecorationWidth).blur(function () {
                _this.config.secondDecorationWidth = $(this).val();
            }))
            .append($('<label for="' + _this.id + '_secondDecorationFillColor">Füllfarbe: </label>'))
            .append($('<input id="' + _this.id + '_secondDecorationFillColor" type="text" class="colorPickerNoOp"/>').addClass("ui-widget-content ui-corner-all").val(this.config.secondDecorationFillColor).blur(function () {
                _this.config.secondDecorationFillColor = $(this).val();
            }))
            .append($('<label for="' + _this.id + '_secondDecorationRadius">Radius: </label>'))
            .append($('<input id="' + _this.id + '_secondDecorationRadius" type="text" class="spinner"/>').addClass("ui-widget-content ui-corner-all").val(this.config.secondDecorationRadius).blur(function () {
                _this.config.secondDecorationRadius = $(this).val();
            }))
            .append($('<label for="' + _this.id + '_secondDecorationStartAt">Position: </label>'))
            .append($('<input id="' + _this.id + '_secondDecorationStartAt" type="text" class="spinner"/>').addClass("ui-widget-content ui-corner-all").val(this.config.secondDecorationStartAt).blur(function () {
                _this.config.secondDecorationStartAt = $(this).val();
            }))
        )
        .append($('<div class="expertView"><b>Stundenstriche:</b></div>'))
        .append($('<div class="expertView"></div>')
            .append($('<label for="' + _this.id + '_largeIndicatorColor">Farbe: </label>'))
            .append($('<input id="' + _this.id + '_largeIndicatorColor" type="text" class="colorPicker" data-opacity="'+this.config.largeIndicatorAlpha+'"/>').addClass("ui-widget-content ui-corner-all").val(this.config.largeIndicatorColor).blur(function () {
                _this.config.largeIndicatorColor = $(this).val();
                _this.config.largeIndicatorAlpha = $(this).attr('data-opacity');
            }))
            .append($('<label for="' + _this.id + '_largeIndicatorWidth" class="expertView">Breite: </label>'))
            .append($('<input id="' + _this.id + '_largeIndicatorWidth" type="text" class="spinnerMin"/>').addClass("ui-widget-content ui-corner-all").val(this.config.largeIndicatorWidth).blur(function () {
                _this.config.largeIndicatorWidth = $(this).val();
            }))
            .append($('<label for="' + _this.id + '_largeIndicatorStartAt" class="expertView">Von: </label>'))
            .append($('<input id="' + _this.id + '_largeIndicatorStartAt" type="text" class="spinner"/>').addClass("ui-widget-content ui-corner-all").val(this.config.largeIndicatorStartAt).blur(function () {
                _this.config.largeIndicatorStartAt = $(this).val();
            }))
            .append($('<label for="' + _this.id + '_largeIndicatorEndAt" class="expertView">Bis: </label>'))
            .append($('<input id="' + _this.id + '_largeIndicatorEndAt" type="text" class="spinner"/>').addClass("ui-widget-content ui-corner-all").val(this.config.largeIndicatorEndAt).blur(function () {
                _this.config.largeIndicatorEndAt = $(this).val();
            }))
        )
        .append($('<div class="expertView"><b>Minutenstriche:</b></div>'))
        .append($('<div class="expertView"></div>')
            .append($('<label for="' + _this.id + '_smallIndicatorColor">Farbe: </label>'))
            .append($('<input id="' + _this.id + '_smallIndicatorColor" type="text" class="colorPicker" data-opacity="'+this.config.smallIndicatorAlpha+'"/>').addClass("ui-widget-content ui-corner-all").val(this.config.smallIndicatorColor).blur(function () {
                _this.config.smallIndicatorColor = $(this).val();
                _this.config.smallIndicatorAlpha = $(this).attr('data-opacity');
            }))
            .append($('<label for="' + _this.id + '_smallIndicatorWidth">Breite: </label>'))
            .append($('<input id="' + _this.id + '_smallIndicatorWidth" type="text" class="spinnerMin"/>').addClass("ui-widget-content ui-corner-all").val(this.config.smallIndicatorWidth).blur(function () {
                _this.config.smallIndicatorWidth = $(this).val();
            }))
            .append($('<label for="' + _this.id + '_smallIndicatorStartAt">Von: </label>'))
            .append($('<input id="' + _this.id + '_smallIndicatorStartAt" type="text" class="spinner"/>').addClass("ui-widget-content ui-corner-all").val(this.config.smallIndicatorStartAt).blur(function () {
                _this.config.smallIndicatorStartAt = $(this).val();
            }))
            .append($('<label for="' + _this.id + '_smallIndicatorEndAt">Bis: </label>'))
            .append($('<input id="' + _this.id + '_smallIndicatorEndAt" type="text" class="spinner"/>').addClass("ui-widget-content ui-corner-all").val(this.config.smallIndicatorEndAt).blur(function () {
                _this.config.smallIndicatorEndAt = $(this).val();
            }))
        )
        .find('label').css({'padding-left': '10px', 'padding-right': '0px', 'text-align': 'right'})
    ;
    $('.colorPicker').colorpicker({
        colorFormat: ['#HEX3ATTR', '#HEXATTR'],
        regional: 'local',
        showOn: 'span',
        okOnEnter: true,
        alpha: true
    });
    $('.colorPickerNoOp').colorpicker({
        colorFormat: ['#HEX3', '#HEX'],
        regional: 'local',
        showOn: 'span',
        okOnEnter: true
    });

    $('.spinnerMin').spinner({min: 0, incremental: true}).removeClass("ui-widget-content ui-corner-all").css("width", 39);
    $('.spinner').spinner({incremental: true}).removeClass("ui-widget-content ui-corner-all").css("width", 39);
    $('.multiSelect').multiselect({multiple: false, header: false, selectedList: 1, minWidth: 'auto', height: 'auto', noneSelectedText: ' '});
    $('#' + _this.id + '_seconds').checkbox().checkbox(boolToChecked(this.config.seconds));
    if (!_this.globals['expertView']){
        $('.expertView').hide();
        $('span.ui-spinner > input.expertView').parent('span').hide();
    }
    $(this.container).dialog('option', 'position', 'center');
};

