function HCS_CLOCKS_FlipClock(containerElement, eventHandler, globals, config, selfPath) {
    var _this = this;
    this.container = containerElement;
    this.selfPath = selfPath;

    this.config = {};
    this.config.face = 'TwentyFourHourClockShort';
    this.config.width = 50;
    this.config.height = 70;
    this.config.fontSize = 60;
    this.config.color = colorToHex(getCSS('color', 'ui-widget-header'));
    this.config.bgColor = colorToHex(getCSS('background-color', 'ui-widget-header'));
    this.config.dotColor = colorToHex(getCSS('background-color', 'ui-widget-header'));
    this.config.dotSize = 8;
    this.config.radius = 3;
    this.config.shadowColor = colorToHex(getCSS('background-color', 'ui-widget-default'));
    this.config.textShadowColor = colorToHex(getCSS('color', 'ui-state-default'));
    this.config.borderSize = 1;
    this.config.borderStyle = 'solid';
    this.config.borderColor = colorToHex(getCSS('border-top-color', 'ui-widget-content'));
    $.extend(this.config, config);

    // load assets
    yepnope({
        load: [
            _this.selfPath + "assets/css/flipclock.css",
            _this.selfPath + "assets/js/libs/prefixfree.min.js",
            _this.selfPath + "assets/js/flipclock.min.js",
            _this.selfPath + "assets/js/faces/TwentyFourHourClockShort.js",
            _this.selfPath + "assets/js/faces/TwelveHourClockShort.js"
        ],
        complete: function () {
            _this.init();
        }
    });
}
HCS_CLOCKS_FlipClock.prototype = new Widget;
HCS_CLOCKS_FlipClock.prototype.constructor = HCS_CLOCKS_FlipClock;

HCS_CLOCKS_FlipClock.prototype.init = function () {
    this.clock = $(this.container).FlipClock({
        autoStart: true,
        clockFace:  this.config.face,
        defaultClockFace: 'TwentyFourHourClock'
    });
    $('.flip-clock-wrapper ul').css({
        'width': this.config.width + 'px',
        'height': this.config.height + 'px',
        'line-height': (parseInt(this.config.height) - (parseInt(this.config.borderSize)*2) ) + 'px',
        'font-size':  this.config.height + 'px',
        'border-radius': this.config.radius + 'px',
        'border': this.config.borderSize + 'px ' + this.config.borderStyle + ' ' + this.config.borderColor,
        'box-shadow': '0 2px 5px rgba('+hexToRgb(this.config.shadowColor).r+', '+hexToRgb(this.config.shadowColor).g+', '+hexToRgb(this.config.shadowColor).b+', .7)'
    });
    $('.flip-clock-wrapper ul li a div div.inn').css({
        'color': this.config.color,
        'background-color': this.config.bgColor,
        'font-size': this.config.fontSize + 'px',
        'border-radius': this.config.radius + 'px',
        'text-shadow': '0 1px 2px '+this.config.textShadowColor
    });
    $('.flip-clock-divider').css({
        'width': (parseInt(this.config.width) * 0.4) + 'px',
        'height': (parseInt(this.config.height) + 10) + 'px'
    });
    $('.flip-clock-dot').css({
        'background-color': this.config.dotColor,
        'width': this.config.dotSize + 'px',
        'height': this.config.dotSize + 'px',
        'left': (parseInt(this.config.width) * 0.2 - (parseInt(this.config.dotSize)/2) ) + 'px',
        'box-shadow': '0 0 5px rgba('+hexToRgb(this.config.shadowColor).r+', '+hexToRgb(this.config.shadowColor).g+', '+hexToRgb(this.config.shadowColor).b+', .5)'
    });
    $('.flip-clock-dot.top').css({
        'top': (parseInt(this.config.height) * 0.3) + 'px'
    });
    $('.flip-clock-dot.bottom').css({
        'bottom': (parseInt(this.config.height) * 0.3) + 'px'
    });
}


// CONFIG AREA
function HCS_CLOCKS_FlipClock_CONFIG(containerElement, eventHandler, globals, selfPath) {
    var _this = this;
    this.container = containerElement;
    this.eventHandler = eventHandler;
    this.globals = globals;

    this.config = {};
    this.config.face = 'TwentyFourHourClockShort';
    this.config.width = 50;
    this.config.height = 70;
    this.config.fontSize = 60;
    this.config.color = colorToHex(getCSS('color', 'ui-widget-header'));
    this.config.bgColor = colorToHex(getCSS('background-color', 'ui-widget-header'));
    this.config.dotColor = colorToHex(getCSS('background-color', 'ui-widget-header'));
    this.config.dotSize = 8;
    this.config.radius = 3;
    this.config.shadowColor = colorToHex(getCSS('background-color', 'ui-widget-default'));
    this.config.textShadowColor = colorToHex(getCSS('color', 'ui-state-default'));
    this.config.borderSize = 1;
    this.config.borderStyle = 'solid';
    this.config.borderColor = colorToHex(getCSS('border-top-color', 'ui-widget-content'));


    this.id = randomString(16, 'aA');
}
HCS_CLOCKS_FlipClock_CONFIG.prototype = new Widget_CONFIG;
HCS_CLOCKS_FlipClock_CONFIG.prototype.constructor = HCS_CLOCKS_FlipClock_CONFIG;

HCS_CLOCKS_FlipClock_CONFIG.prototype.createContent = function () {
    var _this = this;
    $(this.container)
        .addClass('hcs_table')
        .empty()
        .append($('<br />'))
        .append($('<div class="hcs_tr"></div>')
            .append($('<label for="' + _this.id + '_face" class="hcs_td">Uhrenstil: </label>'))
            .append($('<select id="' + _this.id + '_face" class="multiSelect" style="width: 128px;"/>')
                .append($('<option value="TwentyFourHourClockShort">24h kurz</option>'))
                .append($('<option value="TwentyFourHourClock">24h</option>'))
                .append($('<option value="TwelveHourClockShort">12h kurz</option>'))
                .append($('<option value="TwelveHourClock">12h</option>'))
            .val(this.config.face).bind("multiselectclick", function(event, ui){
                    _this.config.face = ui.value;
                }).blur(function () {
                _this.config.face = $(this).val();
            }))
        )
        .append($('<div><b>Ziffer:</b></div>'))
        .append($('<div class="hcs_tr"></div>')
            .append($('<label for="' + _this.id + '_width" class="hcs_td">Höhe: </label>'))
            .append($('<input id="' + _this.id + '_width" type="text" class="spinner hcs_td"/>').addClass("ui-widget-content ui-corner-all").val(this.config.height).blur(function () {
                _this.config.height = $(this).val();
            }))
            .append($('<label for="' + _this.id + '_width" class="hcs_td">Breite: </label>'))
            .append($('<input id="' + _this.id + '_width" type="text" class="spinner hcs_td"/>').addClass("ui-widget-content ui-corner-all").val(this.config.width).blur(function () {
                _this.config.width = $(this).val();
            }))
        )
        .append($('<div><b>Zahlen:</b></div>'))
        .append($('<div class="hcs_tr"></div>')
            .append($('<label for="' + _this.id + '_fontSizeh" class="hcs_td">Größe: </label>'))
            .append($('<input id="' + _this.id + '_fontSize" type="text" class="spinner hcs_td"/>').addClass("ui-widget-content ui-corner-all").val(this.config.fontSize).blur(function () {
                _this.config.fontSize = $(this).val();
            }))
            .append($('<label for="' + _this.id + '_color" class="hcs_td">Farbe: </label>'))
            .append($('<input id="' + _this.id + '_color" type="text" class="colorPickerNoOp hcs_td"/>').addClass("ui-widget-content ui-corner-all").val(this.config.color).blur(function () {
                _this.config.color = $(this).val();
            }))
            .append($('<label for="' + _this.id + '_textShadowColor" class="hcs_td">Schattenfarbe: </label>'))
            .append($('<input id="' + _this.id + '_textShadowColor" type="text" class="colorPickerNoOp hcs_td"/>').addClass("ui-widget-content ui-corner-all").val(this.config.textShadowColor).blur(function () {
                _this.config.textShadowColor = $(this).val();
            }))
        )
        .append($('<div><b>Hintergrund:</b></div>'))
        .append($('<div class="hcs_tr"></div>')
            .append($('<label for="' + _this.id + '_bgColor" class="hcs_td">Farbe: </label>'))
            .append($('<input id="' + _this.id + '_bgColor" type="text" class="colorPickerNoOp hcs_td"/>').addClass("ui-widget-content ui-corner-all").val(this.config.bgColor).blur(function () {
                _this.config.bgColor = $(this).val();
            }))
            .append($('<label for="' + _this.id + '_shadowColor" class="hcs_td">Schattenfarbe: </label>'))
            .append($('<input id="' + _this.id + '_shadowColor" type="text" class="colorPickerNoOp hcs_td"/>').addClass("ui-widget-content ui-corner-all").val(this.config.shadowColor).blur(function () {
                _this.config.shadowColor = $(this).val();
            }))
            .append($('<label for="' + _this.id + '_radius" class="hcs_td">Eckenradius: </label>'))
            .append($('<input id="' + _this.id + '_radius" type="text" class="spinner hcs_td"/>').addClass("ui-widget-content ui-corner-all").val(this.config.radius).blur(function () {
                _this.config.radius = $(this).val();
            }))
        )
        .append($('<div><b>Hintergrund-Rahmen:</b></div>'))
        .append($('<div class="hcs_tr"></div>')
            .append($('<label for="' + _this.id + '_borderColor" class="hcs_td">Rahmenfarbe: </label>'))
            .append($('<input id="' + _this.id + '_borderColor" type="text" class="colorPickerNoOp hcs_td"/>').addClass("ui-widget-content ui-corner-all").val(this.config.borderColor).blur(function () {
                _this.config.borderColor = $(this).val();
            }))
            .append($('<label for="' + _this.id + '_borderSize" class="hcs_td">Rahmendicke: </label>'))
            .append($('<input id="' + _this.id + '_borderSize" type="text" class="spinner hcs_td"/>').addClass("ui-widget-content ui-corner-all").val(this.config.borderSize).blur(function () {
                _this.config.borderSize = $(this).val();
            }))
            .append($('<label for="' + _this.id + '_borderStyle" class="hcs_td">Rahmenstil: </label>'))
            .append($('<select id="' + _this.id + '_borderStyle" class="multiSelect" style="width: 200px;"/>')
                .append($('<option value="none">Keine Linie</option>'))
                .append($('<option value="dotted">Gepunktete Linie</option>'))
                .append($('<option value="dashed">Gestrichelte Linie</option>'))
                .append($('<option value="solid">Durchgezogene Linie</option>'))
                .append($('<option value="double">Doppelte Linie</option>'))
                .append($('<option value="groove">3D-Linie (groove)</option>'))
                .append($('<option value="ridge">3D-Linie (ridge)</option>'))
                .append($('<option value="inset">3D-Linie (inset)</option>'))
                .append($('<option value="outset">3D-Linie (outset)</option>'))
            .val(this.config.borderStyle).bind("multiselectclick", function(event, ui){
                    _this.config.borderStyle = ui.value;
                }).blur(function () {
                _this.config.borderStyle = $(this).val();
            })
            )
        )
        .append($('<div><b>Trennpunkte:</b></div>'))
        .append($('<div class="hcs_tr"></div>')
            .append($('<label for="' + _this.id + '_dotSize" class="hcs_td">Größe: </label>'))
            .append($('<input id="' + _this.id + '_dotSize" type="text" class="spinner hcs_td"/>').addClass("ui-widget-content ui-corner-all").val(this.config.dotSize).blur(function () {
                _this.config.dotSize = $(this).val();
            }))
            .append($('<label for="' + _this.id + '_dotColor" class="hcs_td">Farbe: </label>'))
            .append($('<input id="' + _this.id + '_dotColor" type="text" class="colorPickerNoOp hcs_td"/>').addClass("ui-widget-content ui-corner-all").val(this.config.dotColor).blur(function () {
                _this.config.dotColor = $(this).val();
            }))
        )
        .find('label').css({'padding': '10px', 'text-align': 'right'})
        //.find('.hcs_td').css('padding-right', '10px')
    ;
    $('.colorPickerNoOp').colorpicker({
        colorFormat: ['#HEX3', '#HEX'],
        regional: 'local',
        showOn: 'span',
        okOnEnter: true
    });
    $('.spinner').spinner({min: 0, incremental: true}).removeClass("ui-widget-content ui-corner-all").css("width", 39);
    $('.multiSelect').multiselect({multiple: false, header: false, selectedList: 1, minWidth: 'auto', height: 'auto', noneSelectedText: ' '});
    $(this.container).dialog('option', 'position', 'center');

};

