// DISPLAY AREA
function HCS_CLOCKS_TextClock(containerElement, eventHandler, globals, config, selfPath) {
    this.container = containerElement;

    this.config = {};
    this.config.color = colorToHex(getCSS('color', 'ui-widget-content'));
    this.config.fontSize = getCSS('font-size', 'ui-widget');
    this.config.fontFamily = getCSS('font-family', 'ui-widget');
    this.config.fontWeight = getCSS('font-weight', 'ui-widget-content');
    this.config.format = '%DAYNAME%, %DAY%. %MONTHNAME% %YEAR% - %HOUR%:%MINUTE%:%SECOND%';

    $.extend(this.config, config);

    this.update();
}
HCS_CLOCKS_TextClock.prototype = new Widget;
HCS_CLOCKS_TextClock.prototype.constructor = HCS_CLOCKS_TextClock;

HCS_CLOCKS_TextClock.prototype.update = function () {
    var _this = this;
    var date = new Date();

    var tday   = ["Sonntag","Montag","Dienstag","Mittwoch","Donnerstag","Freitag","Samstag"];
    var tmonth = ["","Januar","Februar","März","April","Mai","Juni","Juli","August","September","Oktober","November","Dezember"];

    var nhour  = date.getHours();
    var nmin   = date.getMinutes();
    var nsec   = date.getSeconds();
    var nday   = date.getDay();
    var nmonth = date.getMonth()+1;
    var ndate  = date.getDate();
    var nyear  = date.getYear();
    var nshortHour = nhour;
    var ap;

    if(nmin <= 9){nmin="0"+nmin}
    if(nsec <= 9){nsec="0"+nsec}
    if(nyear<1000) nyear=nyear+1900;

    var nyearShort = nyear.toString().substr(2,2);

    if(nhour ==  0) {ap = "AM";nshortHour = 12;}
    else if(nhour <= 11) {ap = "AM";}
    else if(nhour == 12) {ap = "PM";}
    else if(nhour >= 13) {ap = "PM";nshortHour -= 12;}

    var resultString = this.config.format.replace(/%HOUR%/g, nhour);
    resultString = resultString.replace(/%SHORTHOUR%/g, nshortHour);
    resultString = resultString.replace(/%MINUTE%/g, nmin);
    resultString = resultString.replace(/%SECOND%/g, nsec);
    resultString = resultString.replace(/%AM_PM%/g, ap);

    resultString = resultString.replace(/%YEAR%/g, nyear);
    resultString = resultString.replace(/%YEARSHORT%/g, nyearShort);
    resultString = resultString.replace(/%MONTH%/g, nmonth);
    resultString = resultString.replace(/%MONTHNAME%/g, tmonth[nmonth]);
    resultString = resultString.replace(/%DAY%/g, ndate);
    resultString = resultString.replace(/%DAYNAME%/g, tday[nday]);


    $(this.container).empty().append($('<span></span>').css({
        'color': _this.config.color,
        'font-size': _this.config.fontSize,
        'font-family': _this.config.fontFamily,
        'font-weight': _this.config.fontWeight
    }).append(resultString));
    setTimeout(function(){_this.update();}, 500);
}

// CONFIG AREA
function HCS_CLOCKS_TextClock_CONFIG(containerElement, eventHandler, globals, selfPath) {
    var _this = this;
    this.container = containerElement;
    this.eventHandler = eventHandler;
    this.globals = globals;

    this.config = {};
    this.config.color = colorToHex(getCSS('color', 'ui-widget-content'));
    this.config.fontSize = getCSS('font-size', 'ui-widget');
    this.config.fontFamily = getCSS('font-family', 'ui-widget');
    this.config.fontWeight = getCSS('font-weight', 'ui-widget-content');
    this.config.format = '%DAYNAME%, %DAY%. %MONTHNAME% %YEAR% - %HOUR%:%MINUTE%:%SECOND%';
    this.id = randomString(16, 'aA');
}
HCS_CLOCKS_TextClock_CONFIG.prototype = new Widget_CONFIG;
HCS_CLOCKS_TextClock_CONFIG.prototype.constructor = HCS_CLOCKS_TextClock_CONFIG;

HCS_CLOCKS_TextClock_CONFIG.prototype.createContent = function () {
    var _this = this;
    $(this.container)
        .append($('<div></div>')
            .append($('<b>Format:</b>'))
            .append($('<br/>'))
            .append($('<input id="' + _this.id + '_format" type="textarea" style="width:750px"/>').addClass("ui-widget-content ui-corner-all").val(this.config.format).blur(function () {
                _this.config.format = $(this).val();
            }))
        )
        .append($('<br/>'))
        .append($('<div class="hcs_table"></div>')
            .append($('<div class="hcs_tr"></div>')
                .append($('<div class="hcs_td" style="text-align: right; padding-left: 40px;"><b>%HOUR% : </b></div>'))
                .append($('<div class="hcs_td">Stunden (0-24)</div>'))
                .append($('<div class="hcs_td" style="text-align: right; padding-left: 40px;"><b>%DAY% : </b></div>'))
                .append($('<div class="hcs_td">Tag (1-31)</div>'))
            )
            .append($('<div class="hcs_tr"></div>')
                .append($('<div class="hcs_td" style="text-align: right; padding-left: 40px;"><b>%SHORTHOUR% : </b></div>'))
                .append($('<div class="hcs_td">Stunden (0-12)</div>'))
                .append($('<div class="hcs_td" style="text-align: right; padding-left: 40px;"><b>%DAYNAME% : </b></div>'))
                .append($('<div class="hcs_td">Tagesname</div>'))
            )
            .append($('<div class="hcs_tr"></div>')
                .append($('<div class="hcs_td" style="text-align: right; padding-left: 40px;"><b>%AM_PM% : </b></div>'))
                .append($('<div class="hcs_td">AM oder PM</div>'))
                .append($('<div class="hcs_td" style="text-align: right; padding-left: 40px;"><b>%MONTH% : </b></div>'))
                .append($('<div class="hcs_td">Monat (1-12)</div>'))
            )
            .append($('<div class="hcs_tr"></div>')
                .append($('<div class="hcs_td" style="text-align: right; padding-left: 40px;"><b>%MINUTE% : </b></div>'))
                .append($('<div class="hcs_td">Minuten (00-59)</div>'))
                .append($('<div class="hcs_td" style="text-align: right; padding-left: 40px;"><b>%MONTHNAME% : </b></div>'))
                .append($('<div class="hcs_td">Monatsname</div>'))
            )
            .append($('<div class="hcs_tr"></div>')
                .append($('<div class="hcs_td" style="text-align: right; padding-left: 40px;"><b>%SECOND% : </b></div>'))
                .append($('<div class="hcs_td">Sekunden (00-59)</div>'))
                .append($('<div class="hcs_td" style="text-align: right; padding-left: 40px;"><b>%YEAR% : </b></div>'))
                .append($('<div class="hcs_td">Jahr (4-stellig)</div>'))
            )
            .append($('<div class="hcs_tr"></div>')
                .append($('<div class="hcs_td"></div>'))
                .append($('<div class="hcs_td"></div>'))
                .append($('<div class="hcs_td" style="text-align: right; padding-left: 40px;"><b>%YEARSHORT% : </b></div>'))
                .append($('<div class="hcs_td">Jahr (2-stellig)</div>'))
            )
        )

        .append($('<div></div>')
            .append($('<b>Schrift:</b>'))
            .append($('<br/>'))
            .append($('<label for="' + _this.id + '_fontSize">Größe: </label>'))
            .append($('<input id="' + _this.id + '_fontSize" type="textarea" style="width:70px"/>').addClass("ui-widget-content ui-corner-all").val(this.config.fontSize).blur(function () {
                _this.config.fontSize = $(this).val();
            }))
            .append($('<label for="' + _this.id + '_color">Farbe: </label>'))
            .append($('<input id="' + _this.id + '_color" type="text" class="colorPickerNoOp"/>').addClass("ui-widget-content ui-corner-all").val(this.config.color).blur(function () {
                _this.config.color = $(this).val();
            }))
            .append($('<label for="' + _this.id + '_fontWeight">Dicke: </label>'))
            .append($('<select id="' + _this.id + '_fontWeight" class="multiSelect" style="width: 100px;"/>')
                .append($('<option value="normal">normal</option>'))
                .append($('<option value="bold">bold</option>'))
                .append($('<option value="bolder">bolder</option>'))
                .append($('<option value="lighter">lighter</option>'))
                .append($('<option value="100">100</option>'))
                .append($('<option value="200">200</option>'))
                .append($('<option value="300">300</option>'))
                .append($('<option value="400">400</option>'))
                .append($('<option value="500">500</option>'))
                .append($('<option value="600">600</option>'))
                .append($('<option value="700">700</option>'))
                .append($('<option value="800">800</option>'))
                .append($('<option value="900">900</option>'))
                .append($('<option value="inherit">inherit</option>'))
                .val(this.config.fontWeight).bind("multiselectclick", function(event, ui){
                    _this.config.fontWeight = ui.value;
                }).blur(function () {
                    _this.config.fontWeight = $(this).val();
                }))
            .append($('<label for="' + _this.id + '_fontFamily">Art: </label>'))
            .append($('<input id="' + _this.id + '_fontFamily" type="textarea" style="width:220px"/>').addClass("ui-widget-content ui-corner-all").val(this.config.fontFamily).blur(function () {
                _this.config.fontFamily = $(this).val();
            }))
        )
        .find('label').css({'padding-left': '10px', 'padding-right': '0px'})
    ;
    $('.hcs_td').css({'padding-right': '10px'});
    $('.colorPickerNoOp').colorpicker({
        colorFormat: ['#HEX3', '#HEX'],
        regional: 'local',
        showOn: 'span',
        okOnEnter: true
    });
    $('.multiSelect').multiselect({multiple: false, header: false, selectedList: 1, minWidth: 'auto', height: 'auto', noneSelectedText: ' '});
    $(this.container).dialog('option', 'position', 'center');
};