function HCS_CLOCKS_FlipClock(containerElement, eventHandler, globals, config, selfPath) {
    var _this = this;
    this.container = containerElement;
    this.selfPath = selfPath;
    this.assets = {};
    this.assets.preFix = false;
    this.assets.fc = false;

    this.config = {};
    this.config.face = 'TwentyFourHourClockShort';
    this.config.width = 50;
    this.config.height = 70;
    this.config.fontSize = 60;
    this.config.color = colorToHex(getCSS('color', 'ui-widget-header'));
    this.config.bgColor = colorToHex(getCSS('background-color', 'ui-widget-header'));
    this.config.dotColor = colorToHex(getCSS('background-color', 'ui-widget-header'));
    this.config.dotSize = 8;
    this.config.radius = 3;
    this.config.shadowColor = colorToHex(getCSS('background-color', 'ui-widget-default'));
    this.config.textShadowColor = colorToHex(getCSS('color', 'ui-state-default'));
    this.config.borderSize = 1;
    this.config.borderStyle = 'solid';
    this.config.borderColor = colorToHex(getCSS('border-top-color', 'ui-widget-content'));
    $.extend(this.config, config);

    // load assets
    yepnope({
        load: [
            _this.selfPath + "assets/css/flipclock.css",
            _this.selfPath + "assets/js/libs/prefixfree.min.js",
            _this.selfPath + "assets/js/flipclock.min.js",
            _this.selfPath + "assets/js/faces/TwentyFourHourClockShort.js",
            _this.selfPath + "assets/js/faces/TwelveHourClockShort.js"
        ],
        complete: function () {
            _this.init();
        }
    });
}
HCS_CLOCKS_FlipClock.prototype = new Widget;
HCS_CLOCKS_FlipClock.prototype.constructor = HCS_CLOCKS_FlipClock;

HCS_CLOCKS_FlipClock.prototype.init = function () {
    this.clock = $(this.container).FlipClock({
        autoStart: true,
        clockFace:  this.config.face,
        defaultClockFace: 'TwentyFourHourClock'
    });
    $('.flip-clock-wrapper ul').css({
        'width': this.config.width + 'px',
        'height': this.config.height + 'px',
        'line-height': (parseInt(this.config.height) - (parseInt(this.config.borderSize)*2) ) + 'px',
        'font-size':  this.config.height + 'px',
        'border-radius': this.config.radius + 'px',
        'border': this.config.borderSize + 'px ' + this.config.borderStyle + ' ' + this.config.borderColor,
        'box-shadow': '0 2px 5px rgba('+hexToRgb(this.config.shadowColor).r+', '+hexToRgb(this.config.shadowColor).g+', '+hexToRgb(this.config.shadowColor).b+', .7)'
    });
    $('.flip-clock-wrapper ul li a div div.inn').css({
        'color': this.config.color,
        'background-color': this.config.bgColor,
        'font-size': this.config.fontSize + 'px',
        'border-radius': this.config.radius + 'px',
        'text-shadow': '0 1px 2px '+this.config.textShadowColor
    });
    $('.flip-clock-divider').css({
        'width': (parseInt(this.config.width) * 0.4) + 'px',
        'height': (parseInt(this.config.height) + 10) + 'px'
    });
    $('.flip-clock-dot').css({
        'background-color': this.config.dotColor,
        'width': this.config.dotSize + 'px',
        'height': this.config.dotSize + 'px',
        'left': (parseInt(this.config.width) * 0.2 - (parseInt(this.config.dotSize)/2) ) + 'px',
        'box-shadow': '0 0 5px rgba('+hexToRgb(this.config.shadowColor).r+', '+hexToRgb(this.config.shadowColor).g+', '+hexToRgb(this.config.shadowColor).b+', .5)'
    });
    $('.flip-clock-dot.top').css({
        'top': (parseInt(this.config.height) * 0.3) + 'px'
    });
    $('.flip-clock-dot.bottom').css({
        'bottom': (parseInt(this.config.height) * 0.3) + 'px'
    });
}
