function HCS_CLOCKS_TextClock(containerElement, eventHandler, globals, config, selfPath) {
    this.container = containerElement;

    this.config = {};
    this.config.color = colorToHex(getCSS('color', 'ui-widget-content'));
    this.config.fontSize = getCSS('font-size', 'ui-widget');
    this.config.fontFamily = getCSS('font-family', 'ui-widget');
    this.config.fontWeight = getCSS('font-weight', 'ui-widget-content');
    this.config.format = '%DAYNAME%, %DAY%. %MONTHNAME% %YEAR% - %HOUR%:%MINUTE%:%SECOND%';

    $.extend(this.config, config);

    this.update();
}
HCS_CLOCKS_TextClock.prototype = new Widget;
HCS_CLOCKS_TextClock.prototype.constructor = HCS_CLOCKS_TextClock;

HCS_CLOCKS_TextClock.prototype.update = function () {
    var _this = this;
    var date = new Date();

    var tday   = ["Sonntag","Montag","Dienstag","Mittwoch","Donnerstag","Freitag","Samstag"];
    var tmonth = ["","Januar","Februar","März","April","Mai","Juni","Juli","August","September","Oktober","November","Dezember"];

    var nhour  = date.getHours();
    var nmin   = date.getMinutes();
    var nsec   = date.getSeconds();
    var nday   = date.getDay();
    var nmonth = date.getMonth()+1;
    var ndate  = date.getDate();
    var nyear  = date.getYear();
    var nshortHour = nhour;
    var ap;

    if(nmin <= 9){nmin="0"+nmin}
    if(nsec <= 9){nsec="0"+nsec}
    if(nyear<1000) nyear=nyear+1900;

    var nyearShort = nyear.toString().substr(2,2);

    if(nhour ==  0) {ap = "AM";nshortHour = 12;}
    else if(nhour <= 11) {ap = "AM";}
    else if(nhour == 12) {ap = "PM";}
    else if(nhour >= 13) {ap = "PM";nshortHour -= 12;}

    var resultString = this.config.format.replace(/%HOUR%/g, nhour);
    resultString = resultString.replace(/%SHORTHOUR%/g, nshortHour);
    resultString = resultString.replace(/%MINUTE%/g, nmin);
    resultString = resultString.replace(/%SECOND%/g, nsec);
    resultString = resultString.replace(/%AM_PM%/g, ap);

    resultString = resultString.replace(/%YEAR%/g, nyear);
    resultString = resultString.replace(/%YEARSHORT%/g, nyearShort);
    resultString = resultString.replace(/%MONTH%/g, nmonth);
    resultString = resultString.replace(/%MONTHNAME%/g, tmonth[nmonth]);
    resultString = resultString.replace(/%DAY%/g, ndate);
    resultString = resultString.replace(/%DAYNAME%/g, tday[nday]);


    $(this.container).css({'pointer-events':'none'}).empty().append($('<span></span>').css({
        'color': _this.config.color,
        'font-size': _this.config.fontSize,
        'font-family': _this.config.fontFamily,
        'font-weight': _this.config.fontWeight
    }).append(resultString));
    setTimeout(function(){_this.update();}, 500);
}