function HCS_Diagrams_Chart(containerElement, eventHandler, globals, config, selfPath) {
    var _this = this;
    this.config = config;
    this.container = containerElement;
    this.eventHandler = eventHandler;
    this.globals = globals;
    this.path = selfPath;

    yepnope({
        load: [
            _this.globals.rootPath + 'includes/js/highcharts/highstock.js',
            _this.globals.rootPath + 'includes/js/highcharts/highcharts-more.js',
            _this.globals.rootPath + 'language/' + _this.globals.LANGUAGE + '/highcharts-lang.js',
            _this.globals.rootPath + 'style/highcharts-style.js',
            _this.globals.rootPath + 'style/' + _this.globals.STYLE + '/highcharts-style.js'],
        complete: function () {
            if (_this.config.exportEnabled == true){
                yepnope({load: [_this.globals.rootPath + 'includes/js/highcharts/highcharts-exporting.js'], complete: function (){_this.init();}});
            } else {
                _this.init();
            }
        }
    });
}
HCS_Diagrams_Chart.prototype = new Widget;
HCS_Diagrams_Chart.prototype.constructor = HCS_Diagrams_Chart;

HCS_Diagrams_Chart.prototype.init = function () {
    var _this = this;
    var subList = [];

    Highcharts.setOptions({
        global: {
            useUTC: false
        }
    });

    var yAxisTemp = [];
    _this.config.yAxis = hcs_parseJSON(_this.config.yAxis);
    for (var key in _this.config.yAxis) {
        (function(key){
            yAxisTemp.push({
                id: key,
                title: {text: _this.config.yAxis[key].title},
                opposite: _this.config.yAxis[key].opposite,
                type: _this.config.yAxis[key].type
            });
        })(key);
    }

    var interval = null;
    var date = new Date();
    if (_this.config.interval != '') {
        interval = date.getTime() - (_this.config.interval*1000);
    }

    var chartOptions = {
        chart: {
            renderTo: this.container,
            zoomType: 'x'
        },
        title: {
            text: _this.config.title
        },
        subtitle: {
            text: _this.config.subTitle
        },
        xAxis: {
            type: 'datetime',
            min: interval,
            max: date.getTime()
        },
        exporting: {
            enabled: _this.config.exportEnabled
        },
        plotOptions: {
            series: {
                dataGrouping: {
                    enabled: true,
                    smoothed: true,
                    groupPixelWidth: parseInt(_this.config.groupingDistance)
                }
            }
        }
    }

    if(yAxisTemp.length > 0){
        chartOptions.yAxis = yAxisTemp;
    }

    this.container.highcharts(chartOptions);
    this.chart = this.container.highcharts();

    _this.config.series = hcs_parseJSON(_this.config.series);

    for (var key in _this.config.series) {
        var serie = {
            id: 'series-'+key,
            name: _this.config.series[key].name,
            type: _this.config.series[key].type,
            step: _this.config.series[key].step,
            color: _this.config.series[key].color
        }
        if (_this.config.series[key].yAxis != ''){
            serie.yAxis = _this.config.series[key].yAxis;
        }
        _this.chart.addSeries(serie);

        if ((_this.config.series[key].ccu != '') && (_this.config.series[key].adr != '') && (_this.config.series[key].dp != '') ){
            subList['series-'+key] = {"ccu": _this.config.series[key].ccu, "adr": _this.config.series[key].adr, "dp": _this.config.series[key].dp};
            (function(key){
                _this.eventHandler.getHistoryValueBySn(_this.config.series[key].ccu, _this.config.series[key].adr, _this.config.series[key].dp, interval, function(values){
                    _this.chart.get('series-'+key).setData(values);
                    _this.chart.hideLoading();
                });
            })(key);
        }
    }
    if (_this.config.liveUpdate){
        eventHandler.register(function (param) {_this.updateValue(param)}, subList);
    }
};

HCS_Diagrams_Chart.prototype.updateValue = function(transport){
    for (var key in transport){
        this.chart.get(key).addPoint([(new Date()).getTime(), parseFloat(transport[key])]);
    }
    var interval = null;
    var date = new Date();
    if (this.config.interval != '') {
        interval = date.getTime() - (this.config.interval*1000);
    }

    var date = new Date();
    this.chart.xAxis[0].setExtremes(interval, date.getTime(), true)
};