function fillDevices(param_obejct, ctrlDevices, includeSystemVariables) {

    var _this = param_obejct;
    var content = $('<div></div>');
    $(_this.devicesDlg).empty().append('<div class="ui-helper-reset"></div>').append(content);
    for (var ccuId in ctrlDevices) {
        var ccu = $('<div/>');

        $(content).append('<h3>' + ccuId + ' - ' + ctrlDevices[ccuId]['CCU_NAME'] + '</h3>').append($('<div/>').append(ccu));
        for (var devAdr in ctrlDevices[ccuId]) {
            if (devAdr == 'CCU_NAME'){
                continue;
            }
            var device = $('<div/>');
            $(ccu).append('<h3>' + ctrlDevices[ccuId][devAdr]['Name'] + ' (' + devAdr + ') - ' + ctrlDevices[ccuId][devAdr]['Type'] + '</h3>').append(device);
            for (var chnAdr in ctrlDevices[ccuId][devAdr]['Channels']) {
                var channel = $('<div/>');
                $(device).append('<h3>' + ctrlDevices[ccuId][devAdr]['Channels'][chnAdr]['Name'] + ' (' + chnAdr + ')</h3>').append(channel);
                for (var dp in ctrlDevices[ccuId][devAdr]['Channels'][chnAdr]['DPs']) {
                    $(channel)
                        .append($('<div class="ui-widget-content" style="font-weight: bold; margin-top: 5px;">' + ctrlDevices[ccuId][devAdr]['Channels'][chnAdr]['DPs'][dp] + '</div>')
                            .on('click', {pccu: ccuId, pchannel: chnAdr, pdp: ctrlDevices[ccuId][devAdr]['Channels'][chnAdr]['DPs'][dp], pname: ctrlDevices[ccuId][devAdr]['Channels'][chnAdr]['Name']}, function (e) {
                                $('#' + _this.id + '_ccu').val(e.data.pccu);
                                _this.config.ccu = e.data.pccu;

                                $('#' + _this.id + '_adr').val(e.data.pchannel);
                                _this.config.adr = e.data.pchannel;

                                $('#' + _this.id + '_dp').val(e.data.pdp);
                                _this.config.dp = e.data.pdp;

                                _this.deviceName = e.data.pname;

                                $(_this.devicesDlg).dialog('close');
                            })
                            .hover(function () {$(this).addClass('ui-state-hover');}, function () {$(this).removeClass('ui-state-hover');})
                            .mouseover(function () {$(this).css('cursor', 'pointer');})
                        );
                }
            }
            $(device).accordion({heightStyle: "content", autoHeight: false, collapsible: true, active: false});
        }
        $(ccu).accordion({heightStyle: "content", collapsible: true, active: false});

        if (includeSystemVariables){
            (function(ccuId, ccu, _this){
                _this.eventHandler.getSystemVariablesForCcuId(function (param) {
                    var sysvar = $('<div/>');
                    $(ccu).append('<h3>Systemvariablen</h3>').append(sysvar);
                    for (var sysIndex in param) {
                        $(sysvar)
                            .append($('<div class="ui-widget-content" style="font-weight: bold; margin-top: 5px;">' + param[sysIndex]['Name'] + ' - ' + SysVarTypeToString(param[sysIndex]['ValueType']) + ' (' + SysVarSubTypeToString(param[sysIndex]['ValueSubType']) + ')</div>')
                                .on('click', {pccu: ccuId, pchannel: 'SYSTEM_VARIABLES', pdp:  param[sysIndex]['Id'], pname: param[sysIndex]['Name']}, function (e) {
                                    $('#' + _this.id + '_ccu').val(e.data.pccu);
                                    _this.config.ccu = e.data.pccu;

                                    $('#' + _this.id + '_adr').val(e.data.pchannel);
                                    _this.config.adr = e.data.pchannel;

                                    $('#' + _this.id + '_dp').val(e.data.pdp);
                                    _this.config.dp = e.data.pdp;

                                    _this.deviceName = e.data.pname;

                                    $(_this.devicesDlg).dialog('close');
                                })
                                .hover(function () {$(this).addClass('ui-state-hover');}, function () {$(this).removeClass('ui-state-hover');})
                                .mouseover(function () {$(this).css('cursor', 'pointer');})
                            );
                    }
                    $(ccu).accordion("refresh").accordion({active: false});
                    $('.ui-accordion .ui-accordion-content').css({'padding-left': '1em', 'padding-right': '0em', 'padding-top': '0.1em'})
                }, ccuId);
            })(ccuId, ccu, _this);
        }

    }
    $(content).accordion({heightStyle: "content", collapsible: true, active: false});
    $('.ui-accordion .ui-accordion-content').css({'padding-left': '1em', 'padding-right': '0em', 'padding-top': '0.1em'})
};