// DISPLAY AREA
function HCS_Pic_Image(containerElement, eventHandler, globals, config, selfPath) {
    var _this = this;
    this.config = config;
    this.container = containerElement;
    this.eventHandler = eventHandler;
    this.globals = globals;
    if((typeof this.config.file === "undefined") || (this.config.file == '')){
        this.file = selfPath + 'images/status_missing.png';
    } else {
        this.file = selfPath + 'images/image/' + this.config.file;
    }

    this.button = $('<div style="border-width: 0px; background: 0px 0px url(\'' + this.file + '\') no-repeat;" />')

    var theImage = new Image();
    theImage.src = this.file;
    this.imageSourceWidth = parseInt(theImage.width);
    this.imageSourceHeight = parseInt(theImage.height);
    this.imageWidth = parseInt(this.imageSourceWidth);
    theImage.onload = function(){
        _this.imageSourceWidth = parseInt(theImage.width);
        _this.imageSourceHeight = parseInt(theImage.height);
        _this.imageWidth = parseInt(_this.imageSourceWidth);
        $(_this.button).css({
            'width': _this.imageWidth+'px',
            'height': _this.imageSourceHeight+'px'
        });
    };

    $(this.button).css({'width': this.imageWidth+'px','height': this.imageSourceHeight+'px'})
    $(containerElement).empty().append(this.button);
}
HCS_Pic_Image.prototype = new Widget;
HCS_Pic_Image.prototype.constructor = HCS_Pic_Image;

// CONFIG AREA
function HCS_Pic_Image_CONFIG(containerElement, eventHandler, globals, selfPath) {
    var _this = this;
    this.container = containerElement;
    this.eventHandler = eventHandler;
    this.globals = globals;
    this.path = selfPath;

    if (selfPath.charAt(selfPath.length-1) == '/'){
        this.selfFolderName = selfPath.substring(0, selfPath.length-1)
    }
    this.selfFolderName = this.selfFolderName.substring(this.selfFolderName.lastIndexOf('/')+1, this.selfFolderName.length)

    this.config = {};
    this.config.file = "";

    this.id = randomString(16, 'aA');

    var spinnerPath = "url('" + this.globals["rootPath"] + "data/images/spinner.gif');";

    this.pictureDlg = $('<div id="' + _this.id + '_Pictures"></div>')
        .append($('<div style="height:100%; width:100%; background: no-repeat center; background-image: ' + spinnerPath + '"></div>'))
        .dialog({resizable: true, height: 700, width: 'auto', modal: true, title: "Bild auswählen", autoOpen: false});

    $.getScript(selfPath + 'includes.js', function(){
        eventHandler.getFolderContent(function (param) {fillPictures(_this.pictureDlg, _this.path, 'images/image/', param, _this.id + '_path', _this.config.file);}, './data/widgets/' + _this.selfFolderName + '/images/image/');
    });
}
HCS_Pic_Image_CONFIG.prototype = new Widget_CONFIG;
HCS_Pic_Image_CONFIG.prototype.constructor = HCS_Pic_Image_CONFIG;

HCS_Pic_Image_CONFIG.prototype.createContent = function () {
    var _this = this;

    $(this.container)
        .append($('<div>Die Bilder müssen in den Ordner "images/image" innerhalb<br />des widgets Ordner abgelegt werden.</div>'))
        .append($('<div></div>')
            .append($('<button>Bild auswählen</button>').button().click(function () {
                $(_this.pictureDlg).dialog('open');
            }))
        )
        .append($('<div></div>')
            .append($('<label for="' + _this.id + '_path">Dateiname:</label>'))
            .append($('<br/>'))
            .append($('<input id="' + _this.id + '_path" style="width:400px" type="text"/>').addClass("ui-widget-content ui-corner-all").val(this.config.file).blur(function () {
                _this.config.file = $(this).val();
            }).click(function () {
                $(_this.pictureDlg).dialog('open');
            }))
        )
    ;
};

HCS_Pic_ToggleButton_CONFIG.prototype.createComment = function () {
    return this.config.file;
};