function HCS_Pic_PageLink(containerElement, eventHandler, globals, config, selfPath) {
    var _this = this;
    this.config = config;
    this.container = containerElement;
    if((typeof this.config.file === "undefined") || (this.config.file == '')){
        this.file = selfPath + 'images/button_missing.png';
    } else {
        this.file = selfPath + 'images/button/' + this.config.file;
    }

    this.button = $('<div style="border-width: 0px; background: 0px 0px url(\'' + this.file + '\') no-repeat;" />')

    var theImage = new Image();
    theImage.src = this.file;
    this.imageSourceWidth = parseInt(theImage.width);
    this.imageSourceHeight = parseInt(theImage.height);
    this.imageWidth = parseInt(this.imageSourceWidth / 2);
    theImage.onload = function(){
        _this.imageSourceWidth = parseInt(theImage.width);
        _this.imageSourceHeight = parseInt(theImage.height);
        _this.imageWidth = parseInt(_this.imageSourceWidth / 2);
        $(_this.button).css({
            'width': _this.imageWidth+'px',
            'height': _this.imageSourceHeight+'px'
        });
    };

    $(containerElement).empty();
    $(this.button).css({'width': this.imageWidth+'px','height': this.imageSourceHeight+'px'});
    $(containerElement).append(this.button);
}
HCS_Pic_PageLink.prototype = new Widget;
HCS_Pic_PageLink.prototype.constructor = HCS_Pic_PageLink;

function HCS_Pic_PageLink_CONFIG(containerElement, eventHandler, globals, selfPath) {
    var _this = this;
    this.container = containerElement;
    this.eventHandler = eventHandler;
    this.globals = globals;
    this.path = selfPath;

    if (selfPath.charAt(selfPath.length-1) == '/'){
        this.selfFolderName = selfPath.substring(0, selfPath.length-1)
    }
    this.selfFolderName = this.selfFolderName.substring(this.selfFolderName.lastIndexOf('/')+1, this.selfFolderName.length)

    this.config = {};
    this.config.newWindow = false;
    this.config.pageId = "";
    this.config.pageName = "";
    this.config.file = "";

    this.id = randomString(16, 'aA');

    var spinnerPath = "url('" + this.globals["rootPath"] + "data/images/spinner.gif');";

    this.PageDlg = $('<div id="' + _this.id + '_PageDlg"></div>')
        .append($('<div style="height:100%; width:100%; background: no-repeat center; background-image: ' + spinnerPath + '"></div>'))
        .dialog({resizable: true, height: 700, width: 'auto', modal: true, title: "Steuerungsseite wählen", autoOpen: false});

    this.pictureDlg = $('<div id="' + _this.id + '_Pictures"></div>')
        .append($('<div style="height:100%; width:100%; background: no-repeat center; background-image: ' + spinnerPath + '"></div>'))
        .dialog({resizable: true, height: 700, width: 'auto', modal: true, title: "Bild auswählen", autoOpen: false});

    eventHandler.getPages(function (param) {
        _this.fillContent(param)
    });

    $.getScript(selfPath + 'includes.js', function(){
        eventHandler.getFolderContent(function (param) {fillPictures(_this.pictureDlg, _this.path, 'images/button/', param, _this.id + '_path', _this.config.file);}, './data/widgets/' + _this.selfFolderName + '/images/button/');
    });
}

HCS_Pic_PageLink_CONFIG.prototype = new Widget_CONFIG;
HCS_Pic_PageLink_CONFIG.prototype.constructor = HCS_Pic_PageLink_CONFIG;

HCS_Pic_PageLink_CONFIG.prototype.createContent = function () {
    var _this = this;

    $(this.container)
        .append($('<div></div>')
            .append($('<div style="float: left; width: 60px;"></div>')
                .append($('<label for="' + _this.id + '_newWindow">Neu:</label>'))
                .append($('<br/>'))
                .append($('<input type="checkbox" id="' + _this.id + '_newWindow"/>').click(function () {
                    _this.config.newWindow = ($(this).prop("checked")) ? true : false;
                }))
            )
            .append($('<div style="float: left; width: 300px;"></div>')
                .append($('<label for="' + _this.id + '_page">Steuerungsseite:</label>'))
                .append($('<br/>'))
                .append($('<input id="' + _this.id + '_page" type="text" style="width:340px" disabled/>').addClass("ui-widget-content ui-corner-all").val(this.config.pageName))
            )
        )
        .append($('<div class="ui-helper-clearfix" />'))
        .append($('<br/>'))
        .append($('<div></div>')
            .append($('<button>Steuerungsseite auswählen</button>').button().click(function () {
                $(_this.PageDlg).dialog('open');
            }))
            .append($('<br/>'))
        )
        .append($('<div class="ui-helper-clearfix" />'))
        .append($('<br/>'))
        .append($('<div>Die Bilder für den Knopf müssen in den Ordner<br />"images/button" innerhalb des widgets Ordner abgelegt<br />werden.<br />Die Bilder müssen 2x so breit wie der resultierende<br />Knopf sein.<br /><b>Links ist das normale Bild und rechts das Bild des<br />gedrückten Knopf.</b></div>'))
        .append($('<div></div>')
            .append($('<button>Bild auswählen</button>').button().click(function () {
                $(_this.pictureDlg).dialog('open');
            }))
        )
        .append($('<div></div>')
            .append($('<label for="' + _this.id + '_path">Dateiname:</label>'))
            .append($('<br/>'))
            .append($('<input id="' + _this.id + '_path" style="width:400px" type="text"/>').addClass("ui-widget-content ui-corner-all").val(this.config.file).blur(function () {
                _this.config.file = $(this).val();
            }).click(function () {
                $(_this.pictureDlg).dialog('open');
            }))
        )
    ;
    $('#' + _this.id + '_newWindow').checkbox().checkbox(boolToChecked(this.config.newWindow));
};

HCS_Pic_PageLink_CONFIG.prototype.fillContent = function (content) {
    $(this.PageDlg).empty()
        .append($('<table class="ui-widget ui-widget-content"></table>')
            .append($('<thead></thead>')
                .append($('<tr class="ui-widget-header"></tr>')
                    .append($('<th style="min-width: 40px;">ID</th>'))
                    .append($('<th>Name</th>'))
                    .append($('<th>Kommentar</th>'))
                )
            )
            .append($('<tbody id="' + this.id + '_tBody"></tbody>'))
        );

    var _this = this;

    for (var pageIndex in content) {
        var tr = $('#' + this.id + '_tBody').append($('<tr></tr>')).children().last();

        $(tr).append($('<th style="font-weight: normal; border-bottom: #FFF thin dashed;">' + content[pageIndex]['Id'] + '</th>'))
            .append($('<th style="font-weight: normal; border-bottom: #FFF thin dashed;">' + content[pageIndex]['Name'] + '</th>'))
            .append($('<th style="font-weight: normal; border-bottom: #FFF thin dashed;">' + content[pageIndex]['Comment'] + '</th>'))
            .on('click', {pId: content[pageIndex]['Id'], pName: content[pageIndex]['Name']}, function (e) {
                $('#' + _this.id + '_page').val(e.data.pName);
                _this.config.pageName = e.data.pName;
                _this.config.pageId = e.data.pId;

                $(_this.PageDlg).dialog('close');
            })
            .hover(function(){$(this).addClass('ui-state-hover');},function(){$(this).removeClass('ui-state-hover');})
            .mouseover(function() {$(this).css('cursor', 'pointer');})
        ;
    }
};

HCS_Pic_PageLink_CONFIG.prototype.createComment = function () {
    return this.config.pageName;
};