// DISPLAY AREA
function HCS_Pic_Slider(containerElement, eventHandler, globals, config, selfPath) {
    var _this = this;
    this.config = config;
    this.container = containerElement;
    this.config.orientation = 'horizontal'; // horizontal, vertical
    this.path = selfPath;
    if((typeof this.config.file === "undefined") || (this.config.file == '')){
        this.file = selfPath + 'images/slider_missing.png';
    } else {
        this.file = selfPath + 'images/slider/' + this.config.file;
    }

    this.sliderContainer = $('<div style="background: url(\'' + this.file + '\') 0px 0px; border: none;" />');
    this.slider = this.sliderContainer.slider({
        orientation: this.config.orientation,
        animate: "fast",
        max: 100,
        min: 0,
        step: 5,
        value: 40,
        range: 'min',
        disabled: true
    });

    var theImage = new Image();
    theImage.src = this.file;
    this.imageSourceWidth = parseInt(theImage.width);
    this.imageSourceHeight = parseInt(theImage.height);
    this.imageHeight = parseInt(this.imageSourceHeight / 2);
    theImage.onload = function(){
        _this.imageSourceWidth = parseInt(theImage.width);
        _this.imageSourceHeight = parseInt(theImage.height);
        _this.imageHeight = parseInt(_this.imageSourceHeight / 2);

        $(_this.sliderContainer).css('height', _this.imageHeight+'px');
        $(_this.slider)
            .find('.ui-slider-range').css('background', 'url(' + _this.file + ') 0px -' + _this.imageHeight + 'px').end()
            .find('.ui-slider-handle').css('height', _this.imageHeight + 'px');
    };

    this.slider
        .css('opacity', '1')
        .removeClass('ui-corner-all ui-widget-content ui-widget ui-widget-content ui-state-default ui-widget-header')

        .find('.ui-slider-range')
        .removeClass('ui-corner-all ui-widget-content ui-widget ui-widget-content ui-state-default ui-widget-header')
        .css('background', 'none')
        .css('background', 'url(\'' + this.file + '\') 0px -' + this.imageHeight + 'px')
        .end()

        .find('.ui-slider-handle')
        .removeClass('ui-corner-all ui-widget-content ui-widget ui-widget-content ui-state-default ui-widget-header')
        .css('border', 'none')
        .css('background', 'none')
        .css('outline', 'none')
        .css('width', '30px')
        .css('height', this.imageHeight + 'px')
        .css('margin-left', '-15px')
        .css('top', '0px')
        .end();
    $(this.slider).find('.ui-slider-handle').unbind('mousedown').unbind('click');
    $(this.container).empty().append(this.slider);

}
HCS_Pic_Slider.prototype = new Widget;
HCS_Pic_Slider.prototype.constructor = HCS_Pic_Slider;

// CONFIG AREA
function HCS_Pic_Slider_CONFIG(containerElement, eventHandler, globals, selfPath) {
    var _this = this;
    this.container = containerElement;
    this.eventHandler = eventHandler;
    this.globals = globals;
    this.path = selfPath;

    if (selfPath.charAt(selfPath.length-1) == '/'){
        this.selfFolderName = selfPath.substring(0, selfPath.length-1)
    }
    this.selfFolderName = this.selfFolderName.substring(this.selfFolderName.lastIndexOf('/')+1, this.selfFolderName.length)

    this.config = {};
    this.config.ccu = "";
    this.config.adr = "";
    this.config.dp = "";
    this.config.file = "";
    this.id = randomString(16, 'aA');

    var spinnerPath = "url('" + this.globals["rootPath"] + "data/images/spinner.gif');";

    this.devicesDlg = $('<div id="' + _this.id + '_Devices"></div>')
        .append($('<div style="height:100%; width:100%; background: no-repeat center; background-image: ' + spinnerPath + '"></div>'))
        .dialog({resizable: true, height: 700, width: 'auto', modal: true, title: "Gerät wählen", autoOpen: false});

    this.pictureDlg = $('<div id="' + _this.id + '_Pictures"></div>')
        .append($('<div style="height:100%; width:100%; background: no-repeat center; background-image: ' + spinnerPath + '"></div>'))
        .dialog({resizable: true, height: 700, width: 'auto', modal: true, title: "Bild auswählen", autoOpen: false});

    $.getScript(selfPath + 'includes.js', function(){
        eventHandler.getDataPointDevices(function (param) {fillDevices(_this, param, true);}, 'LEVEL');
        eventHandler.getFolderContent(function (param) {fillPictures(_this.pictureDlg, _this.path, 'images/slider/', param, _this.id + '_path', _this.config.file);}, './data/widgets/' + _this.selfFolderName + '/images/slider/');
    });
}
HCS_Pic_Slider_CONFIG.prototype = new Widget_CONFIG;
HCS_Pic_Slider_CONFIG.prototype.constructor = HCS_Pic_Slider_CONFIG;

HCS_Pic_Slider_CONFIG.prototype.createContent = function () {
    var _this = this;

    $(this.container)
        .append($('<div></div>')
            .append($('<div style="float: left; width: 70px;"></div>')
                .append($('<label for="' + _this.id + '_ccu">CCU:</label>'))
                .append($('<br/>'))
                .append($('<input id="' + _this.id + '_ccu" style="width: 50px;" type="text" disabled/>').addClass("ui-widget-content ui-corner-all").val(this.config.ccu).blur(function () {
                    _this.config.ccu = $(this).val();
                }))
            )
            .append($('<div style="float: left; width: 170px;"></div>')
                .append($('<label for="' + _this.id + '_adr">Adresse:</label>'))
                .append($('<br/>'))
                .append($('<input id="' + _this.id + '_adr" style="width: 150px;" type="text" disabled/>').addClass("ui-widget-content ui-corner-all").val(this.config.adr).blur(function () {
                    _this.config.adr = $(this).val();
                }))
            )
            .append($('<div style="float: left; width: 170px;"></div>')
                .append($('<label for="' + _this.id + '_dp">DataPoint:</label>'))
                .append($('<br/>'))
                .append($('<input id="' + _this.id + '_dp" style="width: 150px;" type="text" disabled/>').addClass("ui-widget-content ui-corner-all").val(this.config.dp).blur(function () {
                    _this.config.dp = $(this).val();
                }))
            )
        )
        .append($('<div class="ui-helper-clearfix" />'))
        .append($('<br/>'))
        .append($('<div></div>')
            .append($('<button>Geräte wählen</button>').button().click(function () {
                $(_this.devicesDlg).dialog('open');
            }))
            .append($('<br/>'))
        )
        .append($('<div class="ui-helper-clearfix" />'))
        .append($('<br/>'))
        .append($('<div>Die Bilder für den Knopf müssen in den Ordner<br />"images/slider" innerhalb des widgets Ordner abgelegt<br />werden.<br />Die Bilder müssen 2x so hoch wie der resultierende<br />Knopf sein.<br /><b>Oben ist der Hintergrund und unten der <br />Vordergrund für den Slider.</b></div>'))
        .append($('<div></div>')
            .append($('<button>Bild auswählen</button>').button().click(function () {
                $(_this.pictureDlg).dialog('open');
            }))
        )
        .append($('<div></div>')
            .append($('<label for="' + _this.id + '_path">Dateiname:</label>'))
            .append($('<br/>'))
            .append($('<input id="' + _this.id + '_path" style="width:400px" type="text"/>').addClass("ui-widget-content ui-corner-all").val(this.config.file).blur(function () {
                _this.config.file = $(this).val();
            }).click(function () {
                $(_this.pictureDlg).dialog('open');
            }))
        )
    ;
};

HCS_Pic_Slider_CONFIG.prototype.createComment = function () {
    return this.deviceName;
};

