// DISPLAY AREA
function HCS_Pic_Status(containerElement, eventHandler, globals, config, selfPath) {
    var _this = this;
    this.config = config;
    this.container = containerElement;
    this.eventHandler = eventHandler;
    this.globals = globals;
    this.selfPath = selfPath;

    if((typeof this.config.standardImage === "undefined") || (this.config.standardImage == '')){
        this.file = selfPath + 'images/status_missing.png';
    } else {
        this.file = selfPath + 'images/status/' + this.config.standardImage;
    }

    this.imageContainer = $('<div style="border-width: 0px; background: 0px 0px url(\'' + this.file + '\') no-repeat;" />')

    var theImage = new Image();
    theImage.src = this.file;
    this.imageSourceWidth = parseInt(theImage.width);
    this.imageSourceHeight = parseInt(theImage.height);
    theImage.onload = function(){
        _this.imageSourceWidth = parseInt(theImage.width);
        _this.imageSourceHeight = parseInt(theImage.height);
        $(_this.imageContainer).css({
            'width': _this.imageSourceWidth+'px',
            'height': _this.imageSourceHeight+'px'
        });
    };

    $(containerElement).empty();
    $(this.imageContainer).css({'width': this.imageSourceWidth+'px','height': this.imageSourceHeight+'px'});
    $(containerElement).append(this.imageContainer);
}
HCS_Pic_Status.prototype = new Widget;
HCS_Pic_Status.prototype.constructor = HCS_Pic_Status;

// CONFIG AREA
function HCS_Pic_Status_CONFIG(containerElement, eventHandler, globals, selfPath) {
    var _this = this;
    this.container = containerElement;
    this.eventHandler = eventHandler;
    this.globals = globals;
    this.path = selfPath;

    if (selfPath.charAt(selfPath.length-1) == '/'){
        this.selfFolderName = selfPath.substring(0, selfPath.length-1)
    }
    this.selfFolderName = this.selfFolderName.substring(this.selfFolderName.lastIndexOf('/')+1, this.selfFolderName.length)

    this.config = {};
    this.config.replace = "{}";
    this.config.value = "%VALUE%";
    this.config.ccu = "";
    this.config.adr = "";
    this.config.dp = "";
    this.config.standardImage = "";

    this.id = randomString(16, 'aA');
    this.replaceObj = null;
    this.folderContent = null;

    this.bla = null;

    var spinnerPath = "url('" + this.globals["rootPath"] + "data/images/spinner.gif');";

    this.devicesDlg = $('<div id="' + _this.id + '_Devices"></div>')
        .append($('<div style="height:100%; width:100%; background: no-repeat center; background-image: ' + spinnerPath + '"></div>'))
        .dialog({resizable: true, height: 700, width: 'auto', modal: true, title: "Wähle Geräte Datenpunkt", autoOpen: false});

    this.pictureDlg = $('<div id="' + _this.id + '_Pictures"></div>')
        .append($('<div style="height:100%; width:100%; background: no-repeat center; background-image: ' + spinnerPath + '"></div>'))
        .dialog({resizable: true, height: 700, width: 'auto', modal: true, title: "Bild auswählen", autoOpen: false});

    $.getScript(selfPath + 'includes.js', function(){
        eventHandler.getDataPointDevices(function (param) {fillDevices(_this, param, true);}, '*');
        eventHandler.getFolderContent(function (param) {
            _this.folderContent = param;
            fillPictures(_this.pictureDlg, _this.path, 'images/status/', _this.folderContent, _this.id + '_standardImage', _this.bla);
        }, './data/widgets/' + _this.selfFolderName + '/images/status/');
    });

    this.replaceDlg = $('<div />')
        .append($('<div></div>')
            .append($('<div>Wertebereich mit Komma trennen bspw. 1 bis 10: <b>1,10</b></div>'))
            .append($('<div style="float: left; width: 150px;"></div>')
                .append($('<label for="' + _this.id + '_repaceValue">Wert:</label>'))
                .append($('<br/>'))
                .append($('<input id="' + _this.id + '_repaceValue" style="width: 140px;" type="text"/>').addClass("ui-widget-content ui-corner-all"))
            )
            .append($('<div style="float: left; width: 300px;"></div>')
                .append($('<label for="' + _this.id + '_replaceString">ersetzen mit:</label>'))
                .append($('<div style="line-height:30px; height: 30px"></div>')
                    .append($('<input id="' + _this.id + '_replaceString" type="text" style="width:250px"/>').click(function (){
                        fillPictures(_this.pictureDlg, _this.path, 'images/status/', _this.folderContent, _this.id + '_replaceString', _this.bla);
                        $(_this.pictureDlg).dialog('open');
                    }).addClass("ui-widget-content ui-corner-all"))
                    .append($('<button style="margin-left: 5px; height: 28px; top: -2px; width: 36px;"/>').button().button("option", "icons", {primary: 'ui-icon-circle-plus'}).click(function () {
                        _this.replaceObj[$('#' + _this.id + '_repaceValue').val()] = $('#' + _this.id + '_replaceString').val();
                        $('#' + _this.id + '_repaceValue').val('');
                        $('#' + _this.id + '_replaceString').val('');
                        _this.fillReplace();
                    }))
                )
            )
        )
        .append('<div class="ui-helper-clearfix" />')
        .append('<br/>')
        .append($('<table style="width: 100%" class="ui-widget ui-widget-content StateTable"></table>')
            .append($('<thead></thead>')
                .append($('<tr class="ui-widget-header"></tr>')
                    .append('<th>Wert</th>')
                    .append('<th>wird ersetzt mit</th>')
                    .append('<th style="width: 100px;">Entfernen</th>')
                )
            )
            .append($('<tbody id="replaceHeader"></tbody>'))
        )
        .dialog({
            resizable: false,
            height: 'auto',
            width: '500',
            modal: true,
            title: "Werte ersetzen",
            autoOpen: false,
            open: function () {
                _this.replaceObj = hcs_parseJSON(_this.config.replace);
                _this.fillReplace();
            },
            buttons: {
                "Abbrechen": function () {
                    $(this).dialog('close');
                },
                "Speichern": function () {
                    var replaceString = JSON.stringify(_this.replaceObj);

                    $('#' + _this.id + '_replace').val(replaceString);
                    _this.config.replace = replaceString;
                    $(this).dialog('close');
                }
            }
        });
}
HCS_Pic_Status_CONFIG.prototype = new Widget_CONFIG;
HCS_Pic_Status_CONFIG.prototype.constructor = HCS_Pic_Status_CONFIG;

HCS_Pic_Status_CONFIG.prototype.createContent = function () {
    var _this = this;
    $(this.container)
        .append($('<div></div>')
            .append($('<div style="float: left; width: 70px;"></div>')
                .append($('<label for="' + _this.id + '_ccu">CCU:</label>'))
                .append($('<br/>'))
                .append($('<input id="' + _this.id + '_ccu" style="width: 50px;" type="text" disabled/>').addClass("ui-widget-content ui-corner-all").val(this.config.ccu).blur(function () {
                    _this.config.ccu = $(this).val();
                }))
            )
            .append($('<div style="float: left; width: 170px;"></div>')
                .append($('<label for="' + _this.id + '_adr">Address:</label>'))
                .append($('<br/>'))
                .append($('<input id="' + _this.id + '_adr" style="width: 150px;" type="text" disabled/>').addClass("ui-widget-content ui-corner-all").val(this.config.adr).blur(function () {
                    _this.config.adr = $(this).val();
                }))
            )
            .append($('<div style="float: left; width: 170px;"></div>')
                .append($('<label for="' + _this.id + '_dp">DataPoint:</label>'))
                .append($('<br/>'))
                .append($('<input id="' + _this.id + '_dp" style="width: 150px;" type="text" disabled/>').addClass("ui-widget-content ui-corner-all").val(this.config.dp).blur(function () {
                    _this.config.dp = $(this).val();
                }))
            )
        )
        .append($('<div class="ui-helper-clearfix" />'))
        .append($('<br/>'))
        .append($('<div></div>')
            .append($('<button>Select Device DataPoint</button>').button().click(function () {
                $(_this.devicesDlg).dialog('open');
            }))
            .append($('<br/>'))
        )
        .append($('<br/>'))
        .append($('<div></div>')
            .append($('<div style="float: left; width: 400px;"></div>')
                .append($('<label for="' + _this.id + '_value">Wert umrechnen z.B. "%VALUE% * 100":</label>'))
                .append($('<div style="line-height:30px; height: 30px"></div>')
                    .append($('<input id="' + _this.id + '_value" type="text" style="width:355px"/>').addClass("ui-widget-content ui-corner-all").val(this.config.value).blur(function () {
                        _this.config.value = $(this).val();
                    }))
                    .append($('<button style="margin-left: 5px; height: 28px; top: -2px; width: 36px;"/>').button().button("option", "icons", {primary: 'ui-icon-circle-plus'}).click(function () {
                        var iText = $('#' + _this.id + '_value');
                        iText.val(iText.val() + '%VALUE%');
                        _this.config.value = iText.val();
                    }))
                )
            )
        )
        .append($('<br/>'))
        .append($('<div></div>')
            .append($('<div style="float: left; width: 400px;"></div>')
                .append($('<label for="' + _this.id + '_replace">Werte individuell ersetzen:</label>'))
                .append($('<div style="line-height:30px; height: 30px"></div>')
                    .append($('<input id="' + _this.id + '_replace" type="text" disabled style="width:355px"/>').addClass("ui-widget-content ui-corner-all").val(this.config.replace).blur(function () {
                        _this.config.replace = $(this).val();
                    }))
                    .append($('<button style="margin-left: 5px; height: 28px; top: -2px; width: 36px;"/>').button().button("option", "icons", {primary: 'ui-icon-pencil'}).click(function () {
                        _this.replaceDlg.dialog('open');
                    }))
                )
            )
        )
        .append($('<br />'))
        .append($('<div class="ui-helper-clearfix" />'))
        .append($('<div />')
            .append($('<label for="' + _this.id + '_standardImage">Standard Bild:</label>'))
            .append($('<div style="line-height:30px; height: 30px"></div>')
                .append($('<input id="' + _this.id + '_standardImage" type="text" style="width:400px"/>').addClass("ui-widget-content ui-corner-all").val(this.config.standardImage).blur(function () {
                    _this.config.standardImage = $(this).val();
                }).click(function () {
                    fillPictures(_this.pictureDlg, _this.path, 'images/status/', _this.folderContent, _this.id + '_standardImage', _this.config.standardImage);
                    $(_this.pictureDlg).dialog('open');
                }))
            )
        )
        .find('label').css({'padding-left': '10px', 'padding-right': '0px'})
    ;
    $(this.container).dialog('option', 'position', 'center');
};

HCS_Pic_Status_CONFIG.prototype.fillReplace = function () {
    var _this = this;
    $('#replaceHeader').empty();
    for (var key in this.replaceObj){
        $('#replaceHeader').append($('<tr>' +
            '<th class="replaceKey">' + key + '</th>' +
            '<th class="replaceString">' + this.replaceObj[key] + '</th>' +
            '<th><a class="replaceDelete">Entfernen</a></th>' +
            '</tr>'));
    }
    $('.replaceDelete').button({
        icons: {primary: "ui-icon-closethick"},
        text: false
    }).click(function () {
            var delKey = $(this).parent().siblings('.replaceKey').text();
            delete _this.replaceObj[delKey];
            _this.fillReplace();
        });
    $('.replaceKey').click(function () {
        $('#' + _this.id + '_repaceValue').val($(this).html());
        $('#' + _this.id + '_replaceString').val($(this).siblings('.replaceString').html());
    });
    $('.replaceString').click(function () {
        $('#' + _this.id + '_repaceValue').val($(this).siblings('.replaceKey').html());
        $('#' + _this.id + '_replaceString').val($(this).html());
    });
};

HCS_Pic_Status_CONFIG.prototype.createComment = function () {
    return this.deviceName;
};