// DISPLAY AREA
function HCS_Pic_StatusBinary(containerElement, eventHandler, globals, config, selfPath) {
    var _this = this;
    this.config = config;
    this.container = containerElement;
    this.eventHandler = eventHandler;
    this.globals = globals;
    this.selfPath = selfPath;

    if((typeof this.config.offImage === "undefined") || (this.config.offImage == '')){
        this.file = selfPath + 'images/status_missing.png';
    } else {
        this.file = selfPath + 'images/status/' + this.config.offImage;
    }

    this.imageContainer = $('<div style="border-width: 0px; background: 0px 0px url(\'' + this.file + '\') no-repeat;" />')

    var theImage = new Image();
    theImage.src = this.file;
    this.imageSourceWidth = parseInt(theImage.width);
    this.imageSourceHeight = parseInt(theImage.height);
    theImage.onload = function(){
        _this.imageSourceWidth = parseInt(theImage.width);
        _this.imageSourceHeight = parseInt(theImage.height);
        $(_this.imageContainer).css({
            'width': _this.imageSourceWidth+'px',
            'height': _this.imageSourceHeight+'px'
        });
    };

    $(containerElement).empty();
    $(this.imageContainer).css({'width': this.imageSourceWidth+'px','height': this.imageSourceHeight+'px'});
    $(containerElement).append(this.imageContainer);
}
HCS_Pic_StatusBinary.prototype = new Widget;
HCS_Pic_StatusBinary.prototype.constructor = HCS_Pic_StatusBinary;

// CONFIG AREA
function HCS_Pic_StatusBinary_CONFIG(containerElement, eventHandler, globals, selfPath) {
    var _this = this;
    this.container = containerElement;
    this.eventHandler = eventHandler;
    this.globals = globals;
    this.path = selfPath;

    if (selfPath.charAt(selfPath.length-1) == '/'){
        this.selfFolderName = selfPath.substring(0, selfPath.length-1)
    }
    this.selfFolderName = this.selfFolderName.substring(this.selfFolderName.lastIndexOf('/')+1, this.selfFolderName.length)

    this.config = {};
    this.config.ccu = "";
    this.config.adr = "";
    this.config.dp = "";
    this.config.offImage = "";
    this.config.onImage = "";

    this.id = randomString(16, 'aA');
    this.folderContent = null;

    var spinnerPath = "url('" + this.globals["rootPath"] + "data/images/spinner.gif');";

    this.devicesDlg = $('<div id="' + _this.id + '_Devices"></div>')
        .append($('<div style="height:100%; width:100%; background: no-repeat center; background-image: ' + spinnerPath + '"></div>'))
        .dialog({resizable: true, height: 700, width: 'auto', modal: true, title: "Wähle Geräte Datenpunkt", autoOpen: false});

    this.pictureDlg = $('<div id="' + _this.id + '_Pictures"></div>')
        .append($('<div style="height:100%; width:100%; background: no-repeat center; background-image: ' + spinnerPath + '"></div>'))
        .dialog({resizable: true, height: 700, width: 'auto', modal: true, title: "Bild auswählen", autoOpen: false});

    $.getScript(selfPath + 'includes.js', function(){
        eventHandler.getDataPointDevices(function (param) {fillDevices(_this, param, true);}, '*');
        eventHandler.getFolderContent(function (param) {
            _this.folderContent = param;
        }, './data/widgets/' + _this.selfFolderName + '/images/status/');
    });
}
HCS_Pic_StatusBinary_CONFIG.prototype = new Widget_CONFIG;
HCS_Pic_StatusBinary_CONFIG.prototype.constructor = HCS_Pic_StatusBinary_CONFIG;

HCS_Pic_StatusBinary_CONFIG.prototype.createContent = function () {
    var _this = this;
    $(this.container)
        .append($('<div></div>')
            .append($('<div style="float: left; width: 70px;"></div>')
                .append($('<label for="' + _this.id + '_ccu">CCU:</label>'))
                .append($('<br/>'))
                .append($('<input id="' + _this.id + '_ccu" style="width: 50px;" type="text" disabled/>').addClass("ui-widget-content ui-corner-all").val(this.config.ccu).blur(function () {
                    _this.config.ccu = $(this).val();
                }))
            )
            .append($('<div style="float: left; width: 170px;"></div>')
                .append($('<label for="' + _this.id + '_adr">Address:</label>'))
                .append($('<br/>'))
                .append($('<input id="' + _this.id + '_adr" style="width: 150px;" type="text" disabled/>').addClass("ui-widget-content ui-corner-all").val(this.config.adr).blur(function () {
                    _this.config.adr = $(this).val();
                }))
            )
            .append($('<div style="float: left; width: 170px;"></div>')
                .append($('<label for="' + _this.id + '_dp">DataPoint:</label>'))
                .append($('<br/>'))
                .append($('<input id="' + _this.id + '_dp" style="width: 150px;" type="text" disabled/>').addClass("ui-widget-content ui-corner-all").val(this.config.dp).blur(function () {
                    _this.config.dp = $(this).val();
                }))
            )
        )
        .append($('<div class="ui-helper-clearfix" />'))
        .append($('<br/>'))
        .append($('<div></div>')
            .append($('<button>Select Device DataPoint</button>').button().click(function () {
                $(_this.devicesDlg).dialog('open');
            }))
            .append($('<br/>'))
        )
        .append($('<br />'))
        .append($('<div class="ui-helper-clearfix" />'))
        .append($('<div />')
            .append($('<label for="' + _this.id + '_offImage">Bild für Zustand "0/Aus/Falsch":</label>'))
            .append($('<div style="line-height:30px; height: 30px"></div>')
                .append($('<input id="' + _this.id + '_offImage" type="text" style="width:400px"/>').addClass("ui-widget-content ui-corner-all").val(this.config.offImage).blur(function () {
                    _this.config.offImage = $(this).val();
                }).click(function () {
                    fillPictures(_this.pictureDlg, _this.path, 'images/status/', _this.folderContent, _this.id + '_offImage', _this.config.offImage);
                    $(_this.pictureDlg).dialog('open');
                }))
            )
        )
        .append($('<div />')
            .append($('<label for="' + _this.id + '_onImage">Bild für Zustand "1/An/Wahr":</label>'))
            .append($('<div style="line-height:30px; height: 30px"></div>')
                .append($('<input id="' + _this.id + '_onImage" type="text" style="width:400px"/>').addClass("ui-widget-content ui-corner-all").val(this.config.onImage).blur(function () {
                    _this.config.onImage = $(this).val();
                }).click(function () {
                    fillPictures(_this.pictureDlg, _this.path, 'images/status/', _this.folderContent, _this.id + '_onImage', _this.config.onImage);
                    $(_this.pictureDlg).dialog('open');
                }))
            )
        )
        .find('label').css({'padding-left': '10px', 'padding-right': '0px'})
    ;
    $(this.container).dialog('option', 'position', 'center');
};

HCS_Pic_StatusBinary_CONFIG.prototype.createComment = function () {
    return this.deviceName;
};
