function HCS_Pic_Status(containerElement, eventHandler, globals, config, selfPath) {
    var _this = this;
    this.config = config;
    this.container = containerElement;
    this.eventHandler = eventHandler;
    this.globals = globals;
    this.selfPath = selfPath;

    if((typeof this.config.standardImage === "undefined") || (this.config.standardImage == '')){
        this.file = selfPath + 'images/status_missing.png';
    } else {
        this.file = selfPath + 'images/status/' + this.config.standardImage;
    }

    this.imageContainer = $('<div style="border-width: 0px; background: 0px 0px url(\'' + this.file + '\') no-repeat;" />')
    this.updatePicture();

    $(containerElement).empty();
    $(this.imageContainer).css({'width': this.imageSourceWidth+'px','height': this.imageSourceHeight+'px'})
        .click(function () {
            eventHandler.getValueSn(_this.config.ccu, _this.config.adr, _this.config.dp, function (param) {
                _this.updateValue({"1": param});
            });
        });
    $(containerElement).append(this.imageContainer);
    eventHandler.register(function (param) {_this.updateValue(param)}, {"1": {"ccu": config["ccu"], "adr": config["adr"], "dp": config["dp"]}});
}

HCS_Pic_Status.prototype = new Widget;
HCS_Pic_Status.prototype.constructor = HCS_Pic_Status;

HCS_Pic_Status.prototype.updatePicture = function (){
    var _this = this;
    var theImage = new Image();
    theImage.src = this.file;
    this.imageSourceWidth = parseInt(theImage.width);
    this.imageSourceHeight = parseInt(theImage.height);
    theImage.onload = function(){
        _this.imageSourceWidth = parseInt(theImage.width);
        _this.imageSourceHeight = parseInt(theImage.height);
        $(_this.imageContainer).css({
            'width': _this.imageSourceWidth+'px',
            'height': _this.imageSourceHeight+'px',
            'background': '0px 0px url(' + _this.file + ')'
        });
    };
};

HCS_Pic_Status.prototype.updateValue = function(transport) {
   // $(this.container).empty();
    var value = this.config.value.replace(/%VALUE%/g, transport["1"]);

    if (isNumber(transport["1"])){
        value = eval(value).toString();
    }

    var replaceValueArray = hcs_parseJSON(this.config.replace);
    var newImage = '';
    var key = '';

    for (var replaceValue in replaceValueArray){
        key = replaceValue;

        if (replaceValue == value){
            // perfect match
            newImage = replaceValueArray[key];
            break;
        } else {
            // check if there is an matching interval
            var split = key.split(",");
            if ( (split.length == 2) && (betweenNumbers(value, parseFloat(split[0]), parseFloat(split[1]) )) ){
                newImage = replaceValueArray[key];
            }
        }
    }
    if (newImage == ''){
        // no match
        newImage = this.config.standardImage;
    }
    this.file = this.selfPath + 'images/status/' + newImage;
    this.updatePicture();
};