function HCS_Pic_StatusBinary(containerElement, eventHandler, globals, config, selfPath) {
    var _this = this;
    this.config = config;
    this.container = containerElement;
    this.eventHandler = eventHandler;
    this.globals = globals;
    this.selfPath = selfPath;

    if((typeof this.config.offImage === "undefined") || (this.config.offImage == '')){
        this.file = selfPath + 'images/status_missing.png';
    } else {
        this.file = selfPath + 'images/status/' + this.config.offImage;
    }

    this.imageContainer = $('<div style="border-width: 0px; background: 0px 0px url(\'' + this.file + '\') no-repeat;" />')
    this.updatePicture();

    $(containerElement).empty();
    $(this.imageContainer).css({'width': this.imageSourceWidth+'px','height': this.imageSourceHeight+'px'})
        .click(function () {
            eventHandler.getValueSn(_this.config.ccu, _this.config.adr, _this.config.dp, function (param) {
                _this.updateValue({"1": param});
            });
        });
    $(containerElement).append(this.imageContainer);
    eventHandler.register(function (param) {_this.updateValue(param)}, {"1": {"ccu": config["ccu"], "adr": config["adr"], "dp": config["dp"]}});
}

HCS_Pic_StatusBinary.prototype = new Widget;
HCS_Pic_StatusBinary.prototype.constructor = HCS_Pic_StatusBinary;

HCS_Pic_StatusBinary.prototype.updatePicture = function (){
    var _this = this;
    var theImage = new Image();
    theImage.src = this.file;
    this.imageSourceWidth = parseInt(theImage.width);
    this.imageSourceHeight = parseInt(theImage.height);
    theImage.onload = function(){
        _this.imageSourceWidth = parseInt(theImage.width);
        _this.imageSourceHeight = parseInt(theImage.height);
        $(_this.imageContainer).css({
            'width': _this.imageSourceWidth+'px',
            'height': _this.imageSourceHeight+'px',
            'background': '0px 0px url(' + _this.file + ')'
        });
    };
};

HCS_Pic_StatusBinary.prototype.updateValue = function(transport) {
   // $(this.container).empty();
    var value = transport["1"];
    var newImage = '';

    if (isNumber(value)){
        if (value == 0){
            newImage = this.config.offImage;
        } else {
            newImage = this.config.onImage;
        }
    } else {

        if ($.inArray(value.toLowerCase(), ["aus", "off", "0", "false", "falsch"]) >= 0){
            newImage = this.config.offImage;
        } else {
            newImage = this.config.onImage;
        }
    }
    this.file = this.selfPath + 'images/status/' + newImage;
    this.updatePicture();

};