function HCS_Pic_ToggleButton(containerElement, eventHandler, globals, config, selfPath) {
    var _this = this;
    this.config = config;
    this.container = containerElement;
    this.expected = true;
    this.state = false;
    this.eventHandler = eventHandler;
    this.globals = globals;
    this.working = false;
    this.worker = false;

    if((typeof this.config.file === "undefined") || (this.config.file == '')){
        this.file = selfPath + 'images/toggle_missing.png';
    } else {
        this.file = selfPath + 'images/toggle/' + this.config.file;
    }

    this.button = $('<div style="border-width: 0px; background: 0px 0px url(\'' + this.file + '\') no-repeat;" />')

    var theImage = new Image();
    theImage.src = this.file;
    this.imageSourceWidth = parseInt(theImage.width);
    this.imageSourceHeight = parseInt(theImage.height);
    this.imageWidth = parseInt(this.imageSourceWidth / 10);
    theImage.onload = function(){
        _this.imageSourceWidth = parseInt(theImage.width);
        _this.imageSourceHeight = parseInt(theImage.height);
        _this.imageWidth = parseInt(_this.imageSourceWidth / 10);
        $(_this.button).css({
            'width': _this.imageWidth+'px',
            'height': _this.imageSourceHeight+'px'
        });
    };

    $(containerElement).empty();
    $(this.button).css({'width': this.imageWidth+'px','height': this.imageSourceHeight+'px'})
        .click(function () {
            _this.eventHandler.getValueSn(_this.config.ccu, _this.config.adr, _this.config.dp, function (param) {
                _this.updateValue({"state": param})
            });
        })
        .mousedown(function () {
            $(this).css('background-position', '-' + _this.imageWidth + 'px, 0px');
        })
        .mouseup(function () {
            $(this).css('background-position', '0px, 0px');
        });
    $(containerElement).append(this.button);

    if (_this.config.dp == 'LEVEL') {
        this.worker = true;
        eventHandler.register(function (param) {
                _this.updateValue(param)
            },
            {
                "working": {"ccu": config.ccu, "adr": config.adr, "dp": "WORKING"},
                "state": {"ccu": config.ccu, "adr": config.adr, "dp": _this.config.dp}
            });
    } else {
        eventHandler.register(function (param) {
                _this.updateValue(param);
            },
            {
                "state": {"ccu": config.ccu, "adr": config.adr, "dp": _this.config.dp}
            });
    }

}
HCS_Pic_ToggleButton.prototype = new Widget;
HCS_Pic_ToggleButton.prototype.constructor = HCS_Pic_ToggleButton;

HCS_Pic_ToggleButton.prototype.updateValue = function (value) {
    if (typeof value["working"] != "undefined") {
        if ((value["working"] == true) || (value["working"] == 'true')) {
            this.working = true;
        } else {
            this.working = false;
        }
    }
    if (typeof value["state"] != "undefined") {
        if ((value["state"] == true) || (value["state"] == 'true') || (value["state"] > 0)) {
            this.state = true;
        } else {
            this.state = false;
        }
        this.expected = false;
    }

    this.updateButton();
};

HCS_Pic_ToggleButton.prototype.updateButton = function () {
    var _this = this;
    var mode = 'unknown';

    if (this.working) {
        return;
    }

    if (this.state && !this.expected) {
        mode = 'on';

    } else if (this.state && this.expected) {
        mode = 'expected on';

    } else if (!this.state && !this.expected) {
        mode = 'off';

    } else if (!this.state && this.expected) {
        mode = 'expected off';
    }

    switch (mode) {
        case "on":
            $(this.button)
                .css('background-position', '-' + _this.imageWidth * 2 + 'px, 0px')
                .mouseup(function () {
                    $(this).css('background-position', '-' + _this.imageWidth * 2 + 'px, 0px');
                })
                .mouseleave(function () {
                    $(this).css('background-position', '-' + _this.imageWidth * 2 + 'px, 0px');
                })
                .unbind('click')
                .unbind('mousedown')
                .click(function () {
                    if (_this.globals['RIGHTS'] >= 2) {
                        _this.eventHandler.setValueSn(_this.config.ccu, _this.config.adr, _this.config.dp, 0);
                        _this.state = false;
                        _this.expected = true;
                        _this.updateButton();
                        if (_this.worker) {
                            _this.working = true;
                        }
                    }
                })
                .title = this.config.titleOn;
            if (_this.globals['RIGHTS'] >= 2) {
                $(this.button).mousedown(function () {
                    $(this).css('background-position', '-' + _this.imageWidth * 3 + 'px, 0px');
                })
            }
            break;

        case "expected on":
            $(this.button)
                .css('background-position', '-' + _this.imageWidth * 4 + 'px, 0px')
                .mouseup(function () {
                    $(this).css('background-position', '-' + _this.imageWidth * 4 + 'px, 0px');
                })
                .mouseleave(function () {
                    $(this).css('background-position', '-' + _this.imageWidth * 4 + 'px, 0px');
                })
                .unbind('click')
                .unbind('mousedown')
                .click(function () {
                    if (_this.config.setWhileUncertain) {
                        if (_this.globals['RIGHTS'] >= 2) {
                            _this.eventHandler.setValueSn(_this.config.ccu, _this.config.adr, _this.config.dp, 0);
                            _this.state = false;
                            _this.expected = true;
                            _this.updateButton();
                            if (_this.worker) {
                                _this.working = true;
                            }
                        }
                    } else {
                        _this.eventHandler.getValueSn(_this.config.ccu, _this.config.adr, 'STATE', function (param) {
                            _this.updateValue({"state": param})
                        });
                    }
                })
                .title = this.config.titleOnExpected;
            if (_this.globals['RIGHTS'] >= 2) {
                $(this.button).mousedown(function () {
                    $(this).css('background-position', '-' + _this.imageWidth * 5 + 'px, 0px');
                })
            }
            break;

        case "off":
            $(this.button)
                .css('background-position', '-' + _this.imageWidth * 6 + 'px, 0px')
                .mouseup(function () {
                    $(this).css('background-position', '-' + _this.imageWidth * 6 + 'px, 0px');
                })
                .mouseleave(function () {
                    $(this).css('background-position', '-' + _this.imageWidth * 6 + 'px, 0px');
                })
                .unbind('click')
                .unbind('mousedown')
                .click(function () {
                    if (_this.globals['RIGHTS'] >= 2) {
                        _this.eventHandler.setValueSn(_this.config.ccu, _this.config.adr, _this.config.dp, 1);
                        _this.state = true;
                        _this.expected = true;
                        _this.updateButton();
                        if (_this.worker) {
                            _this.working = true;
                        }
                    }
                })
                .title = this.config.titleOff;
            if (_this.globals['RIGHTS'] >= 2) {
                $(this.button).mousedown(function () {
                    $(this).css('background-position', '-' + _this.imageWidth * 7 + 'px, 0px');
                })
            }
            break;

        case "expected off":
            $(this.button)
                .css('background-position', '-' + _this.imageWidth * 8 + 'px, 0px')
                .mouseup(function () {
                    $(this).css('background-position', '-' + _this.imageWidth * 8 + 'px, 0px');
                })
                .mouseleave(function () {
                    $(this).css('background-position', '-' + _this.imageWidth * 8 + 'px, 0px');
                })
                .unbind('click')
                .unbind('mousedown')
                .click(function () {
                    if (_this.config.setWhileUncertain) {
                        if (_this.globals['RIGHTS'] >= 2) {
                            _this.eventHandler.setValueSn(_this.config.ccu, _this.config.adr, _this.config.dp, 1);
                            _this.state = true;
                            _this.expected = true;
                            _this.updateButton();
                            if (_this.worker) {
                                _this.working = true;
                            }
                        }
                    } else {
                        _this.eventHandler.getValueSn(_this.config.ccu, _this.config.adr, _this.config.dp, function (param) {
                            _this.updateValue({"state": param})
                        });
                    }
                })
                .title = this.config.titleOffExpected;
            if (_this.globals['RIGHTS'] >= 2) {
                $(this.button).mousedown(function () {
                    $(this).css('background-position', '-' + _this.imageWidth * 9 + 'px, 0px');
                })
            }
            break;


    }
};