$(function () {
    $("body").addClass("ui-widget ui-widget-content");
    $("input:text, input:password, select").addClass("ui-widget-content ui-corner-all");
    $("option").addClass("ui-widget-content");
    $("input:submit, input:button").button();
});

function SysVarTypeToString(type) {
    var list = {2: "Boolean", 4: "Float", 16: "Integer", 20: "String"};
    return list[type];
}
function SysVarSubTypeToString(type) {
    var list = {0: "Zahl", 2: "Logikwert", 6: "Alarm", 11: "Zeichenkette", 23: "Anwesenheit", 29: "Werteliste"};
    return list[type];
}

function obj_len(obj) {
    var ob_len = 0;
    for (i in obj) ++ob_len;
    return ob_len;
}

function hexToRgb(hex) {
    // Expand shorthand form (e.g. "03F") to full form (e.g. "0033FF")
    var shorthandRegex = /^#?([a-f\d])([a-f\d])([a-f\d])$/i;
    hex = hex.replace(shorthandRegex, function (m, r, g, b) {
        return r + r + g + g + b + b;
    });

    var result = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);
    return result ? {
        r: parseInt(result[1], 16),
        g: parseInt(result[2], 16),
        b: parseInt(result[3], 16)
    } : null;
}

function rgbToHex(r, g, b) {
    return "#" + ((1 << 24) + (r << 16) + (g << 8) + b).toString(16).slice(1);
}
function colorToHex(color) {
    var cache = parseColor(color);
    return rgbToHex(cache[0], cache[1], cache[2]);
}

function boolToChecked(bValue) {
    if (bValue) {
        return 'check';
    } else {
        return 'uncheck';
    }
}

function addCss(css) {
    if (document.createStyleSheet) {
        document.createStyleSheet(css);
    }
    else {
        $("head").append($("<link rel='stylesheet' href='" + css + "' type='text/css' media='screen' />"));
    }
}

function isset(obj) {
    if (typeof obj === 'undefined') {
        return false;
    } else {
        return true;
    }
}


function hcs_parseJSON(json) {
    var obj = JSON && JSON.parse(json) || $.parseJSON(json);
    return obj;
}

function displayDialog(param_text) {
    var text = '<span class="ui-icon ui-icon-alert" style="float:left; margin:6px 7px 25px 0;"></span>';
    text += param_text;
    $("#dialogText").empty().append(text);
    $("#dialog").dialog('open');
}

function randomString(length, chars) {
    var mask = '';
    if (chars.indexOf('a') > -1) mask += 'abcdefghijklmnopqrstuvwxyz';
    if (chars.indexOf('A') > -1) mask += 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
    if (chars.indexOf('#') > -1) mask += '0123456789';
    if (chars.indexOf('!') > -1) mask += '~`!@#$%^&*()_+-={}[]:";\'<>?,./|\\';
    var result = '';
    for (var i = length; i > 0; --i) result += mask[Math.round(Math.random() * (mask.length - 1))];
    return result;
}

function getCSS(prop, fromClass) {
    var $inspector = $("<div>").css('display', 'none').addClass(fromClass);
    $("body").append($inspector); // add to DOM, in order to read the CSS property
    try {
        return $inspector.css(prop);
    } finally {
        $inspector.remove(); // and remove from DOM
    }
};

/**!
 * @preserve $.parseColor
 * Copyright 2011 THEtheChad Elliott
 * Released under the MIT and GPL licenses.
 */


// Parse hex/rgb{a} color syntax.
// @input string
// @returns string rgba(r,g,b,a)
function parseColor(color) {
    var cache
        , p = parseInt // Use p as a byte saving reference to parseInt
        , color = color.replace(/\s\s*/g, '') // Remove all spaces
        ;//var
// Checks for 6 digit hex and converts string to integer
    if (cache = /^#([\da-fA-F]{2})([\da-fA-F]{2})([\da-fA-F]{2})/.exec(color))
        cache = [p(cache[1], 16), p(cache[2], 16), p(cache[3], 16)];
// Checks for 3 digit hex and converts string to integer
    else if (cache = /^#([\da-fA-F])([\da-fA-F])([\da-fA-F])/.exec(color))
        cache = [p(cache[1], 16) * 17, p(cache[2], 16) * 17, p(cache[3], 16) * 17];
// Checks for rgba and converts string to
// integer/float using unary + operator to save bytes
    else if (cache = /^rgba\(([\d]+),([\d]+),([\d]+),([\d]+|[\d]*.[\d]+)\)/.exec(color))
        cache = [+cache[1], +cache[2], +cache[3], +cache[4]];
// Checks for rgb and converts string to
// integer/float using unary + operator to save bytes
    else if (cache = /^rgb\(([\d]+),([\d]+),([\d]+)\)/.exec(color))
        cache = [+cache[1], +cache[2], +cache[3]];
// Otherwise throw an exception to make debugging easier
    else cache = [0,0,0];
// Performs RGBA conversion by default
//    isNaN(cache[3]) && (cache[3] = 1);
// Adds or removes 4th value based on rgba support
// Support is flipped twice to prevent erros if
// it's not defined
    return cache;
}

function changeAlpha(color, alpha) {
    var cache = parseColor(color);
    return 'rgba(' + cache[0] + ',' + cache[1] + ',' + cache[2] + ',' + parseFloat(alpha) + ')';
}

function parseHex(color) {
    var cache = parseColor(color);
    return '#' + (cache[0] < 16 ? '0'+cache[0].toString(16) : cache[0].toString(16)) + (cache[1] < 16 ? '0'+cache[1].toString(16) : cache[1].toString(16)) + (cache[2] < 16 ? '0'+cache[2].toString(16) : cache[2].toString(16));
}

function colorToHsv(color) {
    var cache = parseColor(color);

    var var_R = ( cache[0] / 255 );                     //RGB from 0 to 255
    var var_G = ( cache[1] / 255 );
    var var_B = ( cache[2] / 255 );

    var var_Min = Math.min(var_R, var_G, var_B);    //Min. value of RGB
    var var_Max = Math.max(var_R, var_G, var_B);    //Max. value of RGB
    var del_Max = var_Max - var_Min;            //Delta RGB value

    var H = 0;
    var S = 0;
    var V = var_Max;

    if (del_Max == 0)                     //This is a gray, no chroma...
    {
        H = 0                                //HSV results from 0 to 1
        S = 0
    }
    else                                    //Chromatic data...
    {
        S = del_Max / var_Max;

        var del_R = ( ( ( var_Max - var_R ) / 6 ) + ( del_Max / 2 ) ) / del_Max;
        var del_G = ( ( ( var_Max - var_G ) / 6 ) + ( del_Max / 2 ) ) / del_Max;
        var del_B = ( ( ( var_Max - var_B ) / 6 ) + ( del_Max / 2 ) ) / del_Max;

        if (var_R == var_Max) {
            H = del_B - del_G;
        }
        else if (var_G == var_Max) {
            H = ( 1 / 3 ) + del_R - del_B;
        }
        else if (var_B == var_Max) {
            H = ( 2 / 3 ) + del_G - del_R;
        }

        if (H < 0) H += 1
        if (H > 1) H -= 1
    }
    return [H, S, V];
}

function hsvToRgb(H, S, V) {
    var R = 0, G = 0, B = 0, var_r, var_g, var_b;
    if (S == 0)                       //HSV from 0 to 1
    {
        R = V * 255;
        G = V * 255;
        B = V * 255;
    }
    else {
        var var_h = H * 6;
        if (var_h == 6) {
            //H must be < 1
            var_h = 0;
        }
        var var_i = parseInt(var_h);             //Or ... var_i = floor( var_h )
        var var_1 = V * ( 1 - S );
        var var_2 = V * ( 1 - S * ( var_h - var_i ) );
        var var_3 = V * ( 1 - S * ( 1 - ( var_h - var_i ) ) );

        if (var_i == 0) {
            var_r = V;
            var_g = var_3;
            var_b = var_1;
        }
        else if (var_i == 1) {
            var_r = var_2;
            var_g = V;
            var_b = var_1;
        }
        else if (var_i == 2) {
            var_r = var_1;
            var_g = V;
            var_b = var_3;
        }
        else if (var_i == 3) {
            var_r = var_1;
            var_g = var_2;
            var_b = V;
        }
        else if (var_i == 4) {
            var_r = var_3;
            var_g = var_1;
            var_b = V;
        }
        else {
            var_r = V;
            var_g = var_1;
            var_b = var_2;
        }

        R = var_r * 255;                  //RGB results from 0 to 255
        G = var_g * 255;
        B = var_b * 255;
    }
    return [parseInt(R), parseInt(G), parseInt(B)];
}

function shiftToOne(number) {
    if (number < 0) {
        return shiftToOne(number + 1);
    } else if (number > 1) {
        return shiftToOne(number - 1);
    } else {
        return number;
    }
}

function arrayToRgbString(array) {
    return 'rgb(' + array[0] + ', ' + array[1] + ', ' + array[2] + ')';
}

function getHarmonicColors(color) {
    var hsv = colorToHsv(color);
    var H = hsv[0];
    var S = hsv[1];
    var V = hsv[2];

    var original = arrayToRgbString(hsvToRgb(H, S, V));
    var analogLeft = arrayToRgbString(hsvToRgb(shiftToOne(H - 0.125), S, V));
    var analogRight = arrayToRgbString(hsvToRgb(shiftToOne(H + 0.125), S, V));
    var complement = arrayToRgbString(hsvToRgb(shiftToOne(H + 0.5), S, V));
    var left = arrayToRgbString(hsvToRgb(shiftToOne(H - 0.25), S, V));
    var right = arrayToRgbString(hsvToRgb(shiftToOne(H + 0.25), S, V));
    var triadicLeft = arrayToRgbString(hsvToRgb(shiftToOne(H - 0.33), S, V));
    var triadicRight = arrayToRgbString(hsvToRgb(shiftToOne(H + 0.33), S, V));
    var splitLeft = arrayToRgbString(hsvToRgb(shiftToOne(H - 0.41), S, V));
    var splitRight = arrayToRgbString(hsvToRgb(shiftToOne(H + 0.41), S, V));

    var N = arrayToRgbString(hsvToRgb(H, S, V));
    var NW = arrayToRgbString(hsvToRgb(shiftToOne(H - 0.125), S, V));
    var NE = arrayToRgbString(hsvToRgb(shiftToOne(H + 0.125), S, V));
    var W = arrayToRgbString(hsvToRgb(shiftToOne(H - 0.25), S, V));
    var E = arrayToRgbString(hsvToRgb(shiftToOne(H + 0.25), S, V));
    var SW = arrayToRgbString(hsvToRgb(shiftToOne(H - 0.375), S, V));
    var SE = arrayToRgbString(hsvToRgb(shiftToOne(H + 0.375), S, V));
    var S = arrayToRgbString(hsvToRgb(shiftToOne(H + 0.5), S, V));

//    return [N, NW, NE, W, E, SW, SE, S];
    return [original, complement, left, right, splitLeft, analogRight, splitRight, analogLeft, triadicLeft, triadicRight];
}

function betweenNumbers(number, first, last){
    return (first < last ? ((number >= first) && (number <= last)) : ((number >= last) && (number <= first)));
}

function isNumber(n) {
    return !isNaN(parseFloat(n)) && isFinite(n);
}