<?php

// <editor-fold defaultstate="collapsed" desc="CALLABLE PROTECTION">
// Make file not callable directly
if (!defined('HCS_CALLABLE_FILE')) {
    header('HTTP/1.0 404 Not Found');
    die('Do not access this file directly.');
}
// </editor-fold>
/* -------------------------------------------------------------------------- */

// <editor-fold defaultstate="collapsed" desc="INCLUDES">
require_once('common_functions.php');
require_once('homematic.php');
require_once('sql.php');
require_once('globals.php');


// </editor-fold>

// Default the site-wide variables
if (!isset($HCS_ROOTPATH)) {
    $HCS_ROOTPATH = '../../';
}

/* -------------------------------------------------------------------------- */

// <editor-fold defaultstate="collapsed" desc="FUNCTIONS HCS">

function redirect($param_url, $param_return = false, $param_extern = false)
{
    // TODO: Fix redirect, but also able without global variables.
    /*    if (!$param_extern) {
            $protocol = 'http://';
            $server = preg_replace('/^\/?(.*?)\/?$/', '\1', trim(HCS_SERVER_NAME));
            $port = (HCS_SERVER_PORT != 80) ? ':' . trim(HCS_SERVER_PORT) . '/' : '/';
            $script = preg_replace('/^\/?(.*?)\/?$/', '\1', trim(HCS_SERVER_PATH));

            $param_url = preg_replace('/^\/?(.*?)\/?$/', '\1', trim($param_url));
            $param_url = str_replace('&amp;', '&', $param_url);

            #$location = $protocol . $server . $port . '/' . (!empty($script) ? $script . '/' : '') . $url;
            $location = $protocol . $server . $port . (!empty($script) ? $script . '/' : '') . $param_url;
        } else {
            $location = $param_url;
        }*/
    $location = $param_url;
    if ($param_return) {
        return $param_url;
    }
    //die($location);

    header('Location: ' . $location);
    echo "<script>window.location.href = '" . $location . "';</script>";
    exit;
}

function getHCSCookie($param_cookieName)
{
    $cookieName = 'HCS_' . $param_cookieName;
    return (isset($_COOKIE[$cookieName])) ? $_COOKIE[$cookieName] : '';

}

function setHCSCookie($param_cookieName, $param_cookieData, $param_cookieTime)
{
    $cookieName = 'HCS_' . $param_cookieName;
    setcookie($cookieName, $param_cookieData, time() + $param_cookieTime, '/');

}

function setLanguageCookie($param_language)
{
    setHCSCookie('Language', $param_language, 60 * 60 * 24 * 365);

}

function setStyleCookie($param_style)
{
    setHCSCookie("Style", $param_style, 60 * 60 * 24 * 365);
}

/**
 * returns comparison result
 * @param string $param_version1
 * @param string $param_version2
 * @return int
 */
function compareVersion($param_version1, $param_version2)
{
    $result = 0;
    $match1 = explode('.', $param_version1);
    $match2 = explode('.', $param_version2);
    $int1 = sprintf('%d%02d%02d%02d', $match1[0], $match1[1], intval($match1[2]), intval($match1[3]));
    $int2 = sprintf('%d%02d%02d%02d', $match2[0], $match2[1], intval($match2[2]), intval($match2[3]));


    if ($int1 < $int2) {
        $result = -1;
    }
    if ($int1 > $int2) {
        $result = 1;
    }
    return $result;

}

function getLoggedInUser(SQL $param_sql = null)
{
    if (!isset($_SESSION['serverMade'])
        || ($_SESSION['serverMade'] !== true)
        || !isset($_SESSION['username'])
        || !is_string($_SESSION['username'])
        || ($_SESSION['username'] == '')
    ) {
        // session is not ok check for login cookie
        if ($param_sql != null) {
            $sql = $param_sql;
        } else {
            $sql = new SQL();
        }

        $user = $sql->checkLoginCookies();
        if ($user !== false) {
            // cookie data is ok
            return $user;
        }
        return false;
    } else {
        // session data is ok. pickup Session
        return $_SESSION['username'];
    }
    return false;
}

function checkNewestHcsVersion(SQL $param_sql = null)
{
    $sql = null;
    if ($param_sql != null) {
        $sql = $param_sql;
    } else {
        $sql = new SQL();
    }
    $newestVersion = '';
    $versionFile = @file('http://hcs.xenorate.com/version_check');
    if ($versionFile[0]) {
        $parse = explode('|', $versionFile[0]);
        if ($parse[0]) {
            $newestVersion = $parse[0];
            $sql->insertOrUpdateInTo(HCS_TABLE_PREFIX . 'Values', array('Name' => 'LastUpdateCheck', 'Value' => time()), array('Name'));
        }
    }
    return $newestVersion;
}

function valid_folder($path)
{
    $ignore = array('.', '..', '.svn', 'CVS', 'cache', 'install', 'index.html', '.htaccess');

    if (isset($path)) {
        if (!is_file($path) && !is_link($path) && !in_array(basename($path), $ignore)) {
            return true;
        }
    }

    return false;

}

/**
 * Option Selected value method
 * Returns ' checked="checked"' for use in checkbox/radio <input> tags if $condition is true
 */
function option_selected($condition)
{
    return ($condition) ? ' selected="selected"' : '';

}

function highcharts_LinetypeAndStepFromDatapoint($param_dataPoint)
{

    $type = 'line';
    $step = 'false';
    switch (strtoupper($param_dataPoint)){
        case 'LEVEL':
            $type = 'area';
            $step = 'true';
            break;
        case 'SETPOINT':
            $type = 'line';
            $step = 'true';
            break;

        default:
            $temp = Homematic_XmlRpc::getValueTypeByDp($param_dataPoint, '');
            switch ($temp[0]) {
                case Homematic_ValueTypes::Integer:
                    $type = 'spline';
                    $step = 'false';
                    break;

                case Homematic_ValueTypes::Float:
                    $type = 'spline';
                    $step = 'false';
                    break;

                case Homematic_ValueTypes::Boolean:
                    $type = 'area';
                    $step = 'true';
                    break;

                case Homematic_ValueTypes::String:
                    $type = 'line';
                    $step = 'false';
                    break;
            }
            break;
    }

    return array($type, $step);

}

// </editor-fold>

/* -------------------------------------------------------------------------- */

// <editor-fold defaultstate="collapsed" desc="FUNCTIONS HCS HOMEMATIC">

function ProgramsArrayToSqlTable($param_CcuId, array $param_ProgramArray, SQL $param_SqlObject, $param_tableName = '')
{
    if ($param_tableName === '') {
        $param_tableName = HCS_TABLE_PREFIX . 'Programs';
    }
    $currentTime = date(SQL_SERVER_DATETIME_FORMAT);
    foreach ($param_ProgramArray as $id => $program) {
        if (isset($program["Name"]) && ($program["Name"] != "")) {
            $param_SqlObject->insertOrUpdateInTo($param_tableName, array(
                'CcuId' => $param_CcuId,
                'Id' => $id,
                'Name' => $program["Name"],
                'Description' => $program["Description"],
                'LastUpdate' => $currentTime), array('CcuId', 'Id'));
        }
    }
    $param_SqlObject->query("DELETE FROM " . HCS_TABLE_PREFIX . "Programs WHERE ((LastUpdate < '" . $currentTime . "') AND (CcuId = " . $param_CcuId . ") );");
}

function CraftsArrayToSqlTable($param_CcuId, array $param_CraftArray, SQL $param_SqlObject, $param_tableName = '')
{
    if ($param_tableName === '') {
        $param_tableName = HCS_TABLE_PREFIX . 'Crafts';
    }
    $currentTime = date(SQL_SERVER_DATETIME_FORMAT);

    // delete crafts association
    $param_SqlObject->query("DELETE FROM " . HCS_TABLE_PREFIX . "EntityCrafts WHERE CcuId = " . $param_CcuId . ";");

    // add crafts
    foreach ($param_CraftArray as $name => $craft) {
        if (isset($craft["ID"]) && ($craft["ID"] != "") && ($name != "")) {
            $param_SqlObject->insertOrUpdateInTo($param_tableName, array(
                'CcuId' => $param_CcuId,
                'Id' => $craft["ID"],
                'Name' => $name,
                'Description' => $craft["Description"],
                'LastUpdate' => $currentTime), array('CcuId', 'Id'));
        }
        // add crafts association
        if (isset($craft["Channels"]) && ($craft["Channels"] != "")) {
            foreach ($craft["Channels"] as $entity) {
                $param_SqlObject->replaceInTo(HCS_TABLE_PREFIX . "EntityCrafts", array(
                        'CcuId' => $param_CcuId,
                        'CraftId' => $craft["ID"],
                        'EntityId' => $entity), array("CcuId", "CraftId", "EntityId"));
            }
        }
    }
    // delete old crafts
    $param_SqlObject->query("DELETE FROM " . HCS_TABLE_PREFIX . "Crafts WHERE ((LastUpdate < '" . $currentTime . "') AND (CcuId = " . $param_CcuId . ") );");
}

function RoomArrayToSqlTable($param_CcuId, array $param_RoomArray, SQL $param_SqlObject, $param_tableName = '')
{
    if ($param_tableName === '') {
        $param_tableName = HCS_TABLE_PREFIX . 'Rooms';
    }
    $currentTime = date(SQL_SERVER_DATETIME_FORMAT);

    // delete room association
    $param_SqlObject->query("DELETE FROM " . HCS_TABLE_PREFIX . "EntityRooms WHERE CcuId = " . $param_CcuId . ";");

    // add rooms
    foreach ($param_RoomArray as $name => $room) {
        if (isset($room["ID"]) && ($room["ID"] != "") && ($name != "")) {
            $param_SqlObject->insertOrUpdateInTo($param_tableName, array(
                'CcuId' => $param_CcuId,
                'Id' => $room["ID"],
                'Name' => $name,
                'Description' => $room["Description"],
                'LastUpdate' => $currentTime), array('CcuId', 'Id'));
        }
        // add room association
        if (isset($room["Channels"]) && ($room["Channels"] != "")) {
            foreach ($room["Channels"] as $entity) {
                $param_SqlObject->replaceInTo(HCS_TABLE_PREFIX . "EntityRooms", array(
                        'CcuId' => $param_CcuId,
                        'RoomId' => $room["ID"],
                        'EntityId' => $entity), array("CcuId", "RoomId", "EntityId"));
            }
        }
    }
    // delete old rooms
    $param_SqlObject->query("DELETE FROM " . HCS_TABLE_PREFIX . "Rooms WHERE ((LastUpdate < '" . $currentTime . "') AND (CcuId = " . $param_CcuId . ") );");
}

function homematicSysVarArrayToSqlTable($param_CcuId, array $param_homematicSystemVariableArray, SQL $param_SqlObject, $param_tableName = '')
{
    if ($param_tableName === '') {
        $param_tableName = HCS_TABLE_PREFIX . 'SystemVariables';
    }
    $currentTime = date(SQL_SERVER_DATETIME_FORMAT);
    foreach ($param_homematicSystemVariableArray as $id => $variable) {
        if (isset($variable["Name"]) && ($variable["Name"] != "") && ($id != "")) {
            $param_SqlObject->insertOrUpdateInTo($param_tableName, array(
                'CcuId' => $param_CcuId,
                'Id' => $id,
                'Name' => $variable["Name"],
                'Description' => $variable["Description"],
                'ValueMin' => $variable["ValueMin"],
                'ValueMax' => $variable["ValueMax"],
                'ValueUnit' => $variable["ValueUnit"],
                'ValueType' => $variable["ValueType"],
                'ValueSubType' => $variable["ValueSubType"],
                'ValueList' => $variable["ValueList"],
                'LastUpdate' => $currentTime), array('CcuId', 'Id'));
        }
    }
    $param_SqlObject->query("DELETE FROM " . HCS_TABLE_PREFIX . "SystemVariables WHERE ((LastUpdate < '" . $currentTime . "') AND (CcuId = " . $param_CcuId . ") );");
}

function homematicDeviceArrayToSqlTable($param_CcuId, array $param_homematicDeviceArray, SQL $param_SqlObject, $readLastValue = false)
{
    $currentTime = date(SQL_SERVER_DATETIME_FORMAT);

    foreach ($param_homematicDeviceArray as $devId => $device) {
        $param_SqlObject->insertOrUpdateInTo(HCS_TABLE_PREFIX . 'Devices', array(
                'CcuId' => $param_CcuId,
                'Id' => $devId,
                'Address' => $device['Address'],
                'Name' => $device['Name'],
                'Type' => $device['HssType'],
                'Interface' => HomematicControl::stringToHomematicInterface($device['Interface']),
                'LastUpdate' => $currentTime), array('Address', 'CcuId'));

        foreach ($device['Channels'] as $chnId => $channel) {
            $param_SqlObject->insertOrUpdateInTo(HCS_TABLE_PREFIX . 'Channels', array(
                    'DeviceAddress' => $device['Address'],
                    'CcuId' => $param_CcuId,
                    'Id' => $chnId,
                    'Address' => $channel['Address'],
                    'Name' => $channel['Name'],
                    'HssType' => $channel['HssType'],
                    'Label' => $channel['ChnLabel'],
                    'Type' => $channel['ChannelType'],
                    'Direction' => $channel['ChnDirection'],
                    'LastUpdate' => $currentTime), array('Address', 'CcuId'));

            foreach ($channel['DPs'] as $dpId => $dp) {
                $param_SqlObject->insertOrUpdateInTo(HCS_TABLE_PREFIX . 'DataPoints', array(
                        'CcuId' => $param_CcuId,
                        'Id' => $dpId,
                        'ChannelAddress' => $channel['Address'],
                        'Name' => $dp['Name'],
                        'Type' => $dp['Type'],
                        'TypeName' => $dp['TypeName'],
                        'Operations' => (int)$dp['Operations'],
                        'ValueType' => $dp['ValueType'],
                        'ValueUnit' => $dp['ValueUnit'],
                        'LastUpdate' => $currentTime), array('CcuId', 'Id'));
                if ($readLastValue){
                    $param_SqlObject->insertOrUpdateInTo(HCS_TABLE_PREFIX . 'CurrentStates', array(
                            'ChannelAddress' => $channel['Address'],
                            'DataPoint' => $dp['Type'],
                            'LastUpdate' => date(SQL_SERVER_DATETIME_FORMAT, strtotime($dp['Timestamp'])),
                            'Value' => (string)$dp['Value'],
                            'CcuId' => $param_CcuId), array('CcuId', 'ChannelAddress', 'DataPoint'));
                }
            }
        }
    }
    $param_SqlObject->query("DELETE FROM " . HCS_TABLE_PREFIX . "DataPoints WHERE ((LastUpdate < '" . $currentTime . "') AND (CcuId = " . $param_CcuId . ") );");
    $param_SqlObject->query("DELETE FROM " . HCS_TABLE_PREFIX . "Channels WHERE ((LastUpdate < '" . $currentTime . "') AND (CcuId = " . $param_CcuId . ") );");
    $param_SqlObject->query("DELETE FROM " . HCS_TABLE_PREFIX . "Devices WHERE ((LastUpdate < '" . $currentTime . "') AND (CcuId = " . $param_CcuId . ") );");
    $param_SqlObject->query("DELETE FROM " . HCS_TABLE_PREFIX . "CurrentStates WHERE ((LastUpdate < '" . $currentTime . "') AND (CcuId = " . $param_CcuId . ") );");
}

// </editor-fold>

/* -------------------------------------------------------------------------- */

// <editor-fold defaultstate="collapsed" desc="CLASS HOMEMATIC CONTROL">
class HomematicControl
{
    private static function updateCcuSubscriptionByValues($param_ccu)
    {
        $result = true;
        $ccuRf = new Homematic_XmlRpcInterface($param_ccu["CcuAddress"], Homematic_Interface::RF, $param_ccu['CallbackAddress'], $param_ccu["Id"]);
        if ($param_ccu['SubscribeRfEvents']) {
            if (!$ccuRf->init()) {
                $result &= false;
            }
        } else {
            if (!$ccuRf->deinit()) {
                $result &= false;
            }
        }
        $ccuWired = new Homematic_XmlRpcInterface($param_ccu["CcuAddress"], Homematic_Interface::Wired, $param_ccu['CallbackAddress'], $param_ccu["Id"]);
        if ($param_ccu['SubscribeWiredEvents']) {
            if (!$ccuWired->init()) {
                $result &= false;
            }
        } else {
            $temp = $ccuWired->deinit();
            if (!$temp) {
                if ($param_ccu["CcuVersion"] == 'CCU1') {
                    $result &= false;
                }
            }
        }
        if ($param_ccu["CcuVersion"] == 'CCU1') {
            $ccuSystem = new Homematic_XmlRpcInterface($param_ccu["CcuAddress"], Homematic_Interface::System, $param_ccu['CallbackAddress'], $param_ccu["Id"]);
            if ($param_ccu['SubscribeSystemEvents']) {
                if (!$ccuSystem->init()) {
                    $result &= false;
                }
            } else {
                if (!$ccuSystem->deinit()) {
                    $result &= false;
                }
            }
        }
        return $result;
    }

    static function updateCcuSubscription($param_ccuId, SQL $param_sql = null)
    {
        if ($param_sql != null) {
            $sql = $param_sql;
        } else {
            $sql = new SQL();
        }
        $query = $sql->queryRequest("SELECT * FROM " . HCS_TABLE_PREFIX . "CcuList WHERE Id =" . (int)$param_ccuId . ";");
        if (count($query) > 0) {
            if (self::updateCcuSubscriptionByValues($query[0])) {
                Logging::info('[updateCcuSubscription] updated subscriptions for CCU ID:' . $param_ccuId);
                return true;
            } else {
                Logging::error('[updateCcuSubscription] could not update subscriptions correctly for CCU ID:' . $param_ccuId);
                return false;
            }
        } else {
            Logging::error('[updateCcuSubscription] could find CCU with ID:' . $param_ccuId);
            return false;
        }
    }

    static function updateAllCcuSubscriptions(SQL $param_sql = null)
    {
        if ($param_sql != null) {
            $sql = $param_sql;
        } else {
            $sql = new SQL();
        }
        $query = $sql->queryRequest("SELECT * FROM " . HCS_TABLE_PREFIX . "CcuList;");
        if (count($query) > 0) {
            $result = true;
            foreach ($query as $ccu) {
                $result &= self::updateCcuSubscriptionByValues($ccu);
            }
            if ($result) {
                Logging::info('[updateAllCcuSubscriptions] updated all CCU-subscriptions.');
                return true;
            } else {
                Logging::error('[updateAllCcuSubscriptions] could not update all CCU-subscriptions correctly.');
                return false;
            }
        } else {
            Logging::info('[updateAllCcuSubscriptions] could not find any CCU to update subscriptions.');
            return false;
        }
    }

    static function getValueByName($param_ccuId, $param_name, $param_dataPoint, $param_interface = "XML-RPC", SQL $param_sql = null)
    {
        if ($param_dataPoint != null) {
            $sql = null;
            if ($param_sql != null) {
                $sql = $param_sql;
            } else {
                $sql = new SQL();
            }
            $ccu = $sql->queryRequest("SELECT CcuAddress, CallbackAddress FROM " . HCS_TABLE_PREFIX . "CcuList WHERE Id = '" . $param_ccuId . "';");
            if ((count($ccu) > 0) && ($ccu[0]["CcuAddress"] != null)) {
                if ($param_interface == "HSS") {
                    $regahss = new Homematic_ReGaHSS($ccu[0]["CcuAddress"]);
                    $value = $regahss->getValueByName($param_name, $param_dataPoint);
                    if ($value === false) {
                        Logging::error("[getValueByName] could not get value '" . $param_dataPoint . "' on device " . $param_name);
                        return false;
                    } else {
                        $sn = self::getSnByName($param_ccuId, $param_name, $sql);
                        if (!($sn === false)) {
                            // fix $value for logging
                            $temp = Homematic_XmlRpc::getValueTypeByDp($param_dataPoint, $value);
                            if (count($temp) == 2) {
                                $value = $temp[1];
                                booleanToString($value);
                            }
                            LogEvent($param_ccuId, $sn, $param_dataPoint, $value, $sql);
                            Logging::info("[getValueByName] got value '" . $param_dataPoint . "' on device " . $sn . "; value: " . $value);
                            return $value;
                        } else {
                            Logging::error("[getValueByName] could not get SN for: " . $param_name . " from CCU-ID: " . $param_ccuId);
                            return false;
                        }
                    }
                } else {
                    $interfaceAndSn = self::getInterfaceAndSnByName($param_ccuId, $param_name, $sql);
                    if (!($interfaceAndSn === false)) {
                        $interface = $interfaceAndSn[0];
                        $sn = $interfaceAndSn[1];
                        $xmlrpc = new Homematic_XmlRpcInterface($ccu[0]["CcuAddress"], $interface);
                        $value = $xmlrpc->getValue($sn, $param_dataPoint);
                        if ($value === false) {
                            Logging::error("[getValueByName] could not get value '" . $param_dataPoint . "' on device " . $param_name);
                            return false;
                        } else {
                            // fix $value for logging
                            $temp = Homematic_XmlRpc::getValueTypeByDp($param_dataPoint, $value);
                            if (count($temp) == 2) {
                                $value = $temp[1];
                                booleanToString($value);
                            }
                            LogEvent($param_ccuId, $sn, $param_dataPoint, $value, $sql);
                            Logging::info("[getValueByName] got value '" . $param_dataPoint . "' on device " . $sn . "; value: " . $value);
                            return $value;
                        }
                    } else {
                        Logging::error("[getValueByName] could not get Interface and SN for: " . $param_name . " from CCU-ID: " . $param_ccuId);
                        return false;
                    }
                }
            } else {
                Logging::error("[getValueByName] could not get CCU info with ID: " . $param_ccuId);
                return false;
            }
        } else {
            Logging::error("[getValueByName] could not get value. Not all parameters set. " . print_r($param_dataPoint, true));
            return false;
        }

    }

    static function setValueByName($param_ccuId, $param_name, $param_dataPoint, $param_value, $param_interface = "XML-RPC", SQL $param_sql = null)
    {
        if (($param_dataPoint != null) && ($param_value != null)) {
            $sql = null;
            if ($param_sql != null) {
                $sql = $param_sql;
            } else {
                $sql = new SQL();
            }
            $ccu = $sql->queryRequest("SELECT CcuAddress, CallbackAddress FROM " . HCS_TABLE_PREFIX . "CcuList WHERE Id = '" . $param_ccuId . "';");
            if ((count($ccu) > 0) && ($ccu[0]["CcuAddress"] != null)) {
                if ($param_interface == "HSS") {
                    $regahss = new Homematic_ReGaHSS($ccu[0]["CcuAddress"]);
                    $result = $regahss->setValueByName($param_name, $param_dataPoint, $param_value);
                    if ($result === false) {
                        Logging::error("[setValueByName] could not set value to '" . $param_value . "' to '" . $param_dataPoint . "' on device " . $param_name);
                        return false;
                    } else {
                        $sn = self::getSnByName($param_ccuId, $param_name, $sql);
                        if (!($sn === false)) {
                            // fix $value for logging
                            $temp = Homematic_XmlRpc::getValueTypeByDp($param_dataPoint, $param_value);
                            if (count($temp) == 2) {
                                $param_value = $temp[1];
                                booleanToString($param_value);
                            }
                            LogEvent($param_ccuId, $sn, $param_dataPoint, $param_value, $sql);
                            Logging::info("[setValueByName] set value '" . $param_value . "' to '" . $param_dataPoint . "' on device " . $sn);
                            return true;
                        } else {
                            Logging::error("[setValueByName] could not get SN for: " . $param_name . " from CCU-ID: " . $param_ccuId);
                            return false;
                        }
                    }
                } else {
                    $interfaceAndSn = self::getInterfaceAndSnByName($param_ccuId, $param_name, $sql);
                    if (!($interfaceAndSn === false)) {
                        $interface = $interfaceAndSn[0];
                        $sn = $interfaceAndSn[1];
                        $xmlrpc = new Homematic_XmlRpcInterface($ccu[0]["CcuAddress"], $interface);
                        $result = $xmlrpc->setValue($sn, $param_dataPoint, $param_value);
                        if ($result === false) {
                            Logging::error("[setValueByName] could not set value to '" . $param_value . " for " . $param_dataPoint . "' on device " . $param_name);
                            return false;
                        } else {
                            // fix $value for logging
                            $temp = Homematic_XmlRpc::getValueTypeByDp($param_dataPoint, $param_value);
                            if (count($temp) == 2) {
                                $param_value = $temp[1];
                                booleanToString($param_value);
                            }
                            LogEvent($param_ccuId, $sn, $param_dataPoint, $param_value, $sql);
                            Logging::info("[setValueByName] set value: " . $param_value . " to '" . $param_dataPoint . "' on device " . $sn);
                            return true;
                        }
                    } else {
                        Logging::error("[setValueByName] could not get Interface and SN for: " . $param_name . " from CCU-ID: " . $param_ccuId);
                        return false;
                    }
                }
            } else {
                Logging::error("[setValueByName] could not get CCU info with ID: " . $param_ccuId);
                return false;
            }
        } else {
            Logging::error("[setValueByName] could not set value. Not all parameters set. " . print_r($param_dataPoint, true) . "; " . print_r($param_value, true));
            return false;
        }

    }

    static function getValueBySn($param_ccuId, $param_sn, $param_dataPoint, $param_interface = "XML-RPC", SQL $param_sql = null)
    {
        if ($param_dataPoint != null) {
            $sql = null;
            if ($param_sql != null) {
                $sql = $param_sql;
            } else {
                $sql = new SQL();
            }
            $ccu = $sql->queryRequest("SELECT CcuAddress, CallbackAddress FROM " . HCS_TABLE_PREFIX . "CcuList WHERE Id = '" . $param_ccuId . "';");
            if ((count($ccu) > 0) && ($ccu[0]["CcuAddress"] != null)) {
                $interface = self::getInterfaceBySn($param_ccuId, $param_sn, $sql);
                if (!($interface === false)) {
                    if ($param_interface == "HSS") {
                        $regahss = new Homematic_ReGaHSS($ccu[0]["CcuAddress"]);
                        $value = $regahss->getValueBySn($interface, $param_sn, $param_dataPoint);
                    } else {
                        $xmlrpc = new Homematic_XmlRpcInterface($ccu[0]["CcuAddress"], $interface);
                        $value = $xmlrpc->getValue($param_sn, $param_dataPoint);
                    }
                    if ($value === false) {
                        Logging::error("[getValueBySn] could not get value '" . $param_dataPoint . "' on device " . $param_sn);
                        return false;
                    } else {
                        // fix $value for logging
                        $temp = Homematic_XmlRpc::getValueTypeByDp($param_dataPoint, $value);
                        if (count($temp) == 2) {
                            $value = $temp[1];
                            booleanToString($value);
                        }
                        LogEvent($param_ccuId, $param_sn, $param_dataPoint, $value, $sql);
                        Logging::info("[getValueBySn] got value for '" . $param_dataPoint . "' on device " . $param_sn . "; value: " . $value);
                        return $value;
                    }
                } else {
                    Logging::error("[getValueBySn] could not get Interface for: " . $param_sn . " from CCU-ID: " . $param_ccuId);
                    return false;
                }
            } else {
                Logging::error("[getValueBySn] could not get CCU info with ID: " . $param_ccuId);
                return false;
            }
        } else {
            Logging::error("[getValueBySn] could not get value. Not all parameters set. " . print_r($param_dataPoint, true));
            return false;
        }

    }

    static function setValueBySn($param_ccuId, $param_sn, $param_dataPoint, $param_value, $param_interface = "XML-RPC", SQL $param_sql = null)
    {
        if (($param_dataPoint != null) && ($param_value != null)) {
            $sql = null;
            if ($param_sql != null) {
                $sql = $param_sql;
            } else {
                $sql = new SQL();
            }
            $ccu = $sql->queryRequest("SELECT CcuAddress, CallbackAddress FROM " . HCS_TABLE_PREFIX . "CcuList WHERE Id = '" . $param_ccuId . "';");
            if ((count($ccu) > 0) && ($ccu[0]["CcuAddress"] != null)) {
                $interface = self::getInterfaceBySn($param_ccuId, $param_sn, $sql);
                if (!($interface === false)) {
                    if ($param_interface == "HSS") {
                        $regahss = new Homematic_ReGaHSS($ccu[0]["CcuAddress"]);
                        $result = $regahss->setValueBySn($interface, $param_sn, $param_dataPoint, $param_value);
                    } else {
                        $xmlrpc = new Homematic_XmlRpcInterface($ccu[0]["CcuAddress"], $interface);
                        $result = $xmlrpc->setValue($param_sn, $param_dataPoint, $param_value);
                    }
                    if ($result === false) {
                        Logging::error("[setValueBySn] could not set value '" . $param_value . "' to '" . $param_dataPoint . "' on device " . $param_sn);
                        return false;
                    } else {
// fix $value for logging
                        $temp = Homematic_XmlRpc::getValueTypeByDp($param_dataPoint, $param_value);
                        if (count($temp) == 2) {
                            $param_value = $temp[1];
                            booleanToString($param_value);
                        }
                        LogEvent($param_ccuId, $param_sn, $param_dataPoint, $param_value, $sql);
                        Logging::info("[setValueBySn] set value '" . $param_value . "' to '" . $param_dataPoint . "' on device " . $param_sn);
                        return true;
                    }
                } else {
                    Logging::error("[setValueBySn] could not get Interface for: " . $param_sn . " from CCU-ID: " . $param_ccuId);
                    return false;
                }
            } else {
                Logging::error("[setValueBySn] could not get CCU info with ID: " . $param_ccuId);
                return false;
            }
        } else {
            Logging::error("[setValueBySn] could not set value. Not all parameters set. " . print_r($param_dataPoint, true) . ", " . print_r($param_value, true));
            return false;
        }

    }

    static function getAllSystemVariables($param_ccuId, SQL $param_sql = null)
    {
        $sql = null;
        if ($param_sql != null) {
            $sql = $param_sql;
        } else {
            $sql = new SQL();
        }
        $ccu = $sql->queryRequest("SELECT CcuAddress, CallbackAddress FROM " . HCS_TABLE_PREFIX . "CcuList WHERE Id = '" . $param_ccuId . "';");
        if ((count($ccu) > 0) && ($ccu[0]["CcuAddress"] != null)) {
            $regahss = new Homematic_ReGaHSS($ccu[0]["CcuAddress"]);
            $values = $regahss->getAllSystemVariables();
            if ($values === false) {
                Logging::error("[getAllSystemVariables] could not get all system variables");
                return false;
            } else {
                foreach($values as $id => $value){
                    LogEvent($param_ccuId, 'SYSTEM_VARIABLES', (int)$id, $value, $sql);
                    Logging::info("[getAllSystemVariables] got value for variable ID '" . $id . "; value: " . $value);
                }
                return $values;
            }
        } else {
            Logging::error("[getAllSystemVariables] could not get CCU info with ID: " . $param_ccuId);
            return false;
        }
    }

    static function getSystemVariable($param_ccuId, $param_sn, SQL $param_sql = null)
    {
        if (($param_sn != null)) {
            $sql = null;
            if ($param_sql != null) {
                $sql = $param_sql;
            } else {
                $sql = new SQL();
            }
            $ccu = $sql->queryRequest("SELECT CcuAddress, CallbackAddress FROM " . HCS_TABLE_PREFIX . "CcuList WHERE Id = '" . $param_ccuId . "';");
            if ((count($ccu) > 0) && ($ccu[0]["CcuAddress"] != null)) {
                $regahss = new Homematic_ReGaHSS($ccu[0]["CcuAddress"]);
                $value = $regahss->getSystemVariable($param_sn);
                if ($value === false) {
                    Logging::error("[getSystemVariable] could not get system variable '" . $param_sn);
                    return false;
                } else {
                    $query = $sql->queryRequest("SELECT Id FROM " . HCS_TABLE_PREFIX . "SystemVariables WHERE Name = '" . $param_sn . "';");
                    if (count($query) > 0) {
                        LogEvent($param_ccuId, 'SYSTEM_VARIABLES', $query[0]['Id'], $value, $sql);
                        Logging::info("[getSystemVariable] got value for '" . $param_sn . "; value: " . $value);
                        return $value;
                    } else {
                        Logging::error("[getSystemVariable] could not get ID for system variable '" . $param_sn . "'");
                        return false;
                    }
                }
            } else {
                Logging::error("[getSystemVariable] could not get CCU info with ID: " . $param_ccuId);
                return false;
            }
        } else {
            Logging::error("[getSystemVariable] could not get value. Not all parameters set. " . print_r($param_sn, true));
            return false;
        }
    }

    static function setSystemVariable($param_ccuId, $param_sn, $param_value, SQL $param_sql = null)
    {
        if (($param_sn != null) && ($param_value != null)) {
            $sql = null;
            if ($param_sql != null) {
                $sql = $param_sql;
            } else {
                $sql = new SQL();
            }
            $ccu = $sql->queryRequest("SELECT CcuAddress, CallbackAddress FROM " . HCS_TABLE_PREFIX . "CcuList WHERE Id = '" . $param_ccuId . "';");
            if ((count($ccu) > 0) && ($ccu[0]["CcuAddress"] != null)) {

                $regahss = new Homematic_ReGaHSS($ccu[0]["CcuAddress"]);

                if ($regahss->setSystemVariable($param_sn, $param_value) === false) {
                    Logging::error("[setSystemVariable] could not set " . $param_value . " on system variable '" . $param_sn);
                    return false;
                } else {
                    $query = $sql->queryRequest("SELECT Id FROM " . HCS_TABLE_PREFIX . "SystemVariables WHERE Name = '" . $param_sn . "';");
                    if (count($query) > 0) {
                        LogEvent($param_ccuId, 'SYSTEM_VARIABLES', $query[0]['Id'], $param_value, $sql);
                        Logging::info("[setSystemVariable] got value for '" . $param_sn . "; value: " . $param_value);
                        return true;
                    } else {
                        Logging::error("[setSystemVariable] could not get ID for system variable '" . $param_sn);
                        return false;
                    }
                }
            } else {
                Logging::error("[setSystemVariable] could not get CCU info with ID: " . $param_ccuId);
                return false;
            }
        } else {
            Logging::error("[setSystemVariable] could not set value. Not all parameters set. " . print_r($param_sn, true) . ", " . print_r($param_value, true));
            return false;
        }
    }

    static function executeProgram($param_ccuId, $param_prog, SQL $param_sql = null)
    {
        if (($param_prog != null)) {
            $sql = null;
            if ($param_sql != null) {
                $sql = $param_sql;
            } else {
                $sql = new SQL();
            }
            $ccu = $sql->queryRequest("SELECT CcuAddress, CallbackAddress FROM " . HCS_TABLE_PREFIX . "CcuList WHERE Id = '" . $param_ccuId . "';");
            if ((count($ccu) > 0) && ($ccu[0]["CcuAddress"] != null)) {

                $regahss = new Homematic_ReGaHSS($ccu[0]["CcuAddress"]);

                if ($regahss->executeProgram($param_prog) === false) {
                    Logging::error("[executeProgram] could not execute program '" . $param_prog);
                    return false;
                } else {
                    Logging::info("[executeProgram] executed program '" . $param_prog);
                    return true;
                }
            } else {
                Logging::error("[executeProgram] could not get CCU info with ID: " . $param_ccuId);
                return false;
            }
        } else {
            Logging::error("[executeProgram] could not execute program. Not all parameters set. " . print_r($param_prog, true));
            return false;
        }
    }

    static function updateRoomList($param_ccuId, SQL $param_sql = null)
    {
        $sql = null;
        if ($param_sql != null) {
            $sql = $param_sql;
        } else {
            $sql = new SQL();
        }
        $ccu = $sql->queryRequest("SELECT CcuAddress, CallbackAddress FROM " . HCS_TABLE_PREFIX . "CcuList WHERE Id = '" . $param_ccuId . "';");
        if ((count($ccu) > 0) && ($ccu[0]["CcuAddress"] != null)) {
            $regahss = new Homematic_ReGaHSS($ccu[0]["CcuAddress"]);
            RoomArrayToSqlTable($param_ccuId, $regahss->getRoomList(), $sql);
            Logging::info("[updateCraftList] updated rooms list");
            return true;
        } else {
            Logging::error("[updateRoomList] could not get CCU info with ID: " . $param_ccuId);
            return false;
        }
    }

    static function updateCraftList($param_ccuId, SQL $param_sql = null)
    {
        $sql = null;
        if ($param_sql != null) {
            $sql = $param_sql;
        } else {
            $sql = new SQL();
        }
        $ccu = $sql->queryRequest("SELECT CcuAddress, CallbackAddress FROM " . HCS_TABLE_PREFIX . "CcuList WHERE Id = '" . $param_ccuId . "';");
        if ((count($ccu) > 0) && ($ccu[0]["CcuAddress"] != null)) {
            $regahss = new Homematic_ReGaHSS($ccu[0]["CcuAddress"]);
            CraftsArrayToSqlTable($param_ccuId, $regahss->getCraftsList(), $sql);
            Logging::info("[updateCraftList] updated crafts list");
            return true;
        } else {
            Logging::error("[updateCraftList] could not get CCU info with ID: " . $param_ccuId);
            return false;
        }
    }

    static function updateProgramsList($param_ccuId, SQL $param_sql = null)
    {
        $sql = null;
        if ($param_sql != null) {
            $sql = $param_sql;
        } else {
            $sql = new SQL();
        }
        $ccu = $sql->queryRequest("SELECT CcuAddress, CallbackAddress FROM " . HCS_TABLE_PREFIX . "CcuList WHERE Id = '" . $param_ccuId . "';");
        if ((count($ccu) > 0) && ($ccu[0]["CcuAddress"] != null)) {
            $regahss = new Homematic_ReGaHSS($ccu[0]["CcuAddress"]);
            ProgramsArrayToSqlTable($param_ccuId, $regahss->getProgramsList(), $sql);
            Logging::info("[updateProgramsList] updated programs list");
            return true;
        } else {
            Logging::error("[updateProgramsList] could not get CCU info with ID: " . $param_ccuId);
            return false;
        }
    }

    static function updateDeviceList($param_ccuId, SQL $param_sql = null)
    {
        $sql = null;
        if ($param_sql != null) {
            $sql = $param_sql;
        } else {
            $sql = new SQL();
        }
        $ccu = $sql->queryRequest("SELECT CcuAddress, CallbackAddress FROM " . HCS_TABLE_PREFIX . "CcuList WHERE Id = '" . $param_ccuId . "';");
        if ((count($ccu) > 0) && ($ccu[0]["CcuAddress"] != null)) {
            $regahss = new Homematic_ReGaHSS($ccu[0]["CcuAddress"]);
            homematicDeviceArrayToSqlTable($param_ccuId, $regahss->getDeviceList(), $sql);
            Logging::info("[updateDeviceList] updated devices list");
            return true;
        } else {
            Logging::error("[updateDeviceList] could not get CCU info with ID: " . $param_ccuId);
            return false;
        }
    }

    static function updateSystemVariableList($param_ccuId, SQL $param_sql = null)
    {
        $sql = null;
        if ($param_sql != null) {
            $sql = $param_sql;
        } else {
            $sql = new SQL();
        }
        $ccu = $sql->queryRequest("SELECT CcuAddress, CallbackAddress FROM " . HCS_TABLE_PREFIX . "CcuList WHERE Id = '" . $param_ccuId . "';");
        if ((count($ccu) > 0) && ($ccu[0]["CcuAddress"] != null)) {
            $regahss = new Homematic_ReGaHSS($ccu[0]["CcuAddress"]);
            homematicSysVarArrayToSqlTable($param_ccuId, $regahss->getSystemVariableList(), $sql);
            Logging::info("[updateSystemVariableList] updated system variables list");
            return true;
        } else {
            Logging::error("[updateSystemVariableList] could not get CCU info with ID: " . $param_ccuId);
            return false;
        }
    }

    static function updateAllList($param_ccuId, SQL $param_sql = null)
    {
        $sql = null;
        if ($param_sql != null) {
            $sql = $param_sql;
        } else {
            $sql = new SQL();
        }
        $ccu = $sql->queryRequest("SELECT CcuAddress, CallbackAddress FROM " . HCS_TABLE_PREFIX . "CcuList WHERE Id = '" . $param_ccuId . "';");
        if ((count($ccu) > 0) && ($ccu[0]["CcuAddress"] != null)) {
            $regahss = new Homematic_ReGaHSS($ccu[0]["CcuAddress"]);
            RoomArrayToSqlTable($param_ccuId, $regahss->getRoomList(), $sql);
            CraftsArrayToSqlTable($param_ccuId, $regahss->getCraftsList(), $sql);
            ProgramsArrayToSqlTable($param_ccuId, $regahss->getProgramsList(), $sql);
            homematicSysVarArrayToSqlTable($param_ccuId, $regahss->getSystemVariableList(), $sql);
            homematicDeviceArrayToSqlTable($param_ccuId, $regahss->getDeviceList(), $sql);

            Logging::info("[updateAllList] updated all lists");
            return true;
        } else {
            Logging::error("[updateAllList] could not get CCU info with ID: " . $param_ccuId);
            return false;
        }
    }

    static function getSnByName($param_ccuId, $param_name, SQL $param_sql = null)
    {
        $sql = null;
        if ($param_sql != null) {
            $sql = $param_sql;
        } else {
            $sql = new SQL();
        }
        if (($param_ccuId != null) && ($param_name != null)) {
            $device = $sql->queryRequest("SELECT Address FROM " . HCS_TABLE_PREFIX . "Channels WHERE Name = '" . $param_name . "' AND CcuId = '" . $param_ccuId . "';");
            if (count($device) > 0) {
                return $device[0]["Address"];
            } else {
                Logging::error("[getSnByName] could not find device with name:. " . $param_name . " on CCU ID: " . $param_ccuId);
                return false;
            }
        } else {
            Logging::error("[getSnByName] could read device. Not all parameters set. " . print_r($param_ccuId, true) . " " . print_r($param_name, true));
            return false;
        }

    }

    static function getInterfaceAndSnByName($param_ccuId, $param_name, SQL $param_sql = null)
    {
        $sql = null;
        if ($param_sql != null) {
            $sql = $param_sql;
        } else {
            $sql = new SQL();
        }
        if (($param_ccuId != null) && ($param_name != null)) {
            $device = $sql->queryRequest("SELECT c.Address, d.Interface FROM (" . HCS_TABLE_PREFIX . "Channels AS c LEFT JOIN " . HCS_TABLE_PREFIX . "Devices AS d ON c.DeviceAddress = d.Address) WHERE c.Name = '" . $param_name . "' AND d.CcuId = '" . $param_ccuId . "';");
            if (count($device) > 0) {
                $result = array($device[0]["Interface"], $device[0]["Address"]);
                return $result;
            } else {
                Logging::error("[getInterfaceAndSnByName] could not find device with name:. " . $param_name . " on CCU ID: " . $param_ccuId);
                return false;
            }
        } else {
            Logging::error("[getInterfaceAndSnByName] could read device. Not all parameters set. " . print_r($param_ccuId, true) . " " . print_r($param_name, true));
            return false;
        }

    }

    static function getInterfaceBySn($param_ccuId, $param_sn, SQL $param_sql = null)
    {
        $sql = null;
        if ($param_sql != null) {
            $sql = $param_sql;
        } else {
            $sql = new SQL();
        }
        if (($param_ccuId != null) && ($param_sn != null)) {
            $device = $sql->queryRequest("SELECT d.Interface FROM (" . HCS_TABLE_PREFIX . "Channels AS c LEFT JOIN " . HCS_TABLE_PREFIX . "Devices AS d ON c.DeviceAddress = d.Address) WHERE c.Address = '" . $param_sn . "' AND d.CcuId = '" . $param_ccuId . "';");
            if (count($device) > 0) {
                return $device[0]["Interface"];
            } else {
                Logging::error("[getInterfaceBySn] could not find device with SN:. " . $param_sn . " on CCU ID: " . $param_ccuId);
                return false;
            }
        } else {
            Logging::error("[getInterfaceBySn] could read device. Not all parameters set. " . print_r($param_ccuId, true) . " " . print_r($param_sn, true));
            return false;
        }

    }

    static function getSysVarNameById($param_ccuId, $param_id, $param_sql = null)
    {
        $sql = null;
        if ($param_sql != null) {
            $sql = $param_sql;
        } else {
            $sql = new SQL();
        }

        if (($param_ccuId != null) && ($param_id != null)) {
            $param_id = (int)$param_id;
            $device = $sql->queryRequest("SELECT Name FROM " . HCS_TABLE_PREFIX . "SystemVariables WHERE Id = '" . $param_id . "' AND CcuId = '" . $param_ccuId . "';");
            if (count($device) > 0) {
                return $device[0]["Name"];
            } else {
                Logging::error("[getSysVarNameById] could not find system variable with ID: " . $param_id . " on CCU ID: " . $param_ccuId);
                return false;
            }
        } else {
            Logging::error("[getSysVarNameById] could read system variable name. Not all parameters set. " . print_r($param_ccuId, true) . " " . print_r($param_id, true));
            return false;
        }

    }

    static function getSysVarIdByName($param_ccuId, $param_name, $param_sql = null)
    {
        $sql = null;
        if ($param_sql != null) {
            $sql = $param_sql;
        } else {
            $sql = new SQL();
        }

        if (($param_ccuId != null) && ($param_name != null)) {
            $device = $sql->queryRequest("SELECT Id FROM " . HCS_TABLE_PREFIX . "SystemVariables WHERE Name = '" . $param_name . "' AND CcuId = '" . $param_ccuId . "';");
            if (count($device) > 0) {
                return $device[0]["Name"];
            } else {
                Logging::error("[getSysVarIdByName] could not find system variable with Name:. " . $param_name . " on CCU ID: " . $param_ccuId);
                return false;
            }
        } else {
            Logging::error("[getSysVarIdByName] could read system variable ID. Not all parameters set. " . print_r($param_ccuId, true) . " " . print_r($param_name, true));
            return false;
        }
    }

    static function intToSystemVariableType($param_int)
    {
        switch ($param_int) {
            case 2:
                return 'Boolean';
                break;
            case 4:
                return 'Number';
                break;
            case 16:
                return 'ValueList';
                break;
            case 20:
                return 'String';
                break;
            default:
                return $param_int;
                break;
        }
    }

    static function stringToHomematicInterface($param_string)
    {
        if ($param_string == "BidCos-RF") {
            return Homematic_Interface::RF;
        } elseif ($param_string == "BidCos-Wired") {
            return Homematic_Interface::Wired;
        } elseif ($param_string == "System") {
            return Homematic_Interface::System;
        } elseif ($param_string == "CUxD") {
            return Homematic_Interface::CUxD;
        } else {
            Logging::warning("[Homematic_ReGaHSS->stringToHomematicInterface] interface string '" . $param_string . "' is not valid.");
            return $param_string;
        }

    }

    static function homematicInterfaceToString($param_interface)
    {
        if ($param_interface == Homematic_Interface::RF) {
            return "BidCos-RF";
        } elseif ($param_interface == Homematic_Interface::Wired) {
            return "BidCos-Wired";
        } elseif ($param_interface == Homematic_Interface::System) {
            return "System";
        } elseif ($param_interface == Homematic_Interface::CUxD) {
            return "CUxD";
        } else {
            Logging::warning("[Homematic_ReGaHSS->homematicInterfaceToString] interface paramter '" . $param_interface . "' is not valid.");
            return $param_interface;
        }

    }
}

// </editor-fold>

/* -------------------------------------------------------------------------- */

// <editor-fold defaultstate="collapsed" desc="CLASS SQL SINGLETON">
class SqlSingleton
{

    private $SqlInstances = array('mysql' => array(), 'mssql' => array(), 'sqlite' => array(), 'sqlite3' => array());
    static private $instance = null;

    static public function getInstance()
    {
        if (self::$instance === null) {
            self::$instance = new self;
        }
        return self::$instance;
    }


    public static function getSqlInstance($param_type, $param_database, $param_host = '', $param_user = '', $param_password = '')
    {
        $instance = self::getInstance();

        switch ($param_type) {
            case 'mysql':
                $hash = md5($param_database . $param_host . $param_user . $param_password);
                if (!isset($instance->SqlInstances[$param_type][$hash])) {
                    $instance->SqlInstances[$param_type][$hash] = new MySQL($param_database, $param_host, $param_user, $param_password);
                }
                return $instance->SqlInstances[$param_type][$hash];
                break;
            case 'mssql':
                $hash = md5($param_database . $param_host . $param_user . $param_password);
                if (!isset($instance->SqlInstances[$param_type][$hash])) {
                    $instance->SqlInstances[$param_type][$hash] = new MSSQL($param_database, $param_host, $param_user, $param_password);
                }
                return $instance->SqlInstances[$param_type][$hash];
                break;
            case 'sqlite':
                $hash = md5($param_database);
                if (!isset($instance->SqlInstances[$param_type][$hash])) {
                    $instance->SqlInstances[$param_type][$hash] = new SQLite($param_database);
                }
                return $instance->SqlInstances[$param_type][$hash];
                break;
            case 'sqlite3':
                $hash = md5($param_database);
                if (!isset($instance->SqlInstances[$param_type][$hash])) {
                    $instance->SqlInstances[$param_type][$hash] = new SQLite_3($param_database);
                }
                return $instance->SqlInstances[$param_type][$hash];
                break;
            default:

                return false;
                break;
        }
    }

    private function __construct()
    {

    }

    private function __clone()
    {

    }


}

// </editor-fold>

/* -------------------------------------------------------------------------- */

// <editor-fold defaultstate="collapsed" desc="CLASS SQL">
class SQL
{

    private $sqlObject;
    public $type;
    private $sqlStrings = array();

    function __construct($param_sqlServerType = '', $param_database = SQL_SERVER_DATABASE, $param_host = SQL_SERVER_HOST, $param_user = SQL_SERVER_USERNAME, $param_password = SQL_SERVER_PASSWORD)
    {
        $type = ($param_sqlServerType === '' && defined('SQL_SERVER_TYPE')) ? strtolower(SQL_SERVER_TYPE) : (($param_sqlServerType != '') ? $param_sqlServerType : '');

        switch ($type) {
            case 'mysql':
                $this->type = 'MySQL';
                $this->sqlStrings['autoIncrement'] = 'AUTO_INCREMENT';
                $this->sqlStrings['boolean'] = 'BOOLEAN';
                $this->sqlStrings['timestamp'] = 'TIMESTAMP';
                $this->sqlStrings['timestamp_default'] = 'TIMESTAMP DEFAULT CURRENT_TIMESTAMP';
                $this->sqlStrings['timestamp_default_updated'] = 'TIMESTAMP DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP';
                break;

            case 'mssql':
                $this->type = 'MSSQL';
                $this->sqlStrings['autoIncrement'] = 'IDENTITY';
                $this->sqlStrings['boolean'] = 'BIT';
                $this->sqlStrings['timestamp'] = 'DATETIME';
                $this->sqlStrings['timestamp_default'] = 'DATETIME';
                $this->sqlStrings['timestamp_default_updated'] = 'DATETIME';
                break;

            case 'sqlite':
                $this->type = 'SQLite';
                $this->sqlStrings['autoIncrement'] = 'AUTOINCREMENT';
                $this->sqlStrings['boolean'] = 'BOOLEAN';
                $this->sqlStrings['timestamp'] = 'TIMESTAMP';
                $this->sqlStrings['timestamp_default'] = 'TIMESTAMP DEFAULT CURRENT_TIMESTAMP';
                $this->sqlStrings['timestamp_default_updated'] = 'TIMESTAMP DEFAULT CURRENT_TIMESTAMP';
                break;

            case 'sqlite3':
                $this->type = 'SQLite3';
                $this->sqlStrings['autoIncrement'] = 'AUTOINCREMENT';
                $this->sqlStrings['boolean'] = 'BOOLEAN';
                $this->sqlStrings['timestamp'] = 'TIMESTAMP';
                $this->sqlStrings['timestamp_default'] = 'TIMESTAMP DEFAULT CURRENT_TIMESTAMP';
                $this->sqlStrings['timestamp_default_updated'] = 'TIMESTAMP DEFAULT CURRENT_TIMESTAMP';
                break;

            case '':
            default:
                $this->sqlStrings['autoIncrement'] = '';
                $this->sqlStrings['boolean'] = '';
                $this->sqlStrings['timestamp'] = '';
                $this->sqlStrings['timestamp_default'] = '';
                $this->sqlStrings['timestamp_default_updated'] = '';

                Logging::error("[SQL] Could not create SQL class instance. '$type' is not a valid DBAL", true);
                break;
        }

        $sqlInstance = SqlSingleton::getSqlInstance($type, $param_database, $param_host, $param_user, $param_password);
        if ($sqlInstance === false) {
            Logging::error("[SQL] Could not get SQL class instance.", true);
        }
        if ($sqlInstance instanceof iSQL) {
            $this->sqlObject = $sqlInstance;
        }

    }

    function query($param_queryString)
    {
        return $this->sqlObject->query($param_queryString);

    }

    function getPreviousQueryAutoId()
    {
        return $this->sqlObject->getPreviousQueryAutoId();

    }

    function queryExec($param_queryString)
    {
        return $this->sqlObject->queryExec($param_queryString);

    }

    function queryRequest($param_queryString)
    {
        return $this->sqlObject->queryRequest($param_queryString);

    }

    function createTable($param_tableName, $param_definition)
    {
        return $this->sqlObject->createTable($param_tableName, $param_definition);

    }

    function deleteIdFromTable($param_tableName, $param_id)
    {
        return $this->sqlObject->deleteIdFromTable($param_tableName, $param_id);

    }

    function dropTable($param_tableName)
    {
        return $this->sqlObject->dropTable($param_tableName);

    }

    function truncateTable($param_tableName)
    {
        return $this->sqlObject->truncateTable($param_tableName);

    }

    function getTables()
    {
        return $this->sqlObject->getTables();

    }

    function insertOrUpdateInTo($param_tableName, array $param_columnsAndValues, array $param_Keys = array())
    {
        return $this->sqlObject->insertOrUpdateInTo($param_tableName, $param_columnsAndValues, $param_Keys);

    }

    function replaceInTo($param_tableName, array $param_columnsAndValues, array $param_Keys = array())
    {
        return $this->sqlObject->replaceInTo($param_tableName, $param_columnsAndValues, $param_Keys);

    }

    function checkLoginData($param_username, $param_password)
    {
        $query = $this->sqlObject->queryRequest("SELECT Password FROM " . HCS_TABLE_PREFIX . "Users WHERE Username = '" . escapeData($param_username) . "';");
        if ((count($query) == 1) && (hasher($param_password, $query[0]['Password']) === true)) {
            $this->updateUser($param_username, array('LastLogin' => date(SQL_SERVER_DATETIME_FORMAT)));
            return true;
        }
        return false;

    }

    function createLoginCookies($param_username, $param_durability = 2592000)
    {
        $expire = time() + $param_durability;
        if (($param_username != '') && ($param_durability >= 0)) {
            $query = $this->sqlObject->queryRequest("SELECT Username, Password, EMail FROM " . HCS_TABLE_PREFIX . "Users WHERE Username = '" . escapeData($param_username) . "';");
            if ((count($query) == 1)) {
                $userToken = base64_encode($query[0]['Username'] . '\\' . substr($query[0]['Password'], 10, 10));
                $hashToken = hasher($query[0]['Username'] . substr($query[0]['Password'], 20, 60) . $query[0]['EMail']);

                setcookie('userToken', $userToken, $expire, '/', NULL, NULL, TRUE);
                setcookie('hashToken', $hashToken, $expire, '/', NULL, NULL, TRUE);
            }
        }

    }

    /**
     *
     * @param string $param_userToken
     * @param string $param_hashToken
     * @param boolean $param_createNewCookie
     * @return boolean/string correct username or false
     */
    function checkLoginCookies($param_userToken = NULL, $param_hashToken = NULL, $param_createNewCookie = true)
    {
        $userToken = '';
        if ($param_userToken != NULL) {
            $userToken = $param_userToken;
        } else {
            checkedSet($userToken, $_COOKIE['userToken']);
            if ($userToken == '') {
                clearLoginCookies();
                clearSession();
                return false;
            }
        }

        $hashToken = '';
        if ($param_hashToken != NULL) {
            $hashToken = $param_hashToken;
        } else {
            checkedSet($hashToken, $_COOKIE['hashToken']);
            if ($hashToken == '') {
                clearLoginCookies();
                clearSession();
                return false;
            }
        }

        if (($userToken != '') && ($hashToken != '')) {
            list($username, $passwordPart) = explode('\\', base64_decode($userToken));
            if (($username != '') && ($passwordPart != '')) {
                $query = $this->sqlObject->queryRequest("SELECT Username, Password, EMail FROM " . HCS_TABLE_PREFIX . "Users WHERE Username = '" . escapeData($username) . "';");
                if ((count($query) == 1)) {
                    // ceck if the PW part matches for the user
                    if (substr($query[0]['Password'], 10, 10) == $passwordPart) {
                        // it is now save to assume that the username is correct. now check the token.
                        $hash = $query[0]['Username'] . substr($query[0]['Password'], 20, 60) . $query[0]['EMail'];
                        if (hasher($hash, $hashToken) === true) {
                            // correct cookie login
                            if ($param_createNewCookie) {
                                $this->createLoginCookies($query[0]['Username']);
                            }
                            //generate a new session
                            $this->createSession($query[0]['Username']);
                            $_SESSION['autoLogin'] = true;
                            return $query[0]['Username'];
                        }
                    }
                }
            }
        }
        clearLoginCookies();
        clearSession();
        return false;

    }

    function createSession($param_username)
    {
        if (session_id() == "") {
            @session_start();
        }
        // we can assume we have a session
        // generate a new session and delete any old entries
        regenerateSession();
        $_SESSION = array();

        if (!is_string($param_username) && ($param_username != '')) {
            return false;
        }

        $_SESSION['serverMade'] = true;
        $_SESSION['autoLogin'] = false;
        $_SESSION['username'] = $param_username;
        $_SESSION['email'] = '';
        $_SESSION['created'] = time();
        $_SESSION['lastUse'] = time();
        $_SESSION['admin'] = false;

        $_SESSION['style'] = 'homematic';
        $_SESSION['language'] = 'german';

        $query = $this->sqlObject->queryRequest("SELECT Style, Language, EMail FROM " . HCS_TABLE_PREFIX . "Users WHERE Username = '" . escapeData($param_username) . "';");
        if ((count($query) == 1)) {
            $_SESSION['style'] = $query[0]['Style'];
            $_SESSION['language'] = $query[0]['Language'];
            $_SESSION['email'] = $query[0]['EMail'];
        }
        if ($this->isUserAdmin($param_username) === true) {
            $_SESSION['admin'] = true;
        }
        return true;
    }

    function isUserAdmin($param_username)
    {
        $query = $this->sqlObject->queryRequest("SELECT Adminrights FROM " . HCS_TABLE_PREFIX . "Users WHERE Username = '" . escapeData($param_username) . "';");
        if ((count($query) == 1) && ($query[0]['Adminrights'] == 1)) {
            return true;
        }
        return false;

    }

    function checkWidgetPageAssociation($param_Id, $param_page)
    {
        $result = $this->sqlObject->queryRequest("SELECT Id FROM " . HCS_TABLE_PREFIX . "PageWidgets WHERE Id = '" . $param_Id . "' AND PageId = '" . $param_page . "';");
        if (count($result) == 1) {
            return true;
        }
        return false;
    }

    function getPageRights($param_page)
    {
        $userRight = -1;
        $result = $this->sqlObject->queryRequest("SELECT StandardRights FROM " . HCS_TABLE_PREFIX . "Pages WHERE Id = '" . $param_page . "';");
        if (($result == '') || (count($result) <= 0) || !(isset($result[0]["StandardRights"]))) {
            return false;
        }
        $pageRight = $result[0]["StandardRights"];
        $loggedInUser = getLoggedInUser($this);

        if ($loggedInUser != false) {
            $result = $this->sqlObject->queryRequest("SELECT Rights FROM " . HCS_TABLE_PREFIX . "UserRights WHERE PageId = '" . $param_page . "' AND Username='" . $loggedInUser . "';");
            if (($result != '') && (count($result) > 0)) {
                $userRight = $result[0]["Rights"];
            }
        }

        if (isset($_SESSION['admin']) && ($_SESSION['admin'] === true)) {
            $right = 3;
        } else {
            $right = max($pageRight, $userRight);
        }

        return $right;
    }

    function updateUser($param_username, array $param_columnsAndValues)
    {
        $param_columnsAndValues['Username'] = $param_username;
        return $this->sqlObject->insertOrUpdateInTo(HCS_TABLE_PREFIX . 'Users', $param_columnsAndValues, array('Username'));

    }

    function deleteUser($param_username)
    {
        $result = $this->sqlObject->queryExec("DELETE FROM " . HCS_TABLE_PREFIX . "UserRights WHERE Username = '" . $param_username . "';");
        $result &= $this->sqlObject->queryExec("DELETE FROM " . HCS_TABLE_PREFIX . "Users WHERE Username = '" . $param_username . "';");
        return $result;
    }

    function deleteCcu($param_id)
    {
        $result = $this->sqlObject->queryExec("DELETE FROM " . HCS_TABLE_PREFIX . "EntityCrafts WHERE CcuId = '" . $param_id . "';");
        $result &= $this->sqlObject->queryExec("DELETE FROM " . HCS_TABLE_PREFIX . "EntityRooms WHERE CcuId = '" . $param_id . "';");
        $result &= $this->sqlObject->queryExec("DELETE FROM " . HCS_TABLE_PREFIX . "HistoryStates WHERE CcuId = '" . $param_id . "';");
        $result &= $this->sqlObject->queryExec("DELETE FROM " . HCS_TABLE_PREFIX . "CurrentStates WHERE CcuId = '" . $param_id . "';");
        $result &= $this->sqlObject->queryExec("DELETE FROM " . HCS_TABLE_PREFIX . "Programs WHERE CcuId = '" . $param_id . "';");
        $result &= $this->sqlObject->queryExec("DELETE FROM " . HCS_TABLE_PREFIX . "Crafts WHERE CcuId = '" . $param_id . "';");
        $result &= $this->sqlObject->queryExec("DELETE FROM " . HCS_TABLE_PREFIX . "Rooms WHERE CcuId = '" . $param_id . "';");
        $result &= $this->sqlObject->queryExec("DELETE FROM " . HCS_TABLE_PREFIX . "Tasks WHERE CcuId = '" . $param_id . "';");
        $result &= $this->sqlObject->queryExec("DELETE FROM " . HCS_TABLE_PREFIX . "SystemVariables WHERE CcuId = '" . $param_id . "';");
        $result &= $this->sqlObject->queryExec("DELETE FROM " . HCS_TABLE_PREFIX . "DataPoints WHERE CcuId = '" . $param_id . "';");
        $result &= $this->sqlObject->queryExec("DELETE FROM " . HCS_TABLE_PREFIX . "Channels WHERE CcuId = '" . $param_id . "';");
        $result &= $this->sqlObject->queryExec("DELETE FROM " . HCS_TABLE_PREFIX . "Devices WHERE CcuId = '" . $param_id . "';");
        $result &= $this->sqlObject->queryExec("DELETE FROM " . HCS_TABLE_PREFIX . "CcuList WHERE Id = '" . $param_id . "';");
        return $result;
    }

    function deletePage($param_id)
    {
        $result = $this->sqlObject->queryExec("DELETE FROM " . HCS_TABLE_PREFIX . "PageWidgets WHERE PageId = '" . $param_id . "';");
        $result &= $this->sqlObject->queryExec("DELETE FROM " . HCS_TABLE_PREFIX . "UserRights WHERE PageId = '" . $param_id . "';");
        $result &= $this->sqlObject->queryExec("DELETE FROM " . HCS_TABLE_PREFIX . "Pages WHERE Id = '" . $param_id . "';");
        return $result;
    }

    function deleteTask($param_id)
    {
        return $this->sqlObject->queryExec("DELETE FROM " . HCS_TABLE_PREFIX . "Tasks WHERE Id = '" . $param_id . "';");
    }

    function deletePageWidget($param_id)
    {
        return $this->sqlObject->queryExec("DELETE FROM " . HCS_TABLE_PREFIX . "PageWidgets WHERE Id = '" . $param_id . "';");
    }

    function lockPageWidget($param_id)
    {
        return $this->sqlObject->insertOrUpdateInTo(HCS_TABLE_PREFIX . 'PageWidgets', array(
            'Id' => (int)$param_id,
            'Locked' => 1
        ), array('Id'));
    }

    function unlockPageWidget($param_id)
    {
        return $this->sqlObject->insertOrUpdateInTo(HCS_TABLE_PREFIX . 'PageWidgets', array(
            'Id' => (int)$param_id,
            'Locked' => 0
        ), array('Id'));
    }

    function duplicatePageWidget($param_id)
    {
        $widget = $this->queryRequest("SELECT * FROM " . HCS_TABLE_PREFIX . "PageWidgets WHERE Id=" . (int)$param_id);
        if (count($widget) > 0) {
            return $this->sqlObject->insertOrUpdateInTo(HCS_TABLE_PREFIX . 'PageWidgets', array(
                    'WidgetId' => $widget[0]['WidgetId'],
                    'PageId' => $widget[0]['PageId'],
                    'Configuration' => $widget[0]['Configuration'],
                    'Overflow' => $widget[0]['Overflow'],
                    'posLeft' => $widget[0]['posLeft'],
                    'posTop' => $widget[0]['posTop'],
                    'Width' => $widget[0]['Width'],
                    'Height' => $widget[0]['Height'],
                    'ZIndex' => $widget[0]['ZIndex'],
                ));
        } else {
            return false;
        }
    }

    function deleteLoggingRule($param_id)
    {
        global $HCS_ROOTPATH;
        deleteCacheFile($HCS_ROOTPATH . 'data/cache/rules.json', $HCS_ROOTPATH . 'data/cache/rules_delete');
        return $this->sqlObject->queryExec("DELETE FROM " . HCS_TABLE_PREFIX . "LoggingRules WHERE Id = '" . $param_id . "';");
    }

    function changeLoggingRulePriorityUp($param_id)
    {
        global $HCS_ROOTPATH;
        deleteCacheFile($HCS_ROOTPATH . 'data/cache/rules.json', $HCS_ROOTPATH . 'data/cache/rules_delete');
        $request = $this->sqlObject->queryRequest("SELECT Priority FROM " . HCS_TABLE_PREFIX . "LoggingRules WHERE Id = '" . $param_id . "';");
        if (($request != '') && (count($request) > 0)) {
            $upPriorityId = $this->sqlObject->queryRequest("SELECT Id, Priority FROM " . HCS_TABLE_PREFIX . "LoggingRules WHERE Priority > " . (int)$request[0]['Priority'] . " ORDER BY Priority ASC;");
            if (($upPriorityId != '') && (count($upPriorityId) > 0)) {
                $swapId = $upPriorityId[0]['Id'];
                $newPriority = (int)$upPriorityId[0]['Priority'];
                $result = $this->queryExec("UPDATE " . HCS_TABLE_PREFIX . "LoggingRules SET Priority = " . $newPriority . " WHERE Id = " . $param_id . ";");
                $result &= $this->queryExec("UPDATE " . HCS_TABLE_PREFIX . "LoggingRules SET Priority = " . ($newPriority - 1) . " WHERE Id = " . $swapId . ";");
                return $result;
            } else {
                // keine Tauschpriorität gefunden -> schon höchste Priorität
                return true;
            }
        } else {
            return false;
        }
    }

    function changeLoggingRulePriorityDown($param_id)
    {
        global $HCS_ROOTPATH;
        deleteCacheFile($HCS_ROOTPATH . 'data/cache/rules.json', $HCS_ROOTPATH . 'data/cache/rules_delete');
        $request = $this->sqlObject->queryRequest("SELECT Priority FROM " . HCS_TABLE_PREFIX . "LoggingRules WHERE Id = '" . $param_id . "';");
        if (($request != '') && (count($request) > 0)) {
            $downPriorityId = $this->sqlObject->queryRequest("SELECT Id, Priority FROM " . HCS_TABLE_PREFIX . "LoggingRules WHERE Priority < " . (int)$request[0]['Priority'] . " ORDER BY Priority DESC;");
            if (($downPriorityId != '') && (count($downPriorityId) > 0)) {
                $swapId = $downPriorityId[0]['Id'];
                $newPriority = (int)$downPriorityId[0]['Priority'];
                $result = $this->queryExec("UPDATE " . HCS_TABLE_PREFIX . "LoggingRules SET Priority = " . $newPriority . " WHERE Id = " . $param_id . ";");
                $result &= $this->queryExec("UPDATE " . HCS_TABLE_PREFIX . "LoggingRules SET Priority = " . ($newPriority + 1) . " WHERE Id = " . $swapId . ";");
                return $result;
            } else {
                // keine Tauschpriorität gefunden -> schon niedrichste Priorität
                return true;
            }
        } else {
            return false;
        }
    }

    function addLoggingRule($param_ccuid = '*', $param_device = '*', $param_datapoint = '*', $param_value = '*', $param_interval = 0, $param_lifespan = 0, $param_changes = 1)
    {
        global $HCS_ROOTPATH;
        deleteCacheFile($HCS_ROOTPATH . 'data/cache/rules.json', $HCS_ROOTPATH . 'data/cache/rules_delete');
        // get currently highest priority
        $request = $this->sqlObject->queryRequest("SELECT Priority FROM " . HCS_TABLE_PREFIX . "LoggingRules ORDER BY Priority DESC;");
        if (($request != '') && (count($request) > 0)) {
            $priority = (int)$request[0]['Priority'] + 1;
        } else {
            $priority = 0;
        }

        return $this->sqlObject->insertOrUpdateInTo(HCS_TABLE_PREFIX . 'LoggingRules', array(
                'Priority' => $priority,
                'CcuId' => $param_ccuid,
                'Device' => $param_device,
                'DataPoint' => $param_datapoint,
                'Value' => $param_value,
                'LoggingInterval' => $param_interval,
                'LifeSpan' => $param_lifespan,
                'OnlyLogChanges' => (int)$param_changes
            ));

    }

    function editLoggingRule($param_id, $param_ccuid = '*', $param_device = '*', $param_datapoint = '*', $param_value = '*', $param_interval = 0, $param_lifespan = 0, $param_changes = 1)
    {
        global $HCS_ROOTPATH;
        deleteCacheFile($HCS_ROOTPATH . 'data/cache/rules.json', $HCS_ROOTPATH . 'data/cache/rules_delete');
        return $this->sqlObject->insertOrUpdateInTo(HCS_TABLE_PREFIX . 'LoggingRules', array(
            'Id' => (int)$param_id,
            'CcuId' => $param_ccuid,
            'Device' => $param_device,
            'DataPoint' => $param_datapoint,
            'Value' => $param_value,
            'LoggingInterval' => $param_interval,
            'LifeSpan' => $param_lifespan,
            'OnlyLogChanges' => (int)$param_changes
        ), array('Id'));

    }

    function addRuleToSql($param_rule)
    {
        global $HCS_ROOTPATH;
        deleteCacheFile($HCS_ROOTPATH . 'data/cache/rules.json', $HCS_ROOTPATH . 'data/cache/rules_delete');
        if (($param_rule[7] === false) || ($param_rule[7] === "false")) {
            $param_rule[7] = 0;
        }
        $this->sqlObject->insertOrUpdateInTo(HCS_TABLE_PREFIX . "LoggingRules", array(
            "Priority" => $param_rule[0],
            "CcuId" => $param_rule[1],
            "Device" => $param_rule[2],
            "DataPoint" => $param_rule[3],
            "Value" => $param_rule[4],
            "LoggingInterval" => $param_rule[5],
            "LifeSpan" => $param_rule[6],
            "OnlyLogChanges" => $param_rule[7]
        ), array());
    }

    function addUser($param_username, $param_password, $param_email, $param_admin = 0, $param_style = 'homematic', $param_language = 'german')
    {
        $values = array(
            'Username' => $param_username,
            'EMail' => $param_email,
            'Adminrights' => (int)$param_admin,
            'LastLogin' => date(SQL_SERVER_DATETIME_FORMAT),
            'Style' => $param_style,
            'Language' => $param_language
        );

        if ($param_password != '') {
            $values['Password'] = hasher($param_password);
        } else {
            if (count($this->sqlObject->queryRequest("SELECT * FROM " . HCS_TABLE_PREFIX . "Users WHERE Username = '" . $param_username . "';")) <= 0) {
                return false;
            }
        }
        return $this->sqlObject->insertOrUpdateInTo(HCS_TABLE_PREFIX . 'Users', $values, array('Username'));
    }

    function addCcu($param_ip, $param_name, $param_version, $param_wired, $param_rf, $param_system)
    {
        $callbackAddress = HCS_SERVER_NAME . ':' . HCS_SERVER_PORT . HCS_SERVER_PATH . 'server.php';
        return $this->sqlObject->insertOrUpdateInTo(HCS_TABLE_PREFIX . 'CcuList', array(
                'CcuAddress' => $param_ip,
                'CcuName' => $param_name,
                'CcuVersion' => $param_version,
                'CallbackAddress' => $callbackAddress,
                'SubscribeWiredEvents' => $param_wired,
                'SubscribeRfEvents' => $param_rf,
                'SubscribeSystemEvents' => $param_system,
            ));
    }

    function editCcu($param_id, $param_ip, $param_name, $param_version, $param_wired, $param_rf, $param_system)
    {
        $callbackAddress = HCS_SERVER_NAME . ':' . HCS_SERVER_PORT . HCS_SERVER_PATH . 'server.php';
        return $this->sqlObject->insertOrUpdateInTo(HCS_TABLE_PREFIX . 'CcuList', array(
                'Id' => (int)$param_id,
                'CcuAddress' => $param_ip,
                'CcuName' => $param_name,
                'CcuVersion' => $param_version,
                'CallbackAddress' => $callbackAddress,
                'SubscribeWiredEvents' => $param_wired,
                'SubscribeRfEvents' => $param_rf,
                'SubscribeSystemEvents' => $param_system,
            ), array('Id'));

    }

    function addPageWidget($page, $widgetId, $oflow, $comment, $lock, $left, $top, $width, $height, $zIndex, $config)
    {
        return $this->sqlObject->insertOrUpdateInTo(HCS_TABLE_PREFIX . 'PageWidgets', array(
                'WidgetId' => $widgetId,
                'PageId' => $page,
                'Configuration' => $config,
                'Overflow' => $oflow,
                'Comment' => $comment,
                'Locked' => $lock,
                'posLeft' => $left,
                'posTop' => $top,
                'Width' => $width,
                'Height' => $height,
                'ZIndex' => $zIndex,
            ));
    }

    function editPageWidget($id, $page, $widgetId, $oflow, $comment, $lock, $left, $top, $width, $height, $zIndex, $config)
    {
        return $this->sqlObject->insertOrUpdateInTo(HCS_TABLE_PREFIX . 'PageWidgets', array(
                'Id' => (int)$id,
                'WidgetId' => $widgetId,
                'PageId' => $page,
                'Configuration' => $config,
                'Overflow' => $oflow,
                'Comment' => $comment,
                'Locked' => $lock,
                'posLeft' => $left,
                'posTop' => $top,
                'Width' => $width,
                'Height' => $height,
                'ZIndex' => $zIndex,
            ), array('Id'));
    }

    function editPage($param_id, $param_name, $param_right, $param_comment, $param_start = false)
    {

        if ($param_start) {
            $this->queryExec('UPDATE ' . HCS_TABLE_PREFIX . 'Pages SET StartPage = 0');
        }

        return $this->sqlObject->insertOrUpdateInTo(HCS_TABLE_PREFIX . 'Pages', array(
                'Id' => (int)$param_id,
                'StartPage' => (int)$param_start,
                'Name' => $param_name,
                'StandardRights' => $param_right,
                'Comment' => $param_comment,
            ), array('Id'));

    }

    function duplicatePage($param_id)
    {
        $request = $this->queryRequest("SELECT * FROM " . HCS_TABLE_PREFIX . "Pages WHERE Id=" . (int)$param_id);
        if ((count($request) <= 0)) {
            // no page to duplicate
            return false;
        }

        $result = $this->sqlObject->insertOrUpdateInTo(HCS_TABLE_PREFIX . 'Pages', array(
                'Name' => $request[0]['Name'],
                'StartPage' => 0,
                'StandardRights' => $request[0]['StandardRights'],
                'Comment' => $request[0]['Comment'],
                'Title' => $request[0]['Title'],
                'CssStyle' => $request[0]['CssStyle'],
                'Style' => $request[0]['Style'],
                'LoginHeader' => (int)$request[0]['LoginHeader'],
                'PageTail' => (int)$request[0]['PageTail'],
                'EventUpdates' => (int)$request[0]['EventUpdates'],
                'RefreshTimeout' => (int)$request[0]['RefreshTimeout'],
                'RefreshRate' => (int)$request[0]['RefreshRate'],
                'RefreshWaitTime' => (int)$request[0]['RefreshWaitTime'],
            ));
        if (!$result) {
            return false;
        }
        $pageId = $this->sqlObject->getPreviousQueryAutoId();

        $widgets = $this->queryRequest("SELECT * FROM " . HCS_TABLE_PREFIX . "PageWidgets WHERE PageId=" . (int)$param_id);
        foreach ($widgets as $widget) {
            $result &= $this->sqlObject->insertOrUpdateInTo(HCS_TABLE_PREFIX . 'PageWidgets', array(
                    'WidgetId' => $widget['WidgetId'],
                    'PageId' => $pageId,
                    'Configuration' => $widget['Configuration'],
                    'Overflow' => $widget['Overflow'],
                    'posLeft' => $widget['posLeft'],
                    'posTop' => $widget['posTop'],
                    'Width' => $widget['Width'],
                    'Height' => $widget['Height'],
                    'ZIndex' => $widget['ZIndex'],
                ));
        }

        $userRights = $this->queryRequest("SELECT * FROM " . HCS_TABLE_PREFIX . "UserRights WHERE PageId=" . (int)$param_id);
        foreach ($userRights as $userRight) {
            $result &= $this->sqlObject->insertOrUpdateInTo(HCS_TABLE_PREFIX . 'UserRights', array(
                    'Username' => $userRight['Username'],
                    'PageId' => $pageId,
                    'Rights' => $userRight['Rights'],
                ));
        }
        return $result;
    }

    function editPageConfig($param_id, $param_title = "", $param_cssStyle = "", $param_style = "", $param_header = false, $param_tail = false, $param_updates = true, $param_timeout = 30, $param_rate = 0, $param_wait = 10)
    {
        return $this->sqlObject->insertOrUpdateInTo(HCS_TABLE_PREFIX . 'Pages', array(
                'Id' => (int)$param_id,
                'Title' => $param_title,
                'CssStyle' => $param_cssStyle,
                'Style' => $param_style,
                'LoginHeader' => (int)$param_header,
                'PageTail' => (int)$param_tail,
                'EventUpdates' => (int)$param_updates,
                'RefreshTimeout' => (int)$param_timeout,
                'RefreshRate' => (int)$param_rate,
                'RefreshWaitTime' => (int)$param_wait,
            ), array('Id'));

    }

    function addPageUserRight($param_pageId, $param_username, $param_right)
    {
        return $this->sqlObject->insertOrUpdateInTo(HCS_TABLE_PREFIX . 'UserRights', array(
                'PageId' => (int)$param_pageId,
                'Username' => $param_username,
                'Rights' => (int)$param_right,
            ), array('PageId', 'Username'));

    }

    function addPage($param_name, $param_right = 0, $param_comment = "", $param_start = false, $param_title = "", $param_cssStyle = "", $param_style = "standard", $param_header = false, $param_tail = false, $param_updates = true, $param_timeout = 30, $param_rate = 1, $param_wait = 0)
    {
        $start = (bool)$param_start;

        // if there is no page yet, make 1st page also the start page.
        $request = $this->queryRequest("SELECT Id, StartPage FROM " . HCS_TABLE_PREFIX . "Pages");
        if ((count($request) <= 0)) {
            $start = true;
        }

        if ($start) {
            $this->queryExec('UPDATE ' . HCS_TABLE_PREFIX . 'Pages SET StartPage = 0');
        }

        return $this->sqlObject->insertOrUpdateInTo(HCS_TABLE_PREFIX . 'Pages', array(
                'Name' => $param_name,
                'StartPage' => (int)$start,
                'StandardRights' => $param_right,
                'Comment' => $param_comment,
                'Title' => $param_title,
                'CssStyle' => $param_cssStyle,
                'Style' => $param_style,
                'LoginHeader' => (int)$param_header,
                'PageTail' => (int)$param_tail,
                'EventUpdates' => (int)$param_updates,
                'RefreshTimeout' => (int)$param_timeout,
                'RefreshRate' => (int)$param_rate,
                'RefreshWaitTime' => (int)$param_wait,
            ));

    }

    function updateWidgetPacket($param_folder)
    {
        global $HCS_ROOTPATH;

        $fileContent = file_get_contents($HCS_ROOTPATH . 'data/widgets/' . $param_folder . '/content.json');
        if ($fileContent === false) {
            return false;
        } else {
            $content = json_decode($fileContent, true);
            $name = null;
            $comment = null;

            checkedSet($name, $content["name"]);
            checkedSet($comment, $content["comment"]);
            if ((count($content["widgets"]) >= 1) && ($name !== null) && ($comment !== null)) {
                $result = $this->sqlObject->queryRequest("SELECT Id FROM " . HCS_TABLE_PREFIX . "WidgetPackets WHERE LOWER(Folder) = LOWER('" . $param_folder . "');");
                if (count($result) > 0) {
                    $packetId = $result[0]['Id'];
                    $result = $this->sqlObject->insertOrUpdateInTo(HCS_TABLE_PREFIX . 'WidgetPackets', array(
                            'Id' => $packetId,
                            'Name' => $name,
                            'Folder' => $param_folder,
                            'Comment' => $comment
                        ), array('Id'));
                    if ($result !== false) {
                        $currentTime = date(SQL_SERVER_DATETIME_FORMAT);
                        foreach ($content["widgets"] as $widget) {
                            if (count($widget) == 5) {
                                $result = $this->sqlObject->insertOrUpdateInTo(HCS_TABLE_PREFIX . 'Widgets', array(
                                        'PacketId' => $packetId,
                                        'Name' => $widget["Name"],
                                        'ClassFile' => $widget["ClassFile"],
                                        'ClassName' => $widget["ClassName"],
                                        'ConfigClassFile' => $widget["ConfigClassFile"],
                                        'Description' => $widget["Description"],
                                        'LastUpdate' => $currentTime
                                    ), array('ClassName', 'PacketId'));
                                if ($result === false) {
                                    return false;
                                }
                            } else {
                                return false;
                            }
                        }
                        $this->sqlObject->query("DELETE FROM " . HCS_TABLE_PREFIX . "Widgets WHERE ((LastUpdate < '" . $currentTime . "') AND (PacketId = " . $packetId . ") );");
                        return true;
                    } else {
                        return false;
                    }
                } else {
                    $this->addWidgetPacket($param_folder);
                }
            } else {
                // content style is wrong
                return false;
            }
        }
        return true;
    }

    function addWidgetPacket($param_folder)
    {
        global $HCS_ROOTPATH;

        $fileContent = file_get_contents($HCS_ROOTPATH . 'data/widgets/' . $param_folder . '/content.json');
        if ($fileContent === false) {
            return false;
        } else {
            $content = json_decode($fileContent, true);
            $name = null;
            $comment = null;

            checkedSet($name, $content["name"]);
            checkedSet($comment, $content["comment"]);
            if ((count($content["widgets"]) >= 1) && ($name !== null) && ($comment !== null)) {

                $result = $this->sqlObject->insertOrUpdateInTo(HCS_TABLE_PREFIX . 'WidgetPackets', array(
                        'Name' => $name,
                        'Folder' => $param_folder,
                        'Comment' => $comment
                    ));
                $packetId = $this->sqlObject->getPreviousQueryAutoId();

                if ($result != false) {
                    $currentTime = date(SQL_SERVER_DATETIME_FORMAT);
                    foreach ($content["widgets"] as $widget) {
                        if (count($widget) == 5) {
                            $result = $this->sqlObject->insertOrUpdateInTo(HCS_TABLE_PREFIX . 'Widgets', array(
                                    'PacketId' => $packetId,
                                    'Name' => $widget["Name"],
                                    'ClassFile' => $widget["ClassFile"],
                                    'ClassName' => $widget["ClassName"],
                                    'ConfigClassFile' => $widget["ConfigClassFile"],
                                    'Description' => $widget["Description"],
                                    'LastUpdate' => $currentTime
                                ));
                            if ($result === false) {
                                return false;
                            }
                        }
                    }
                    return true;
                }
            }
            return false;
        }
    }

    function deleteWidgetPacket($param_id)
    {
        $result = true;
        // get all Widget-IDs for this Widget-Packet
        $request = $this->sqlObject->queryRequest("SELECT Id FROM " . HCS_TABLE_PREFIX . "Widgets WHERE PacketId= '" . (int)$param_id . "';");
        // delete all PageWidgets for each widget
        foreach ($request as $widget) {
            $result &= $this->sqlObject->queryExec("DELETE FROM " . HCS_TABLE_PREFIX . "PageWidgets WHERE WidgetId = '" . $widget["Id"] . "';");
        }
        if ($result == true) {
            // delete all widgets for this packet
            $result &= $this->sqlObject->queryExec("DELETE FROM " . HCS_TABLE_PREFIX . "Widgets WHERE PacketId = '" . (int)$param_id . "';");
            if ($result == true) {
                $result &= $this->sqlObject->queryExec("DELETE FROM " . HCS_TABLE_PREFIX . "WidgetPackets WHERE Id = '" . (int)$param_id . "';");
            }
        }
        return $result;
    }

    function updateUserRight($param_username, $param_pageId, $param_right)
    {
        return $this->sqlObject->insertOrUpdateInTo(HCS_TABLE_PREFIX . 'UserRights', array(
                'Username' => $param_username,
                'PageId' => $param_pageId,
                'Right' => $param_right
            ));

    }

    function addTask($param_ccuid, $param_name, $param_type, $param_interface, $param_designator, $param_parameter, $param_nextExecution, $param_interval)
    {
        return $this->sqlObject->insertOrUpdateInTo(HCS_TABLE_PREFIX . 'Tasks', array(
                'CcuId' => $param_ccuid,
                'Name' => $param_name,
                'Type' => $param_type,
                'Interface' => $param_interface,
                'Designator' => $param_designator,
                'Parameter' => $param_parameter,
                'NextExecution' => $param_nextExecution,
                'ExecutionInterval' => (int)$param_interval
            ));

    }

    function editTask($param_id, $param_ccuid, $param_name, $param_type, $param_interface, $param_designator, $param_parameter, $param_nextExecution, $param_interval)
    {
        return $this->sqlObject->insertOrUpdateInTo(HCS_TABLE_PREFIX . 'Tasks', array(
                'Id' => (int)$param_id,
                'CcuId' => $param_ccuid,
                'Name' => $param_name,
                'Type' => $param_type,
                'Interface' => $param_interface,
                'Designator' => $param_designator,
                'Parameter' => $param_parameter,
                'NextExecution' => $param_nextExecution,
                'ExecutionInterval' => (int)$param_interval
            ), array('Id', 'CcuId'));
    }

    function initializeSQL()
    {
        defined('HCS_TABLE_PREFIX') or define('HCS_TABLE_PREFIX', 'hcs_');

        // alte Tabellen löschen
        $this->sqlObject->dropTable(HCS_TABLE_PREFIX . "DevicesCrafts");
        $this->sqlObject->dropTable(HCS_TABLE_PREFIX . "DevicesRooms");
        $this->sqlObject->dropTable(HCS_TABLE_PREFIX . "Config");

        // Tabellen löschen
        $this->sqlObject->dropTable(HCS_TABLE_PREFIX . "Values");
        $this->sqlObject->dropTable(HCS_TABLE_PREFIX . "ClientPages");
        $this->sqlObject->dropTable(HCS_TABLE_PREFIX . "PageWidgets");
        $this->sqlObject->dropTable(HCS_TABLE_PREFIX . "Widgets");
        $this->sqlObject->dropTable(HCS_TABLE_PREFIX . "WidgetPackets");
        $this->sqlObject->dropTable(HCS_TABLE_PREFIX . "UserRights");
        $this->sqlObject->dropTable(HCS_TABLE_PREFIX . "Users");
        $this->sqlObject->dropTable(HCS_TABLE_PREFIX . "Pages");
        $this->sqlObject->dropTable(HCS_TABLE_PREFIX . "EventClients");
        $this->sqlObject->dropTable(HCS_TABLE_PREFIX . "HistoryStates");
        $this->sqlObject->dropTable(HCS_TABLE_PREFIX . "CurrentStates");
        $this->sqlObject->dropTable(HCS_TABLE_PREFIX . "LoggingRules");
        $this->sqlObject->dropTable(HCS_TABLE_PREFIX . "Tasks");
        $this->sqlObject->dropTable(HCS_TABLE_PREFIX . "EntityRooms");
        $this->sqlObject->dropTable(HCS_TABLE_PREFIX . "Rooms");
        $this->sqlObject->dropTable(HCS_TABLE_PREFIX . "EntityCrafts");
        $this->sqlObject->dropTable(HCS_TABLE_PREFIX . "Crafts");
        $this->sqlObject->dropTable(HCS_TABLE_PREFIX . "Programs");
        $this->sqlObject->dropTable(HCS_TABLE_PREFIX . "DataPoints");
        $this->sqlObject->dropTable(HCS_TABLE_PREFIX . "Channels");
        $this->sqlObject->dropTable(HCS_TABLE_PREFIX . "Devices");
        $this->sqlObject->dropTable(HCS_TABLE_PREFIX . "SystemVariables");
        $this->sqlObject->dropTable(HCS_TABLE_PREFIX . "CcuList");

        $this->sqlObject->createTable(HCS_TABLE_PREFIX . 'CcuList', 'Id INT NOT NULL ' . $this->sqlStrings['autoIncrement'] . ',
          CcuAddress VARCHAR(255),
          CcuName VARCHAR(255),
          CcuVersion VARCHAR(255),
          CallbackAddress VARCHAR(255),
          SubscribeWiredEvents ' . $this->sqlStrings['boolean'] . ',
          SubscribeRfEvents ' . $this->sqlStrings['boolean'] . ',
          SubscribeSystemEvents ' . $this->sqlStrings['boolean'] . ',
          PRIMARY KEY(Id)'
        );
        $this->sqlObject->createTable(HCS_TABLE_PREFIX . 'SystemVariables', 'CcuId INT NOT NULL,
          Id INT NOT NULL,
          Name VARCHAR(255),
          Description VARCHAR(255),
          ValueMin VARCHAR(255),
          ValueMax VARCHAR(255),
          ValueUnit VARCHAR(255),
          ValueType VARCHAR(255),
          ValueSubType VARCHAR(255),
          ValueList VARCHAR(255),
          LastUpdate VARCHAR(255),
          FOREIGN KEY(CcuId) REFERENCES ' . HCS_TABLE_PREFIX . 'CcuList(Id),
          PRIMARY KEY(CcuId, Id)'
        );
        $this->sqlObject->createTable(HCS_TABLE_PREFIX . 'Devices', 'CcuId INT NOT NULL,
          Id INT NOT NULL,
          Address VARCHAR(63),
          Name VARCHAR(255),
          Type VARCHAR(255),
          Interface VARCHAR(255),
          LastUpdate VARCHAR(255),
          FOREIGN KEY(CcuId) REFERENCES ' . HCS_TABLE_PREFIX . 'CcuList(Id),
          PRIMARY KEY(CcuId, Address)'
        );

        $this->sqlObject->createTable(HCS_TABLE_PREFIX . 'Channels', 'CcuId INT NOT NULL,
          DeviceAddress VARCHAR(63),
          Id INT NOT NULL,
          Address VARCHAR(63),
          Name VARCHAR(255),
          HssType VARCHAR(255),
          Type VARCHAR(255),
          Label VARCHAR(255),
          Direction VARCHAR(255),
          LastUpdate VARCHAR(255),
          FOREIGN KEY(CcuId) REFERENCES ' . HCS_TABLE_PREFIX . 'CcuList(Id),
          FOREIGN KEY(CcuId, DeviceAddress) REFERENCES ' . HCS_TABLE_PREFIX . 'Devices(CcuId, Address),
          PRIMARY KEY(CcuId, Address)'
        );

        $this->sqlObject->createTable(HCS_TABLE_PREFIX . 'DataPoints', 'CcuId INT NOT NULL,
          Id INT NOT NULL,
          ChannelAddress VARCHAR(63),
          Name VARCHAR(255),
          Type VARCHAR(255),
          TypeName VARCHAR(255),
          Operations INT,
          ValueType VARCHAR(255),
          ValueUnit VARCHAR(255),
          LastUpdate VARCHAR(255),
          FOREIGN KEY(CcuId) REFERENCES ' . HCS_TABLE_PREFIX . 'CcuList(Id),
          FOREIGN KEY(CcuId, ChannelAddress) REFERENCES ' . HCS_TABLE_PREFIX . 'Channels(CcuId, Address),
          PRIMARY KEY(CcuId, Id)'
        );

        $this->sqlObject->createTable(HCS_TABLE_PREFIX . 'Programs', 'CcuId INT NOT NULL,
          Id INT NOT NULL,
          Name VARCHAR(255) NOT NULL,
          Description VARCHAR(255),
          LastExecuted VARCHAR(255),
          LastUpdate VARCHAR(255),
          FOREIGN KEY(CcuId) REFERENCES ' . HCS_TABLE_PREFIX . 'CcuList(Id),
          PRIMARY KEY(CcuId, Id)'
        );
        $this->sqlObject->createTable(HCS_TABLE_PREFIX . 'Crafts', 'CcuId INT NOT NULL,
          Id INT NOT NULL,
          Name VARCHAR(255) NOT NULL,
          Description VARCHAR(255),
          LastUpdate VARCHAR(255),
          FOREIGN KEY(CcuId) REFERENCES ' . HCS_TABLE_PREFIX . 'CcuList(Id),
          PRIMARY KEY(CcuId, Id)'
        );
        $this->sqlObject->createTable(HCS_TABLE_PREFIX . 'EntityCrafts', 'CcuId INT NOT NULL,
          CraftId INT NOT NULL,
          EntityId VARCHAR(63),
          FOREIGN KEY(CcuId) REFERENCES ' . HCS_TABLE_PREFIX . 'CcuList(Id),
          FOREIGN KEY(CcuId, CraftId) REFERENCES ' . HCS_TABLE_PREFIX . 'Crafts(CcuId, Id),
          PRIMARY KEY(CcuId, CraftId, EntityId)'
        );
        $this->sqlObject->createTable(HCS_TABLE_PREFIX . 'Rooms', 'CcuId INT NOT NULL,
          Id INT NOT NULL,
          Name VARCHAR(255) NOT NULL,
          Description VARCHAR(255),
          LastUpdate VARCHAR(255),
          FOREIGN KEY(CcuId) REFERENCES ' . HCS_TABLE_PREFIX . 'CcuList(Id),
          PRIMARY KEY(CcuId, Id)'
        );
        $this->sqlObject->createTable(HCS_TABLE_PREFIX . 'EntityRooms', 'CcuId INT NOT NULL,
          RoomId INT NOT NULL,
          EntityId VARCHAR(63),
          FOREIGN KEY(CcuId) REFERENCES ' . HCS_TABLE_PREFIX . 'CcuList(Id),
          FOREIGN KEY(CcuId, RoomId) REFERENCES ' . HCS_TABLE_PREFIX . 'Rooms(CcuId, Id),
          PRIMARY KEY(CcuId, RoomId, EntityId)'
        );
        $this->sqlObject->createTable(HCS_TABLE_PREFIX . 'Tasks', 'Id INT NOT NULL ' . $this->sqlStrings['autoIncrement'] . ',
          CcuId INT NOT NULL,
          Name VARCHAR(255),
          Type VARCHAR(255),
          Interface VARCHAR(255),
          Designator TEXT,
          Parameter TEXT,
          NextExecution VARCHAR(255),
          ExecutionInterval INT,
          FOREIGN KEY(CcuId) REFERENCES ' . HCS_TABLE_PREFIX . 'CcuList(Id),
          PRIMARY KEY(Id)'
        );
        $this->sqlObject->createTable(HCS_TABLE_PREFIX . 'HistoryStates', 'CcuId INT NOT NULL,
          ChannelAddress VARCHAR(255),
          DataPoint VARCHAR(255),
          Value VARCHAR(255),
          Timestamp VARCHAR(255),
          Expiration VARCHAR(255),
          FOREIGN KEY(CcuId) REFERENCES ' . HCS_TABLE_PREFIX . 'CcuList(Id)'
        );
        $this->sqlObject->queryExec('CREATE INDEX IDX_LOGGING_EXPIRATION ON ' . HCS_TABLE_PREFIX . 'HistoryStates(Expiration)');
        $this->sqlObject->queryExec('CREATE INDEX IDX_LOGGING_TIMESTAMP ON ' . HCS_TABLE_PREFIX . 'HistoryStates(Timestamp)');
        $this->sqlObject->queryExec('CREATE INDEX IDX_LOGGING_ADDRESS ON ' . HCS_TABLE_PREFIX . 'HistoryStates(ChannelAddress)');
        $this->sqlObject->queryExec('CREATE INDEX IDX_LOGGING_DATAPOINT ON ' . HCS_TABLE_PREFIX . 'HistoryStates(DataPoint)');
        $this->sqlObject->queryExec('CREATE INDEX IDX_LOGGING_VALUE ON ' . HCS_TABLE_PREFIX . 'HistoryStates(Value)');
        $this->sqlObject->createTable(HCS_TABLE_PREFIX . 'CurrentStates', 'CcuId INT NOT NULL,
          ChannelAddress VARCHAR(63),
          DataPoint VARCHAR(63),
          Value VARCHAR(255),
          LastUpdate VARCHAR(255),
          FOREIGN KEY(CcuId) REFERENCES ' . HCS_TABLE_PREFIX . 'CcuList(Id),
          PRIMARY KEY(CcuId, ChannelAddress, DataPoint)'
        );
        $this->sqlObject->createTable(HCS_TABLE_PREFIX . 'LoggingRules', 'Id INT NOT NULL ' . $this->sqlStrings['autoIncrement'] . ',
          Priority INT,
          CcuId VARCHAR(255),
          Device VARCHAR(255),
          DataPoint VARCHAR(255),
          Value VARCHAR(255),
          LoggingInterval VARCHAR(255),
          LifeSpan VARCHAR(255),
          ValueConversion VARCHAR(255),
          OnlyLogChanges ' . $this->sqlStrings['boolean'] . ',
          PRIMARY KEY(Id)'
        );
        $this->sqlObject->createTable(HCS_TABLE_PREFIX . 'EventClients', 'Id INT NOT NULL ' . $this->sqlStrings['autoIncrement'] . ',
          CallbackId VARCHAR(255),
          CallbackAddress VARCHAR(255),
          PRIMARY KEY(Id)'
        );
        $this->sqlObject->createTable(HCS_TABLE_PREFIX . 'Users', 'Username VARCHAR(63),
          Password VARCHAR(255),
          EMail VARCHAR(255),
          Adminrights ' . $this->sqlStrings['boolean'] . ',
          LastLogin VARCHAR(255),
          Style VARCHAR(255),
          Language VARCHAR(255),
          PRIMARY KEY(Username)'
        );
        $this->sqlObject->createTable(HCS_TABLE_PREFIX . 'Pages', 'Id INT NOT NULL ' . $this->sqlStrings['autoIncrement'] . ',
          Name VARCHAR(255),
          StandardRights INT NOT NULL,
          StartPage ' . $this->sqlStrings['boolean'] . ',
          Comment TEXT,
          Title VARCHAR(255),
          CssStyle TEXT,
          Style VARCHAR(255),
          LoginHeader ' . $this->sqlStrings['boolean'] . ',
          PageTail ' . $this->sqlStrings['boolean'] . ',
          EventUpdates ' . $this->sqlStrings['boolean'] . ',
          RefreshTimeout INT,
          RefreshRate INT,
          RefreshWaitTime INT,
          PRIMARY KEY(Id)'
        );
        $this->sqlObject->createTable(HCS_TABLE_PREFIX . 'UserRights', 'Username VARCHAR(63),
          PageId INT NOT NULL,
          Rights INT NOT NULL,
          FOREIGN KEY(Username) REFERENCES ' . HCS_TABLE_PREFIX . 'Users(Username),
          FOREIGN KEY(PageId) REFERENCES ' . HCS_TABLE_PREFIX . 'Pages(Id),
          PRIMARY KEY(Username, PageId)'
        );
        $this->sqlObject->createTable(HCS_TABLE_PREFIX . 'WidgetPackets', 'Id INT NOT NULL ' . $this->sqlStrings['autoIncrement'] . ',
          Name VARCHAR(255),
          Folder VARCHAR(255),
          Comment TEXT,
          PRIMARY KEY(Id)'
        );
        $this->sqlObject->createTable(HCS_TABLE_PREFIX . 'Widgets', 'Id INT NOT NULL ' . $this->sqlStrings['autoIncrement'] . ',
          PacketId INT NOT NULL,
          Name VARCHAR(255),
          ClassFile VARCHAR(255),
          ClassName VARCHAR(255),
          ConfigClassFile VARCHAR(255),
          Description TEXT,
          LastUpdate VARCHAR(255),
          FOREIGN KEY(PacketId) REFERENCES ' . HCS_TABLE_PREFIX . 'WidgetPackets(Id),
          PRIMARY KEY(Id),
          CONSTRAINT UniqueClassName UNIQUE (ClassName)'
        );
        $this->sqlObject->createTable(HCS_TABLE_PREFIX . 'PageWidgets', 'Id INT NOT NULL ' . $this->sqlStrings['autoIncrement'] . ',
          WidgetId INT NOT NULL,
          PageId INT NOT NULL,
          Configuration TEXT,
          Comment TEXT,
          Locked ' . $this->sqlStrings['boolean'] . ',
          Overflow VARCHAR(255),
          posLeft VARCHAR(255),
          posTop VARCHAR(255),
          Width VARCHAR(255),
          Height VARCHAR(255),
          ZIndex VARCHAR(255),
          FOREIGN KEY(WidgetId) REFERENCES ' . HCS_TABLE_PREFIX . 'Widgets(Id),
          FOREIGN KEY(PageId) REFERENCES ' . HCS_TABLE_PREFIX . 'Pages(Id),
          PRIMARY KEY(Id)'
        );
        $this->sqlObject->createTable(HCS_TABLE_PREFIX . 'ClientPages', 'Id VARCHAR(255),
          LastUpdate VARCHAR(255),
          PRIMARY KEY(Id)'
        );
        $this->sqlObject->createTable(HCS_TABLE_PREFIX . 'Values', 'Name VARCHAR(255),
          Value VARCHAR(255),
          PRIMARY KEY(Name)'
        );
    }
}

// </editor-fold>

/* -------------------------------------------------------------------------- */

// EOF
?>