<?php

// <editor-fold defaultstate="collapsed" desc="CALLABLE PROTECTION">
// Make file not callable directly
if (!defined('HCS_CALLABLE_FILE')) {
    header('HTTP/1.0 404 Not Found');
    die('You shall not access this file directly.');
    exit;
}
// </editor-fold>
/* -------------------------------------------------------------------------- */

require_once('common_functions.php');
require_once('globals.php');

//defined('SQL_SERVER_DATETIME_FORMAT') or define('SQL_SERVER_DATETIME_FORMAT', 'Y-m-d\TH:i:s');

interface iSQL
{

    function query($param_queryString);

    function getPreviousQueryAutoId();

    function queryExec($param_queryString);

    function dropTable($param_tableName);

    function deleteIdFromTable($param_tableName, $param_id);

    function queryRequest($param_queryString);

    function createTable($param_tableName, $param_definition);

    function truncateTable($param_tableName);

    function replaceInTo($param_tableName, array $param_columnsAndValues, array $param_Keys = array());

    function insertOrUpdateInTo($param_tableName, array $param_columnsAndValues, array $param_Keys = array());

    function getTables();
}

class MySQL implements iSQL
{

    private $MySqlLinkId;
    private $database;

    function __construct($param_database = SQL_SERVER_DATABASE, $param_host = SQL_SERVER_HOST, $param_user = SQL_SERVER_USERNAME, $param_password = SQL_SERVER_PASSWORD, $param_new = false)
    {
        $this->MySqlLinkId = mysql_connect($param_host, $param_user, $param_password, $param_new);
        if (!$this->MySqlLinkId) {
            Logging::error("[MySQL] couldn't establish MySQL connection. " . mysql_errno() . ":\"" . mysql_error() . "\" ");
        } else {
            Logging::debug("[MySQL] established MySQL connection: " . $this->MySqlLinkId);
            $this->selectDb($param_database);
        }
    }

    function __destruct()
    {
        if ($this->MySqlLinkId) {
            mysql_close($this->MySqlLinkId);
            Logging::debug("[MySQL] closed MySQL connection: " . $this->MySqlLinkId);
            $this->MySqlLinkId = NULL;
        } else {
            Logging::debug("[MySQL] MySQL connection already closed.");
        }
    }

    function query($param_queryString)
    {
        $result = mysql_query($param_queryString, $this->MySqlLinkId);
        if (!$result) {
            Logging::error("[MySQL->query] Invalid query: \n" . mysql_error($this->MySqlLinkId) . "\n\n in query: \n" . $param_queryString . "\n");
            return false;
        } else {
            Logging::debug("[MySQL->query] Sent query: " . $param_queryString . "\n");
            return $result;
        }
    }

    function getPreviousQueryAutoId()
    {
        $result = mysql_insert_id($this->MySqlLinkId);
        if ($result === false || $result === 0) {
            Logging::warning("[MySQL->getPreviousQueryAutoId] Could not get AUTO_INCREMENT ID for previous query.\n");
            return false;
        } else {
            Logging::debug("[MySQL->query] Got AUTO_INCREMENT ID for previous query: " . $result . "\n");
            return $result;
        }
    }

    function queryExec($param_queryString)
    {
        if (!mysql_query($param_queryString, $this->MySqlLinkId)) {
            Logging::error("[MySQL->query] Invalid query: \n" . mysql_error($this->MySqlLinkId) . "\n\n in query: \n" . $param_queryString);
            return false;
        } else {
            Logging::debug("[MySQL->query] Sent query: " . $param_queryString);
            return true;
        }
    }

    function createTable($param_tableName, $param_definition)
    {
        if (!($this->query('CREATE TABLE IF NOT EXISTS ' . $param_tableName . '(' . $param_definition . ')'))) {
            Logging::error("[MySQL->createTable] Couldn't create table: \"" . $param_tableName . "\" in database: \"" . $this->database . "\".");
            return false;
        } else {
            Logging::info("[MySQL->createTable] Created table: \"" . $param_tableName . "\" in database: \"" . $this->database . "\".");
            return true;
        }
    }

    function dropTable($param_tableName)
    {
        if (!($this->query("DROP TABLE IF EXISTS " . $param_tableName))) {
            Logging::error("[MySQL->dropTable] Couldn't drop table: \"" . $param_tableName . "\" from database: \"" . $this->database . "\".");
            return false;
        } else {
            Logging::info("[MySQL->dropTable] Dropped table: \"" . $param_tableName . "\" from database: \"" . $this->database . "\".");
            return true;
        }
    }

    function truncateTable($param_tableName)
    {
        if (!($this->query("TRUNCATE TABLE " . $param_tableName))) {
            Logging::error("[MySQL->truncateTable] Couldn't truncate table: \"" . $param_tableName . "\" from database: \"" . $this->database . "\".");
            return false;
        } else {
            Logging::info("[MySQL->truncateTable] Truncated table: \"" . $param_tableName . "\" from database: \"" . $this->database . "\".");
            return true;
        }

    }

    function deleteIdFromTable($param_tableName, $param_id)
    {
        if (!($this->query("DELETE FROM " . $param_tableName . " WHERE Id = '" . (string)$param_id . "';"))) {
            Logging::error("[MySQL->deleteIdFromTable] Couldn't delete ID: " . $param_id . " from table: \"" . $param_tableName . "\".");
            return false;
        } else {
            Logging::info("[MySQL->deleteIdFromTable] Deleted id: " . $param_id . " from table: \"" . $param_tableName . "\".");
            return true;
        }
    }

    function queryRequest($param_queryString)
    {
        $QueryResult = array();
        $QueryAnswer = $this->query($param_queryString);
        while ($PartAnswer = mysql_fetch_assoc($QueryAnswer)) {
            $QueryResult[] = $PartAnswer;
        }
        Logging::debug("[MySQL->queryRequest] received: \n" . var_export($QueryResult, true));
        return $QueryResult;
    }

    function selectDb($param_databaseName)
    {
        $result = mysql_select_db($param_databaseName, $this->MySqlLinkId);
        if (!$result) {
            Logging::error("[MySQL->select_db] can't use database: \"" . $param_databaseName . "\" : \n" . mysql_error($this->MySqlLinkId));
            return false;
        } else {
            Logging::debug("[MySQL->select_db] selected database: " . $param_databaseName);
            $this->database = $param_databaseName;
            return $result;
        }
    }

    function replaceInTo($param_tableName, array $param_columnsAndValues, array $param_Keys = array())
    {
        $columns = '';
        $values = '';
        foreach ($param_columnsAndValues as $column => $value) {
            $columns .= $column . ', ';
            if (is_string($value)) {
                $value = "'" . $value . "'";
            }
            if (($value === 'NULL') || ($value === null) || ($value === NULL)) {
                $value = "NULL";
            }
            $values .= $value . ', ';
        }
        if (count($param_columnsAndValues) > 0) {
            $columns = substr($columns, 0, -2);
            $values = substr($values, 0, -2);
            return $this->query('REPLACE INTO ' . $param_tableName . ' (' . $columns . ') VALUES (' . $values . ')');
        }
    }

    function insertOrUpdateInTo($param_tableName, array $param_columnsAndValues, array $param_Keys = array())
    {
        $columns = '';
        $values = '';
        $updateQuery = '';

        foreach ($param_columnsAndValues as $column => $value) {
            $columns .= $column . ', ';
            if (is_string($value)) {
                $value = "'" . str_replace("'", "\\'", str_replace("\\", "\\\\", $value)) . "'";
            }
            if (($value === 'NULL') || ($value === null) || ($value === NULL)) {
                $value = "NULL";
            }
            $values .= $value . ', ';

            if (!(in_array($column, $param_Keys))) {
                $updateQuery .= $column . ' = ' . $value . ', ';
            }
        }
        if (count($param_columnsAndValues) > 0) {
            $columns = substr($columns, 0, -2);
            $values = substr($values, 0, -2);

            $query = 'INSERT INTO ' . $param_tableName . ' (' . $columns . ') VALUES (' . $values . ')';
            $query .= ' ON DUPLICATE KEY UPDATE ';
            $query .= substr($updateQuery, 0, -2) . ';';

            return $this->query($query);
        }
    }

    function getTables()
    {
        $query = $this->queryRequest("SHOW TABLES;");
        $tables = array();
        foreach ($query as $row) {
            $tables[] = (current($row) === false) ? '' : current($row);
        }
        return $tables;
    }
}

class MSSQL implements iSQL
{

    private $MsSqlLinkId;
    private $database;

    function __construct($param_database = SQL_SERVER_DATABASE, $param_host = SQL_SERVER_HOST, $param_user = SQL_SERVER_USERNAME, $param_password = SQL_SERVER_PASSWORD, $param_new = false)
    {
        $connectionInfo = array(
            "Database" => $param_database,
            "UID" => $param_user,
            "PWD" => $param_password,
            "ReturnDatesAsStrings" => true
        );

        $this->MsSqlLinkId = sqlsrv_connect($param_host, $connectionInfo);
        if (!$this->MsSqlLinkId) {
            Logging::error("[MS-SQL] couldn't establish MS-SQL connection. MSSQL-Error:\"" . print_r(sqlsrv_errors(), true) . "\" ");
        } else {
            Logging::debug("[MS-SQL] established MS-SQL connection: " . $this->MsSqlLinkId);
            $this->database = $param_database;
        }

    }

    function __destruct()
    {
        if ($this->MsSqlLinkId) {
            sqlsrv_close($this->MsSqlLinkId);
            Logging::debug("[MS-SQL] closing MS-SQL connection: " . $this->MsSqlLinkId);
            $this->MsSqlLinkId = NULL;
        } else {
            Logging::debug("[MS-SQL] MS-SQL connection already closed.");
        }

    }

    function createTable($param_tableName, $param_definition)
    {
        if (!($this->query("IF NOT EXISTS (SELECT TABLE_NAME FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_NAME = '" . $param_tableName . "') CREATE TABLE " . $param_tableName . " (" . $param_definition . ")"))) {
            Logging::error("[MS-SQL->createTable] Couldn't create table: \"" . $param_tableName . "\" in database: \"" . $this->database . "\".");
            return false;
        } else {
            Logging::info("[MS-SQL->createTable] Created table: \"" . $param_tableName . "\" in database: \"" . $this->database . "\".");
            return true;
        }

    }

    function deleteIdFromTable($param_tableName, $param_id)
    {
        if (!($this->query("DELETE FROM " . $param_tableName . " WHERE Id = '" . (string)$param_id . "';"))) {
            Logging::error("[MS-SQL->deleteIdFromTable] Couldn't delete ID: " . $param_id . " from table: \"" . $param_tableName . "\".");
            return false;
        } else {
            Logging::info("[MS-SQL->deleteIdFromTable] Deleted id: " . $param_id . " from table: \"" . $param_tableName . "\".");
            return true;
        }

    }

    function dropTable($param_tableName)
    {
        if (!($this->query("IF EXISTS(SELECT TABLE_NAME FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_NAME = '" . $param_tableName . "') DROP TABLE " . $param_tableName . "; "))) {
            Logging::error("[MS-SQL->dropTable] Couldn't drop table: \"" . $param_tableName . "\" from database: \"" . $this->database . "\".");
            return false;
        } else {
            Logging::info("[MS-SQL->dropTable] Dropped table: \"" . $param_tableName . "\" from database: \"" . $this->database . "\".");
            return true;
        }

    }

    function query($param_queryString)
    {
        $result = sqlsrv_query($this->MsSqlLinkId, $param_queryString);
        if (!$result) {
            Logging::error("[MS-SQL->query] Invalid query: \n" . print_r(sqlsrv_errors(), true) . "\n\n in query: \n" . $param_queryString . "\n");
            return false;
        } else {
            Logging::debug("[MS-SQL->query] Sent query: " . $param_queryString . "\n");
            return $result;
        }

    }

    function getPreviousQueryAutoId()
    {
        $query = $this->query('SELECT SCOPE_IDENTITY() AS LAST_INSERT_ID');
        $query_result = sqlsrv_fetch_array($query);
        $result = $query_result["LAST_INSERT_ID"];

        if ($result === false || $result === 0) {
            Logging::warning("[MS-SQL->getPreviousQueryAutoId] Could not get AUTO_INCREMENT ID for previous query.\n");
            return false;
        } else {
            Logging::debug("[MS-SQL->query] Got AUTO_INCREMENT ID for previous query: " . $result . "\n");
            return $result;
        }
    }

    function queryExec($param_queryString)
    {
        if (!sqlsrv_query($this->MsSqlLinkId, $param_queryString)) {
            Logging::error("[MS-SQL->query] Invalid query: \n" . print_r(sqlsrv_errors(), true) . "\n\n in query: \n" . $param_queryString);
            return false;
        } else {
            Logging::debug("[MS-SQL->query] Sent query: " . $param_queryString);
            return true;
        }

    }

    function queryRequest($param_queryString)
    {
        $QueryResult = array();
        $QueryAnswer = $this->query($param_queryString);

        while ($PartAnswer = sqlsrv_fetch_array($QueryAnswer, SQLSRV_FETCH_ASSOC)) {
            $QueryResult[] = $PartAnswer;
        }

        Logging::debug("[MS-SQL->queryRequest] received: \n" . print_r($QueryResult, true));
        return $QueryResult;

    }

    function truncateTable($param_tableName)
    {
        if (!($this->query("TRUNCATE TABLE " . $param_tableName))) {
            Logging::error("[MS-SQL->truncateTable] Couldn't truncate table: \"" . $param_tableName . "\" from database: \"" . $this->database . "\".");
            return false;
        } else {
            Logging::info("[MS-SQL->truncateTable] Truncated table: \"" . $param_tableName . "\" from database: \"" . $this->database . "\".");
            return true;
        }

    }

    function insertOrUpdateInTo($param_tableName, array $param_columnsAndValues, array $param_Keys = array())
    {
        $updateQuery = '';
        $columns = '';
        $values = '';
        $updateColumns = '';
        $updateValues = '';
        $keys = '';
        $insertKey = false;

        foreach ($param_columnsAndValues as $column => $value) {
            if (is_string($value)) {
                $value = "'" . str_replace("'", "''", $value) . "'";
            }
            if (($value === 'NULL') || ($value === null) || ($value === NULL)) {
                $value = "NULL";
            }
            $columns .= $column . ', ';
            $values .= $value . ', ';
            if (!(in_array($column, $param_Keys))) {
                $updateQuery .= 'Target.' . $column . ' = Source.' . $column . ', ';
                $updateColumns .= $column . ', ';
                $updateValues .= $value . ', ';
            } else {
                $insertKey = true;
            }
        }

        $updateQuery = substr($updateQuery, 0, -2);

        foreach ($param_Keys as $key) {
            $keys .= '(Source.' . $key . ' = Target.' . $key . ') AND ';
        }

        if (count($param_columnsAndValues) > 0) {
            $columns = substr($columns, 0, -2);
            $values = substr($values, 0, -2);
            $updateColumns = substr($updateColumns, 0, -2);
            $updateValues = substr($updateValues, 0, -2);
            if (count($param_Keys) > 0) {
                $keys = substr($keys, 0, -5);
            } else {
                $keys = '1=0';
            }

            $query = 'MERGE INTO ' . $param_tableName . ' AS Target USING (VALUES (' . $values . ')) As Source (' . $columns . ') ON (' . $keys . ') ';
            if (strlen($updateQuery) >= 3) {
                $query .= 'WHEN MATCHED THEN UPDATE SET ' . $updateQuery;
            }
            $query .= ' WHEN NOT MATCHED THEN ';
            $query .= 'INSERT (' . $columns . ') VALUES (' . $values . ');';

            // alles was eine IDENTITY variable hat (auto increment)
            $identityToggle = false;
            if ($insertKey) {
                $result = $this->getTableIdsArray();
                for ($i = 0; $i < count($result); $i++) {
                    if ($param_tableName == $result[$i]["TABLE_NAME"]) {
                        if (array_key_exists($result[$i]["COLUMN_NAME"], $param_columnsAndValues)) {
                            $identityToggle = true;
                        }
                    }

                }
            }
            if ($identityToggle) {
                return $this->query("SET IDENTITY_INSERT " . $param_tableName . " ON;" . $query . "SET IDENTITY_INSERT " . $param_tableName . " OFF;");
            } else {
                return $this->query($query);
            }

        }

    }

    function replaceInTo($param_tableName, array $param_columnsAndValues, array $param_Keys = array())
    {
        return $this->insertOrUpdateInTo($param_tableName, $param_columnsAndValues, $param_Keys);

    }

    function getTables()
    {
        $query = $this->queryRequest("SELECT TABLE_NAME FROM INFORMATION_SCHEMA.TABLES;");
        $tables = array();
        foreach ($query as $row) {
            $tables[] = (current($row) === false) ? '' : current($row);
        }
        return $tables;

    }

    function getTableIdsArray(){
        global $HCS_ROOTPATH;
        $writeNew = false;
        $tableIdsArray = array();

        $fileToken = $HCS_ROOTPATH . 'data/cache/tableIds_delete';
        $file = $HCS_ROOTPATH . 'data/cache/tableIds.json';
        if ( (file_exists($fileToken) && !is_dir($fileToken)) || (!is_readable($file)) ) {
            $writeNew = true;
            deleteCacheFile($file, $fileToken);
        }

        if(!$writeNew){
            $content = file_get_contents($file);
            if ($content !== false ){
                $tableIdsArray = json_decode($content, true);
                Logging::info("[MS-SQL->getTableIdsArray] Got logging rules array from cache.");
            } else {
                $writeNew = true;
                Logging::warning("[MS-SQL->getTableIdsArray] Could not get logging rules array from cache.");
            }
        }

        if ($writeNew){
            deleteCacheFile($file, $fileToken);
            $tableIdsArray = $this->queryRequest("SELECT TABLE_NAME, COLUMN_NAME FROM INFORMATION_SCHEMA.COLUMNS WHERE COLUMNPROPERTY(OBJECT_ID(TABLE_NAME),COLUMN_NAME,'ISIDENTITY') = 1");
            file_put_contents($file, json_encode($tableIdsArray));
            Logging::info("[MS-SQL->getTableIdsArray] Got logging rules array from Database.");
        } else {
        }

        return $tableIdsArray;
    }
}

class SQLite_3 implements iSQL
{

    private $SQLiteDatabaseHandle;
    private $database;

    function __construct($param_database = SQL_SERVER_DATABASE)
    {
        $error_message = "";
        $this->SQLiteDatabaseHandle = new SQLite3("./" . $param_database . ".db3");
        if (!$this->SQLiteDatabaseHandle) {
            $error = (file_exists($param_database)) ? "could not open SQLite3 database (" . $param_database . "), check permissions." : "could not create SQLite3 database (" . $param_database . "), check permissions.";
            Logging::error("[SQLite3] " . $error . " Error Message:\"" . $error_message . "\" ");
        } else {
            Logging::debug("[SQLite3] opened SQLite3 database: " . $param_database);
            $this->database = $param_database;
        }

    }

    function __destruct()
    {
        Logging::debug("[SQLite3] closed SQLite database: " . $this->database);

    }

    function createTable($param_tableName, $param_definition)
    {
        if (!($this->query('CREATE TABLE IF NOT EXISTS ' . $param_tableName . '(' . $param_definition . ')'))) {
            Logging::error("[SQLite3->createTable] Couldn't create table: \"" . $param_tableName . "\" in database: \"" . $this->database . "\".");
            return false;
        } else {
            Logging::info("[SQLite3->createTable] Created table: \"" . $param_tableName . "\" in database: \"" . $this->database . "\".");
            return true;
        }

    }

    function deleteIdFromTable($param_tableName, $param_id)
    {
        if (!($this->query("DELETE FROM " . $param_tableName . " WHERE Id = '" . (string)$param_id . "';"))) {
            Logging::error("[SQLite3->deleteIdFromTable] Couldn't delete ID: " . $param_id . " from table: \"" . $param_tableName . "\".");
            return false;
        } else {
            Logging::info("[SQLite3->deleteIdFromTable] Deleted id: " . $param_id . " from table: \"" . $param_tableName . "\".");
            return true;
        }

    }

    function dropTable($param_tableName)
    {
        if (!($this->query("DROP TABLE IF EXISTS " . $param_tableName))) {
            Logging::error("[SQLite3->dropTable] Couldn't drop table: \"" . $param_tableName . "\" from database: \"" . $this->database . "\".");
            return false;
        } else {
            Logging::info("[SQLite3->dropTable] Dropped table: \"" . $param_tableName . "\" from database: \"" . $this->database . "\".");
            return true;
        }

    }

    function query($param_queryString)
    {
        $result = $this->SQLiteDatabaseHandle->query($param_queryString);
        if ($result === false) {
            Logging::error("[SQLite3->query] Could not execute query. Error: " . $this->SQLiteDatabaseHandle->lastErrorMsg() . "\nin query: \n" . $param_queryString . "\n");
            return false;
        } else {
            Logging::debug("[SQLite3->query] Sent query: " . $param_queryString . "\nChanged Rows: " . $this->SQLiteDatabaseHandle->changes());
            return $result;
        }

    }

    function queryExec($param_queryString)
    {
        $result = $this->SQLiteDatabaseHandle->exec($param_queryString);
        if ($result === false) {
            Logging::error("[SQLite3->queryExec] Could not execute query. Error: " . $this->SQLiteDatabaseHandle->lastErrorMsg() . "\nin query: \n" . $param_queryString . "\n");
            return false;
        } else {
            Logging::debug("[SQLite3->queryExec] Sent query: " . $param_queryString . "\nChanged Rows: " . $this->SQLiteDatabaseHandle->changes());
            return true;
        }

    }

    function queryRequest($param_queryString)
    {
        $result = $this->query($param_queryString);
        if ($result === false) {
            Logging::error("[SQLite3->queryRequest] Could not execute query. Error: " . $this->SQLiteDatabaseHandle->lastErrorMsg() . "\nin query: \n" . $param_queryString . "\n");
            return false;
        } else {
            Logging::debug("[SQLite3->queryRequest] Sent query: " . $param_queryString . "\nChanged Rows: " . $this->SQLiteDatabaseHandle->changes());
            $rows = array();
            while ($row = $result->fetchArray(SQLITE3_ASSOC)) {
                $rows[] = $row;
            }
            return $rows;
        }

    }

    function truncateTable($param_tableName)
    {
        if (!($this->query("TRUNCATE TABLE " . $param_tableName))) {
            Logging::error("[SQLite3->truncateTable] Couldn't truncate table: \"" . $param_tableName . "\" from database: \"" . $this->database . "\".");
            return false;
        } else {
            Logging::info("[SQLite3->truncateTable] Truncated table: \"" . $param_tableName . "\" from database: \"" . $this->database . "\".");
            return true;
        }

    }

    function insertOrUpdateInTo($param_tableName, array $param_columnsAndValues, array $param_Keys = array())
    {
        return $this->replaceInTo($param_tableName, $param_columnsAndValues, $param_Keys);

    }

    function replaceInTo($param_tableName, array $param_columnsAndValues, array $param_Keys = array())
    {
        $columns = '';
        $values = '';
        foreach ($param_columnsAndValues as $column => $value) {
            $columns .= $column . ', ';
            if (is_string($value)) {
                $value = "'" . $value . "'";
            }
            if (($value === 'NULL') || ($value === null) || ($value === NULL)) {
                $value = "NULL";
            }
            $values .= $value . ', ';
        }
        if (count($param_columnsAndValues) > 0) {
            $columns = substr($columns, 0, -2);
            $values = substr($values, 0, -2);
            return $this->query('REPLACE INTO ' . $param_tableName . ' (' . $columns . ') VALUES (' . $values . ')');
        }

    }

    function getTables()
    {
        $query = $this->queryRequest("SHOW TABLES;");
        $tables = array();
        foreach ($query as $row) {
            $tables[] = (current($row) === false) ? '' : current($row);
        }
        return $tables;

    }

    function getPreviousQueryAutoId()
    {
        // TODO: Implement getPreviousQueryAutoId() method.
    }
}

class SQLite implements iSQL
{

    private $SQLiteDatabaseHandle;
    private $database;

    function __construct($param_database = SQL_SERVER_DATABASE)
    {
        $error_message = "";
        $this->SQLiteDatabaseHandle = new SQLiteDatabase($param_database . ".db", 0666, $error_message);
        if (!$this->SQLiteDatabaseHandle) {
            $error = (file_exists($param_database)) ? "could not open SQLite database (" . $param_database . "), check permissions." : "could not create SQLite database (" . $param_database . "), check permissions.";
            Logging::error("[SQLite] " . $error . " Error Message:\"" . $error_message . "\" ");
        } else {
            Logging::debug("[SQLite] opened SQLite database: " . $param_database);
            $this->database = $param_database;
        }

    }

    function __destruct()
    {
        Logging::debug("[SQLite] closed SQLite database: " . $this->database);

    }

    function deleteIdFromTable($param_tableName, $param_id)
    {
        if (!($this->query("DELETE FROM " . $param_tableName . " WHERE Id = '" . (string)$param_id . "';"))) {
            Logging::error("[SQLite->deleteIdFromTable] Couldn't delete Id: " . $param_id . " from table: \"" . $param_tableName . "\".");
            return false;
        } else {
            Logging::info("[SQLite->deleteIdFromTable] Deleted id: " . $param_id . " from table: \"" . $param_tableName . "\".");
            return true;
        }

    }

    function createTable($param_tableName, $param_definition)
    {
        if ($this->checkTableExists($param_tableName)) {
            Logging::warning("[SQLite->createTable] Did not create table: \"" . $param_tableName . "\" in database: \"" . $this->database . "\" because it already exist.");
            return true;
        } else {

            if (!($this->query('CREATE TABLE ' . $param_tableName . '(' . $param_definition . ')'))) {
                Logging::error("[SQLite->createTable] Couldn't create table: \"" . $param_tableName . "\" in database: \"" . $this->database . "\".");
                return false;
            } else {
                Logging::info("[SQLite->createTable] Created table: \"" . $param_tableName . "\" in database: \"" . $this->database . "\".");
                return true;
            }
        }

    }

    function dropTable($param_tableName)
    {
        if ($this->checkTableExists($param_tableName)) {
            if (!($this->query("DROP TABLE " . $param_tableName))) {
                Logging::error("[SQLite->dropTable] Couldn't drop table: \"" . $param_tableName . "\" from database: \"" . $this->database . "\".");
                return false;
            } else {
                Logging::info("[SQLite->dropTable] Dropped table: \"" . $param_tableName . "\" from database: \"" . $this->database . "\".");
                return true;
            }
        } else {
            Logging::debug("[SQLite->dropTable] Did not drop table: \"" . $param_tableName . "\" from database: \"" . $this->database . "\" because it doesn't exist.");
            return true;
        }

    }

    function query($param_queryString)
    {
        $query_error = "";
        $result = $this->SQLiteDatabaseHandle->query($param_queryString);
        if ($query_error) {
            Logging::error("[SQLite->query] Invalid query: \n" . $query_error . "\n\n in query: \n" . $param_queryString . "\n");
            return false;
        }
        if ($result === false) {
            Logging::error("[SQLite->query] Could not execute query: \n" . $param_queryString . "\n");
            return false;
        } else {
            Logging::debug("[SQLite->query] Sent query: " . $param_queryString . "\nChanged Rows: " . $this->SQLiteDatabaseHandle->changes());
            return $result;
        }

    }

    function queryExec($param_queryString)
    {
        $query_error = "";
        $result = $this->SQLiteDatabaseHandle->queryExec($param_queryString, $query_error);
        if ($query_error) {
            Logging::error("[SQLite->queryExec] Invalid query: \n" . $query_error . "\n\n in query: \n" . $param_queryString . "\n");
            return false;
        }
        if ($result === false) {
            Logging::error("[SQLite->queryExec] Could not execute query: \n" . $param_queryString . "\n");
            return false;
        } else {
            Logging::debug("[SQLite->queryExec] Sent query: " . $param_queryString . "\nChanged Rows: " . $this->SQLiteDatabaseHandle->changes());
            return true;
        }

    }

    function queryRequest($param_queryString)
    {
        $result = $this->SQLiteDatabaseHandle->arrayQuery($param_queryString, SQLITE_ASSOC);
        if ($result === false) {
            Logging::error("[SQLite->queryRequest] Could not execute query. Error: " . sqlite_error_string(sqlite_last_error($this->SQLiteDatabaseHandle)) . "\nin query: \n" . $param_queryString . "\n");
            return false;
        } else {
            Logging::debug("[SQLite->queryRequest] Sent query: " . $param_queryString . "\nChanged Rows: " . $this->SQLiteDatabaseHandle->changes());
            return $result;
        }

    }

    private function checkTableExists($param_tableName)
    {
        return (count($this->SQLiteDatabaseHandle->arrayQuery("SELECT name FROM sqlite_master WHERE type='table' AND name='" . $param_tableName . "'")) > 0);

    }

    function truncateTable($param_tableName)
    {
        if (!($this->query("DELETE FROM " . $param_tableName))) {
            Logging::error("[MySQL->truncateTable] Couldn't truncate table: \"" . $param_tableName . "\" from database: \"" . $this->database . "\".");
            return false;
        } else {
            Logging::info("[MySQL->truncateTable] Truncated table: \"" . $param_tableName . "\" from database: \"" . $this->database . "\".");
            return true;
        }

    }

    function insertOrUpdateInTo($param_tableName, array $param_columnsAndValues, array $param_Keys = array())
    {
        return $this->replaceInTo($param_tableName, $param_columnsAndValues, $param_Keys);

    }

    function replaceInTo($param_tableName, array $param_columnsAndValues, array $param_Keys = array())
    {
        $columns = '';
        $values = '';
        foreach ($param_columnsAndValues as $column => $value) {
            $columns .= $column . ', ';
            if (is_string($value)) {
                $value = "'" . $value . "'";
            }
            if (($value === 'NULL') || ($value === null) || ($value === NULL)) {
                $value = "NULL";
            }
            $values .= $value . ', ';
        }
        if (count($param_columnsAndValues) > 0) {
            $columns = substr($columns, 0, -2);
            $values = substr($values, 0, -2);
            return $this->query('REPLACE INTO ' . $param_tableName . ' (' . $columns . ') VALUES (' . $values . ')');
        }

    }

    function getTables()
    {
        $query = $this->queryRequest("SHOW TABLES;");
        $tables = array();
        foreach ($query as $row) {
            $tables[] = (current($row) === false) ? '' : current($row);
        }
        return $tables;

    }

    function getPreviousQueryAutoId()
    {
        // TODO: Implement getPreviousQueryAutoId() method.
    }
}

function sqlEscapeString($param_string)
{
    if (SQL_SERVER_TYPE != "MySQL") {
        return addslashes($param_string);
    } else {
        return mysql_real_escape_string($param_string);
    }

}

?>