<?php

define('HCS_CALLABLE_FILE', true);
$HCS_ROOTPATH = './';
include_once($HCS_ROOTPATH . 'common.php');
global $TEMPLATE, $_LANGUAGE, $_CONFIG;

if (!isset($sql)) {
    $sql = @new SQL();
}
$loggedInUser = getLoggedInUser($sql);
$TEMPLATE->setFilename('page.html');


//get page
$id = '';
checkedSet($id, $_GET['id']);
checkedSet($id, $_POST['id']);
if ($id == '') {
    $s = sprintf($_LANGUAGE['L_NO_PAGE_ID'], '<a href="' . insertSessionId($HCS_ROOTPATH) . 'index.php">', '</a>');
    $TEMPLATE->displayDieMessage($_LANGUAGE['L_ERROR'], $s);
    die('Security: you should never reach this!');
}
$right = $sql->getPageRights($id);

// could not get rights
if ($right === false) {
    $s = sprintf($_LANGUAGE['L_COULD_NOT_READ_STANDARD_RIGHTS'], '<a href="' . insertSessionId($HCS_ROOTPATH . 'index.php') . '">', '</a>', $id);
    $TEMPLATE->displayDieMessage($_LANGUAGE['L_ERROR'], $s);
    die('Security: you should never reach this!');
}

// no rights
if ($right <= 0) {
    $TEMPLATE->displayDieMessage($_LANGUAGE['L_WARNING'], $_LANGUAGE['L_NO_RIGHTS']);
    die('Security: you should never reach this!');
}
// $right > 0; 1: show, 2:control, 3:edit


$request = $sql->queryRequest("SELECT * FROM " . HCS_TABLE_PREFIX . "Pages WHERE Id= '" . (int)$id . "';");
$style = $request[0]["Style"];
if (($style == 'none')) {
    $TEMPLATE->assignVariables(array('HCS_STYLE' => ''));
} elseif (($style == 'standard') || ($style == '')) {
    //don't change the HCS_STYLE. should be set by the Template Class
} else {
    $TEMPLATE->assignVariables(array('HCS_STYLE' => $style));
}
$TEMPLATE->assignVariables(array(
    'PAGE_RIGHTS' => $right,
    'PAGE_ID' => $id,
    'PAGE_TITLE' => $request[0]["Title"],
    'SHOW_LOGIN_REDIRECT' => (bool)$request[0]["LoginHeader"],
    'SHOW_PAGE_TAIL' => (bool)$request[0]["PageTail"],
    'EVENT_UPDATES' => (bool)$request[0]["EventUpdates"],
    'STYLE' => $request[0]["Style"],
    'CSS_STYLE' => $request[0]["CssStyle"],
    'REFRESH_TIMEOUT' => $request[0]["RefreshTimeout"],
    'REFRESH_RATE' => $request[0]["RefreshRate"],
    'REFRESH_WAIT_TIME' => $request[0]["RefreshWaitTime"],
    'LANGUAGE' => $_CONFIG['language'],
));

$request = $sql->queryRequest("SELECT " . HCS_TABLE_PREFIX . "PageWidgets.Id AS Id, " . HCS_TABLE_PREFIX . "Widgets.Id AS ClassId, ClassName, " . HCS_TABLE_PREFIX . "WidgetPackets.Folder, ClassFile, Configuration, posTop, posLeft, Width, Height, ZIndex, Overflow  FROM (" . HCS_TABLE_PREFIX . "PageWidgets LEFT JOIN " . HCS_TABLE_PREFIX . "Widgets ON " . HCS_TABLE_PREFIX . "PageWidgets.WidgetId = " . HCS_TABLE_PREFIX . "Widgets.Id) LEFT JOIN " . HCS_TABLE_PREFIX . "WidgetPackets ON " . HCS_TABLE_PREFIX . "Widgets.PacketId = " . HCS_TABLE_PREFIX . "WidgetPackets.Id WHERE PageId= '" . (int)$id . "';");
$JsIncludes = array();
foreach ($request as $widget) {
    $folder = $HCS_ROOTPATH . 'data/widgets/' . $widget["Folder"] . '/';
    $TEMPLATE->assignBlockVariables('widgets', array(
        'ID' => $widget["Id"],
        'CLASS_ID' => $widget["ClassId"],
        'CLASS' => $widget["ClassName"],
        'CONFIG' => unescapeData($widget["Configuration"]),
        'PATH' => $folder,
        'TOP' => $widget["posTop"],
        'LEFT' => $widget["posLeft"],
        'WIDTH' => $widget["Width"],
        'HEIGHT' => $widget["Height"],
        'Z_INDEX' => $widget["ZIndex"],
        'OVERFLOW' => $widget["Overflow"],
    ));

    if (!in_array($folder . $widget["ClassFile"], $JsIncludes)) {
        $JsIncludes[] = $folder . $widget["ClassFile"];
    }
}

foreach ($JsIncludes as $include) {
    $TEMPLATE->assignBlockVariables('widgetJsIncludes', array('PATH' => $include));
}

if ($loggedInUser != false) {
    $TEMPLATE->assignVariables(array(
        'L_INFO_LOGGED_IN_TITLE' => sprintf($_LANGUAGE['L_INFO_LOGGED_IN_TITLE'], $loggedInUser),
        'SESSION_INFO' => sprintf($_LANGUAGE['L_SESSION_INFO'], nl2br(var_export($_SESSION, true))),
        'SESSION_ID' => 'SID: ' . session_id(),
        'COOKIE_INFO' => sprintf($_LANGUAGE['L_COOKIE_INFO'], nl2br(var_export($_COOKIE, true))),
    ));
} else {
    $s = sprintf($_LANGUAGE['L_INFO_NOT_LOGGEDIN_TEXT'], '<a href="' . insertSessionId($HCS_ROOTPATH . 'login.php?redirect=' . getRequestUri()) . '">', '</a>');
    $TEMPLATE->assignVariables(array(
        'L_INFO_NOT_LOGGEDIN_TITLE' => $_LANGUAGE['L_INFO_NOT_LOGGEDIN_TITLE'],
        'L_INFO_NOT_LOGGEDIN_TEXT' => $s,
    ));
}

$TEMPLATE->preparePageHeader();
$TEMPLATE->prepratePageTailAndDisplay();
// EOF
?>