<?php

define('HCS_CALLABLE_FILE', true);
$HCS_ROOTPATH = './';
$hcs_configFile = $HCS_ROOTPATH . 'config.php';


if ( is_file($hcs_configFile) ) {
    include_once($hcs_configFile);
}
require_once($HCS_ROOTPATH . "includes/php/xmlrpc_functions.php");
include_once($HCS_ROOTPATH . "includes/php/tasker_functions.php");


function checkCallerAddressMatchingForChannelAddress($param_callerAddress, $param_channelAddress, SQL $param_sql = null) {
    $sql = null;
    if ( $param_sql != null ) {
        $sql = $param_sql;
    } else {
        $sql = new SQL();
    }
    $query = $sql->queryRequest("SELECT CcuAddress FROM (" . HCS_TABLE_PREFIX . "Channels AS c LEFT JOIN " . HCS_TABLE_PREFIX . "Devices AS d ON c.DeviceAddress = d.Address) LEFT JOIN " . HCS_TABLE_PREFIX . "CcuList AS cl ON c.CcuId = cl.Id WHERE c.Address = '" . $param_channelAddress . "';");

    foreach($query as $ccu){
        if ($ccu["CcuAddress"] == $param_callerAddress){
            return true;
        }
    }
    return false;

}

function getCcuAddressByChannelAddress($param_channelAddress, SQL $param_sql = null) {
    $sql = null;
    if ( $param_sql != null ) {
        $sql = $param_sql;
    } else {
        $sql = new SQL();
    }
    $ccu = $sql->queryRequest("SELECT CcuAddress FROM (" . HCS_TABLE_PREFIX . "Channels AS c LEFT JOIN " . HCS_TABLE_PREFIX . "Devices AS d ON c.DeviceAddress = d.Address) LEFT JOIN " . HCS_TABLE_PREFIX . "CcuList AS cl ON c.CcuId = cl.Id WHERE c.Address = '" . $param_channelAddress . "';");

    return $ccu[0]["CcuAddress"];

}

function getCcuAddressByCcuId($param_ccuId, SQL $param_sql = null) {
    $sql = null;
    if ( $param_sql != null ) {
        $sql = $param_sql;
    } else {
        $sql = new SQL();
    }
    $ccu = array();
    $ccu = $sql->queryRequest("SELECT CcuAddress FROM " . HCS_TABLE_PREFIX . "CcuList WHERE Id = " . (int)$param_ccuId . ";");

    return $ccu[0]["CcuAddress"];
}


if ( !function_exists('extractScalarParams') ) {

    function extractScalarParams($param_xmlRpcMsg) {
        $MsgParamScalars = array();
        $MsgNumParams = $param_xmlRpcMsg->getNumParams();

        for ( $i = 0; $i < $MsgNumParams; $i++ ) {
            $Param = $param_xmlRpcMsg->getParam($i);
            if ( $Param->kindOf() == "scalar" ) {
                if ( $Param->scalarTyp() == "boolean" ) {
                    if ( $Param->scalarVal() == true ) {
                        $MsgParamScalars[$i] = "true";
                    } else if ( $Param->scalarVal() == false ) {
                        $MsgParamScalars[$i] = "false";
                    }
                } else if ( $Param->scalarTyp() == "int" ) {
                    $MsgParamScalars[$i] = (int) ($Param->scalarVal());
                } else if ( $Param->scalarTyp() == "double" ) {
                    $MsgParamScalars[$i] = (double) ($Param->scalarVal());
                } else if ( $Param->scalarTyp() == "string" ) {
                    $MsgParamScalars[$i] = (string) ($Param->scalarVal());
                } else {
                    $MsgParamScalars[$i] = (string) ($Param->scalarVal());
                }
//        } else if( $Param->kindOf() == "array" ) {
//            for($j = 0; $i < $Param->arraySize(); $j++) {
//                // each arrayElement.kindOf() can be again "struct", "array" or "scalar"
//                //$arrayElement = $Param->arrayMem($j);
//            }
//        } else if( $Param->kindOf() == "struct" ) {
//            $Param->structreset();
//            while( list($structElementKey, $structElementValue) = $Param->structEach() ) {
//                // each structElementValue.kindOf() can be again "struct", "array" or "scalar"
//                //echo($structElementKey.":".$structElementValue);
//            }
            }
        }
        return $MsgParamScalars;

    }

}

function output($param_xmlRpcMsg) {
    $inhalt = date('Y/m/d H:i:s') . ":\n" . $param_xmlRpcMsg . "\n\n";
    $handle = fopen("server_log.txt", "a");
    fwrite($handle, $inhalt);
    fclose($handle);

    return new xmlrpcresp(new xmlrpcval("", "string"));

}

function blank($param_xmlRpcMsg) {
    return new xmlrpcresp(new xmlrpcval("", "string"));

}

function homematic_xmlrpc_event($param_xmlRpcMsg) {
    ob_start();

    $MsgParamScalars = extractScalarParams($param_xmlRpcMsg);
    $return = new xmlrpcresp(new xmlrpcval("", "string"));
    if ( count($MsgParamScalars) == 4 ) {
        $sql = new SQL();
        $channelAddress = (string) $MsgParamScalars[1];
        $callerAddress = $_SERVER["REMOTE_ADDR"];

        if ( checkCallerAddressMatchingForChannelAddress($callerAddress, $channelAddress, $sql) ) {
            $ccuId = (string) $MsgParamScalars[0];
            $dataPoint = (string) $MsgParamScalars[2];
            $value = (string) $MsgParamScalars[3];
            Logging::info("[XML-RPC Server->event] Received $ccuId - $channelAddress - $dataPoint : $value");
            LogEvent($ccuId, $channelAddress, $dataPoint, $value, $sql);

            if ( function_exists("homematicGateway_eventScalar") ) {
                $return = homematicGateway_eventScalar($MsgParamScalars, $sql);
            }
        } else {
            $ccuAddress = getCcuAddressByChannelAddress($channelAddress, $sql);
            Logging::error("[XML-RPC Server->event] event sender address ($callerAddress) did not match CCU address ($ccuAddress) for this channel ($channelAddress).");
            executeTasker();
        }
    }
    ob_clean();

    return $return;
}

$s = new xmlrpc_server(
                  array(
                    "listDevices" => array("function" => "blank" , 'signature' => array(array('array'), array('array', 'string')), 'docstring' => 'Diese Methode gibt alle der Logikschicht bekannten Geräte für den Schnittstellenprozess mit der Id interface_id in Form von Gerätebeschreibungen zurück. Damit kann der Schnittstellenprozess durch Aufruf von newDevices() und deleteDevices() einen Abgleich vornehmen.'), // asks for known devices
                    "multiCall" => array("function" => "output", 'signature' => array(array('array', 'array')), 'docstring' => 'Sollte nie aufgerufen werden - eigentlich.'),
                    "event" => array("function" => "homematic_xmlrpc_event", 'signature' => array(array('string', 'string', 'string', 'string', 'undefined')), 'docstring' => 'Mit dieser Methode teilt der Schnittstellenprozess der Logikschicht mit, dass sich ein Wert geändert hat oder ein Event (z.B. Tastendruck) empfangen wurde.'),
                    "newDevices" => array("function" => "blank", 'signature' => array(array('string', 'string', 'array')), 'docstring' => 'Mit dieser Methode wird der Logikschicht mitgeteilt, dass neue Geräte gefunden wurden.'), // sends unknown devices
                    "newDevice" => array("function" => "output", 'signature' => array(array('string', 'string', 'array')), 'docstring' => 'Sollte nie aufgerufen werden - eigentlich.'),
                )
);



?>